/* Logging.c generated by valac 0.56.18, the Vala compiler
 * generated from Logging.vala, do not modify */

/*
 * Copyright (C) 2011 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdarg.h>
#include <stdio.h>
#include <gio/gio.h>
#include <gee.h>

#define DVB_LOGGING_COLOR_FORMATTER_clear "\033[00m"
#define DVB_LOGGING_LOG_MANAGER_DEFAULT_NAME "default"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DVB_LOGGING_LOG_LEVEL_LOG,
	DVB_LOGGING_LOG_LEVEL_DEBUG,
	DVB_LOGGING_LOG_LEVEL_INFO,
	DVB_LOGGING_LOG_LEVEL_WARNING,
	DVB_LOGGING_LOG_LEVEL_ERROR
} DVBLoggingLogLevel;

#define DVB_LOGGING_TYPE_LOG_LEVEL (dvb_logging_log_level_get_type ())

#define DVB_LOGGING_TYPE_FORMATTER (dvb_logging_formatter_get_type ())
#define DVB_LOGGING_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_FORMATTER, DVBLoggingFormatter))
#define DVB_LOGGING_IS_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_FORMATTER))
#define DVB_LOGGING_FORMATTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_LOGGING_TYPE_FORMATTER, DVBLoggingFormatterIface))

typedef struct _DVBLoggingFormatter DVBLoggingFormatter;
typedef struct _DVBLoggingFormatterIface DVBLoggingFormatterIface;

#define DVB_LOGGING_TYPE_HANDLER (dvb_logging_handler_get_type ())
#define DVB_LOGGING_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_HANDLER, DVBLoggingHandler))
#define DVB_LOGGING_IS_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_HANDLER))
#define DVB_LOGGING_HANDLER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_LOGGING_TYPE_HANDLER, DVBLoggingHandlerIface))

typedef struct _DVBLoggingHandler DVBLoggingHandler;
typedef struct _DVBLoggingHandlerIface DVBLoggingHandlerIface;

#define DVB_LOGGING_TYPE_DEFAULT_FORMATTER (dvb_logging_default_formatter_get_type ())
#define DVB_LOGGING_DEFAULT_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatter))
#define DVB_LOGGING_DEFAULT_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatterClass))
#define DVB_LOGGING_IS_DEFAULT_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER))
#define DVB_LOGGING_IS_DEFAULT_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_DEFAULT_FORMATTER))
#define DVB_LOGGING_DEFAULT_FORMATTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatterClass))

typedef struct _DVBLoggingDefaultFormatter DVBLoggingDefaultFormatter;
typedef struct _DVBLoggingDefaultFormatterClass DVBLoggingDefaultFormatterClass;
typedef struct _DVBLoggingDefaultFormatterPrivate DVBLoggingDefaultFormatterPrivate;
enum  {
	DVB_LOGGING_DEFAULT_FORMATTER_0_PROPERTY,
	DVB_LOGGING_DEFAULT_FORMATTER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_default_formatter_properties[DVB_LOGGING_DEFAULT_FORMATTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_LOGGING_TYPE_COLOR_FORMATTER (dvb_logging_color_formatter_get_type ())
#define DVB_LOGGING_COLOR_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatter))
#define DVB_LOGGING_COLOR_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatterClass))
#define DVB_LOGGING_IS_COLOR_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER))
#define DVB_LOGGING_IS_COLOR_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_COLOR_FORMATTER))
#define DVB_LOGGING_COLOR_FORMATTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatterClass))

typedef struct _DVBLoggingColorFormatter DVBLoggingColorFormatter;
typedef struct _DVBLoggingColorFormatterClass DVBLoggingColorFormatterClass;
typedef struct _DVBLoggingColorFormatterPrivate DVBLoggingColorFormatterPrivate;
enum  {
	DVB_LOGGING_COLOR_FORMATTER_0_PROPERTY,
	DVB_LOGGING_COLOR_FORMATTER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_color_formatter_properties[DVB_LOGGING_COLOR_FORMATTER_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_CONSOLE_HANDLER (dvb_logging_console_handler_get_type ())
#define DVB_LOGGING_CONSOLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandler))
#define DVB_LOGGING_CONSOLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandlerClass))
#define DVB_LOGGING_IS_CONSOLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER))
#define DVB_LOGGING_IS_CONSOLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_CONSOLE_HANDLER))
#define DVB_LOGGING_CONSOLE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandlerClass))

typedef struct _DVBLoggingConsoleHandler DVBLoggingConsoleHandler;
typedef struct _DVBLoggingConsoleHandlerClass DVBLoggingConsoleHandlerClass;
typedef struct _DVBLoggingConsoleHandlerPrivate DVBLoggingConsoleHandlerPrivate;
enum  {
	DVB_LOGGING_CONSOLE_HANDLER_0_PROPERTY,
	DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY,
	DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY,
	DVB_LOGGING_CONSOLE_HANDLER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_console_handler_properties[DVB_LOGGING_CONSOLE_HANDLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DVB_LOGGING_TYPE_FILE_HANDLER (dvb_logging_file_handler_get_type ())
#define DVB_LOGGING_FILE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandler))
#define DVB_LOGGING_FILE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandlerClass))
#define DVB_LOGGING_IS_FILE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_FILE_HANDLER))
#define DVB_LOGGING_IS_FILE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_FILE_HANDLER))
#define DVB_LOGGING_FILE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandlerClass))

typedef struct _DVBLoggingFileHandler DVBLoggingFileHandler;
typedef struct _DVBLoggingFileHandlerClass DVBLoggingFileHandlerClass;
typedef struct _DVBLoggingFileHandlerPrivate DVBLoggingFileHandlerPrivate;
enum  {
	DVB_LOGGING_FILE_HANDLER_0_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY,
	DVB_LOGGING_FILE_HANDLER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;
typedef struct _DVBLoggingLoggerPrivate DVBLoggingLoggerPrivate;
enum  {
	DVB_LOGGING_LOGGER_0_PROPERTY,
	DVB_LOGGING_LOGGER_NAME_PROPERTY,
	DVB_LOGGING_LOGGER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_logger_properties[DVB_LOGGING_LOGGER_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
typedef struct _DVBLoggingLogManagerPrivate DVBLoggingLogManagerPrivate;
enum  {
	DVB_LOGGING_LOG_MANAGER_0_PROPERTY,
	DVB_LOGGING_LOG_MANAGER_NUM_PROPERTIES
};
static GParamSpec* dvb_logging_log_manager_properties[DVB_LOGGING_LOG_MANAGER_NUM_PROPERTIES];

struct _DVBLoggingFormatterIface {
	GTypeInterface parent_iface;
	gchar* (*format) (DVBLoggingFormatter* self, const gchar* logger_name, DVBLoggingLogLevel level, const gchar* format);
};

struct _DVBLoggingHandlerIface {
	GTypeInterface parent_iface;
	void (*publish) (DVBLoggingHandler* self, const gchar* logger_name, DVBLoggingLogLevel level, const gchar* format, va_list args);
	void (*close) (DVBLoggingHandler* self);
	DVBLoggingFormatter* (*get_formatter) (DVBLoggingHandler* self);
	void (*set_formatter) (DVBLoggingHandler* self, DVBLoggingFormatter* value);
	DVBLoggingLogLevel (*get_threshold) (DVBLoggingHandler* self);
	void (*set_threshold) (DVBLoggingHandler* self, DVBLoggingLogLevel value);
};

struct _DVBLoggingDefaultFormatter {
	GObject parent_instance;
	DVBLoggingDefaultFormatterPrivate * priv;
};

struct _DVBLoggingDefaultFormatterClass {
	GObjectClass parent_class;
	gchar* (*get_level_name) (DVBLoggingDefaultFormatter* self, DVBLoggingLogLevel level);
	gchar* (*format) (DVBLoggingDefaultFormatter* self, const gchar* logger_name, DVBLoggingLogLevel level, const gchar* format);
};

struct _DVBLoggingColorFormatter {
	DVBLoggingDefaultFormatter parent_instance;
	DVBLoggingColorFormatterPrivate * priv;
};

struct _DVBLoggingColorFormatterClass {
	DVBLoggingDefaultFormatterClass parent_class;
};

struct _DVBLoggingConsoleHandler {
	GObject parent_instance;
	DVBLoggingConsoleHandlerPrivate * priv;
};

struct _DVBLoggingConsoleHandlerClass {
	GObjectClass parent_class;
};

struct _DVBLoggingConsoleHandlerPrivate {
	DVBLoggingFormatter* _formatter;
	DVBLoggingLogLevel _threshold;
};

struct _DVBLoggingFileHandler {
	GObject parent_instance;
	DVBLoggingFileHandlerPrivate * priv;
};

struct _DVBLoggingFileHandlerClass {
	GObjectClass parent_class;
};

struct _DVBLoggingFileHandlerPrivate {
	DVBLoggingFormatter* _formatter;
	DVBLoggingLogLevel _threshold;
	gint _limit;
	gint _count;
	gchar* _pattern;
	GOutputStream* os;
	gint file_size;
	gint file_index;
};

struct _DVBLoggingLogger {
	GObject parent_instance;
	DVBLoggingLoggerPrivate * priv;
};

struct _DVBLoggingLoggerClass {
	GObjectClass parent_class;
};

struct _DVBLoggingLoggerPrivate {
	gchar* _name;
	GeeHashSet* handlers;
	GRecMutex __lock_handlers;
};

struct _DVBLoggingLogManager {
	GObject parent_instance;
	DVBLoggingLogManagerPrivate * priv;
};

struct _DVBLoggingLogManagerClass {
	GObjectClass parent_class;
};

struct _DVBLoggingLogManagerPrivate {
	GeeHashMap* loggers;
	GRecMutex __lock_loggers;
};

static gpointer dvb_logging_default_formatter_parent_class = NULL;
static DVBLoggingFormatterIface * dvb_logging_default_formatter_dvb_logging_formatter_parent_iface = NULL;
static gpointer dvb_logging_color_formatter_parent_class = NULL;
static gchar** dvb_logging_color_formatter_colormap;
static gint dvb_logging_color_formatter_colormap_length1;
static gchar** dvb_logging_color_formatter_colormap = NULL;
static gint dvb_logging_color_formatter_colormap_length1 = 0;
static gint _dvb_logging_color_formatter_colormap_size_ = 0;
static gint DVBLoggingConsoleHandler_private_offset;
static gpointer dvb_logging_console_handler_parent_class = NULL;
static DVBLoggingHandlerIface * dvb_logging_console_handler_dvb_logging_handler_parent_iface = NULL;
static gint DVBLoggingFileHandler_private_offset;
static gpointer dvb_logging_file_handler_parent_class = NULL;
static DVBLoggingHandlerIface * dvb_logging_file_handler_dvb_logging_handler_parent_iface = NULL;
static gint DVBLoggingLogger_private_offset;
static gpointer dvb_logging_logger_parent_class = NULL;
static gint DVBLoggingLogManager_private_offset;
static gpointer dvb_logging_log_manager_parent_class = NULL;
static DVBLoggingLogManager* dvb_logging_log_manager_instance;
static DVBLoggingLogManager* dvb_logging_log_manager_instance = NULL;
static GRecMutex dvb_logging_log_manager_instance_mutex;
static GRecMutex dvb_logging_log_manager_instance_mutex = {0};

VALA_EXTERN GType dvb_logging_log_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_logging_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingFormatter, g_object_unref)
VALA_EXTERN gchar* dvb_logging_formatter_format (DVBLoggingFormatter* self,
                                     const gchar* logger_name,
                                     DVBLoggingLogLevel level,
                                     const gchar* format);
static GType dvb_logging_formatter_get_type_once (void);
VALA_EXTERN GType dvb_logging_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingHandler, g_object_unref)
VALA_EXTERN void dvb_logging_handler_publish (DVBLoggingHandler* self,
                                  const gchar* logger_name,
                                  DVBLoggingLogLevel level,
                                  const gchar* format,
                                  va_list args);
VALA_EXTERN void dvb_logging_handler_close (DVBLoggingHandler* self);
VALA_EXTERN DVBLoggingFormatter* dvb_logging_handler_get_formatter (DVBLoggingHandler* self);
VALA_EXTERN void dvb_logging_handler_set_formatter (DVBLoggingHandler* self,
                                        DVBLoggingFormatter* value);
VALA_EXTERN DVBLoggingLogLevel dvb_logging_handler_get_threshold (DVBLoggingHandler* self);
VALA_EXTERN void dvb_logging_handler_set_threshold (DVBLoggingHandler* self,
                                        DVBLoggingLogLevel value);
static GType dvb_logging_handler_get_type_once (void);
VALA_EXTERN GType dvb_logging_default_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingDefaultFormatter, g_object_unref)
VALA_EXTERN gchar* dvb_logging_default_formatter_get_level_name (DVBLoggingDefaultFormatter* self,
                                                     DVBLoggingLogLevel level);
VALA_EXTERN gchar* dvb_logging_default_formatter_format (DVBLoggingDefaultFormatter* self,
                                             const gchar* logger_name,
                                             DVBLoggingLogLevel level,
                                             const gchar* format);
static gchar* dvb_logging_default_formatter_real_get_level_name (DVBLoggingDefaultFormatter* self,
                                                          DVBLoggingLogLevel level);
static gchar* dvb_logging_default_formatter_real_format (DVBLoggingDefaultFormatter* self,
                                                  const gchar* logger_name,
                                                  DVBLoggingLogLevel level,
                                                  const gchar* format);
VALA_EXTERN DVBLoggingDefaultFormatter* dvb_logging_default_formatter_new (void);
VALA_EXTERN DVBLoggingDefaultFormatter* dvb_logging_default_formatter_construct (GType object_type);
static GType dvb_logging_default_formatter_get_type_once (void);
VALA_EXTERN GType dvb_logging_color_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingColorFormatter, g_object_unref)
static gchar* dvb_logging_color_formatter_real_get_level_name (DVBLoggingDefaultFormatter* base,
                                                        DVBLoggingLogLevel level);
static gchar* dvb_logging_color_formatter_real_format (DVBLoggingDefaultFormatter* base,
                                                const gchar* logger_name,
                                                DVBLoggingLogLevel level,
                                                const gchar* format);
VALA_EXTERN DVBLoggingColorFormatter* dvb_logging_color_formatter_new (void);
VALA_EXTERN DVBLoggingColorFormatter* dvb_logging_color_formatter_construct (GType object_type);
static void dvb_logging_color_formatter_finalize (GObject * obj);
static GType dvb_logging_color_formatter_get_type_once (void);
VALA_EXTERN GType dvb_logging_console_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingConsoleHandler, g_object_unref)
static void dvb_logging_console_handler_real_publish (DVBLoggingHandler* base,
                                               const gchar* logger_name,
                                               DVBLoggingLogLevel level,
                                               const gchar* format,
                                               va_list args);
static void dvb_logging_console_handler_real_close (DVBLoggingHandler* base);
VALA_EXTERN DVBLoggingConsoleHandler* dvb_logging_console_handler_new (void);
VALA_EXTERN DVBLoggingConsoleHandler* dvb_logging_console_handler_construct (GType object_type);
static void dvb_logging_console_handler_finalize (GObject * obj);
static GType dvb_logging_console_handler_get_type_once (void);
static void _vala_dvb_logging_console_handler_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_dvb_logging_console_handler_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
VALA_EXTERN GType dvb_logging_file_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingFileHandler, g_object_unref)
VALA_EXTERN DVBLoggingFileHandler* dvb_logging_file_handler_new (const gchar* file_pattern,
                                                     GError** error);
VALA_EXTERN DVBLoggingFileHandler* dvb_logging_file_handler_construct (GType object_type,
                                                           const gchar* file_pattern,
                                                           GError** error);
static void dvb_logging_file_handler_rotate (DVBLoggingFileHandler* self,
                                      GError** error);
static void dvb_logging_file_handler_real_publish (DVBLoggingHandler* base,
                                            const gchar* logger_name,
                                            DVBLoggingLogLevel level,
                                            const gchar* format,
                                            va_list args);
VALA_EXTERN gint dvb_logging_file_handler_get_limit (DVBLoggingFileHandler* self);
static void dvb_logging_file_handler_real_close (DVBLoggingHandler* base);
static GFile* dvb_logging_file_handler_get_next_file (DVBLoggingFileHandler* self);
VALA_EXTERN gint dvb_logging_file_handler_get_count (DVBLoggingFileHandler* self);
VALA_EXTERN const gchar* dvb_logging_file_handler_get_pattern (DVBLoggingFileHandler* self);
VALA_EXTERN void dvb_logging_file_handler_set_limit (DVBLoggingFileHandler* self,
                                         gint value);
VALA_EXTERN void dvb_logging_file_handler_set_count (DVBLoggingFileHandler* self,
                                         gint value);
static void dvb_logging_file_handler_set_pattern (DVBLoggingFileHandler* self,
                                           const gchar* value);
static void dvb_logging_file_handler_finalize (GObject * obj);
static GType dvb_logging_file_handler_get_type_once (void);
static void _vala_dvb_logging_file_handler_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_dvb_logging_file_handler_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN void dvb_logging_logger_addHandler (DVBLoggingLogger* self,
                                    DVBLoggingHandler* handler);
VALA_EXTERN void dvb_logging_logger_removeHandler (DVBLoggingLogger* self,
                                       DVBLoggingHandler* handler);
VALA_EXTERN GeeHashSet* dvb_logging_logger_getHandlers (DVBLoggingLogger* self);
static inline void dvb_logging_logger_log_full (DVBLoggingLogger* self,
                                  DVBLoggingLogLevel level,
                                  const gchar* format,
                                  va_list args);
VALA_EXTERN const gchar* dvb_logging_logger_get_name (DVBLoggingLogger* self);
VALA_EXTERN void dvb_logging_logger_log (DVBLoggingLogger* self,
                             const gchar* format,
                             ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_logging_logger_info (DVBLoggingLogger* self,
                              const gchar* format,
                              ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_logging_logger_warning (DVBLoggingLogger* self,
                                 const gchar* format,
                                 ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN DVBLoggingLogger* dvb_logging_logger_new (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_logger_construct (GType object_type);
VALA_EXTERN void dvb_logging_logger_set_name (DVBLoggingLogger* self,
                                  const gchar* value);
static GObject * dvb_logging_logger_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void dvb_logging_logger_finalize (GObject * obj);
static GType dvb_logging_logger_get_type_once (void);
static void _vala_dvb_logging_logger_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_dvb_logging_logger_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_new (void);
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_construct (GType object_type);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getLogger (DVBLoggingLogManager* self,
                                                     const gchar* name);
static DVBLoggingLogger* dvb_logging_log_manager_createLogger (DVBLoggingLogManager* self,
                                                        const gchar* name);
VALA_EXTERN void dvb_logging_log_manager_cleanup (DVBLoggingLogManager* self);
static GObject * dvb_logging_log_manager_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void dvb_logging_log_manager_finalize (GObject * obj);
static GType dvb_logging_log_manager_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
dvb_logging_log_level_get_type_once (void)
{
	static const GEnumValue values[] = {{DVB_LOGGING_LOG_LEVEL_LOG, "DVB_LOGGING_LOG_LEVEL_LOG", "log"}, {DVB_LOGGING_LOG_LEVEL_DEBUG, "DVB_LOGGING_LOG_LEVEL_DEBUG", "debug"}, {DVB_LOGGING_LOG_LEVEL_INFO, "DVB_LOGGING_LOG_LEVEL_INFO", "info"}, {DVB_LOGGING_LOG_LEVEL_WARNING, "DVB_LOGGING_LOG_LEVEL_WARNING", "warning"}, {DVB_LOGGING_LOG_LEVEL_ERROR, "DVB_LOGGING_LOG_LEVEL_ERROR", "error"}, {0, NULL, NULL}};
	GType dvb_logging_log_level_type_id;
	dvb_logging_log_level_type_id = g_enum_register_static ("DVBLoggingLogLevel", values);
	return dvb_logging_log_level_type_id;
}

GType
dvb_logging_log_level_get_type (void)
{
	static volatile gsize dvb_logging_log_level_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_log_level_type_id__once)) {
		GType dvb_logging_log_level_type_id;
		dvb_logging_log_level_type_id = dvb_logging_log_level_get_type_once ();
		g_once_init_leave (&dvb_logging_log_level_type_id__once, dvb_logging_log_level_type_id);
	}
	return dvb_logging_log_level_type_id__once;
}

gchar*
dvb_logging_formatter_format (DVBLoggingFormatter* self,
                              const gchar* logger_name,
                              DVBLoggingLogLevel level,
                              const gchar* format)
{
	DVBLoggingFormatterIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_LOGGING_FORMATTER_GET_INTERFACE (self);
	if (_iface_->format) {
		return _iface_->format (self, logger_name, level, format);
	}
	return NULL;
}

static void
dvb_logging_formatter_default_init (DVBLoggingFormatterIface * iface,
                                    gpointer iface_data)
{
}

static GType
dvb_logging_formatter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingFormatterIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_formatter_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_logging_formatter_type_id;
	dvb_logging_formatter_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBLoggingFormatter", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_logging_formatter_type_id, G_TYPE_OBJECT);
	return dvb_logging_formatter_type_id;
}

GType
dvb_logging_formatter_get_type (void)
{
	static volatile gsize dvb_logging_formatter_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_formatter_type_id__once)) {
		GType dvb_logging_formatter_type_id;
		dvb_logging_formatter_type_id = dvb_logging_formatter_get_type_once ();
		g_once_init_leave (&dvb_logging_formatter_type_id__once, dvb_logging_formatter_type_id);
	}
	return dvb_logging_formatter_type_id__once;
}

void
dvb_logging_handler_publish (DVBLoggingHandler* self,
                             const gchar* logger_name,
                             DVBLoggingLogLevel level,
                             const gchar* format,
                             va_list args)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->publish) {
		_iface_->publish (self, logger_name, level, format, args);
	}
}

void
dvb_logging_handler_close (DVBLoggingHandler* self)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->close) {
		_iface_->close (self);
	}
}

DVBLoggingFormatter*
dvb_logging_handler_get_formatter (DVBLoggingHandler* self)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->get_formatter) {
		return _iface_->get_formatter (self);
	}
	return NULL;
}

void
dvb_logging_handler_set_formatter (DVBLoggingHandler* self,
                                   DVBLoggingFormatter* value)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->set_formatter) {
		_iface_->set_formatter (self, value);
	}
}

DVBLoggingLogLevel
dvb_logging_handler_get_threshold (DVBLoggingHandler* self)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->get_threshold) {
		return _iface_->get_threshold (self);
	}
	return 0;
}

void
dvb_logging_handler_set_threshold (DVBLoggingHandler* self,
                                   DVBLoggingLogLevel value)
{
	DVBLoggingHandlerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_LOGGING_HANDLER_GET_INTERFACE (self);
	if (_iface_->set_threshold) {
		_iface_->set_threshold (self, value);
	}
}

static void
dvb_logging_handler_default_init (DVBLoggingHandlerIface * iface,
                                  gpointer iface_data)
{
	g_object_interface_install_property (iface, g_param_spec_object ("formatter", "formatter", "formatter", DVB_LOGGING_TYPE_FORMATTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_interface_install_property (iface, g_param_spec_enum ("threshold", "threshold", "threshold", DVB_LOGGING_TYPE_LOG_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static GType
dvb_logging_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingHandlerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_handler_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_logging_handler_type_id;
	dvb_logging_handler_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBLoggingHandler", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_logging_handler_type_id, G_TYPE_OBJECT);
	return dvb_logging_handler_type_id;
}

GType
dvb_logging_handler_get_type (void)
{
	static volatile gsize dvb_logging_handler_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_handler_type_id__once)) {
		GType dvb_logging_handler_type_id;
		dvb_logging_handler_type_id = dvb_logging_handler_get_type_once ();
		g_once_init_leave (&dvb_logging_handler_type_id__once, dvb_logging_handler_type_id);
	}
	return dvb_logging_handler_type_id__once;
}

static gchar*
dvb_logging_default_formatter_real_get_level_name (DVBLoggingDefaultFormatter* self,
                                                   DVBLoggingLogLevel level)
{
	gchar* lvlstr = NULL;
	gchar* result;
	lvlstr = NULL;
	switch (level) {
		case DVB_LOGGING_LOG_LEVEL_LOG:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("LOG");
			_g_free0 (lvlstr);
			lvlstr = _tmp0_;
			break;
		}
		case DVB_LOGGING_LOG_LEVEL_DEBUG:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("DEBUG");
			_g_free0 (lvlstr);
			lvlstr = _tmp1_;
			break;
		}
		case DVB_LOGGING_LOG_LEVEL_INFO:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("INFO");
			_g_free0 (lvlstr);
			lvlstr = _tmp2_;
			break;
		}
		case DVB_LOGGING_LOG_LEVEL_WARNING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("WARNING");
			_g_free0 (lvlstr);
			lvlstr = _tmp3_;
			break;
		}
		case DVB_LOGGING_LOG_LEVEL_ERROR:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("ERROR");
			_g_free0 (lvlstr);
			lvlstr = _tmp4_;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	result = lvlstr;
	return result;
}

gchar*
dvb_logging_default_formatter_get_level_name (DVBLoggingDefaultFormatter* self,
                                              DVBLoggingLogLevel level)
{
	DVBLoggingDefaultFormatterClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = DVB_LOGGING_DEFAULT_FORMATTER_GET_CLASS (self);
	if (_klass_->get_level_name) {
		return _klass_->get_level_name (self, level);
	}
	return NULL;
}

static gchar*
dvb_logging_default_formatter_real_format (DVBLoggingDefaultFormatter* self,
                                           const gchar* logger_name,
                                           DVBLoggingLogLevel level,
                                           const gchar* format)
{
	gchar* lvlstr = NULL;
	gchar* _tmp0_;
	gchar* msg = NULL;
	gchar* _tmp1_;
	gchar* result;
	g_return_val_if_fail (logger_name != NULL, NULL);
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = dvb_logging_default_formatter_get_level_name (self, level);
	lvlstr = _tmp0_;
	_tmp1_ = g_strdup_printf ("%-12s %-12s %s\n", logger_name, lvlstr, format);
	msg = _tmp1_;
	result = msg;
	_g_free0 (lvlstr);
	return result;
}

gchar*
dvb_logging_default_formatter_format (DVBLoggingDefaultFormatter* self,
                                      const gchar* logger_name,
                                      DVBLoggingLogLevel level,
                                      const gchar* format)
{
	DVBLoggingDefaultFormatterClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = DVB_LOGGING_DEFAULT_FORMATTER_GET_CLASS (self);
	if (_klass_->format) {
		return _klass_->format (self, logger_name, level, format);
	}
	return NULL;
}

DVBLoggingDefaultFormatter*
dvb_logging_default_formatter_construct (GType object_type)
{
	DVBLoggingDefaultFormatter * self = NULL;
	self = (DVBLoggingDefaultFormatter*) g_object_new (object_type, NULL);
	return self;
}

DVBLoggingDefaultFormatter*
dvb_logging_default_formatter_new (void)
{
	return dvb_logging_default_formatter_construct (DVB_LOGGING_TYPE_DEFAULT_FORMATTER);
}

static void
dvb_logging_default_formatter_class_init (DVBLoggingDefaultFormatterClass * klass,
                                          gpointer klass_data)
{
	dvb_logging_default_formatter_parent_class = g_type_class_peek_parent (klass);
	((DVBLoggingDefaultFormatterClass *) klass)->get_level_name = (gchar* (*) (DVBLoggingDefaultFormatter*, DVBLoggingLogLevel)) dvb_logging_default_formatter_real_get_level_name;
	((DVBLoggingDefaultFormatterClass *) klass)->format = (gchar* (*) (DVBLoggingDefaultFormatter*, const gchar*, DVBLoggingLogLevel, const gchar*)) dvb_logging_default_formatter_real_format;
}

static void
dvb_logging_default_formatter_dvb_logging_formatter_interface_init (DVBLoggingFormatterIface * iface,
                                                                    gpointer iface_data)
{
	dvb_logging_default_formatter_dvb_logging_formatter_parent_iface = g_type_interface_peek_parent (iface);
	iface->format = (gchar* (*) (DVBLoggingFormatter*, const gchar*, DVBLoggingLogLevel, const gchar*)) dvb_logging_default_formatter_format;
}

static void
dvb_logging_default_formatter_instance_init (DVBLoggingDefaultFormatter * self,
                                             gpointer klass)
{
}

static GType
dvb_logging_default_formatter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingDefaultFormatterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_default_formatter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingDefaultFormatter), 0, (GInstanceInitFunc) dvb_logging_default_formatter_instance_init, NULL };
	static const GInterfaceInfo dvb_logging_formatter_info = { (GInterfaceInitFunc) dvb_logging_default_formatter_dvb_logging_formatter_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_logging_default_formatter_type_id;
	dvb_logging_default_formatter_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBLoggingDefaultFormatter", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_logging_default_formatter_type_id, DVB_LOGGING_TYPE_FORMATTER, &dvb_logging_formatter_info);
	return dvb_logging_default_formatter_type_id;
}

GType
dvb_logging_default_formatter_get_type (void)
{
	static volatile gsize dvb_logging_default_formatter_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_default_formatter_type_id__once)) {
		GType dvb_logging_default_formatter_type_id;
		dvb_logging_default_formatter_type_id = dvb_logging_default_formatter_get_type_once ();
		g_once_init_leave (&dvb_logging_default_formatter_type_id__once, dvb_logging_default_formatter_type_id);
	}
	return dvb_logging_default_formatter_type_id__once;
}

static gchar*
dvb_logging_color_formatter_real_get_level_name (DVBLoggingDefaultFormatter* base,
                                                 DVBLoggingLogLevel level)
{
	DVBLoggingColorFormatter * self;
	gchar* lvlstr = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	self = (DVBLoggingColorFormatter*) base;
	_tmp0_ = DVB_LOGGING_DEFAULT_FORMATTER_CLASS (dvb_logging_color_formatter_parent_class)->get_level_name (G_TYPE_CHECK_INSTANCE_CAST (self, DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatter), level);
	lvlstr = _tmp0_;
	_tmp1_ = dvb_logging_color_formatter_colormap;
	_tmp1__length1 = dvb_logging_color_formatter_colormap_length1;
	_tmp2_ = _tmp1_[level];
	_tmp3_ = g_strdup_printf ("%s%s%s", _tmp2_, lvlstr, DVB_LOGGING_COLOR_FORMATTER_clear);
	result = _tmp3_;
	_g_free0 (lvlstr);
	return result;
}

static gchar*
dvb_logging_color_formatter_real_format (DVBLoggingDefaultFormatter* base,
                                         const gchar* logger_name,
                                         DVBLoggingLogLevel level,
                                         const gchar* format)
{
	DVBLoggingColorFormatter * self;
	gchar* lvlstr = NULL;
	gchar* _tmp0_;
	gchar* msg = NULL;
	gchar* result;
	self = (DVBLoggingColorFormatter*) base;
	g_return_val_if_fail (logger_name != NULL, NULL);
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = dvb_logging_default_formatter_get_level_name ((DVBLoggingDefaultFormatter*) self, level);
	lvlstr = _tmp0_;
	if (level < DVB_LOGGING_LOG_LEVEL_INFO) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = lvlstr;
		_tmp2_ = g_strdup_printf ("%-12s %-20s %s\n", logger_name, _tmp1_, format);
		_g_free0 (msg);
		msg = _tmp2_;
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = lvlstr;
		_tmp4_ = g_strdup_printf ("%-12s %-23s %s\n", logger_name, _tmp3_, format);
		_g_free0 (msg);
		msg = _tmp4_;
	}
	result = msg;
	_g_free0 (lvlstr);
	return result;
}

DVBLoggingColorFormatter*
dvb_logging_color_formatter_construct (GType object_type)
{
	DVBLoggingColorFormatter * self = NULL;
	self = (DVBLoggingColorFormatter*) dvb_logging_default_formatter_construct (object_type);
	return self;
}

DVBLoggingColorFormatter*
dvb_logging_color_formatter_new (void)
{
	return dvb_logging_color_formatter_construct (DVB_LOGGING_TYPE_COLOR_FORMATTER);
}

static void
dvb_logging_color_formatter_class_init (DVBLoggingColorFormatterClass * klass,
                                        gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	dvb_logging_color_formatter_parent_class = g_type_class_peek_parent (klass);
	((DVBLoggingDefaultFormatterClass *) klass)->get_level_name = (gchar* (*) (DVBLoggingDefaultFormatter*, DVBLoggingLogLevel)) dvb_logging_color_formatter_real_get_level_name;
	((DVBLoggingDefaultFormatterClass *) klass)->format = (gchar* (*) (DVBLoggingDefaultFormatter*, const gchar*, DVBLoggingLogLevel, const gchar*)) dvb_logging_color_formatter_real_format;
	G_OBJECT_CLASS (klass)->finalize = dvb_logging_color_formatter_finalize;
	_tmp0_ = g_strdup ("\033[37m");
	_tmp1_ = g_strdup ("\033[36m");
	_tmp2_ = g_strdup ("\033[32;01m");
	_tmp3_ = g_strdup ("\033[33;01m");
	_tmp4_ = g_strdup ("\033[31;01m");
	_tmp5_ = g_new0 (gchar*, 5 + 1);
	_tmp5_[0] = _tmp0_;
	_tmp5_[1] = _tmp1_;
	_tmp5_[2] = _tmp2_;
	_tmp5_[3] = _tmp3_;
	_tmp5_[4] = _tmp4_;
	dvb_logging_color_formatter_colormap = _tmp5_;
	dvb_logging_color_formatter_colormap_length1 = 5;
	_dvb_logging_color_formatter_colormap_size_ = dvb_logging_color_formatter_colormap_length1;
}

static void
dvb_logging_color_formatter_instance_init (DVBLoggingColorFormatter * self,
                                           gpointer klass)
{
}

static void
dvb_logging_color_formatter_finalize (GObject * obj)
{
	DVBLoggingColorFormatter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatter);
	G_OBJECT_CLASS (dvb_logging_color_formatter_parent_class)->finalize (obj);
}

static GType
dvb_logging_color_formatter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingColorFormatterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_color_formatter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingColorFormatter), 0, (GInstanceInitFunc) dvb_logging_color_formatter_instance_init, NULL };
	GType dvb_logging_color_formatter_type_id;
	dvb_logging_color_formatter_type_id = g_type_register_static (DVB_LOGGING_TYPE_DEFAULT_FORMATTER, "DVBLoggingColorFormatter", &g_define_type_info, 0);
	return dvb_logging_color_formatter_type_id;
}

GType
dvb_logging_color_formatter_get_type (void)
{
	static volatile gsize dvb_logging_color_formatter_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_color_formatter_type_id__once)) {
		GType dvb_logging_color_formatter_type_id;
		dvb_logging_color_formatter_type_id = dvb_logging_color_formatter_get_type_once ();
		g_once_init_leave (&dvb_logging_color_formatter_type_id__once, dvb_logging_color_formatter_type_id);
	}
	return dvb_logging_color_formatter_type_id__once;
}

static inline gpointer
dvb_logging_console_handler_get_instance_private (DVBLoggingConsoleHandler* self)
{
	return G_STRUCT_MEMBER_P (self, DVBLoggingConsoleHandler_private_offset);
}

static void
dvb_logging_console_handler_real_publish (DVBLoggingHandler* base,
                                          const gchar* logger_name,
                                          DVBLoggingLogLevel level,
                                          const gchar* format,
                                          va_list args)
{
	DVBLoggingConsoleHandler * self;
	DVBLoggingLogLevel _tmp0_;
	DVBLoggingLogLevel _tmp1_;
	gchar* msg = NULL;
	DVBLoggingFormatter* _tmp2_;
	DVBLoggingFormatter* _tmp3_;
	gchar* _tmp4_;
	self = (DVBLoggingConsoleHandler*) base;
	g_return_if_fail (logger_name != NULL);
	g_return_if_fail (format != NULL);
	_tmp0_ = dvb_logging_handler_get_threshold ((DVBLoggingHandler*) self);
	_tmp1_ = _tmp0_;
	if (level < _tmp1_) {
		return;
	}
	_tmp2_ = dvb_logging_handler_get_formatter ((DVBLoggingHandler*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = dvb_logging_formatter_format (_tmp3_, logger_name, level, format);
	msg = _tmp4_;
	if (level > DVB_LOGGING_LOG_LEVEL_INFO) {
		FILE* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = stderr;
		_tmp6_ = msg;
		vfprintf (_tmp5_, _tmp6_, args);
	} else {
		FILE* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = stdout;
		_tmp8_ = msg;
		vfprintf (_tmp7_, _tmp8_, args);
	}
	_g_free0 (msg);
}

static void
dvb_logging_console_handler_real_close (DVBLoggingHandler* base)
{
	DVBLoggingConsoleHandler * self;
	self = (DVBLoggingConsoleHandler*) base;
}

DVBLoggingConsoleHandler*
dvb_logging_console_handler_construct (GType object_type)
{
	DVBLoggingConsoleHandler * self = NULL;
	self = (DVBLoggingConsoleHandler*) g_object_new (object_type, NULL);
	return self;
}

DVBLoggingConsoleHandler*
dvb_logging_console_handler_new (void)
{
	return dvb_logging_console_handler_construct (DVB_LOGGING_TYPE_CONSOLE_HANDLER);
}

static DVBLoggingFormatter*
dvb_logging_console_handler_real_get_formatter (DVBLoggingHandler* base)
{
	DVBLoggingFormatter* result;
	DVBLoggingConsoleHandler* self;
	DVBLoggingFormatter* _tmp0_;
	self = (DVBLoggingConsoleHandler*) base;
	_tmp0_ = self->priv->_formatter;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
dvb_logging_console_handler_real_set_formatter (DVBLoggingHandler* base,
                                                DVBLoggingFormatter* value)
{
	DVBLoggingConsoleHandler* self;
	DVBLoggingFormatter* old_value;
	self = (DVBLoggingConsoleHandler*) base;
	old_value = dvb_logging_console_handler_real_get_formatter (base);
	if (old_value != value) {
		DVBLoggingFormatter* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_formatter);
		self->priv->_formatter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_console_handler_properties[DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY]);
	}
}

static DVBLoggingLogLevel
dvb_logging_console_handler_real_get_threshold (DVBLoggingHandler* base)
{
	DVBLoggingLogLevel result;
	DVBLoggingConsoleHandler* self;
	self = (DVBLoggingConsoleHandler*) base;
	result = self->priv->_threshold;
	return result;
}

static void
dvb_logging_console_handler_real_set_threshold (DVBLoggingHandler* base,
                                                DVBLoggingLogLevel value)
{
	DVBLoggingConsoleHandler* self;
	DVBLoggingLogLevel old_value;
	self = (DVBLoggingConsoleHandler*) base;
	old_value = dvb_logging_console_handler_real_get_threshold (base);
	if (old_value != value) {
		self->priv->_threshold = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_console_handler_properties[DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY]);
	}
}

static void
dvb_logging_console_handler_class_init (DVBLoggingConsoleHandlerClass * klass,
                                        gpointer klass_data)
{
	dvb_logging_console_handler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBLoggingConsoleHandler_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_logging_console_handler_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_logging_console_handler_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_logging_console_handler_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY, dvb_logging_console_handler_properties[DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY] = g_param_spec_object ("formatter", "formatter", "formatter", DVB_LOGGING_TYPE_FORMATTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY, dvb_logging_console_handler_properties[DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY] = g_param_spec_enum ("threshold", "threshold", "threshold", DVB_LOGGING_TYPE_LOG_LEVEL, DVB_LOGGING_LOG_LEVEL_LOG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
dvb_logging_console_handler_dvb_logging_handler_interface_init (DVBLoggingHandlerIface * iface,
                                                                gpointer iface_data)
{
	dvb_logging_console_handler_dvb_logging_handler_parent_iface = g_type_interface_peek_parent (iface);
	iface->publish = (void (*) (DVBLoggingHandler*, const gchar*, DVBLoggingLogLevel, const gchar*, va_list)) dvb_logging_console_handler_real_publish;
	iface->close = (void (*) (DVBLoggingHandler*)) dvb_logging_console_handler_real_close;
	iface->get_formatter = dvb_logging_console_handler_real_get_formatter;
	iface->set_formatter = dvb_logging_console_handler_real_set_formatter;
	iface->get_threshold = dvb_logging_console_handler_real_get_threshold;
	iface->set_threshold = dvb_logging_console_handler_real_set_threshold;
}

static void
dvb_logging_console_handler_instance_init (DVBLoggingConsoleHandler * self,
                                           gpointer klass)
{
	DVBLoggingDefaultFormatter* _tmp0_;
	self->priv = dvb_logging_console_handler_get_instance_private (self);
	_tmp0_ = dvb_logging_default_formatter_new ();
	self->priv->_formatter = (DVBLoggingFormatter*) _tmp0_;
	self->priv->_threshold = DVB_LOGGING_LOG_LEVEL_LOG;
}

static void
dvb_logging_console_handler_finalize (GObject * obj)
{
	DVBLoggingConsoleHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandler);
	_g_object_unref0 (self->priv->_formatter);
	G_OBJECT_CLASS (dvb_logging_console_handler_parent_class)->finalize (obj);
}

static GType
dvb_logging_console_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingConsoleHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_console_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingConsoleHandler), 0, (GInstanceInitFunc) dvb_logging_console_handler_instance_init, NULL };
	static const GInterfaceInfo dvb_logging_handler_info = { (GInterfaceInitFunc) dvb_logging_console_handler_dvb_logging_handler_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_logging_console_handler_type_id;
	dvb_logging_console_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBLoggingConsoleHandler", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_logging_console_handler_type_id, DVB_LOGGING_TYPE_HANDLER, &dvb_logging_handler_info);
	DVBLoggingConsoleHandler_private_offset = g_type_add_instance_private (dvb_logging_console_handler_type_id, sizeof (DVBLoggingConsoleHandlerPrivate));
	return dvb_logging_console_handler_type_id;
}

GType
dvb_logging_console_handler_get_type (void)
{
	static volatile gsize dvb_logging_console_handler_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_console_handler_type_id__once)) {
		GType dvb_logging_console_handler_type_id;
		dvb_logging_console_handler_type_id = dvb_logging_console_handler_get_type_once ();
		g_once_init_leave (&dvb_logging_console_handler_type_id__once, dvb_logging_console_handler_type_id);
	}
	return dvb_logging_console_handler_type_id__once;
}

static void
_vala_dvb_logging_console_handler_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	DVBLoggingConsoleHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandler);
	switch (property_id) {
		case DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY:
		g_value_set_object (value, dvb_logging_handler_get_formatter ((DVBLoggingHandler*) self));
		break;
		case DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY:
		g_value_set_enum (value, dvb_logging_handler_get_threshold ((DVBLoggingHandler*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_logging_console_handler_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	DVBLoggingConsoleHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandler);
	switch (property_id) {
		case DVB_LOGGING_CONSOLE_HANDLER_FORMATTER_PROPERTY:
		dvb_logging_handler_set_formatter ((DVBLoggingHandler*) self, g_value_get_object (value));
		break;
		case DVB_LOGGING_CONSOLE_HANDLER_THRESHOLD_PROPERTY:
		dvb_logging_handler_set_threshold ((DVBLoggingHandler*) self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
dvb_logging_file_handler_get_instance_private (DVBLoggingFileHandler* self)
{
	return G_STRUCT_MEMBER_P (self, DVBLoggingFileHandler_private_offset);
}

DVBLoggingFileHandler*
dvb_logging_file_handler_construct (GType object_type,
                                    const gchar* file_pattern,
                                    GError** error)
{
	DVBLoggingFileHandler * self = NULL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (file_pattern != NULL, NULL);
	self = (DVBLoggingFileHandler*) g_object_new (object_type, "pattern", file_pattern, NULL);
	self->priv->file_index = 0;
	dvb_logging_file_handler_rotate (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}

DVBLoggingFileHandler*
dvb_logging_file_handler_new (const gchar* file_pattern,
                              GError** error)
{
	return dvb_logging_file_handler_construct (DVB_LOGGING_TYPE_FILE_HANDLER, file_pattern, error);
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static void
dvb_logging_file_handler_real_publish (DVBLoggingHandler* base,
                                       const gchar* logger_name,
                                       DVBLoggingLogLevel level,
                                       const gchar* format,
                                       va_list args)
{
	DVBLoggingFileHandler * self;
	DVBLoggingLogLevel _tmp0_;
	DVBLoggingLogLevel _tmp1_;
	gchar* msg = NULL;
	DVBLoggingFormatter* _tmp2_;
	DVBLoggingFormatter* _tmp3_;
	gchar* _tmp4_;
	gchar* txt = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	self = (DVBLoggingFileHandler*) base;
	g_return_if_fail (logger_name != NULL);
	g_return_if_fail (format != NULL);
	_tmp0_ = dvb_logging_handler_get_threshold ((DVBLoggingHandler*) self);
	_tmp1_ = _tmp0_;
	if (level < _tmp1_) {
		return;
	}
	_tmp2_ = dvb_logging_handler_get_formatter ((DVBLoggingHandler*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = dvb_logging_formatter_format (_tmp3_, logger_name, level, format);
	msg = _tmp4_;
	_tmp5_ = msg;
	_tmp6_ = g_strdup_vprintf (_tmp5_, args);
	txt = _tmp6_;
	{
		gint _tmp7_;
		GOutputStream* _tmp12_;
		const gchar* _tmp13_;
		guint8* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_ = 0;
		guint8* _tmp16_;
		gint _tmp16__length1;
		_tmp7_ = self->priv->_limit;
		if (_tmp7_ > 0) {
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp8_ = txt;
			_tmp9_ = strlen (_tmp8_);
			_tmp10_ = _tmp9_;
			self->priv->file_size = self->priv->file_size + _tmp10_;
			_tmp11_ = self->priv->_limit;
			if (self->priv->file_size > _tmp11_) {
				dvb_logging_file_handler_rotate (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
		}
		_tmp12_ = self->priv->os;
		_tmp13_ = txt;
		_tmp14_ = string_get_data (_tmp13_, &_tmp15_);
		_tmp14__length1 = _tmp15_;
		_tmp16_ = _tmp14_;
		_tmp16__length1 = _tmp14__length1;
		g_output_stream_write (_tmp12_, _tmp16_, (gsize) _tmp16__length1, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = stderr;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		fprintf (_tmp17_, "Error in FileHandler.publish: %s\n", _tmp19_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (txt);
		_g_free0 (msg);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (txt);
	_g_free0 (msg);
}

static void
dvb_logging_file_handler_real_close (DVBLoggingHandler* base)
{
	DVBLoggingFileHandler * self;
	GError* _inner_error0_ = NULL;
	self = (DVBLoggingFileHandler*) base;
	{
		GOutputStream* _tmp0_;
		_tmp0_ = self->priv->os;
		g_output_stream_close (_tmp0_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = stderr;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		fprintf (_tmp1_, "Error in FileHandler.close: %s\n", _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
dvb_logging_file_handler_rotate (DVBLoggingFileHandler* self,
                                 GError** error)
{
	GOutputStream* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFileOutputStream* fos = NULL;
	GFile* _tmp2_;
	GFileOutputStream* _tmp11_;
	GBufferedOutputStream* _tmp12_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->os;
	if (_tmp0_ != NULL) {
		dvb_logging_handler_close ((DVBLoggingHandler*) self);
	}
	_tmp1_ = dvb_logging_file_handler_get_next_file (self);
	file = _tmp1_;
	_tmp2_ = file;
	if (g_file_query_exists (_tmp2_, NULL)) {
		GFileOutputStream* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileOutputStream* _tmp5_;
		GFileOutputStream* _tmp6_;
		_tmp4_ = file;
		_tmp5_ = g_file_replace (_tmp4_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (fos);
			_g_object_unref0 (file);
			return;
		}
		_tmp6_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (fos);
		fos = _tmp6_;
		_g_object_unref0 (_tmp3_);
	} else {
		GFileOutputStream* _tmp7_ = NULL;
		GFile* _tmp8_;
		GFileOutputStream* _tmp9_;
		GFileOutputStream* _tmp10_;
		_tmp8_ = file;
		_tmp9_ = g_file_create (_tmp8_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (fos);
			_g_object_unref0 (file);
			return;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		_g_object_unref0 (fos);
		fos = _tmp10_;
		_g_object_unref0 (_tmp7_);
	}
	_tmp11_ = fos;
	_tmp12_ = (GBufferedOutputStream*) g_buffered_output_stream_new ((GOutputStream*) _tmp11_);
	_g_object_unref0 (self->priv->os);
	self->priv->os = (GOutputStream*) _tmp12_;
	self->priv->file_size = 0;
	_g_object_unref0 (fos);
	_g_object_unref0 (file);
}

static GFile*
dvb_logging_file_handler_get_next_file (DVBLoggingFileHandler* self)
{
	gint _tmp0_;
	gchar* filename = NULL;
	const gchar* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_count;
	if (self->priv->file_index == _tmp0_) {
		self->priv->file_index = 0;
	}
	_tmp1_ = self->priv->_pattern;
	_tmp2_ = self->priv->file_index;
	self->priv->file_index = _tmp2_ + 1;
	_tmp3_ = g_strdup_printf (_tmp1_, _tmp2_);
	filename = _tmp3_;
	_tmp4_ = g_file_new_for_path (filename);
	result = _tmp4_;
	_g_free0 (filename);
	return result;
}

static DVBLoggingFormatter*
dvb_logging_file_handler_real_get_formatter (DVBLoggingHandler* base)
{
	DVBLoggingFormatter* result;
	DVBLoggingFileHandler* self;
	DVBLoggingFormatter* _tmp0_;
	self = (DVBLoggingFileHandler*) base;
	_tmp0_ = self->priv->_formatter;
	result = _tmp0_;
	return result;
}

static void
dvb_logging_file_handler_real_set_formatter (DVBLoggingHandler* base,
                                             DVBLoggingFormatter* value)
{
	DVBLoggingFileHandler* self;
	DVBLoggingFormatter* old_value;
	self = (DVBLoggingFileHandler*) base;
	old_value = dvb_logging_file_handler_real_get_formatter (base);
	if (old_value != value) {
		DVBLoggingFormatter* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_formatter);
		self->priv->_formatter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY]);
	}
}

static DVBLoggingLogLevel
dvb_logging_file_handler_real_get_threshold (DVBLoggingHandler* base)
{
	DVBLoggingLogLevel result;
	DVBLoggingFileHandler* self;
	self = (DVBLoggingFileHandler*) base;
	result = self->priv->_threshold;
	return result;
}

static void
dvb_logging_file_handler_real_set_threshold (DVBLoggingHandler* base,
                                             DVBLoggingLogLevel value)
{
	DVBLoggingFileHandler* self;
	DVBLoggingLogLevel old_value;
	self = (DVBLoggingFileHandler*) base;
	old_value = dvb_logging_file_handler_real_get_threshold (base);
	if (old_value != value) {
		self->priv->_threshold = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY]);
	}
}

gint
dvb_logging_file_handler_get_limit (DVBLoggingFileHandler* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_limit;
	return result;
}

void
dvb_logging_file_handler_set_limit (DVBLoggingFileHandler* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_logging_file_handler_get_limit (self);
	if (old_value != value) {
		self->priv->_limit = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY]);
	}
}

gint
dvb_logging_file_handler_get_count (DVBLoggingFileHandler* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_count;
	return result;
}

void
dvb_logging_file_handler_set_count (DVBLoggingFileHandler* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_logging_file_handler_get_count (self);
	if (old_value != value) {
		self->priv->_count = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY]);
	}
}

const gchar*
dvb_logging_file_handler_get_pattern (DVBLoggingFileHandler* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pattern;
	result = _tmp0_;
	return result;
}

static void
dvb_logging_file_handler_set_pattern (DVBLoggingFileHandler* self,
                                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_logging_file_handler_get_pattern (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_pattern);
		self->priv->_pattern = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY]);
	}
}

static void
dvb_logging_file_handler_class_init (DVBLoggingFileHandlerClass * klass,
                                     gpointer klass_data)
{
	dvb_logging_file_handler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBLoggingFileHandler_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_logging_file_handler_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_logging_file_handler_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_logging_file_handler_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY] = g_param_spec_object ("formatter", "formatter", "formatter", DVB_LOGGING_TYPE_FORMATTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY] = g_param_spec_enum ("threshold", "threshold", "threshold", DVB_LOGGING_TYPE_LOG_LEVEL, DVB_LOGGING_LOG_LEVEL_LOG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY] = g_param_spec_int ("limit", "limit", "limit", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY] = g_param_spec_int ("count", "count", "count", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY, dvb_logging_file_handler_properties[DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY] = g_param_spec_string ("pattern", "pattern", "pattern", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
dvb_logging_file_handler_dvb_logging_handler_interface_init (DVBLoggingHandlerIface * iface,
                                                             gpointer iface_data)
{
	dvb_logging_file_handler_dvb_logging_handler_parent_iface = g_type_interface_peek_parent (iface);
	iface->publish = (void (*) (DVBLoggingHandler*, const gchar*, DVBLoggingLogLevel, const gchar*, va_list)) dvb_logging_file_handler_real_publish;
	iface->close = (void (*) (DVBLoggingHandler*)) dvb_logging_file_handler_real_close;
	iface->get_formatter = dvb_logging_file_handler_real_get_formatter;
	iface->set_formatter = dvb_logging_file_handler_real_set_formatter;
	iface->get_threshold = dvb_logging_file_handler_real_get_threshold;
	iface->set_threshold = dvb_logging_file_handler_real_set_threshold;
}

static void
dvb_logging_file_handler_instance_init (DVBLoggingFileHandler * self,
                                        gpointer klass)
{
	DVBLoggingDefaultFormatter* _tmp0_;
	self->priv = dvb_logging_file_handler_get_instance_private (self);
	_tmp0_ = dvb_logging_default_formatter_new ();
	self->priv->_formatter = (DVBLoggingFormatter*) _tmp0_;
	self->priv->_threshold = DVB_LOGGING_LOG_LEVEL_LOG;
	self->priv->_limit = 0;
	self->priv->_count = 1;
}

static void
dvb_logging_file_handler_finalize (GObject * obj)
{
	DVBLoggingFileHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandler);
	_g_object_unref0 (self->priv->_formatter);
	_g_free0 (self->priv->_pattern);
	_g_object_unref0 (self->priv->os);
	G_OBJECT_CLASS (dvb_logging_file_handler_parent_class)->finalize (obj);
}

static GType
dvb_logging_file_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingFileHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_file_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingFileHandler), 0, (GInstanceInitFunc) dvb_logging_file_handler_instance_init, NULL };
	static const GInterfaceInfo dvb_logging_handler_info = { (GInterfaceInitFunc) dvb_logging_file_handler_dvb_logging_handler_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_logging_file_handler_type_id;
	dvb_logging_file_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBLoggingFileHandler", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_logging_file_handler_type_id, DVB_LOGGING_TYPE_HANDLER, &dvb_logging_handler_info);
	DVBLoggingFileHandler_private_offset = g_type_add_instance_private (dvb_logging_file_handler_type_id, sizeof (DVBLoggingFileHandlerPrivate));
	return dvb_logging_file_handler_type_id;
}

GType
dvb_logging_file_handler_get_type (void)
{
	static volatile gsize dvb_logging_file_handler_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_file_handler_type_id__once)) {
		GType dvb_logging_file_handler_type_id;
		dvb_logging_file_handler_type_id = dvb_logging_file_handler_get_type_once ();
		g_once_init_leave (&dvb_logging_file_handler_type_id__once, dvb_logging_file_handler_type_id);
	}
	return dvb_logging_file_handler_type_id__once;
}

static void
_vala_dvb_logging_file_handler_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	DVBLoggingFileHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandler);
	switch (property_id) {
		case DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY:
		g_value_set_object (value, dvb_logging_handler_get_formatter ((DVBLoggingHandler*) self));
		break;
		case DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY:
		g_value_set_enum (value, dvb_logging_handler_get_threshold ((DVBLoggingHandler*) self));
		break;
		case DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY:
		g_value_set_int (value, dvb_logging_file_handler_get_limit (self));
		break;
		case DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY:
		g_value_set_int (value, dvb_logging_file_handler_get_count (self));
		break;
		case DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY:
		g_value_set_string (value, dvb_logging_file_handler_get_pattern (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_logging_file_handler_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	DVBLoggingFileHandler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandler);
	switch (property_id) {
		case DVB_LOGGING_FILE_HANDLER_FORMATTER_PROPERTY:
		dvb_logging_handler_set_formatter ((DVBLoggingHandler*) self, g_value_get_object (value));
		break;
		case DVB_LOGGING_FILE_HANDLER_THRESHOLD_PROPERTY:
		dvb_logging_handler_set_threshold ((DVBLoggingHandler*) self, g_value_get_enum (value));
		break;
		case DVB_LOGGING_FILE_HANDLER_LIMIT_PROPERTY:
		dvb_logging_file_handler_set_limit (self, g_value_get_int (value));
		break;
		case DVB_LOGGING_FILE_HANDLER_COUNT_PROPERTY:
		dvb_logging_file_handler_set_count (self, g_value_get_int (value));
		break;
		case DVB_LOGGING_FILE_HANDLER_PATTERN_PROPERTY:
		dvb_logging_file_handler_set_pattern (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
dvb_logging_logger_get_instance_private (DVBLoggingLogger* self)
{
	return G_STRUCT_MEMBER_P (self, DVBLoggingLogger_private_offset);
}

void
dvb_logging_logger_addHandler (DVBLoggingLogger* self,
                               DVBLoggingHandler* handler)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (handler != NULL);
	{
		GeeHashSet* _tmp0_;
		_tmp0_ = self->priv->handlers;
		g_rec_mutex_lock (&self->priv->__lock_handlers);
		{
			GeeHashSet* _tmp1_;
			_tmp1_ = self->priv->handlers;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, handler);
		}
		__finally0:
		{
			GeeHashSet* _tmp2_;
			_tmp2_ = self->priv->handlers;
			g_rec_mutex_unlock (&self->priv->__lock_handlers);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_logging_logger_removeHandler (DVBLoggingLogger* self,
                                  DVBLoggingHandler* handler)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (handler != NULL);
	{
		GeeHashSet* _tmp0_;
		_tmp0_ = self->priv->handlers;
		g_rec_mutex_lock (&self->priv->__lock_handlers);
		{
			GeeHashSet* _tmp1_;
			_tmp1_ = self->priv->handlers;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, handler);
		}
		__finally0:
		{
			GeeHashSet* _tmp2_;
			_tmp2_ = self->priv->handlers;
			g_rec_mutex_unlock (&self->priv->__lock_handlers);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

GeeHashSet*
dvb_logging_logger_getHandlers (DVBLoggingLogger* self)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->handlers;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static inline void
dvb_logging_logger_log_full (DVBLoggingLogger* self,
                             DVBLoggingLogLevel level,
                             const gchar* format,
                             va_list args)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	{
		GeeHashSet* _tmp0_;
		_tmp0_ = self->priv->handlers;
		g_rec_mutex_lock (&self->priv->__lock_handlers);
		{
			{
				GeeIterator* _handler_it = NULL;
				GeeHashSet* _tmp1_;
				GeeIterator* _tmp2_;
				_tmp1_ = self->priv->handlers;
				_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
				_handler_it = _tmp2_;
				while (TRUE) {
					GeeIterator* _tmp3_;
					DVBLoggingHandler* handler = NULL;
					GeeIterator* _tmp4_;
					gpointer _tmp5_;
					va_list l = {0};
					DVBLoggingHandler* _tmp6_;
					const gchar* _tmp7_;
					_tmp3_ = _handler_it;
					if (!gee_iterator_next (_tmp3_)) {
						break;
					}
					_tmp4_ = _handler_it;
					_tmp5_ = gee_iterator_get (_tmp4_);
					handler = (DVBLoggingHandler*) _tmp5_;
					va_copy (l, args);
					_tmp6_ = handler;
					_tmp7_ = self->priv->_name;
					dvb_logging_handler_publish (_tmp6_, _tmp7_, level, format, l);
					va_end (l);
					_g_object_unref0 (handler);
				}
				_g_object_unref0 (_handler_it);
			}
		}
		__finally0:
		{
			GeeHashSet* _tmp8_;
			_tmp8_ = self->priv->handlers;
			g_rec_mutex_unlock (&self->priv->__lock_handlers);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_logging_logger_log (DVBLoggingLogger* self,
                        const gchar* format,
                        ...)
{
	va_list l = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	va_start (l, format);
	dvb_logging_logger_log_full (self, DVB_LOGGING_LOG_LEVEL_LOG, format, l);
	va_end (l);
}

void
dvb_logging_logger_debug (DVBLoggingLogger* self,
                          const gchar* format,
                          ...)
{
	va_list l = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	va_start (l, format);
	dvb_logging_logger_log_full (self, DVB_LOGGING_LOG_LEVEL_DEBUG, format, l);
	va_end (l);
}

void
dvb_logging_logger_info (DVBLoggingLogger* self,
                         const gchar* format,
                         ...)
{
	va_list l = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	va_start (l, format);
	dvb_logging_logger_log_full (self, DVB_LOGGING_LOG_LEVEL_INFO, format, l);
	va_end (l);
}

void
dvb_logging_logger_warning (DVBLoggingLogger* self,
                            const gchar* format,
                            ...)
{
	va_list l = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	va_start (l, format);
	dvb_logging_logger_log_full (self, DVB_LOGGING_LOG_LEVEL_WARNING, format, l);
	va_end (l);
}

void
dvb_logging_logger_error (DVBLoggingLogger* self,
                          const gchar* format,
                          ...)
{
	va_list l = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (format != NULL);
	va_start (l, format);
	dvb_logging_logger_log_full (self, DVB_LOGGING_LOG_LEVEL_ERROR, format, l);
	va_end (l);
}

DVBLoggingLogger*
dvb_logging_logger_construct (GType object_type)
{
	DVBLoggingLogger * self = NULL;
	self = (DVBLoggingLogger*) g_object_new (object_type, NULL);
	return self;
}

DVBLoggingLogger*
dvb_logging_logger_new (void)
{
	return dvb_logging_logger_construct (DVB_LOGGING_TYPE_LOGGER);
}

const gchar*
dvb_logging_logger_get_name (DVBLoggingLogger* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
dvb_logging_logger_set_name (DVBLoggingLogger* self,
                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_logging_logger_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_logging_logger_properties[DVB_LOGGING_LOGGER_NAME_PROPERTY]);
	}
}

static GObject *
dvb_logging_logger_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBLoggingLogger * self;
	gpointer _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeHashDataFunc _tmp2_;
	gpointer _tmp3_ = NULL;
	GDestroyNotify _tmp4_ = NULL;
	GeeEqualDataFunc _tmp5_;
	GeeHashSet* _tmp6_;
	parent_class = G_OBJECT_CLASS (dvb_logging_logger_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger);
	_tmp2_ = gee_functions_get_hash_func_for (DVB_LOGGING_TYPE_HANDLER, &_tmp0_, &_tmp1_);
	_tmp5_ = gee_functions_get_equal_func_for (DVB_LOGGING_TYPE_HANDLER, &_tmp3_, &_tmp4_);
	_tmp6_ = gee_hash_set_new (DVB_LOGGING_TYPE_HANDLER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_, _tmp0_, _tmp1_, _tmp5_, _tmp3_, _tmp4_);
	_g_object_unref0 (self->priv->handlers);
	self->priv->handlers = _tmp6_;
	return obj;
}

static void
dvb_logging_logger_class_init (DVBLoggingLoggerClass * klass,
                               gpointer klass_data)
{
	dvb_logging_logger_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBLoggingLogger_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_logging_logger_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_logging_logger_set_property;
	G_OBJECT_CLASS (klass)->constructor = dvb_logging_logger_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_logging_logger_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_LOGGING_LOGGER_NAME_PROPERTY, dvb_logging_logger_properties[DVB_LOGGING_LOGGER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
dvb_logging_logger_instance_init (DVBLoggingLogger * self,
                                  gpointer klass)
{
	self->priv = dvb_logging_logger_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_handlers);
}

static void
dvb_logging_logger_finalize (GObject * obj)
{
	DVBLoggingLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger);
	_g_free0 (self->priv->_name);
	g_rec_mutex_clear (&self->priv->__lock_handlers);
	_g_object_unref0 (self->priv->handlers);
	G_OBJECT_CLASS (dvb_logging_logger_parent_class)->finalize (obj);
}

static GType
dvb_logging_logger_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingLogger), 0, (GInstanceInitFunc) dvb_logging_logger_instance_init, NULL };
	GType dvb_logging_logger_type_id;
	dvb_logging_logger_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBLoggingLogger", &g_define_type_info, 0);
	DVBLoggingLogger_private_offset = g_type_add_instance_private (dvb_logging_logger_type_id, sizeof (DVBLoggingLoggerPrivate));
	return dvb_logging_logger_type_id;
}

GType
dvb_logging_logger_get_type (void)
{
	static volatile gsize dvb_logging_logger_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_logger_type_id__once)) {
		GType dvb_logging_logger_type_id;
		dvb_logging_logger_type_id = dvb_logging_logger_get_type_once ();
		g_once_init_leave (&dvb_logging_logger_type_id__once, dvb_logging_logger_type_id);
	}
	return dvb_logging_logger_type_id__once;
}

static void
_vala_dvb_logging_logger_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	DVBLoggingLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger);
	switch (property_id) {
		case DVB_LOGGING_LOGGER_NAME_PROPERTY:
		g_value_set_string (value, dvb_logging_logger_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_logging_logger_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	DVBLoggingLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger);
	switch (property_id) {
		case DVB_LOGGING_LOGGER_NAME_PROPERTY:
		dvb_logging_logger_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
dvb_logging_log_manager_get_instance_private (DVBLoggingLogManager* self)
{
	return G_STRUCT_MEMBER_P (self, DVBLoggingLogManager_private_offset);
}

DVBLoggingLogManager*
dvb_logging_log_manager_getLogManager (void)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogManager* _tmp2_;
	DVBLoggingLogManager* result;
	g_rec_mutex_lock (&dvb_logging_log_manager_instance_mutex);
	_tmp0_ = dvb_logging_log_manager_instance;
	if (_tmp0_ == NULL) {
		DVBLoggingLogManager* _tmp1_;
		_tmp1_ = dvb_logging_log_manager_new ();
		_g_object_unref0 (dvb_logging_log_manager_instance);
		dvb_logging_log_manager_instance = _tmp1_;
	}
	g_rec_mutex_unlock (&dvb_logging_log_manager_instance_mutex);
	_tmp2_ = dvb_logging_log_manager_instance;
	result = _tmp2_;
	return result;
}

DVBLoggingLogger*
dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self)
{
	DVBLoggingLogger* _tmp0_;
	DVBLoggingLogger* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = dvb_logging_log_manager_getLogger (self, DVB_LOGGING_LOG_MANAGER_DEFAULT_NAME);
	result = _tmp0_;
	return result;
}

DVBLoggingLogger*
dvb_logging_log_manager_getLogger (DVBLoggingLogManager* self,
                                   const gchar* name)
{
	DVBLoggingLogger* l = NULL;
	GError* _inner_error0_ = NULL;
	DVBLoggingLogger* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->loggers;
		g_rec_mutex_lock (&self->priv->__lock_loggers);
		{
			GeeHashMap* _tmp1_;
			_tmp1_ = self->priv->loggers;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, name)) {
				GeeHashMap* _tmp2_;
				gpointer _tmp3_;
				_tmp2_ = self->priv->loggers;
				_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, name);
				_g_object_unref0 (l);
				l = (DVBLoggingLogger*) _tmp3_;
			} else {
				DVBLoggingLogger* _tmp4_;
				_tmp4_ = dvb_logging_log_manager_createLogger (self, name);
				_g_object_unref0 (l);
				l = _tmp4_;
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp5_;
			_tmp5_ = self->priv->loggers;
			g_rec_mutex_unlock (&self->priv->__lock_loggers);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (l);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = l;
	return result;
}

static DVBLoggingLogger*
dvb_logging_log_manager_createLogger (DVBLoggingLogManager* self,
                                      const gchar* name)
{
	DVBLoggingLogger* l = NULL;
	DVBLoggingLogger* _tmp0_;
	GeeHashMap* _tmp1_;
	DVBLoggingLogger* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = dvb_logging_logger_new ();
	l = _tmp0_;
	dvb_logging_logger_set_name (l, name);
	_tmp1_ = self->priv->loggers;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, name, l);
	result = l;
	return result;
}

void
dvb_logging_log_manager_cleanup (DVBLoggingLogManager* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->loggers;
		g_rec_mutex_lock (&self->priv->__lock_loggers);
		{
			GeeHashMap* _tmp19_;
			{
				GeeIterator* _logger_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
				_tmp1_ = self->priv->loggers;
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_logger_it = _tmp6_;
				while (TRUE) {
					GeeIterator* _tmp7_;
					DVBLoggingLogger* logger = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					_tmp7_ = _logger_it;
					if (!gee_iterator_next (_tmp7_)) {
						break;
					}
					_tmp8_ = _logger_it;
					_tmp9_ = gee_iterator_get (_tmp8_);
					logger = (DVBLoggingLogger*) _tmp9_;
					{
						GeeIterator* _handler_it = NULL;
						DVBLoggingLogger* _tmp10_;
						GeeHashSet* _tmp11_;
						GeeHashSet* _tmp12_;
						GeeIterator* _tmp13_;
						GeeIterator* _tmp14_;
						_tmp10_ = logger;
						_tmp11_ = dvb_logging_logger_getHandlers (_tmp10_);
						_tmp12_ = _tmp11_;
						_tmp13_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp12_);
						_tmp14_ = _tmp13_;
						_g_object_unref0 (_tmp12_);
						_handler_it = _tmp14_;
						while (TRUE) {
							GeeIterator* _tmp15_;
							DVBLoggingHandler* handler = NULL;
							GeeIterator* _tmp16_;
							gpointer _tmp17_;
							DVBLoggingHandler* _tmp18_;
							_tmp15_ = _handler_it;
							if (!gee_iterator_next (_tmp15_)) {
								break;
							}
							_tmp16_ = _handler_it;
							_tmp17_ = gee_iterator_get (_tmp16_);
							handler = (DVBLoggingHandler*) _tmp17_;
							_tmp18_ = handler;
							dvb_logging_handler_close (_tmp18_);
							_g_object_unref0 (handler);
						}
						_g_object_unref0 (_handler_it);
					}
					_g_object_unref0 (logger);
				}
				_g_object_unref0 (_logger_it);
			}
			_tmp19_ = self->priv->loggers;
			gee_abstract_map_clear ((GeeAbstractMap*) _tmp19_);
		}
		__finally0:
		{
			GeeHashMap* _tmp20_;
			_tmp20_ = self->priv->loggers;
			g_rec_mutex_unlock (&self->priv->__lock_loggers);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

DVBLoggingLogManager*
dvb_logging_log_manager_construct (GType object_type)
{
	DVBLoggingLogManager * self = NULL;
	self = (DVBLoggingLogManager*) g_object_new (object_type, NULL);
	return self;
}

DVBLoggingLogManager*
dvb_logging_log_manager_new (void)
{
	return dvb_logging_log_manager_construct (DVB_LOGGING_TYPE_LOG_MANAGER);
}

static GObject *
dvb_logging_log_manager_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBLoggingLogManager * self;
	gpointer _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeHashDataFunc _tmp2_;
	gpointer _tmp3_ = NULL;
	GDestroyNotify _tmp4_ = NULL;
	GeeEqualDataFunc _tmp5_;
	gpointer _tmp6_ = NULL;
	GDestroyNotify _tmp7_ = NULL;
	GeeEqualDataFunc _tmp8_;
	GeeHashMap* _tmp9_;
	parent_class = G_OBJECT_CLASS (dvb_logging_log_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager);
	_tmp2_ = gee_functions_get_hash_func_for (G_TYPE_STRING, &_tmp0_, &_tmp1_);
	_tmp5_ = gee_functions_get_equal_func_for (G_TYPE_STRING, &_tmp3_, &_tmp4_);
	_tmp8_ = gee_functions_get_equal_func_for (DVB_LOGGING_TYPE_LOGGER, &_tmp6_, &_tmp7_);
	_tmp9_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, DVB_LOGGING_TYPE_LOGGER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_, _tmp0_, _tmp1_, _tmp5_, _tmp3_, _tmp4_, _tmp8_, _tmp6_, _tmp7_);
	_g_object_unref0 (self->priv->loggers);
	self->priv->loggers = _tmp9_;
	return obj;
}

static void
dvb_logging_log_manager_class_init (DVBLoggingLogManagerClass * klass,
                                    gpointer klass_data)
{
	dvb_logging_log_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBLoggingLogManager_private_offset);
	G_OBJECT_CLASS (klass)->constructor = dvb_logging_log_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_logging_log_manager_finalize;
	g_rec_mutex_init (&dvb_logging_log_manager_instance_mutex);
	dvb_logging_log_manager_instance_mutex = dvb_logging_log_manager_instance_mutex;
}

static void
dvb_logging_log_manager_instance_init (DVBLoggingLogManager * self,
                                       gpointer klass)
{
	self->priv = dvb_logging_log_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_loggers);
}

static void
dvb_logging_log_manager_finalize (GObject * obj)
{
	DVBLoggingLogManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager);
	g_rec_mutex_clear (&self->priv->__lock_loggers);
	_g_object_unref0 (self->priv->loggers);
	G_OBJECT_CLASS (dvb_logging_log_manager_parent_class)->finalize (obj);
}

static GType
dvb_logging_log_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBLoggingLogManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_logging_log_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBLoggingLogManager), 0, (GInstanceInitFunc) dvb_logging_log_manager_instance_init, NULL };
	GType dvb_logging_log_manager_type_id;
	dvb_logging_log_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBLoggingLogManager", &g_define_type_info, 0);
	DVBLoggingLogManager_private_offset = g_type_add_instance_private (dvb_logging_log_manager_type_id, sizeof (DVBLoggingLogManagerPrivate));
	return dvb_logging_log_manager_type_id;
}

GType
dvb_logging_log_manager_get_type (void)
{
	static volatile gsize dvb_logging_log_manager_type_id__once = 0;
	if (g_once_init_enter (&dvb_logging_log_manager_type_id__once)) {
		GType dvb_logging_log_manager_type_id;
		dvb_logging_log_manager_type_id = dvb_logging_log_manager_get_type_once ();
		g_once_init_leave (&dvb_logging_log_manager_type_id__once, dvb_logging_log_manager_type_id);
	}
	return dvb_logging_log_manager_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

