/* Main.c generated by valac 0.56.18, the Vala compiler
 * generated from Main.vala, do not modify */

/*
 * Copyright (C) 2008-2011 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gee.h>
#include <stdarg.h>
#include <stdio.h>
#include <signal.h>
#include <gst/mpegts/mpegts.h>

#define DVB_CONSTANTS_DBUS_SERVICE "org.gnome.DVB"
#define DVB_CONSTANTS_DBUS_MANAGER_PATH "/org/gnome/DVB/Manager"
#define DVB_CONSTANTS_DBUS_RECORDINGS_STORE_PATH "/org/gnome/DVB/RecordingsStore"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_MANAGER (dvb_manager_get_type ())
#define DVB_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MANAGER, DVBManager))
#define DVB_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MANAGER, DVBManagerClass))
#define DVB_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MANAGER))
#define DVB_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MANAGER))
#define DVB_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MANAGER, DVBManagerClass))

typedef struct _DVBManager DVBManager;
typedef struct _DVBManagerClass DVBManagerClass;

#define DVB_TYPE_RECORDINGS_STORE (dvb_recordings_store_get_type ())
#define DVB_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStore))
#define DVB_RECORDINGS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStoreClass))
#define DVB_IS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_RECORDINGS_STORE))
#define DVB_IS_RECORDINGS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_RECORDINGS_STORE))
#define DVB_RECORDINGS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStoreClass))

typedef struct _DVBRecordingsStore DVBRecordingsStore;
typedef struct _DVBRecordingsStoreClass DVBRecordingsStoreClass;

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_TYPE_ID_BUS_MANAGER (dvb_id_bus_manager_get_type ())
#define DVB_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManager))
#define DVB_IS_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_MANAGER))
#define DVB_ID_BUS_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManagerIface))

typedef struct _DVBIDBusManager DVBIDBusManager;
typedef struct _DVBIDBusManagerIface DVBIDBusManagerIface;

#define DVB_TYPE_ID_BUS_MANAGER_PROXY (dvb_id_bus_manager_proxy_get_type ())
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_CHANNEL_GROUP_INFO (dvb_channel_group_info_get_type ())
typedef struct _DVBChannelGroupInfo DVBChannelGroupInfo;

#define DVB_TYPE_ADAPTER_INFO (dvb_adapter_info_get_type ())
typedef struct _DVBAdapterInfo DVBAdapterInfo;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DVB_TYPE_ID_BUS_RECORDINGS_STORE (dvb_id_bus_recordings_store_get_type ())
#define DVB_ID_BUS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE, DVBIDBusRecordingsStore))
#define DVB_IS_ID_BUS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE))
#define DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE, DVBIDBusRecordingsStoreIface))

typedef struct _DVBIDBusRecordingsStore DVBIDBusRecordingsStore;
typedef struct _DVBIDBusRecordingsStoreIface DVBIDBusRecordingsStoreIface;

#define DVB_TYPE_ID_BUS_RECORDINGS_STORE_PROXY (dvb_id_bus_recordings_store_proxy_get_type ())

#define DVB_TYPE_RECORDING_INFO (dvb_recording_info_get_type ())
typedef struct _DVBRecordingInfo DVBRecordingInfo;

#define DVB_TYPE_FACTORY (dvb_factory_get_type ())
#define DVB_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_FACTORY, DVBFactory))
#define DVB_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_FACTORY, DVBFactoryClass))
#define DVB_IS_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_FACTORY))
#define DVB_IS_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_FACTORY))
#define DVB_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_FACTORY, DVBFactoryClass))

typedef struct _DVBFactory DVBFactory;
typedef struct _DVBFactoryClass DVBFactoryClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_DATABASE_TYPE_CONFIG_STORE (dvb_database_config_store_get_type ())
#define DVB_DATABASE_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStore))
#define DVB_DATABASE_IS_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE))
#define DVB_DATABASE_CONFIG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStoreIface))

typedef struct _DVBdatabaseConfigStore DVBdatabaseConfigStore;
typedef struct _DVBdatabaseConfigStoreIface DVBdatabaseConfigStoreIface;

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;

#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DVB_TYPE_ID_BUS_DEVICE_GROUP (dvb_id_bus_device_group_get_type ())
#define DVB_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroup))
#define DVB_IS_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP))
#define DVB_ID_BUS_DEVICE_GROUP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroupIface))

typedef struct _DVBIDBusDeviceGroup DVBIDBusDeviceGroup;
typedef struct _DVBIDBusDeviceGroupIface DVBIDBusDeviceGroupIface;

#define DVB_TYPE_ID_BUS_DEVICE_GROUP_PROXY (dvb_id_bus_device_group_proxy_get_type ())

#define DVB_LOGGING_TYPE_FILE_HANDLER (dvb_logging_file_handler_get_type ())
#define DVB_LOGGING_FILE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandler))
#define DVB_LOGGING_FILE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandlerClass))
#define DVB_LOGGING_IS_FILE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_FILE_HANDLER))
#define DVB_LOGGING_IS_FILE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_FILE_HANDLER))
#define DVB_LOGGING_FILE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_FILE_HANDLER, DVBLoggingFileHandlerClass))

typedef struct _DVBLoggingFileHandler DVBLoggingFileHandler;
typedef struct _DVBLoggingFileHandlerClass DVBLoggingFileHandlerClass;

#define DVB_LOGGING_TYPE_HANDLER (dvb_logging_handler_get_type ())
#define DVB_LOGGING_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_HANDLER, DVBLoggingHandler))
#define DVB_LOGGING_IS_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_HANDLER))
#define DVB_LOGGING_HANDLER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_LOGGING_TYPE_HANDLER, DVBLoggingHandlerIface))

typedef struct _DVBLoggingHandler DVBLoggingHandler;
typedef struct _DVBLoggingHandlerIface DVBLoggingHandlerIface;
typedef enum  {
	DVB_LOGGING_LOG_LEVEL_LOG,
	DVB_LOGGING_LOG_LEVEL_DEBUG,
	DVB_LOGGING_LOG_LEVEL_INFO,
	DVB_LOGGING_LOG_LEVEL_WARNING,
	DVB_LOGGING_LOG_LEVEL_ERROR
} DVBLoggingLogLevel;

#define DVB_LOGGING_TYPE_LOG_LEVEL (dvb_logging_log_level_get_type ())

#define DVB_LOGGING_TYPE_FORMATTER (dvb_logging_formatter_get_type ())
#define DVB_LOGGING_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_FORMATTER, DVBLoggingFormatter))
#define DVB_LOGGING_IS_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_FORMATTER))
#define DVB_LOGGING_FORMATTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_LOGGING_TYPE_FORMATTER, DVBLoggingFormatterIface))

typedef struct _DVBLoggingFormatter DVBLoggingFormatter;
typedef struct _DVBLoggingFormatterIface DVBLoggingFormatterIface;

#define DVB_LOGGING_TYPE_CONSOLE_HANDLER (dvb_logging_console_handler_get_type ())
#define DVB_LOGGING_CONSOLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandler))
#define DVB_LOGGING_CONSOLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandlerClass))
#define DVB_LOGGING_IS_CONSOLE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER))
#define DVB_LOGGING_IS_CONSOLE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_CONSOLE_HANDLER))
#define DVB_LOGGING_CONSOLE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_CONSOLE_HANDLER, DVBLoggingConsoleHandlerClass))

typedef struct _DVBLoggingConsoleHandler DVBLoggingConsoleHandler;
typedef struct _DVBLoggingConsoleHandlerClass DVBLoggingConsoleHandlerClass;

#define DVB_LOGGING_TYPE_DEFAULT_FORMATTER (dvb_logging_default_formatter_get_type ())
#define DVB_LOGGING_DEFAULT_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatter))
#define DVB_LOGGING_DEFAULT_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatterClass))
#define DVB_LOGGING_IS_DEFAULT_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER))
#define DVB_LOGGING_IS_DEFAULT_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_DEFAULT_FORMATTER))
#define DVB_LOGGING_DEFAULT_FORMATTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_DEFAULT_FORMATTER, DVBLoggingDefaultFormatterClass))

typedef struct _DVBLoggingDefaultFormatter DVBLoggingDefaultFormatter;
typedef struct _DVBLoggingDefaultFormatterClass DVBLoggingDefaultFormatterClass;

#define DVB_LOGGING_TYPE_COLOR_FORMATTER (dvb_logging_color_formatter_get_type ())
#define DVB_LOGGING_COLOR_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatter))
#define DVB_LOGGING_COLOR_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatterClass))
#define DVB_LOGGING_IS_COLOR_FORMATTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER))
#define DVB_LOGGING_IS_COLOR_FORMATTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_COLOR_FORMATTER))
#define DVB_LOGGING_COLOR_FORMATTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_COLOR_FORMATTER, DVBLoggingColorFormatterClass))

typedef struct _DVBLoggingColorFormatter DVBLoggingColorFormatter;
typedef struct _DVBLoggingColorFormatterClass DVBLoggingColorFormatterClass;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))

struct _DVBChannelGroupInfo {
	gint id;
	gchar* name;
};

struct _DVBAdapterInfo {
	gchar* name;
	gboolean type_t;
	gboolean type_s;
	gboolean type_c;
};

struct _DVBIDBusManagerIface {
	GTypeInterface parent_iface;
	gboolean (*GetScannerForDevice) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, char** opath, gchar** dbusiface, GError** error);
	char** (*GetRegisteredDeviceGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetDeviceGroup) (DVBIDBusManager* self, guint group_id, char** opath, GError** error);
	gboolean (*AddDeviceToNewGroup) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, const gchar* channels_conf, const gchar* recordings_dir, const gchar* name, GError** error);
	gboolean (*GetNameOfRegisteredDevice) (DVBIDBusManager* self, guint adapter, guint frontend, gchar** name, GError** error);
	gint (*GetDeviceGroupSize) (DVBIDBusManager* self, GError** error);
	DVBChannelGroupInfo* (*GetChannelGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*AddChannelGroup) (DVBIDBusManager* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*RemoveChannelGroup) (DVBIDBusManager* self, gint channel_group_id, GError** error);
	GHashTable** (*GetDevices) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetAdapterInfo) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterInfo* info, GError** error);
};

struct _DVBRecordingInfo {
	guint32 id;
	gchar* name;
	gchar* description;
	gint64 length;
	gint64 start_timestamp;
	gchar* channel;
	gchar* location;
};

struct _DVBIDBusRecordingsStoreIface {
	GTypeInterface parent_iface;
	guint32* (*GetRecordings) (DVBIDBusRecordingsStore* self, gint* result_length1, GError** error);
	gboolean (*GetLocation) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** location, GError** error);
	gboolean (*GetName) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** name, GError** error);
	gboolean (*GetDescription) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** description, GError** error);
	gboolean (*GetStartTime) (DVBIDBusRecordingsStore* self, guint32 rec_id, guint** start_time, gint* start_time_length1, GError** error);
	gboolean (*GetStartTimestamp) (DVBIDBusRecordingsStore* self, guint32 rec_id, gint64* timestamp, GError** error);
	gboolean (*GetLength) (DVBIDBusRecordingsStore* self, guint32 rec_id, gint64* length, GError** error);
	gboolean (*Delete) (DVBIDBusRecordingsStore* self, guint32 rec_id, GError** error);
	gboolean (*GetChannelName) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** name, GError** error);
	gboolean (*GetAllInformations) (DVBIDBusRecordingsStore* self, guint32 rec_id, DVBRecordingInfo* infos, GError** error);
};

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseConfigStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_device_groups) (DVBdatabaseConfigStore* self, GError** error);
	DVBDeviceGroup* (*get_device_group) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_last_device) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_group_member) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
	gboolean (*add_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
	gboolean (*remove_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*add_device_to_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*remove_device_from_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*update_from_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*get_parent_groups) (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, gint* group_ids_length1, GError** error);
	gboolean (*add_channel_group) (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*remove_channel_group) (DVBdatabaseConfigStore* self, gint group_id, GError** error);
	GeeList* (*get_channel_groups) (DVBdatabaseConfigStore* self, GError** error);
	GeeList* (*get_channels_of_group) (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
	gboolean (*add_channel_to_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
	gboolean (*remove_channel_from_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
};

struct _DVBIDBusDeviceGroupIface {
	GTypeInterface parent_iface;
	DVBAdapterType (*GetType) (DVBIDBusDeviceGroup* self, GError** error);
	char* (*GetRecorder) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*AddDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	gboolean (*RemoveDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	char* (*GetChannelList) (DVBIDBusDeviceGroup* self, GError** error);
	gchar* (*GetName) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetName) (DVBIDBusDeviceGroup* self, const gchar* name, GError** error);
	gchar** (*GetMembers) (DVBIDBusDeviceGroup* self, gint* result_length1, GError** error);
	gboolean (*GetSchedule) (DVBIDBusDeviceGroup* self, guint channel_sid, char** opath, GError** error);
	gchar* (*GetRecordingsDirectory) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetRecordingsDirectory) (DVBIDBusDeviceGroup* self, const gchar* location, GError** error);
};

struct _DVBLoggingFormatterIface {
	GTypeInterface parent_iface;
	gchar* (*format) (DVBLoggingFormatter* self, const gchar* logger_name, DVBLoggingLogLevel level, const gchar* format);
};

struct _DVBLoggingHandlerIface {
	GTypeInterface parent_iface;
	void (*publish) (DVBLoggingHandler* self, const gchar* logger_name, DVBLoggingLogLevel level, const gchar* format, va_list args);
	void (*close) (DVBLoggingHandler* self);
	DVBLoggingFormatter* (*get_formatter) (DVBLoggingHandler* self);
	void (*set_formatter) (DVBLoggingHandler* self, DVBLoggingFormatter* value);
	DVBLoggingLogLevel (*get_threshold) (DVBLoggingHandler* self);
	void (*set_threshold) (DVBLoggingHandler* self, DVBLoggingLogLevel value);
};

VALA_EXTERN DVBManager* main_manager;
DVBManager* main_manager = NULL;
VALA_EXTERN DVBRecordingsStore* main_recstore;
DVBRecordingsStore* main_recstore = NULL;
VALA_EXTERN gboolean main_has_debug;
gboolean main_has_debug = FALSE;
VALA_EXTERN gboolean main_has_version;
gboolean main_has_version = FALSE;
VALA_EXTERN gboolean main_disable_epg_scanner;
gboolean main_disable_epg_scanner = FALSE;
VALA_EXTERN gboolean main_disable_mediaserver;
gboolean main_disable_mediaserver = FALSE;
VALA_EXTERN GMainLoop* main_mainloop;
GMainLoop* main_mainloop = NULL;
VALA_EXTERN DVBLoggingLogger* main_log;
DVBLoggingLogger* main_log = NULL;
VALA_EXTERN GDBusConnection* main_conn;
GDBusConnection* main_conn = NULL;

VALA_EXTERN GType dvb_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBManager, g_object_unref)
VALA_EXTERN GType dvb_recordings_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBRecordingsStore, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN void main_start_manager (void);
VALA_EXTERN DVBManager* dvb_manager_get_instance (void);
VALA_EXTERN void dvb_utils_dbus_own_name (const gchar* service_name,
                              GBusAcquiredCallback cb,
                              gpointer cb_target);
VALA_EXTERN void main_on_bus_acquired (GDBusConnection* _conn);
static void _main_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection,
                                                   const gchar* name,
                                                   gpointer self);
VALA_EXTERN void dvb_utils_dbus_register_object (GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     GDBusConnection* conn,
                                     const gchar* object_path,
                                     gconstpointer obj);
VALA_EXTERN GType dvb_id_bus_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_manager_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_channel_group_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBChannelGroupInfo* dvb_channel_group_info_dup (const DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_free (DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_copy (const DVBChannelGroupInfo* self,
                                  DVBChannelGroupInfo* dest);
VALA_EXTERN void dvb_channel_group_info_destroy (DVBChannelGroupInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBChannelGroupInfo, dvb_channel_group_info_destroy)
VALA_EXTERN GType dvb_adapter_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBAdapterInfo* dvb_adapter_info_dup (const DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_free (DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_copy (const DVBAdapterInfo* self,
                            DVBAdapterInfo* dest);
VALA_EXTERN void dvb_adapter_info_destroy (DVBAdapterInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBAdapterInfo, dvb_adapter_info_destroy)
VALA_EXTERN GType dvb_id_bus_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusManager, g_object_unref)
VALA_EXTERN void main_restore_device_groups (void);
VALA_EXTERN void main_start_recordings_store (void);
VALA_EXTERN void dvb_logging_logger_info (DVBLoggingLogger* self,
                              const gchar* format,
                              ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN DVBRecordingsStore* dvb_recordings_store_get_instance (void);
VALA_EXTERN GType dvb_id_bus_recordings_store_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_recordings_store_register_object (void* object,
                                                   GDBusConnection* connection,
                                                   const gchar* path,
                                                   GError** error);
VALA_EXTERN GType dvb_recording_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBRecordingInfo* dvb_recording_info_dup (const DVBRecordingInfo* self);
VALA_EXTERN void dvb_recording_info_free (DVBRecordingInfo* self);
VALA_EXTERN void dvb_recording_info_copy (const DVBRecordingInfo* self,
                              DVBRecordingInfo* dest);
VALA_EXTERN void dvb_recording_info_destroy (DVBRecordingInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBRecordingInfo, dvb_recording_info_destroy)
VALA_EXTERN GType dvb_id_bus_recordings_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusRecordingsStore, g_object_unref)
VALA_EXTERN void main_on_exit (gint signum);
VALA_EXTERN void dvb_rtsp_server_shutdown (void);
VALA_EXTERN void dvb_manager_shutdown (void);
VALA_EXTERN DVBFactory* dvb_factory_new (void);
VALA_EXTERN DVBFactory* dvb_factory_construct (GType object_type);
VALA_EXTERN GType dvb_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBFactory, g_object_unref)
VALA_EXTERN void dvb_factory_shutdown (DVBFactory* self);
VALA_EXTERN void dvb_recordings_store_shutdown (void);
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN void dvb_logging_log_manager_cleanup (DVBLoggingLogManager* self);
VALA_EXTERN gboolean main_get_disable_epg_scanner (void);
VALA_EXTERN gboolean main_check_feature_version (const gchar* name,
                                     guint major,
                                     guint minor,
                                     guint micro);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean main_check_requirements (void);
VALA_EXTERN GType dvb_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDeviceGroup, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDevice, g_object_unref)
VALA_EXTERN GType dvb_channel_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelGroup, g_object_unref)
VALA_EXTERN GType dvb_channel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannel, g_object_unref)
VALA_EXTERN GType dvb_database_config_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseConfigStore, g_object_unref)
VALA_EXTERN DVBdatabaseConfigStore* dvb_factory_get_config_store (DVBFactory* self);
VALA_EXTERN GeeList* dvb_database_config_store_get_all_device_groups (DVBdatabaseConfigStore* self,
                                                          GError** error);
VALA_EXTERN GeeArrayList* dvb_manager_get_devs (DVBManager* self);
VALA_EXTERN gboolean dvb_database_config_store_is_group_member (DVBdatabaseConfigStore* self,
                                                    DVBDevice* dev,
                                                    DVBDeviceGroup* group,
                                                    GError** error);
VALA_EXTERN const gchar* dvb_device_get_DevFile (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_group_add (DVBDeviceGroup* self,
                               DVBDevice* device);
VALA_EXTERN GType dvb_id_bus_device_group_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_device_group_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType dvb_id_bus_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusDeviceGroup, g_object_unref)
VALA_EXTERN guint dvb_device_get_Adapter (DVBDevice* self);
VALA_EXTERN guint dvb_device_get_Frontend (DVBDevice* self);
VALA_EXTERN void dvb_manager_restore_device_group_and_timers (DVBManager* self,
                                                  DVBDeviceGroup* device_group);
VALA_EXTERN guint dvb_device_group_get_Id (DVBDeviceGroup* self);
VALA_EXTERN void dvb_device_group_start_epg_scanner (DVBDeviceGroup* self);
VALA_EXTERN void main_configure_logging (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN GType dvb_logging_file_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingFileHandler, g_object_unref)
VALA_EXTERN DVBLoggingFileHandler* dvb_logging_file_handler_new (const gchar* file_pattern,
                                                     GError** error);
VALA_EXTERN DVBLoggingFileHandler* dvb_logging_file_handler_construct (GType object_type,
                                                           const gchar* file_pattern,
                                                           GError** error);
VALA_EXTERN void dvb_logging_file_handler_set_limit (DVBLoggingFileHandler* self,
                                         gint value);
VALA_EXTERN gint dvb_logging_file_handler_get_limit (DVBLoggingFileHandler* self);
VALA_EXTERN GType dvb_logging_log_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_logging_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingFormatter, g_object_unref)
VALA_EXTERN GType dvb_logging_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingHandler, g_object_unref)
VALA_EXTERN void dvb_logging_handler_set_threshold (DVBLoggingHandler* self,
                                        DVBLoggingLogLevel value);
VALA_EXTERN void dvb_logging_logger_addHandler (DVBLoggingLogger* self,
                                    DVBLoggingHandler* handler);
VALA_EXTERN GType dvb_logging_console_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingConsoleHandler, g_object_unref)
VALA_EXTERN DVBLoggingConsoleHandler* dvb_logging_console_handler_new (void);
VALA_EXTERN DVBLoggingConsoleHandler* dvb_logging_console_handler_construct (GType object_type);
VALA_EXTERN DVBLoggingColorFormatter* dvb_logging_color_formatter_new (void);
VALA_EXTERN DVBLoggingColorFormatter* dvb_logging_color_formatter_construct (GType object_type);
VALA_EXTERN GType dvb_logging_default_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingDefaultFormatter, g_object_unref)
VALA_EXTERN GType dvb_logging_color_formatter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingColorFormatter, g_object_unref)
VALA_EXTERN void dvb_logging_handler_set_formatter (DVBLoggingHandler* self,
                                        DVBLoggingFormatter* value);
static gint main_main (gchar** args,
                gint args_length1);
static void _main_on_exit___sighandler_t (gint signum);
VALA_EXTERN void dvb_rtsp_server_start (GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
VALA_EXTERN void dvb_rtsp_server_start_finish (GAsyncResult* _res_);
VALA_EXTERN void dvb_media_server2_start_rygel_services (GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void dvb_media_server2_start_rygel_services_finish (GAsyncResult* _res_);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const GOptionEntry MAIN_options[5] = {{"debug", 'd', (gint) 0, G_OPTION_ARG_NONE, &main_has_debug, "Display debug statements on stdout", NULL}, {"version", (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, &main_has_version, "Display version number", NULL}, {"disable-epg-scanner", (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, &main_disable_epg_scanner, "Disable scanning for EPG data", NULL}, {"disable-mediaserver2", (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, &main_disable_mediaserver, "Disable exporting devices and channels according to Rygel's MediaServe" \
"r2 specification", NULL}, {NULL}};

static void
_main_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection,
                                              const gchar* name,
                                              gpointer self)
{
	main_on_bus_acquired (connection);
}

void
main_start_manager (void)
{
	DVBManager* _tmp0_;
	_tmp0_ = dvb_manager_get_instance ();
	main_manager = _tmp0_;
	dvb_utils_dbus_own_name (DVB_CONSTANTS_DBUS_SERVICE, _main_on_bus_acquired_gbus_acquired_callback, NULL);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
main_on_bus_acquired (GDBusConnection* _conn)
{
	DVBManager* _tmp0_;
	GDBusConnection* _tmp1_;
	g_return_if_fail (_conn != NULL);
	_tmp0_ = main_manager;
	dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_MANAGER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _conn, DVB_CONSTANTS_DBUS_MANAGER_PATH, (DVBIDBusManager*) _tmp0_);
	_tmp1_ = _g_object_ref0 (_conn);
	_g_object_unref0 (main_conn);
	main_conn = _tmp1_;
	main_restore_device_groups ();
	main_start_recordings_store ();
}

void
main_start_recordings_store (void)
{
	DVBLoggingLogger* _tmp0_;
	DVBRecordingsStore* _tmp1_;
	DVBRecordingsStore* _tmp2_;
	GDBusConnection* _tmp3_;
	DVBRecordingsStore* _tmp4_;
	_tmp0_ = main_log;
	dvb_logging_logger_info (_tmp0_, "Main.vala:64: Creating new RecordingsStore D-Bus service");
	_tmp1_ = dvb_recordings_store_get_instance ();
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (main_recstore);
	main_recstore = _tmp2_;
	_tmp3_ = main_conn;
	_tmp4_ = main_recstore;
	dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_RECORDINGS_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp3_, DVB_CONSTANTS_DBUS_RECORDINGS_STORE_PATH, (DVBIDBusRecordingsStore*) _tmp4_);
}

void
main_on_exit (gint signum)
{
	DVBLoggingLogger* _tmp0_;
	DVBFactory* _tmp1_;
	DVBFactory* _tmp2_;
	DVBLoggingLogManager* _tmp3_;
	GMainLoop* _tmp4_;
	_tmp0_ = main_log;
	dvb_logging_logger_info (_tmp0_, "Main.vala:72: Exiting");
	dvb_rtsp_server_shutdown ();
	dvb_manager_shutdown ();
	_tmp1_ = dvb_factory_new ();
	_tmp2_ = _tmp1_;
	dvb_factory_shutdown (_tmp2_);
	_g_object_unref0 (_tmp2_);
	dvb_recordings_store_shutdown ();
	_tmp3_ = dvb_logging_log_manager_getLogManager ();
	dvb_logging_log_manager_cleanup (_tmp3_);
	_g_object_unref0 (main_recstore);
	main_recstore = NULL;
	main_manager = NULL;
	_tmp4_ = main_mainloop;
	g_main_loop_quit (_tmp4_);
}

gboolean
main_get_disable_epg_scanner (void)
{
	gboolean result;
	result = main_disable_epg_scanner;
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

gboolean
main_check_feature_version (const gchar* name,
                            guint major,
                            guint minor,
                            guint micro)
{
	GstRegistry* reg = NULL;
	GstRegistry* _tmp0_;
	GstRegistry* _tmp1_;
	GstPluginFeature* feature = NULL;
	GstRegistry* _tmp2_;
	GstPluginFeature* _tmp3_;
	gboolean ret = FALSE;
	GstPluginFeature* _tmp4_;
	DVBLoggingLogger* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean result;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = gst_registry_get ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	reg = _tmp1_;
	_tmp2_ = reg;
	_tmp3_ = gst_registry_lookup_feature (_tmp2_, name);
	feature = _tmp3_;
	_tmp4_ = feature;
	if (_tmp4_ == NULL) {
		ret = FALSE;
	} else {
		GstPluginFeature* _tmp5_;
		_tmp5_ = feature;
		ret = gst_plugin_feature_check_version (_tmp5_, major, minor, micro);
	}
	_tmp6_ = main_log;
	_tmp7_ = bool_to_string (ret);
	_tmp8_ = _tmp7_;
	dvb_logging_logger_debug (_tmp6_, "Main.vala:99: Has %s >= %u.%u.%u: %s", name, major, minor, micro, _tmp8_);
	_g_free0 (_tmp8_);
	result = ret;
	_g_object_unref0 (feature);
	_g_object_unref0 (reg);
	return result;
}

gboolean
main_check_requirements (void)
{
	gboolean val = FALSE;
	gboolean result;
	val = main_check_feature_version ("dvbsrc", (guint) 1, (guint) 3, (guint) 1);
	if (!val) {
		result = FALSE;
		return result;
	}
	val = main_check_feature_version ("dvbbasebin", (guint) 1, (guint) 3, (guint) 1);
	if (!val) {
		result = FALSE;
		return result;
	}
	val = main_check_feature_version ("tsparse", (guint) 1, (guint) 3, (guint) 1);
	if (!val) {
		result = FALSE;
		return result;
	}
	val = main_check_feature_version ("rtpmp2tpay", (guint) 1, (guint) 3, (guint) 1);
	result = val;
	return result;
}

void
main_restore_device_groups (void)
{
	DVBdatabaseConfigStore* config_store = NULL;
	DVBFactory* _tmp0_;
	DVBFactory* _tmp1_;
	DVBdatabaseConfigStore* _tmp2_;
	DVBdatabaseConfigStore* _tmp3_;
	GeeList* device_groups = NULL;
	guint max_group_id = 0U;
	DVBLoggingLogger* _tmp10_;
	GeeList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dvb_factory_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_factory_get_config_store (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	config_store = _tmp3_;
	{
		GeeList* _tmp4_ = NULL;
		DVBdatabaseConfigStore* _tmp5_;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
		_tmp5_ = config_store;
		_tmp6_ = dvb_database_config_store_get_all_device_groups (_tmp5_, &_inner_error0_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (device_groups);
			_g_object_unref0 (config_store);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp7_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (device_groups);
		device_groups = _tmp7_;
		_g_object_unref0 (_tmp4_);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_critical ("Main.vala:125: %s", _tmp9_);
		_g_error_free0 (e);
		_g_object_unref0 (device_groups);
		_g_object_unref0 (config_store);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (device_groups);
		_g_object_unref0 (config_store);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	max_group_id = (guint) 0;
	_tmp10_ = main_log;
	_tmp11_ = device_groups;
	_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
	_tmp13_ = _tmp12_;
	dvb_logging_logger_info (_tmp10_, "Main.vala:130: Restoring %d device groups", _tmp13_);
	{
		GeeList* _device_group_list = NULL;
		GeeList* _tmp14_;
		gint _device_group_size = 0;
		GeeList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _device_group_index = 0;
		_tmp14_ = device_groups;
		_device_group_list = _tmp14_;
		_tmp15_ = _device_group_list;
		_tmp16_ = gee_collection_get_size ((GeeCollection*) _tmp15_);
		_tmp17_ = _tmp16_;
		_device_group_size = _tmp17_;
		_device_group_index = -1;
		while (TRUE) {
			gint _tmp18_;
			gint _tmp19_;
			DVBDeviceGroup* device_group = NULL;
			GeeList* _tmp20_;
			gpointer _tmp21_;
			DVBManager* _tmp52_;
			DVBDeviceGroup* _tmp53_;
			DVBDeviceGroup* _tmp54_;
			guint _tmp55_;
			guint _tmp56_;
			DVBDeviceGroup* _tmp60_;
			_device_group_index = _device_group_index + 1;
			_tmp18_ = _device_group_index;
			_tmp19_ = _device_group_size;
			if (!(_tmp18_ < _tmp19_)) {
				break;
			}
			_tmp20_ = _device_group_list;
			_tmp21_ = gee_list_get (_tmp20_, _device_group_index);
			device_group = (DVBDeviceGroup*) _tmp21_;
			{
				GeeArrayList* _dev_list = NULL;
				DVBManager* _tmp22_;
				GeeArrayList* _tmp23_;
				GeeArrayList* _tmp24_;
				gint _dev_size = 0;
				GeeArrayList* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gint _dev_index = 0;
				_tmp22_ = main_manager;
				_tmp23_ = dvb_manager_get_devs (_tmp22_);
				_tmp24_ = _tmp23_;
				_dev_list = _tmp24_;
				_tmp25_ = _dev_list;
				_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
				_tmp27_ = _tmp26_;
				_dev_size = _tmp27_;
				_dev_index = -1;
				while (TRUE) {
					gint _tmp28_;
					gint _tmp29_;
					DVBDevice* dev = NULL;
					GeeArrayList* _tmp30_;
					gpointer _tmp31_;
					DVBLoggingLogger* _tmp32_;
					_dev_index = _dev_index + 1;
					_tmp28_ = _dev_index;
					_tmp29_ = _dev_size;
					if (!(_tmp28_ < _tmp29_)) {
						break;
					}
					_tmp30_ = _dev_list;
					_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _dev_index);
					dev = (DVBDevice*) _tmp31_;
					_tmp32_ = main_log;
					dvb_logging_logger_debug (_tmp32_, "Main.vala:134: restoring device");
					{
						gboolean _tmp33_ = FALSE;
						DVBdatabaseConfigStore* _tmp34_;
						DVBDevice* _tmp35_;
						DVBDeviceGroup* _tmp36_;
						_tmp34_ = config_store;
						_tmp35_ = dev;
						_tmp36_ = device_group;
						_tmp33_ = dvb_database_config_store_is_group_member (_tmp34_, _tmp35_, _tmp36_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
								goto __catch1_dvb_database_sql_error;
							}
							_g_object_unref0 (dev);
							_g_object_unref0 (device_group);
							_g_object_unref0 (device_groups);
							_g_object_unref0 (config_store);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						if (_tmp33_) {
							DVBLoggingLogger* _tmp37_;
							DVBDevice* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							DVBDeviceGroup* _tmp41_;
							DVBDevice* _tmp42_;
							_tmp37_ = main_log;
							_tmp38_ = dev;
							_tmp39_ = dvb_device_get_DevFile (_tmp38_);
							_tmp40_ = _tmp39_;
							dvb_logging_logger_debug (_tmp37_, "Main.vala:137: add device %s", _tmp40_);
							_tmp41_ = device_group;
							_tmp42_ = dev;
							if (dvb_device_group_add (_tmp41_, _tmp42_)) {
								DVBDeviceGroup* _tmp43_;
								DVBDevice* _tmp44_;
								guint _tmp45_;
								guint _tmp46_;
								DVBDevice* _tmp47_;
								guint _tmp48_;
								guint _tmp49_;
								_tmp43_ = device_group;
								_tmp44_ = dev;
								_tmp45_ = dvb_device_get_Adapter (_tmp44_);
								_tmp46_ = _tmp45_;
								_tmp47_ = dev;
								_tmp48_ = dvb_device_get_Frontend (_tmp47_);
								_tmp49_ = _tmp48_;
								g_signal_emit_by_name ((DVBIDBusDeviceGroup*) _tmp43_, "device-added", _tmp46_, _tmp49_);
							}
						}
					}
					goto __finally1;
					__catch1_dvb_database_sql_error:
					{
						GError* e = NULL;
						GError* _tmp50_;
						const gchar* _tmp51_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp50_ = e;
						_tmp51_ = _tmp50_->message;
						g_warning ("Main.vala:142: %s", _tmp51_);
						_g_error_free0 (e);
					}
					__finally1:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (dev);
						_g_object_unref0 (device_group);
						_g_object_unref0 (device_groups);
						_g_object_unref0 (config_store);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_g_object_unref0 (dev);
				}
			}
			_tmp52_ = main_manager;
			_tmp53_ = device_group;
			dvb_manager_restore_device_group_and_timers (_tmp52_, _tmp53_);
			_tmp54_ = device_group;
			_tmp55_ = dvb_device_group_get_Id (_tmp54_);
			_tmp56_ = _tmp55_;
			if (_tmp56_ > max_group_id) {
				DVBDeviceGroup* _tmp57_;
				guint _tmp58_;
				guint _tmp59_;
				_tmp57_ = device_group;
				_tmp58_ = dvb_device_group_get_Id (_tmp57_);
				_tmp59_ = _tmp58_;
				max_group_id = _tmp59_;
			}
			_tmp60_ = device_group;
			dvb_device_group_start_epg_scanner (_tmp60_);
			_g_object_unref0 (device_group);
		}
	}
	_g_object_unref0 (device_groups);
	_g_object_unref0 (config_store);
}

void
main_configure_logging (void)
{
	DVBLoggingLogManager* manager = NULL;
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogManager* _tmp1_;
	DVBLoggingLogger* _tmp2_;
	GFile* cache_dir = NULL;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* our_cache = NULL;
	GFile* _tmp5_;
	GFile* log_file = NULL;
	GFile* _tmp6_;
	DVBLoggingConsoleHandler* chandler = NULL;
	DVBLoggingConsoleHandler* _tmp17_;
	DVBLoggingConsoleHandler* _tmp18_;
	DVBLoggingColorFormatter* _tmp19_;
	DVBLoggingColorFormatter* _tmp20_;
	DVBLoggingLogger* _tmp22_;
	DVBLoggingConsoleHandler* _tmp23_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	manager = _tmp1_;
	_tmp2_ = dvb_logging_log_manager_getDefaultLogger (manager);
	_g_object_unref0 (main_log);
	main_log = _tmp2_;
	_tmp3_ = g_get_user_cache_dir ();
	_tmp4_ = g_file_new_for_path (_tmp3_);
	cache_dir = _tmp4_;
	_tmp5_ = g_file_get_child (cache_dir, "gnome-dvb-daemon");
	our_cache = _tmp5_;
	_tmp6_ = g_file_get_child (our_cache, "debug%d.log");
	log_file = _tmp6_;
	{
		DVBLoggingFileHandler* fhandler = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		DVBLoggingFileHandler* _tmp9_;
		DVBLoggingFileHandler* _tmp10_;
		DVBLoggingLogger* _tmp13_;
		_tmp7_ = g_file_get_path (log_file);
		_tmp8_ = _tmp7_;
		_tmp9_ = dvb_logging_file_handler_new (_tmp8_, &_inner_error0_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		fhandler = _tmp10_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		dvb_logging_file_handler_set_limit (fhandler, 1024 * 1024);
		if (main_has_debug) {
			gint _tmp11_;
			gint _tmp12_;
			_tmp11_ = dvb_logging_file_handler_get_limit (fhandler);
			_tmp12_ = _tmp11_;
			dvb_logging_file_handler_set_limit (fhandler, _tmp12_ * 5);
		} else {
			dvb_logging_handler_set_threshold ((DVBLoggingHandler*) fhandler, DVB_LOGGING_LOG_LEVEL_WARNING);
		}
		_tmp13_ = main_log;
		dvb_logging_logger_addHandler (_tmp13_, (DVBLoggingHandler*) fhandler);
		_g_object_unref0 (fhandler);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp14_;
		GError* _tmp15_;
		const gchar* _tmp16_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = stderr;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		fprintf (_tmp14_, "*** Failed creating DVB.Logging.FileHandler: %s\n", _tmp16_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (log_file);
		_g_object_unref0 (our_cache);
		_g_object_unref0 (cache_dir);
		_g_object_unref0 (manager);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp17_ = dvb_logging_console_handler_new ();
	chandler = _tmp17_;
	_tmp18_ = chandler;
	_tmp19_ = dvb_logging_color_formatter_new ();
	_tmp20_ = _tmp19_;
	dvb_logging_handler_set_formatter ((DVBLoggingHandler*) _tmp18_, (DVBLoggingFormatter*) _tmp20_);
	_g_object_unref0 (_tmp20_);
	if (!main_has_debug) {
		DVBLoggingConsoleHandler* _tmp21_;
		_tmp21_ = chandler;
		dvb_logging_handler_set_threshold ((DVBLoggingHandler*) _tmp21_, DVB_LOGGING_LOG_LEVEL_ERROR);
	}
	_tmp22_ = main_log;
	_tmp23_ = chandler;
	dvb_logging_logger_addHandler (_tmp22_, (DVBLoggingHandler*) _tmp23_);
	_g_object_unref0 (chandler);
	_g_object_unref0 (log_file);
	_g_object_unref0 (our_cache);
	_g_object_unref0 (cache_dir);
	_g_object_unref0 (manager);
}

static void
_main_on_exit___sighandler_t (gint signum)
{
	main_on_exit (signum);
}

static gint
main_main (gchar** args,
           gint args_length1)
{
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionGroup* _tmp3_;
	GMainLoop* _tmp14_;
	GMainLoop* _tmp17_;
	GError* _inner_error0_ = NULL;
	gint result;
	g_setenv ("TZ", "/etc/localtime", FALSE);
	signal (SIGINT, _main_on_exit___sighandler_t);
	signal (SIGTERM, _main_on_exit___sighandler_t);
	_tmp0_ = g_option_context_new ("- record and watch TV shows using one or more DVB adapters");
	context = _tmp0_;
	_tmp1_ = context;
	g_option_context_add_main_entries (_tmp1_, MAIN_options, NULL);
	_tmp2_ = context;
	_tmp3_ = gst_init_get_option_group ();
	g_option_context_add_group (_tmp2_, _tmp3_);
	{
		GOptionContext* _tmp4_;
		_tmp4_ = context;
		g_option_context_parse (_tmp4_, (gint*) (&args_length1), &args, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp5_ = -1;
			if (_inner_error0_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp5_;
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		FILE* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stderr;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "%s\n", _tmp8_);
		_tmp9_ = stderr;
		_tmp10_ = args[0];
		fprintf (_tmp9_, "Run '%s --help' to see a full list of available command line options.\n", _tmp10_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (context);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp11_ = -1;
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp11_;
	}
	if (main_has_version) {
		FILE* _tmp12_;
		FILE* _tmp13_;
		_tmp12_ = stdout;
		fprintf (_tmp12_, "%s", PACKAGE_NAME);
		_tmp13_ = stdout;
		fprintf (_tmp13_, " %s\n", PACKAGE_VERSION);
		result = 0;
		_g_option_context_free0 (context);
		return result;
	}
	_tmp14_ = g_main_loop_new (NULL, FALSE);
	_g_main_loop_unref0 (main_mainloop);
	main_mainloop = _tmp14_;
	gst_init ((gint*) (&args_length1), &args);
	gst_mpegts_initialize ();
	main_configure_logging ();
	if (!main_check_requirements ()) {
		FILE* _tmp15_;
		FILE* _tmp16_;
		_tmp15_ = stderr;
		fprintf (_tmp15_, "You don't have all of the necessary requirements to run %s.\n", PACKAGE_NAME);
		_tmp16_ = stderr;
		fprintf (_tmp16_, "Start the daemon with the --debug flag for more details.\n");
		result = -1;
		_g_option_context_free0 (context);
		return result;
	}
	main_start_manager ();
	dvb_rtsp_server_start (NULL, NULL);
	if (!main_disable_mediaserver) {
		dvb_media_server2_start_rygel_services (NULL, NULL);
	}
	_tmp17_ = main_mainloop;
	g_main_loop_run (_tmp17_);
	result = 0;
	_g_option_context_free0 (context);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return main_main (argv, argc);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

