/* Manager.c generated by valac 0.56.18, the Vala compiler
 * generated from Manager.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gudev/gudev.h>
#include <gst/rtsp-server/rtsp-server.h>

#define DVB_CONSTANTS_DBUS_SCANNER_PATH "/org/gnome/DVB/Scanner/%d/%d"
#define DVB_CONSTANTS_DBUS_DEVICE_GROUP_PATH "/org/gnome/DVB/DeviceGroup/%u"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_ID_BUS_MANAGER (dvb_id_bus_manager_get_type ())
#define DVB_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManager))
#define DVB_IS_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_MANAGER))
#define DVB_ID_BUS_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManagerIface))

typedef struct _DVBIDBusManager DVBIDBusManager;
typedef struct _DVBIDBusManagerIface DVBIDBusManagerIface;

#define DVB_TYPE_ID_BUS_MANAGER_PROXY (dvb_id_bus_manager_proxy_get_type ())
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_CHANNEL_GROUP_INFO (dvb_channel_group_info_get_type ())
typedef struct _DVBChannelGroupInfo DVBChannelGroupInfo;

#define DVB_TYPE_ADAPTER_INFO (dvb_adapter_info_get_type ())
typedef struct _DVBAdapterInfo DVBAdapterInfo;

#define DVB_TYPE_MANAGER (dvb_manager_get_type ())
#define DVB_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MANAGER, DVBManager))
#define DVB_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MANAGER, DVBManagerClass))
#define DVB_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MANAGER))
#define DVB_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MANAGER))
#define DVB_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MANAGER, DVBManagerClass))

typedef struct _DVBManager DVBManager;
typedef struct _DVBManagerClass DVBManagerClass;
typedef struct _DVBManagerPrivate DVBManagerPrivate;

#define DVB_MANAGER_TYPE_SCANNER_DATA (dvb_manager_scanner_data_get_type ())
#define DVB_MANAGER_SCANNER_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_MANAGER_TYPE_SCANNER_DATA, DVBManagerScannerData))
#define DVB_MANAGER_SCANNER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_MANAGER_TYPE_SCANNER_DATA, DVBManagerScannerDataClass))
#define DVB_MANAGER_IS_SCANNER_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_MANAGER_TYPE_SCANNER_DATA))
#define DVB_MANAGER_IS_SCANNER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_MANAGER_TYPE_SCANNER_DATA))
#define DVB_MANAGER_SCANNER_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_MANAGER_TYPE_SCANNER_DATA, DVBManagerScannerDataClass))

typedef struct _DVBManagerScannerData DVBManagerScannerData;
typedef struct _DVBManagerScannerDataClass DVBManagerScannerDataClass;

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;
enum  {
	DVB_MANAGER_0_PROPERTY,
	DVB_MANAGER_DEVICE_GROUPS_PROPERTY,
	DVB_MANAGER_DEVS_PROPERTY,
	DVB_MANAGER_NUM_PROPERTIES
};
static GParamSpec* dvb_manager_properties[DVB_MANAGER_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DVBManagerScannerDataPrivate DVBManagerScannerDataPrivate;

#define DVB_TYPE_SCANNER (dvb_scanner_get_type ())
#define DVB_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SCANNER, DVBScanner))
#define DVB_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SCANNER, DVBScannerClass))
#define DVB_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SCANNER))
#define DVB_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SCANNER))
#define DVB_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SCANNER, DVBScannerClass))

typedef struct _DVBScanner DVBScanner;
typedef struct _DVBScannerClass DVBScannerClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_ID_BUS_SCANNER (dvb_id_bus_scanner_get_type ())
#define DVB_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScanner))
#define DVB_IS_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_SCANNER))
#define DVB_ID_BUS_SCANNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScannerIface))

typedef struct _DVBIDBusScanner DVBIDBusScanner;
typedef struct _DVBIDBusScannerIface DVBIDBusScannerIface;

#define DVB_TYPE_ID_BUS_SCANNER_PROXY (dvb_id_bus_scanner_proxy_get_type ())

#define DVB_TYPE_FACTORY (dvb_factory_get_type ())
#define DVB_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_FACTORY, DVBFactory))
#define DVB_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_FACTORY, DVBFactoryClass))
#define DVB_IS_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_FACTORY))
#define DVB_IS_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_FACTORY))
#define DVB_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_FACTORY, DVBFactoryClass))

typedef struct _DVBFactory DVBFactory;
typedef struct _DVBFactoryClass DVBFactoryClass;

#define DVB_DATABASE_TYPE_CONFIG_STORE (dvb_database_config_store_get_type ())
#define DVB_DATABASE_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStore))
#define DVB_DATABASE_IS_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE))
#define DVB_DATABASE_CONFIG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStoreIface))

typedef struct _DVBdatabaseConfigStore DVBdatabaseConfigStore;
typedef struct _DVBdatabaseConfigStoreIface DVBdatabaseConfigStoreIface;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DVB_TYPE_ID_BUS_DEVICE_GROUP (dvb_id_bus_device_group_get_type ())
#define DVB_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroup))
#define DVB_IS_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP))
#define DVB_ID_BUS_DEVICE_GROUP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroupIface))

typedef struct _DVBIDBusDeviceGroup DVBIDBusDeviceGroup;
typedef struct _DVBIDBusDeviceGroupIface DVBIDBusDeviceGroupIface;

#define DVB_TYPE_ID_BUS_DEVICE_GROUP_PROXY (dvb_id_bus_device_group_proxy_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define DVB_TYPE_CHANNEL_LIST (dvb_channel_list_get_type ())
#define DVB_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelList))
#define DVB_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))
#define DVB_IS_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_LIST))
#define DVB_IS_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_LIST))
#define DVB_CHANNEL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))

typedef struct _DVBChannelList DVBChannelList;
typedef struct _DVBChannelListClass DVBChannelListClass;

#define DVB_DATABASE_TYPE_TIMERS_STORE (dvb_database_timers_store_get_type ())
#define DVB_DATABASE_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStore))
#define DVB_DATABASE_IS_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE))
#define DVB_DATABASE_TIMERS_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStoreIface))

typedef struct _DVBdatabaseTimersStore DVBdatabaseTimersStore;
typedef struct _DVBdatabaseTimersStoreIface DVBdatabaseTimersStoreIface;

#define DVB_TYPE_TIMER (dvb_timer_get_type ())
#define DVB_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_TIMER, DVBTimer))
#define DVB_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_TIMER, DVBTimerClass))
#define DVB_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_TIMER))
#define DVB_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_TIMER))
#define DVB_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_TIMER, DVBTimerClass))

typedef struct _DVBTimer DVBTimer;
typedef struct _DVBTimerClass DVBTimerClass;

#define DVB_TYPE_RECORDER (dvb_recorder_get_type ())
#define DVB_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_RECORDER, DVBRecorder))
#define DVB_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_RECORDER, DVBRecorderClass))
#define DVB_IS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_RECORDER))
#define DVB_IS_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_RECORDER))
#define DVB_RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_RECORDER, DVBRecorderClass))

typedef struct _DVBRecorder DVBRecorder;
typedef struct _DVBRecorderClass DVBRecorderClass;

#define DVB_TYPE_RECORDINGS_STORE (dvb_recordings_store_get_type ())
#define DVB_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStore))
#define DVB_RECORDINGS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStoreClass))
#define DVB_IS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_RECORDINGS_STORE))
#define DVB_IS_RECORDINGS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_RECORDINGS_STORE))
#define DVB_RECORDINGS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_RECORDINGS_STORE, DVBRecordingsStoreClass))

typedef struct _DVBRecordingsStore DVBRecordingsStore;
typedef struct _DVBRecordingsStoreClass DVBRecordingsStoreClass;

#define DVB_TYPE_MEDIA_FACTORY (dvb_media_factory_get_type ())
#define DVB_MEDIA_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactory))
#define DVB_MEDIA_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactoryClass))
#define DVB_IS_MEDIA_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MEDIA_FACTORY))
#define DVB_IS_MEDIA_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MEDIA_FACTORY))
#define DVB_MEDIA_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactoryClass))

typedef struct _DVBMediaFactory DVBMediaFactory;
typedef struct _DVBMediaFactoryClass DVBMediaFactoryClass;

#define DVB_DATABASE_TYPE_EPG_STORE (dvb_database_epg_store_get_type ())
#define DVB_DATABASE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStore))
#define DVB_DATABASE_IS_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_EPG_STORE))
#define DVB_DATABASE_EPG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStoreIface))

typedef struct _DVBdatabaseEPGStore DVBdatabaseEPGStore;
typedef struct _DVBdatabaseEPGStoreIface DVBdatabaseEPGStoreIface;

#define DVB_TYPE_EVENT (dvb_event_get_type ())
#define DVB_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT, DVBEvent))
#define DVB_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT, DVBEventClass))
#define DVB_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT))
#define DVB_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT))
#define DVB_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT, DVBEventClass))

typedef struct _DVBEvent DVBEvent;
typedef struct _DVBEventClass DVBEventClass;
enum  {
	DVB_MANAGER_SCANNER_DATA_0_PROPERTY,
	DVB_MANAGER_SCANNER_DATA_NUM_PROPERTIES
};
static GParamSpec* dvb_manager_scanner_data_properties[DVB_MANAGER_SCANNER_DATA_NUM_PROPERTIES];

struct _DVBChannelGroupInfo {
	gint id;
	gchar* name;
};

struct _DVBAdapterInfo {
	gchar* name;
	gboolean type_t;
	gboolean type_s;
	gboolean type_c;
};

struct _DVBIDBusManagerIface {
	GTypeInterface parent_iface;
	gboolean (*GetScannerForDevice) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, char** opath, gchar** dbusiface, GError** error);
	char** (*GetRegisteredDeviceGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetDeviceGroup) (DVBIDBusManager* self, guint group_id, char** opath, GError** error);
	gboolean (*AddDeviceToNewGroup) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, const gchar* channels_conf, const gchar* recordings_dir, const gchar* name, GError** error);
	gboolean (*GetNameOfRegisteredDevice) (DVBIDBusManager* self, guint adapter, guint frontend, gchar** name, GError** error);
	gint (*GetDeviceGroupSize) (DVBIDBusManager* self, GError** error);
	DVBChannelGroupInfo* (*GetChannelGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*AddChannelGroup) (DVBIDBusManager* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*RemoveChannelGroup) (DVBIDBusManager* self, gint channel_group_id, GError** error);
	GHashTable** (*GetDevices) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetAdapterInfo) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterInfo* info, GError** error);
};

struct _DVBManager {
	GObject parent_instance;
	DVBManagerPrivate * priv;
};

struct _DVBManagerClass {
	GObjectClass parent_class;
};

struct _DVBManagerPrivate {
	GeeHashMap* scanners;
	GRecMutex __lock_scanners;
	GeeHashMap* groups;
	GRecMutex __lock_groups;
	GeeArrayList* devices;
	GRecMutex __lock_devices;
	guint device_group_counter;
	GUdevClient* udev_client;
};

struct _DVBManagerScannerData {
	GObject parent_instance;
	DVBManagerScannerDataPrivate * priv;
	DVBScanner* scanner;
	gulong signal_id;
};

struct _DVBManagerScannerDataClass {
	GObjectClass parent_class;
};

struct _DVBIDBusScannerIface {
	GTypeInterface parent_iface;
	void (*Run) (DVBIDBusScanner* self, GError** error);
	void (*Destroy) (DVBIDBusScanner* self, GError** error);
	gboolean (*WriteAllChannelsToFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
	gboolean (*WriteChannelsToFile) (DVBIDBusScanner* self, guint* channel_sids, gint channel_sids_length1, const gchar* path, GError** error);
	gboolean (*AddScanningData) (DVBIDBusScanner* self, GHashTable* data, GError** error);
	gboolean (*AddScanningDataFromFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
};

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseConfigStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_device_groups) (DVBdatabaseConfigStore* self, GError** error);
	DVBDeviceGroup* (*get_device_group) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_last_device) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_group_member) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
	gboolean (*add_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
	gboolean (*remove_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*add_device_to_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*remove_device_from_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*update_from_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*get_parent_groups) (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, gint* group_ids_length1, GError** error);
	gboolean (*add_channel_group) (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*remove_channel_group) (DVBdatabaseConfigStore* self, gint group_id, GError** error);
	GeeList* (*get_channel_groups) (DVBdatabaseConfigStore* self, GError** error);
	GeeList* (*get_channels_of_group) (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
	gboolean (*add_channel_to_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
	gboolean (*remove_channel_from_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
};

struct _DVBIDBusDeviceGroupIface {
	GTypeInterface parent_iface;
	DVBAdapterType (*GetType) (DVBIDBusDeviceGroup* self, GError** error);
	char* (*GetRecorder) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*AddDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	gboolean (*RemoveDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	char* (*GetChannelList) (DVBIDBusDeviceGroup* self, GError** error);
	gchar* (*GetName) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetName) (DVBIDBusDeviceGroup* self, const gchar* name, GError** error);
	gchar** (*GetMembers) (DVBIDBusDeviceGroup* self, gint* result_length1, GError** error);
	gboolean (*GetSchedule) (DVBIDBusDeviceGroup* self, guint channel_sid, char** opath, GError** error);
	gchar* (*GetRecordingsDirectory) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetRecordingsDirectory) (DVBIDBusDeviceGroup* self, const gchar* location, GError** error);
};

struct _DVBdatabaseTimersStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_timers_of_device_group) (DVBdatabaseTimersStore* self, DVBDeviceGroup* dev, GError** error);
	gboolean (*add_timer_to_device_group) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_timer_from_device_group) (DVBdatabaseTimersStore* self, guint timer_id, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_all_timers_from_device_group) (DVBdatabaseTimersStore* self, guint group_id, GError** error);
	gboolean (*update_timer) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
};

struct _DVBdatabaseEPGStoreIface {
	GTypeInterface parent_iface;
	gboolean (*add_or_update_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	DVBEvent* (*get_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_older_than) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	gboolean (*contains_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	GeeList* (*get_events) (DVBdatabaseEPGStore* self, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_of_group) (DVBdatabaseEPGStore* self, guint group_id, GError** error);
};

static gint DVBManager_private_offset;
static gpointer dvb_manager_parent_class = NULL;
static DVBLoggingLogger* dvb_manager_log;
static DVBLoggingLogger* dvb_manager_log = NULL;
static DVBManager* dvb_manager_instance;
static DVBManager* dvb_manager_instance = NULL;
static GRecMutex dvb_manager_instance_mutex;
static GRecMutex dvb_manager_instance_mutex = {0};
VALA_EXTERN GDBusConnection* main_conn;
VALA_EXTERN GstRTSPServer* dvb_rtsp_server_server;
static gpointer dvb_manager_scanner_data_parent_class = NULL;
static DVBIDBusManagerIface * dvb_manager_dvb_id_bus_manager_parent_iface = NULL;

VALA_EXTERN GType dvb_id_bus_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_manager_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_channel_group_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBChannelGroupInfo* dvb_channel_group_info_dup (const DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_free (DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_copy (const DVBChannelGroupInfo* self,
                                  DVBChannelGroupInfo* dest);
VALA_EXTERN void dvb_channel_group_info_destroy (DVBChannelGroupInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBChannelGroupInfo, dvb_channel_group_info_destroy)
VALA_EXTERN GType dvb_adapter_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBAdapterInfo* dvb_adapter_info_dup (const DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_free (DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_copy (const DVBAdapterInfo* self,
                            DVBAdapterInfo* dest);
VALA_EXTERN void dvb_adapter_info_destroy (DVBAdapterInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBAdapterInfo, dvb_adapter_info_destroy)
VALA_EXTERN GType dvb_id_bus_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusManager, g_object_unref)
VALA_EXTERN GType dvb_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBManager, g_object_unref)
static GType dvb_manager_scanner_data_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBManagerScannerData, g_object_unref)
VALA_EXTERN GType dvb_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDeviceGroup, g_object_unref)
VALA_EXTERN GType dvb_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDevice, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBManager* dvb_manager_get_instance (void);
VALA_EXTERN DVBManager* dvb_manager_new (void);
VALA_EXTERN DVBManager* dvb_manager_construct (GType object_type);
VALA_EXTERN void dvb_manager_shutdown (void);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN GType dvb_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBScanner, g_object_unref)
VALA_EXTERN void dvb_scanner_do_destroy (DVBScanner* self);
VALA_EXTERN void dvb_device_group_destroy (DVBDeviceGroup* self);
static gboolean dvb_manager_real_GetScannerForDevice (DVBIDBusManager* base,
                                               guint adapter,
                                               guint frontend,
                                               DVBAdapterType type,
                                               char** opath,
                                               gchar** dbusiface,
                                               GError** error);
VALA_EXTERN DVBDevice* dvb_manager_get_device (DVBManager* self,
                                   guint adapter,
                                   guint frontend);
static DVBDeviceGroup** dvb_manager_get_device_groups_of_device (DVBManager* self,
                                                          DVBDevice* device,
                                                          gint* result_length1);
VALA_EXTERN void dvb_device_group_stop_epg_scanner (DVBDeviceGroup* self);
static DVBManagerScannerData* dvb_manager_scanner_data_new (void);
static DVBManagerScannerData* dvb_manager_scanner_data_construct (GType object_type);
VALA_EXTERN DVBScanner* dvb_scanner_new (DVBDevice* device,
                             DVBAdapterType type);
VALA_EXTERN DVBScanner* dvb_scanner_construct (GType object_type,
                                   DVBDevice* device,
                                   DVBAdapterType type);
VALA_EXTERN void dvb_utils_dbus_register_object (GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     GDBusConnection* conn,
                                     const gchar* object_path,
                                     gconstpointer obj);
VALA_EXTERN GType dvb_id_bus_scanner_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_scanner_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_id_bus_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusScanner, g_object_unref)
static void dvb_manager_on_scanner_destroyed (DVBManager* self,
                                       DVBScanner* scanner);
static void _dvb_manager_on_scanner_destroyed_dvb_scanner_destroyed (DVBScanner* _sender,
                                                              gpointer self);
static gboolean dvb_manager_real_GetDeviceGroup (DVBIDBusManager* base,
                                          guint group_id,
                                          char** opath,
                                          GError** error);
static char** dvb_manager_real_GetRegisteredDeviceGroups (DVBIDBusManager* base,
                                                   gint* result_length1,
                                                   GError** error);
static gboolean dvb_manager_real_AddDeviceToNewGroup (DVBIDBusManager* base,
                                               guint adapter,
                                               guint frontend,
                                               DVBAdapterType type,
                                               const gchar* channels_conf,
                                               const gchar* recordings_dir,
                                               const gchar* name,
                                               GError** error);
VALA_EXTERN gboolean dvb_manager_device_is_in_any_group (DVBManager* self,
                                             DVBDevice* device,
                                             DVBAdapterType type);
VALA_EXTERN DVBDeviceGroup* dvb_device_group_new (guint id,
                                      GFile* channels_conf,
                                      GFile* recordings_dir,
                                      DVBAdapterType type,
                                      gboolean with_epg_scanner);
VALA_EXTERN DVBDeviceGroup* dvb_device_group_construct (GType object_type,
                                            guint id,
                                            GFile* channels_conf,
                                            GFile* recordings_dir,
                                            DVBAdapterType type,
                                            gboolean with_epg_scanner);
VALA_EXTERN void dvb_device_group_set_Name (DVBDeviceGroup* self,
                                const gchar* value);
VALA_EXTERN gboolean dvb_manager_add_device_group (DVBManager* self,
                                       DVBDeviceGroup* devgroup,
                                       gboolean store);
VALA_EXTERN gboolean dvb_device_group_add (DVBDeviceGroup* self,
                               DVBDevice* device);
VALA_EXTERN DVBFactory* dvb_factory_new (void);
VALA_EXTERN DVBFactory* dvb_factory_construct (GType object_type);
VALA_EXTERN GType dvb_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBFactory, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_channel_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelGroup, g_object_unref)
VALA_EXTERN GType dvb_channel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannel, g_object_unref)
VALA_EXTERN GType dvb_database_config_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseConfigStore, g_object_unref)
VALA_EXTERN DVBdatabaseConfigStore* dvb_factory_get_config_store (DVBFactory* self);
VALA_EXTERN gboolean dvb_database_config_store_add_device_to_group (DVBdatabaseConfigStore* self,
                                                        DVBDevice* dev,
                                                        DVBDeviceGroup* devgroup,
                                                        GError** error);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN GType dvb_id_bus_device_group_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_device_group_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType dvb_id_bus_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusDeviceGroup, g_object_unref)
VALA_EXTERN void dvb_manager_restore_device_group_and_timers (DVBManager* self,
                                                  DVBDeviceGroup* device_group);
VALA_EXTERN void dvb_device_group_start_epg_scanner (DVBDeviceGroup* self);
static gboolean dvb_manager_real_GetNameOfRegisteredDevice (DVBIDBusManager* base,
                                                     guint adapter,
                                                     guint frontend,
                                                     gchar** name,
                                                     GError** error);
VALA_EXTERN const gchar* dvb_device_get_Name (DVBDevice* self);
static gint dvb_manager_real_GetDeviceGroupSize (DVBIDBusManager* base,
                                          GError** error);
static DVBChannelGroupInfo* dvb_manager_real_GetChannelGroups (DVBIDBusManager* base,
                                                        gint* result_length1,
                                                        GError** error);
VALA_EXTERN GeeList* dvb_database_config_store_get_channel_groups (DVBdatabaseConfigStore* self,
                                                       GError** error);
VALA_EXTERN gint dvb_channel_group_get_id (DVBChannelGroup* self);
VALA_EXTERN const gchar* dvb_channel_group_get_name (DVBChannelGroup* self);
static gboolean dvb_manager_real_AddChannelGroup (DVBIDBusManager* base,
                                           const gchar* name,
                                           gint* channel_group_id,
                                           GError** error);
VALA_EXTERN gboolean dvb_database_config_store_add_channel_group (DVBdatabaseConfigStore* self,
                                                      const gchar* name,
                                                      gint* channel_group_id,
                                                      GError** error);
static gboolean dvb_manager_real_RemoveChannelGroup (DVBIDBusManager* base,
                                              gint channel_group_id,
                                              GError** error);
VALA_EXTERN gboolean dvb_database_config_store_remove_channel_group (DVBdatabaseConfigStore* self,
                                                         gint group_id,
                                                         GError** error);
static GHashTable** dvb_manager_real_GetDevices (DVBIDBusManager* base,
                                          gint* result_length1,
                                          GError** error);
VALA_EXTERN guint dvb_device_get_Adapter (DVBDevice* self);
VALA_EXTERN guint dvb_device_get_Frontend (DVBDevice* self);
static gboolean dvb_manager_real_GetAdapterInfo (DVBIDBusManager* base,
                                          guint adapter,
                                          guint frontend,
                                          DVBAdapterInfo* info,
                                          GError** error);
VALA_EXTERN gboolean dvb_device_isTerrestrial (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isSatellite (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isCable (DVBDevice* self);
VALA_EXTERN guint dvb_device_group_get_Id (DVBDeviceGroup* self);
VALA_EXTERN gint dvb_device_group_get_size (DVBDeviceGroup* self);
VALA_EXTERN DVBAdapterType dvb_device_group_get_Type (DVBDeviceGroup* self);
VALA_EXTERN void dvb_logging_logger_warning (DVBLoggingLogger* self,
                                 const gchar* format,
                                 ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean dvb_database_config_store_add_device_group (DVBdatabaseConfigStore* self,
                                                     DVBDeviceGroup* dev_group,
                                                     GError** error);
static void dvb_manager_on_device_removed_from_group (DVBManager* self,
                                               DVBIDBusDeviceGroup* idevgroup,
                                               guint adapter,
                                               guint frontend);
static void _dvb_manager_on_device_removed_from_group_dvb_id_bus_device_group_device_removed (DVBIDBusDeviceGroup* _sender,
                                                                                       guint adapter,
                                                                                       guint frontend,
                                                                                       gpointer self);
VALA_EXTERN gboolean dvb_manager_restore_device_group (DVBManager* self,
                                           DVBDeviceGroup* device_group,
                                           gboolean store);
VALA_EXTERN void dvb_logging_logger_info (DVBLoggingLogger* self,
                              const gchar* format,
                              ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN GType dvb_channel_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelList, g_object_unref)
VALA_EXTERN DVBChannelList* dvb_device_group_get_Channels (DVBDeviceGroup* self);
VALA_EXTERN void dvb_channel_list_load (DVBChannelList* self,
                            DVBAdapterType type,
                            GError** error);
VALA_EXTERN void dvb_manager_restore_timers (DVBManager* self,
                                 DVBDeviceGroup* device_group);
VALA_EXTERN GType dvb_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBTimer, g_object_unref)
VALA_EXTERN GType dvb_database_timers_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseTimersStore, g_object_unref)
VALA_EXTERN DVBdatabaseTimersStore* dvb_factory_get_timers_store (DVBFactory* self);
VALA_EXTERN GeeList* dvb_database_timers_store_get_all_timers_of_device_group (DVBdatabaseTimersStore* self,
                                                                   DVBDeviceGroup* dev,
                                                                   GError** error);
VALA_EXTERN GType dvb_recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBRecorder, g_object_unref)
VALA_EXTERN DVBRecorder* dvb_device_group_get_recorder (DVBDeviceGroup* self);
VALA_EXTERN guint32 dvb_timer_get_Id (DVBTimer* self);
VALA_EXTERN gboolean dvb_recorder_add_timer (DVBRecorder* self,
                                 DVBTimer* new_timer,
                                 guint32* timer_id);
VALA_EXTERN gboolean dvb_database_timers_store_remove_timer_from_device_group (DVBdatabaseTimersStore* self,
                                                                   guint timer_id,
                                                                   DVBDeviceGroup* dev,
                                                                   GError** error);
VALA_EXTERN GType dvb_recordings_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBRecordingsStore, g_object_unref)
VALA_EXTERN DVBRecordingsStore* dvb_recordings_store_get_instance (void);
VALA_EXTERN void dvb_recordings_store_update_last_id (DVBRecordingsStore* self,
                                          guint32 new_last_id);
VALA_EXTERN GType dvb_media_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBMediaFactory, g_object_unref)
VALA_EXTERN DVBMediaFactory* dvb_media_factory_new (void);
VALA_EXTERN DVBMediaFactory* dvb_media_factory_construct (GType object_type);
VALA_EXTERN guint dvb_channel_get_Sid (DVBChannel* self);
VALA_EXTERN DVBDeviceGroup* dvb_manager_get_device_group_if_exists (DVBManager* self,
                                                        guint group_id);
VALA_EXTERN gboolean dvb_device_group_contains (DVBDeviceGroup* self,
                                    DVBDevice* device);
VALA_EXTERN DVBDevice* dvb_scanner_get_Device (DVBScanner* self);
VALA_EXTERN gboolean dvb_database_config_store_is_last_device (DVBdatabaseConfigStore* self,
                                                   guint group_id,
                                                   GError** error);
VALA_EXTERN gboolean dvb_database_config_store_remove_device_group (DVBdatabaseConfigStore* self,
                                                        DVBDeviceGroup* devgroup,
                                                        GError** error);
VALA_EXTERN gpointer dvb_event_ref (gpointer instance);
VALA_EXTERN void dvb_event_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_param_spec_event (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void dvb_value_set_event (GValue* value,
                          gpointer v_object);
VALA_EXTERN void dvb_value_take_event (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer dvb_value_get_event (const GValue* value);
VALA_EXTERN GType dvb_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEvent, dvb_event_unref)
VALA_EXTERN GType dvb_database_epg_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseEPGStore, g_object_unref)
VALA_EXTERN DVBdatabaseEPGStore* dvb_factory_get_epg_store (DVBFactory* self);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_of_group (DVBdatabaseEPGStore* self,
                                                        guint group_id,
                                                        GError** error);
VALA_EXTERN gboolean dvb_database_timers_store_remove_all_timers_from_device_group (DVBdatabaseTimersStore* self,
                                                                        guint group_id,
                                                                        GError** error);
static DVBDeviceGroup* dvb_manager_create_device_group_by_id (DVBManager* self,
                                                       guint group_id);
VALA_EXTERN DVBDeviceGroup* dvb_database_config_store_get_device_group (DVBdatabaseConfigStore* self,
                                                            guint group_id,
                                                            GError** error);
static void dvb_manager_first_add_device (DVBManager* self,
                                   GUdevDevice* device);
VALA_EXTERN DVBDevice* dvb_device_new_with_udev (GUdevDevice* device,
                                     const gchar* dev_file,
                                     guint adapter,
                                     guint frontend);
VALA_EXTERN DVBDevice* dvb_device_construct_with_udev (GType object_type,
                                           GUdevDevice* device,
                                           const gchar* dev_file,
                                           guint adapter,
                                           guint frontend);
static void dvb_manager_on_udev_event (DVBManager* self,
                                const gchar* action,
                                GUdevDevice* device);
VALA_EXTERN gboolean dvb_database_config_store_get_parent_groups (DVBdatabaseConfigStore* self,
                                                      guint adapter,
                                                      guint frontend,
                                                      guint** group_ids,
                                                      gint* group_ids_length1,
                                                      GError** error);
VALA_EXTERN gboolean dvb_device_group_remove (DVBDeviceGroup* self,
                                  DVBDevice* device);
VALA_EXTERN GeeCollection* dvb_manager_get_device_groups (DVBManager* self);
VALA_EXTERN GeeArrayList* dvb_manager_get_devs (DVBManager* self);
static void dvb_manager_scanner_data_finalize (GObject * obj);
static GType dvb_manager_scanner_data_get_type_once (void);
static GObject * dvb_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _dvb_manager_on_udev_event_g_udev_client_uevent (GUdevClient* _sender,
                                                      const gchar* action,
                                                      GUdevDevice* device,
                                                      gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN gboolean dvb_id_bus_manager_GetScannerForDevice (DVBIDBusManager* self,
                                                 guint adapter,
                                                 guint frontend,
                                                 DVBAdapterType type,
                                                 char** opath,
                                                 gchar** dbusiface,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetDeviceGroup (DVBIDBusManager* self,
                                            guint group_id,
                                            char** opath,
                                            GError** error);
VALA_EXTERN char** dvb_id_bus_manager_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                     gint* result_length1,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_AddDeviceToNewGroup (DVBIDBusManager* self,
                                                 guint adapter,
                                                 guint frontend,
                                                 DVBAdapterType type,
                                                 const gchar* channels_conf,
                                                 const gchar* recordings_dir,
                                                 const gchar* name,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                       guint adapter,
                                                       guint frontend,
                                                       gchar** name,
                                                       GError** error);
VALA_EXTERN gint dvb_id_bus_manager_GetDeviceGroupSize (DVBIDBusManager* self,
                                            GError** error);
VALA_EXTERN DVBChannelGroupInfo* dvb_id_bus_manager_GetChannelGroups (DVBIDBusManager* self,
                                                          gint* result_length1,
                                                          GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_AddChannelGroup (DVBIDBusManager* self,
                                             const gchar* name,
                                             gint* channel_group_id,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_RemoveChannelGroup (DVBIDBusManager* self,
                                                gint channel_group_id,
                                                GError** error);
VALA_EXTERN GHashTable** dvb_id_bus_manager_GetDevices (DVBIDBusManager* self,
                                            gint* result_length1,
                                            GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetAdapterInfo (DVBIDBusManager* self,
                                            guint adapter,
                                            guint frontend,
                                            DVBAdapterInfo* info,
                                            GError** error);
static void dvb_manager_finalize (GObject * obj);
static GType dvb_manager_get_type_once (void);
static void _vala_dvb_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* DVB_MANAGER_UDEV_SUBSYSTEMS[2] = {"dvb", NULL};

static inline gpointer
dvb_manager_get_instance_private (DVBManager* self)
{
	return G_STRUCT_MEMBER_P (self, DVBManager_private_offset);
}

DVBManager*
dvb_manager_get_instance (void)
{
	DVBManager* _tmp0_;
	DVBManager* _tmp2_;
	DVBManager* result;
	g_rec_mutex_lock (&dvb_manager_instance_mutex);
	_tmp0_ = dvb_manager_instance;
	if (_tmp0_ == NULL) {
		DVBManager* _tmp1_;
		_tmp1_ = dvb_manager_new ();
		_g_object_unref0 (dvb_manager_instance);
		dvb_manager_instance = _tmp1_;
	}
	g_rec_mutex_unlock (&dvb_manager_instance_mutex);
	_tmp2_ = dvb_manager_instance;
	result = _tmp2_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
dvb_manager_shutdown (void)
{
	DVBManager* m = NULL;
	DVBManager* _tmp0_;
	DVBManager* _tmp1_;
	DVBManager* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_rec_mutex_lock (&dvb_manager_instance_mutex);
	_tmp0_ = dvb_manager_instance;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	m = _tmp1_;
	_tmp2_ = dvb_manager_instance;
	if (_tmp2_ != NULL) {
		DVBManager* _tmp3_;
		_tmp3_ = m;
		_g_object_unref0 (_tmp3_->priv->udev_client);
		_tmp3_->priv->udev_client = NULL;
		{
			DVBManager* _tmp4_;
			GeeHashMap* _tmp5_;
			_tmp4_ = m;
			_tmp5_ = _tmp4_->priv->scanners;
			g_rec_mutex_lock (&_tmp4_->priv->__lock_scanners);
			{
				DVBManager* _tmp22_;
				GeeHashMap* _tmp23_;
				{
					GeeIterator* _data_it = NULL;
					DVBManager* _tmp6_;
					GeeHashMap* _tmp7_;
					GeeCollection* _tmp8_;
					GeeCollection* _tmp9_;
					GeeCollection* _tmp10_;
					GeeIterator* _tmp11_;
					GeeIterator* _tmp12_;
					_tmp6_ = m;
					_tmp7_ = _tmp6_->priv->scanners;
					_tmp8_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = _tmp9_;
					_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
					_tmp12_ = _tmp11_;
					_g_object_unref0 (_tmp10_);
					_data_it = _tmp12_;
					while (TRUE) {
						GeeIterator* _tmp13_;
						DVBManagerScannerData* data = NULL;
						GeeIterator* _tmp14_;
						gpointer _tmp15_;
						DVBLoggingLogger* _tmp16_;
						DVBManagerScannerData* _tmp17_;
						DVBScanner* _tmp18_;
						DVBManagerScannerData* _tmp19_;
						DVBManagerScannerData* _tmp20_;
						DVBScanner* _tmp21_;
						_tmp13_ = _data_it;
						if (!gee_iterator_next (_tmp13_)) {
							break;
						}
						_tmp14_ = _data_it;
						_tmp15_ = gee_iterator_get (_tmp14_);
						data = (DVBManagerScannerData*) _tmp15_;
						_tmp16_ = dvb_manager_log;
						dvb_logging_logger_debug (_tmp16_, "Manager.vala:95: Stopping scanner");
						_tmp17_ = data;
						_tmp18_ = _tmp17_->scanner;
						_tmp19_ = data;
						g_signal_handler_disconnect ((GObject*) _tmp18_, _tmp19_->signal_id);
						_tmp20_ = data;
						_tmp21_ = _tmp20_->scanner;
						dvb_scanner_do_destroy (_tmp21_);
						_g_object_unref0 (data);
					}
					_g_object_unref0 (_data_it);
				}
				_tmp22_ = m;
				_tmp23_ = _tmp22_->priv->scanners;
				gee_abstract_map_clear ((GeeAbstractMap*) _tmp23_);
			}
			__finally0:
			{
				DVBManager* _tmp24_;
				GeeHashMap* _tmp25_;
				_tmp24_ = m;
				_tmp25_ = _tmp24_->priv->scanners;
				g_rec_mutex_unlock (&_tmp24_->priv->__lock_scanners);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (m);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		{
			DVBManager* _tmp26_;
			GeeArrayList* _tmp27_;
			_tmp26_ = m;
			_tmp27_ = _tmp26_->priv->devices;
			g_rec_mutex_lock (&_tmp26_->priv->__lock_devices);
			{
				DVBManager* _tmp28_;
				GeeArrayList* _tmp29_;
				_tmp28_ = m;
				_tmp29_ = _tmp28_->priv->devices;
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp29_);
			}
			__finally1:
			{
				DVBManager* _tmp30_;
				GeeArrayList* _tmp31_;
				_tmp30_ = m;
				_tmp31_ = _tmp30_->priv->devices;
				g_rec_mutex_unlock (&_tmp30_->priv->__lock_devices);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (m);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		{
			DVBManager* _tmp32_;
			GeeHashMap* _tmp33_;
			_tmp32_ = m;
			_tmp33_ = _tmp32_->priv->groups;
			g_rec_mutex_lock (&_tmp32_->priv->__lock_groups);
			{
				DVBManager* _tmp45_;
				GeeHashMap* _tmp46_;
				{
					GeeIterator* _devgrp_it = NULL;
					DVBManager* _tmp34_;
					GeeHashMap* _tmp35_;
					GeeCollection* _tmp36_;
					GeeCollection* _tmp37_;
					GeeCollection* _tmp38_;
					GeeIterator* _tmp39_;
					GeeIterator* _tmp40_;
					_tmp34_ = m;
					_tmp35_ = _tmp34_->priv->groups;
					_tmp36_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp35_);
					_tmp37_ = _tmp36_;
					_tmp38_ = _tmp37_;
					_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
					_tmp40_ = _tmp39_;
					_g_object_unref0 (_tmp38_);
					_devgrp_it = _tmp40_;
					while (TRUE) {
						GeeIterator* _tmp41_;
						DVBDeviceGroup* devgrp = NULL;
						GeeIterator* _tmp42_;
						gpointer _tmp43_;
						DVBDeviceGroup* _tmp44_;
						_tmp41_ = _devgrp_it;
						if (!gee_iterator_next (_tmp41_)) {
							break;
						}
						_tmp42_ = _devgrp_it;
						_tmp43_ = gee_iterator_get (_tmp42_);
						devgrp = (DVBDeviceGroup*) _tmp43_;
						_tmp44_ = devgrp;
						dvb_device_group_destroy (_tmp44_);
						_g_object_unref0 (devgrp);
					}
					_g_object_unref0 (_devgrp_it);
				}
				_tmp45_ = m;
				_tmp46_ = _tmp45_->priv->groups;
				gee_abstract_map_clear ((GeeAbstractMap*) _tmp46_);
			}
			__finally2:
			{
				DVBManager* _tmp47_;
				GeeHashMap* _tmp48_;
				_tmp47_ = m;
				_tmp48_ = _tmp47_->priv->groups;
				g_rec_mutex_unlock (&_tmp47_->priv->__lock_groups);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (m);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_g_object_unref0 (dvb_manager_instance);
		dvb_manager_instance = NULL;
	}
	g_rec_mutex_unlock (&dvb_manager_instance_mutex);
	_g_object_unref0 (m);
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @type: the type to scanned
         * @opath: Object path of the scanner service
         * @dbusiface: DBus interface of the scanner service
         * @returns: TRUE on success
         *
         * Get the object path of the channel scanner for this device.
         */
static void
_dvb_manager_on_scanner_destroyed_dvb_scanner_destroyed (DVBScanner* _sender,
                                                         gpointer self)
{
	dvb_manager_on_scanner_destroyed ((DVBManager*) self, _sender);
}

static gboolean
dvb_manager_real_GetScannerForDevice (DVBIDBusManager* base,
                                      guint adapter,
                                      guint frontend,
                                      DVBAdapterType type,
                                      char** opath,
                                      gchar** dbusiface,
                                      GError** error)
{
	DVBManager * self;
	char* _vala_opath = NULL;
	gchar* _vala_dbusiface = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	char* _tmp2_;
	gchar* _tmp3_;
	DVBDevice* device = NULL;
	DVBDevice* _tmp4_;
	DVBDevice* _tmp5_;
	gchar* _tmp6_;
	DVBDeviceGroup** groups = NULL;
	DVBDevice* _tmp7_;
	gint _tmp8_ = 0;
	DVBDeviceGroup** _tmp9_;
	gint groups_length1;
	gint _groups_size_;
	DVBDeviceGroup** _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBManager*) base;
	_tmp0_ = g_strdup_printf (DVB_CONSTANTS_DBUS_SCANNER_PATH, adapter, frontend);
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_vala_opath);
	_vala_opath = _tmp2_;
	_tmp3_ = g_strdup ("");
	_g_free0 (_vala_dbusiface);
	_vala_dbusiface = _tmp3_;
	_tmp4_ = dvb_manager_get_device (self, adapter, frontend);
	device = _tmp4_;
	_tmp5_ = device;
	if (_tmp5_ == NULL) {
		result = FALSE;
		_g_object_unref0 (device);
		_g_free0 (path);
		if (opath) {
			*opath = _vala_opath;
		} else {
			_g_free0 (_vala_opath);
		}
		if (dbusiface) {
			*dbusiface = _vala_dbusiface;
		} else {
			_g_free0 (_vala_dbusiface);
		}
		return result;
	}
	_tmp6_ = g_strdup ("org.gnome.DVB.Scanner");
	_g_free0 (_vala_dbusiface);
	_vala_dbusiface = _tmp6_;
	_tmp7_ = device;
	_tmp9_ = dvb_manager_get_device_groups_of_device (self, _tmp7_, &_tmp8_);
	groups = _tmp9_;
	groups_length1 = _tmp8_;
	_groups_size_ = groups_length1;
	_tmp10_ = groups;
	_tmp10__length1 = groups_length1;
	{
		DVBDeviceGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
		group_collection = _tmp10_;
		group_collection_length1 = _tmp10__length1;
		for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
			DVBDeviceGroup* _tmp11_;
			DVBDeviceGroup* group = NULL;
			_tmp11_ = _g_object_ref0 (group_collection[group_it]);
			group = _tmp11_;
			{
				DVBDeviceGroup* _tmp12_;
				_tmp12_ = group;
				dvb_device_group_stop_epg_scanner (_tmp12_);
				_g_object_unref0 (group);
			}
		}
	}
	{
		GeeHashMap* _tmp13_;
		_tmp13_ = self->priv->scanners;
		g_rec_mutex_lock (&self->priv->__lock_scanners);
		{
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
			_tmp14_ = self->priv->scanners;
			_tmp15_ = path;
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp14_, _tmp15_)) {
				DVBManagerScannerData* data = NULL;
				DVBManagerScannerData* _tmp16_;
				DVBManagerScannerData* _tmp17_;
				DVBDevice* _tmp18_;
				DVBScanner* _tmp19_;
				GDBusConnection* _tmp20_;
				const gchar* _tmp21_;
				DVBManagerScannerData* _tmp22_;
				DVBScanner* _tmp23_;
				DVBManagerScannerData* _tmp24_;
				DVBManagerScannerData* _tmp25_;
				DVBScanner* _tmp26_;
				gulong _tmp27_;
				GeeHashMap* _tmp28_;
				const gchar* _tmp29_;
				DVBManagerScannerData* _tmp30_;
				DVBLoggingLogger* _tmp31_;
				const gchar* _tmp32_;
				_tmp16_ = dvb_manager_scanner_data_new ();
				data = _tmp16_;
				_tmp17_ = data;
				_tmp18_ = device;
				_tmp19_ = dvb_scanner_new (_tmp18_, type);
				_g_object_unref0 (_tmp17_->scanner);
				_tmp17_->scanner = _tmp19_;
				_tmp20_ = main_conn;
				_tmp21_ = path;
				_tmp22_ = data;
				_tmp23_ = _tmp22_->scanner;
				dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_SCANNER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp20_, _tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScanner));
				_tmp24_ = data;
				_tmp25_ = data;
				_tmp26_ = _tmp25_->scanner;
				_tmp27_ = g_signal_connect_object (_tmp26_, "destroyed", (GCallback) _dvb_manager_on_scanner_destroyed_dvb_scanner_destroyed, self, 0);
				_tmp24_->signal_id = _tmp27_;
				_tmp28_ = self->priv->scanners;
				_tmp29_ = path;
				_tmp30_ = data;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
				_tmp31_ = dvb_manager_log;
				_tmp32_ = _vala_dbusiface;
				dvb_logging_logger_debug (_tmp31_, "Manager.vala:161: Created new Scanner D-Bus service for adapter %u, fr" \
"ontend %u (%s)", adapter, frontend, _tmp32_);
				_g_object_unref0 (data);
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp33_;
			_tmp33_ = self->priv->scanners;
			g_rec_mutex_unlock (&self->priv->__lock_scanners);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp34_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_object_unref), NULL);
				_g_object_unref0 (device);
				_g_free0 (path);
				_g_free0 (_vala_opath);
				_g_free0 (_vala_dbusiface);
				return _tmp34_;
			} else {
				gboolean _tmp35_ = FALSE;
				groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_object_unref), NULL);
				_g_object_unref0 (device);
				_g_free0 (path);
				_g_free0 (_vala_opath);
				_g_free0 (_vala_dbusiface);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp35_;
			}
		}
	}
	result = TRUE;
	groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (device);
	_g_free0 (path);
	if (opath) {
		*opath = _vala_opath;
	} else {
		_g_free0 (_vala_opath);
	}
	if (dbusiface) {
		*dbusiface = _vala_dbusiface;
	} else {
		_g_free0 (_vala_dbusiface);
	}
	return result;
}

/**
         * @group_id: A group ID
         * @path: Device group's DBus path
         * @returns: TRUE on success
         */
static gboolean
dvb_manager_real_GetDeviceGroup (DVBIDBusManager* base,
                                 guint group_id,
                                 char** opath,
                                 GError** error)
{
	DVBManager * self;
	char* _vala_opath = NULL;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBManager*) base;
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			GeeHashMap* _tmp1_;
			_tmp1_ = self->priv->groups;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) group_id))) {
				gchar* _tmp2_;
				gchar* _tmp3_;
				char* _tmp4_;
				_tmp2_ = g_strdup_printf (DVB_CONSTANTS_DBUS_DEVICE_GROUP_PATH, group_id);
				_tmp3_ = _tmp2_;
				_tmp4_ = g_strdup (_tmp3_);
				_g_free0 (_vala_opath);
				_vala_opath = _tmp4_;
				_g_free0 (_tmp3_);
				ret = TRUE;
			} else {
				char* _tmp5_;
				_tmp5_ = g_strdup ("");
				_g_free0 (_vala_opath);
				_vala_opath = _tmp5_;
				ret = FALSE;
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp6_;
			_tmp6_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp7_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_vala_opath);
				return _tmp7_;
			} else {
				gboolean _tmp8_ = FALSE;
				_g_free0 (_vala_opath);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp8_;
			}
		}
	}
	result = ret;
	if (opath) {
		*opath = _vala_opath;
	} else {
		_g_free0 (_vala_opath);
	}
	return result;
}

/**
         * @returns: Device groups' DBus path
         */
static char**
dvb_manager_real_GetRegisteredDeviceGroups (DVBIDBusManager* base,
                                            gint* result_length1,
                                            GError** error)
{
	DVBManager * self;
	char** devs = NULL;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	char** _tmp3_;
	gint devs_length1;
	gint _devs_size_;
	DVBLoggingLogger* _tmp4_;
	GeeHashMap* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint i = 0;
	char** _tmp24_;
	gint _tmp24__length1;
	GError* _inner_error0_ = NULL;
	char** result;
	self = (DVBManager*) base;
	_tmp0_ = self->priv->groups;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_new0 (char*, _tmp2_ + 1);
	devs = _tmp3_;
	devs_length1 = _tmp2_;
	_devs_size_ = devs_length1;
	_tmp4_ = dvb_manager_log;
	_tmp5_ = self->priv->groups;
	_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
	_tmp7_ = _tmp6_;
	dvb_logging_logger_debug (_tmp4_, "Manager.vala:196: %d", _tmp7_);
	i = 0;
	{
		GeeHashMap* _tmp8_;
		_tmp8_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			{
				GeeIterator* _key_it = NULL;
				GeeHashMap* _tmp9_;
				GeeSet* _tmp10_;
				GeeSet* _tmp11_;
				GeeSet* _tmp12_;
				GeeIterator* _tmp13_;
				GeeIterator* _tmp14_;
				_tmp9_ = self->priv->groups;
				_tmp10_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = _tmp11_;
				_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
				_tmp14_ = _tmp13_;
				_g_object_unref0 (_tmp12_);
				_key_it = _tmp14_;
				while (TRUE) {
					GeeIterator* _tmp15_;
					guint key = 0U;
					GeeIterator* _tmp16_;
					gpointer _tmp17_;
					char** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					char* _tmp21_;
					gint _tmp22_;
					_tmp15_ = _key_it;
					if (!gee_iterator_next (_tmp15_)) {
						break;
					}
					_tmp16_ = _key_it;
					_tmp17_ = gee_iterator_get (_tmp16_);
					key = (guint) ((guintptr) _tmp17_);
					_tmp18_ = devs;
					_tmp18__length1 = devs_length1;
					_tmp19_ = g_strdup_printf (DVB_CONSTANTS_DBUS_DEVICE_GROUP_PATH, key);
					_tmp20_ = _tmp19_;
					_tmp21_ = g_strdup (_tmp20_);
					_g_free0 (_tmp18_[i]);
					_tmp18_[i] = _tmp21_;
					_g_free0 (_tmp20_);
					_tmp22_ = i;
					i = _tmp22_ + 1;
				}
				_g_object_unref0 (_key_it);
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp23_;
			_tmp23_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				g_propagate_error (error, _inner_error0_);
				devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
				return NULL;
			} else {
				devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp24_ = devs;
	_tmp24__length1 = devs_length1;
	if (result_length1) {
		*result_length1 = _tmp24__length1;
	}
	result = _tmp24_;
	return result;
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @type: type of the new group
         * @channels_conf: Path to channels.conf for this device
         * @recordings_dir: Path where the recordings should be stored
         * @name: Name of group
         * @returns: TRUE when the device has been registered successfully
         *
         * Creates a new DeviceGroup and new DVB device whereas the
         * DVB device is the reference device of this group (i.e.
         * all other devices of this group will inherit the settings
         * of the reference device).
         */
static gboolean
dvb_manager_real_AddDeviceToNewGroup (DVBIDBusManager* base,
                                      guint adapter,
                                      guint frontend,
                                      DVBAdapterType type,
                                      const gchar* channels_conf,
                                      const gchar* recordings_dir,
                                      const gchar* name,
                                      GError** error)
{
	DVBManager * self;
	GFile* chan_file = NULL;
	GFile* _tmp0_;
	GFile* rec_dir = NULL;
	GFile* _tmp1_;
	DVBDevice* device = NULL;
	DVBDevice* _tmp2_;
	DVBDevice* _tmp3_;
	DVBDevice* _tmp4_;
	guint _tmp5_;
	DVBDeviceGroup* devgroup = NULL;
	GFile* _tmp6_;
	GFile* _tmp7_;
	DVBDeviceGroup* _tmp8_;
	DVBDeviceGroup* _tmp9_;
	DVBDeviceGroup* _tmp10_;
	DVBDeviceGroup* _tmp11_;
	DVBDeviceGroup* _tmp12_;
	DVBDevice* _tmp13_;
	DVBDeviceGroup* _tmp26_;
	DVBDeviceGroup* _tmp27_;
	DVBDeviceGroup* _tmp28_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBManager*) base;
	g_return_val_if_fail (channels_conf != NULL, FALSE);
	g_return_val_if_fail (recordings_dir != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = g_file_new_for_path (channels_conf);
	chan_file = _tmp0_;
	_tmp1_ = g_file_new_for_path (recordings_dir);
	rec_dir = _tmp1_;
	_tmp2_ = dvb_manager_get_device (self, adapter, frontend);
	device = _tmp2_;
	_tmp3_ = device;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_g_object_unref0 (device);
		_g_object_unref0 (rec_dir);
		_g_object_unref0 (chan_file);
		return result;
	}
	_tmp4_ = device;
	if (dvb_manager_device_is_in_any_group (self, _tmp4_, type)) {
		result = FALSE;
		_g_object_unref0 (device);
		_g_object_unref0 (rec_dir);
		_g_object_unref0 (chan_file);
		return result;
	}
	_tmp5_ = self->priv->device_group_counter;
	self->priv->device_group_counter = _tmp5_ + 1;
	_tmp6_ = chan_file;
	_tmp7_ = rec_dir;
	_tmp8_ = dvb_device_group_new (self->priv->device_group_counter, _tmp6_, _tmp7_, type, TRUE);
	devgroup = _tmp8_;
	_tmp9_ = devgroup;
	if (_tmp9_ == NULL) {
		result = FALSE;
		_g_object_unref0 (devgroup);
		_g_object_unref0 (device);
		_g_object_unref0 (rec_dir);
		_g_object_unref0 (chan_file);
		return result;
	}
	_tmp10_ = devgroup;
	dvb_device_group_set_Name (_tmp10_, name);
	_tmp11_ = devgroup;
	dvb_manager_add_device_group (self, _tmp11_, TRUE);
	g_signal_emit_by_name ((DVBIDBusManager*) self, "group-added", self->priv->device_group_counter);
	_tmp12_ = devgroup;
	_tmp13_ = device;
	if (dvb_device_group_add (_tmp12_, _tmp13_)) {
		{
			DVBFactory* _tmp14_;
			DVBFactory* _tmp15_;
			DVBdatabaseConfigStore* _tmp16_;
			DVBdatabaseConfigStore* _tmp17_;
			DVBDevice* _tmp18_;
			DVBDeviceGroup* _tmp19_;
			_tmp14_ = dvb_factory_new ();
			_tmp15_ = _tmp14_;
			_tmp16_ = dvb_factory_get_config_store (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = device;
			_tmp19_ = devgroup;
			dvb_database_config_store_add_device_to_group (_tmp17_, _tmp18_, _tmp19_, &_inner_error0_);
			_g_object_unref0 (_tmp17_);
			_g_object_unref0 (_tmp15_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp20_ = FALSE;
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					goto __catch0_dvb_database_sql_error;
				}
				_g_object_unref0 (devgroup);
				_g_object_unref0 (device);
				_g_object_unref0 (rec_dir);
				_g_object_unref0 (chan_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp20_;
			}
		}
		goto __finally0;
		__catch0_dvb_database_sql_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp21_;
			GError* _tmp22_;
			const gchar* _tmp23_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp21_ = dvb_manager_log;
			_tmp22_ = e;
			_tmp23_ = _tmp22_->message;
			dvb_logging_logger_error (_tmp21_, "Manager.vala:251: %s", _tmp23_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (devgroup);
			_g_object_unref0 (device);
			_g_object_unref0 (rec_dir);
			_g_object_unref0 (chan_file);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp24_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (devgroup);
				_g_object_unref0 (device);
				_g_object_unref0 (rec_dir);
				_g_object_unref0 (chan_file);
				return _tmp24_;
			} else {
				gboolean _tmp25_ = FALSE;
				_g_object_unref0 (devgroup);
				_g_object_unref0 (device);
				_g_object_unref0 (rec_dir);
				_g_object_unref0 (chan_file);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp25_;
			}
		}
	}
	_tmp26_ = devgroup;
	g_signal_emit_by_name ((DVBIDBusDeviceGroup*) _tmp26_, "device-added", adapter, frontend);
	_tmp27_ = devgroup;
	dvb_manager_restore_device_group_and_timers (self, _tmp27_);
	_tmp28_ = devgroup;
	dvb_device_group_start_epg_scanner (_tmp28_);
	result = TRUE;
	_g_object_unref0 (devgroup);
	_g_object_unref0 (device);
	_g_object_unref0 (rec_dir);
	_g_object_unref0 (chan_file);
	return result;
}

/**
         * @adapter: Adapter of device
         * @frontend: Frontend of device
         * @name: The name of the device or "Unknown"
         * @returns: TRUE on success
         *
         * The device must be part of group, otherwise "Unknown"
         * is returned.
         */
static gboolean
dvb_manager_real_GetNameOfRegisteredDevice (DVBIDBusManager* base,
                                            guint adapter,
                                            guint frontend,
                                            gchar** name,
                                            GError** error)
{
	DVBManager * self;
	gchar* _vala_name = NULL;
	DVBDevice* dev = NULL;
	DVBDevice* _tmp0_;
	DVBDevice* _tmp1_;
	gboolean result;
	self = (DVBManager*) base;
	_tmp0_ = dvb_manager_get_device (self, adapter, frontend);
	dev = _tmp0_;
	_tmp1_ = dev;
	if (_tmp1_ == NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("");
		_g_free0 (_vala_name);
		_vala_name = _tmp2_;
		result = FALSE;
		_g_object_unref0 (dev);
		if (name) {
			*name = _vala_name;
		} else {
			_g_free0 (_vala_name);
		}
		return result;
	} else {
		DVBDevice* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = dev;
		_tmp4_ = dvb_device_get_Name (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (_vala_name);
		_vala_name = _tmp6_;
		result = TRUE;
		_g_object_unref0 (dev);
		if (name) {
			*name = _vala_name;
		} else {
			_g_free0 (_vala_name);
		}
		return result;
	}
}

/**
         * @returns: the numner of configured device groups
         */
static gint
dvb_manager_real_GetDeviceGroupSize (DVBIDBusManager* base,
                                     GError** error)
{
	DVBManager * self;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
	self = (DVBManager*) base;
	_tmp0_ = self->priv->groups;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/**
         * @returns: ID and name of each channel group
         */
static DVBChannelGroupInfo*
dvb_manager_real_GetChannelGroups (DVBIDBusManager* base,
                                   gint* result_length1,
                                   GError** error)
{
	DVBManager * self;
	DVBdatabaseConfigStore* config = NULL;
	DVBFactory* _tmp0_;
	DVBFactory* _tmp1_;
	DVBdatabaseConfigStore* _tmp2_;
	DVBdatabaseConfigStore* _tmp3_;
	GeeList* groups = NULL;
	DVBChannelGroupInfo* arr = NULL;
	GeeList* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	DVBChannelGroupInfo* _tmp16_;
	gint arr_length1;
	gint _arr_size_;
	DVBChannelGroupInfo* _tmp33_;
	gint _tmp33__length1;
	GError* _inner_error0_ = NULL;
	DVBChannelGroupInfo* result;
	self = (DVBManager*) base;
	_tmp0_ = dvb_factory_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_factory_get_config_store (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	config = _tmp3_;
	{
		GeeList* _tmp4_ = NULL;
		DVBdatabaseConfigStore* _tmp5_;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
		_tmp5_ = config;
		_tmp6_ = dvb_database_config_store_get_channel_groups (_tmp5_, &_inner_error0_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (groups);
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp7_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (groups);
		groups = _tmp7_;
		_g_object_unref0 (_tmp4_);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		DVBChannelGroupInfo* _tmp11_;
		DVBChannelGroupInfo* _tmp12_;
		gint _tmp12__length1;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = dvb_manager_log;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		dvb_logging_logger_error (_tmp8_, "Manager.vala:305: %s", _tmp10_);
		_tmp11_ = g_new0 (DVBChannelGroupInfo, 0);
		_tmp12_ = _tmp11_;
		_tmp12__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp12__length1;
		}
		result = _tmp12_;
		_g_error_free0 (e);
		_g_object_unref0 (groups);
		_g_object_unref0 (config);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (groups);
			_g_object_unref0 (config);
			return NULL;
		} else {
			_g_object_unref0 (groups);
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp13_ = groups;
	_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_new0 (DVBChannelGroupInfo, _tmp15_);
	arr = _tmp16_;
	arr_length1 = _tmp15_;
	_arr_size_ = arr_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp17_ = FALSE;
			_tmp17_ = TRUE;
			while (TRUE) {
				DVBChannelGroupInfo* _tmp19_;
				gint _tmp19__length1;
				DVBChannelGroup* cg = NULL;
				GeeList* _tmp20_;
				gpointer _tmp21_;
				DVBChannelGroupInfo* _tmp22_;
				gint _tmp22__length1;
				DVBChannelGroupInfo _tmp23_ = {0};
				DVBChannelGroupInfo* _tmp24_;
				gint _tmp24__length1;
				DVBChannelGroup* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				DVBChannelGroupInfo* _tmp28_;
				gint _tmp28__length1;
				DVBChannelGroup* _tmp29_;
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				if (!_tmp17_) {
					gint _tmp18_;
					_tmp18_ = i;
					i = _tmp18_ + 1;
				}
				_tmp17_ = FALSE;
				_tmp19_ = arr;
				_tmp19__length1 = arr_length1;
				if (!(i < _tmp19__length1)) {
					break;
				}
				_tmp20_ = groups;
				_tmp21_ = gee_list_get (_tmp20_, i);
				cg = (DVBChannelGroup*) _tmp21_;
				_tmp22_ = arr;
				_tmp22__length1 = arr_length1;
				memset (&_tmp23_, 0, sizeof (DVBChannelGroupInfo));
				dvb_channel_group_info_destroy (&_tmp22_[i]);
				_tmp22_[i] = _tmp23_;
				_tmp24_ = arr;
				_tmp24__length1 = arr_length1;
				_tmp25_ = cg;
				_tmp26_ = dvb_channel_group_get_id (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp24_[i].id = _tmp27_;
				_tmp28_ = arr;
				_tmp28__length1 = arr_length1;
				_tmp29_ = cg;
				_tmp30_ = dvb_channel_group_get_name (_tmp29_);
				_tmp31_ = _tmp30_;
				_tmp32_ = g_strdup (_tmp31_);
				_g_free0 (_tmp28_[i].name);
				_tmp28_[i].name = _tmp32_;
				_g_object_unref0 (cg);
			}
		}
	}
	_tmp33_ = arr;
	_tmp33__length1 = arr_length1;
	if (result_length1) {
		*result_length1 = _tmp33__length1;
	}
	result = _tmp33_;
	_g_object_unref0 (groups);
	_g_object_unref0 (config);
	return result;
}

/**
         * @name: Name of the new group
         * @returns: TRUE on success
         */
static gboolean
dvb_manager_real_AddChannelGroup (DVBIDBusManager* base,
                                  const gchar* name,
                                  gint* channel_group_id,
                                  GError** error)
{
	DVBManager * self;
	gint _vala_channel_group_id = 0;
	DVBdatabaseConfigStore* config = NULL;
	DVBFactory* _tmp0_;
	DVBFactory* _tmp1_;
	DVBdatabaseConfigStore* _tmp2_;
	DVBdatabaseConfigStore* _tmp3_;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBManager*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = dvb_factory_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_factory_get_config_store (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	config = _tmp3_;
	{
		gboolean _tmp4_ = FALSE;
		gint _tmp5_ = 0;
		gboolean _tmp6_;
		_tmp6_ = dvb_database_config_store_add_channel_group (config, name, &_tmp5_, &_inner_error0_);
		_vala_channel_group_id = _tmp5_;
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp7_ = FALSE;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp7_;
		}
		ret = _tmp4_;
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = dvb_manager_log;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		dvb_logging_logger_error (_tmp8_, "Manager.vala:328: %s", _tmp10_);
		ret = FALSE;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp11_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (config);
			return _tmp11_;
		} else {
			gboolean _tmp12_ = FALSE;
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp12_;
		}
	}
	result = ret;
	_g_object_unref0 (config);
	if (channel_group_id) {
		*channel_group_id = _vala_channel_group_id;
	}
	return result;
}

/**
         * @channel_group_id: ID of the ChannelGroup
         * @returns: TRUE on success
         */
static gboolean
dvb_manager_real_RemoveChannelGroup (DVBIDBusManager* base,
                                     gint channel_group_id,
                                     GError** error)
{
	DVBManager * self;
	DVBdatabaseConfigStore* config = NULL;
	DVBFactory* _tmp0_;
	DVBFactory* _tmp1_;
	DVBdatabaseConfigStore* _tmp2_;
	DVBdatabaseConfigStore* _tmp3_;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBManager*) base;
	_tmp0_ = dvb_factory_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_factory_get_config_store (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	config = _tmp3_;
	{
		gboolean _tmp4_ = FALSE;
		_tmp4_ = dvb_database_config_store_remove_channel_group (config, channel_group_id, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp5_ = FALSE;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp5_;
		}
		ret = _tmp4_;
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = dvb_manager_log;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		dvb_logging_logger_error (_tmp6_, "Manager.vala:344: %s", _tmp8_);
		ret = FALSE;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp9_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (config);
			return _tmp9_;
		} else {
			gboolean _tmp10_ = FALSE;
			_g_object_unref0 (config);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp10_;
		}
	}
	result = ret;
	_g_object_unref0 (config);
	return result;
}

/**
         * @returns: informations about all connected
         * devices retrieved via udev
         */
static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static GHashTable**
dvb_manager_real_GetDevices (DVBIDBusManager* base,
                             gint* result_length1,
                             GError** error)
{
	DVBManager * self;
	GHashTable** arr = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GHashTable** _tmp3_;
	gint arr_length1;
	gint _arr_size_;
	GHashTable** _tmp28_;
	gint _tmp28__length1;
	GHashTable** result;
	self = (DVBManager*) base;
	_tmp0_ = self->priv->devices;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_new0 (GHashTable*, _tmp2_ + 1);
	arr = _tmp3_;
	arr_length1 = _tmp2_;
	_arr_size_ = arr_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GeeArrayList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				DVBDevice* dev = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				GHashTable* map = NULL;
				GHashFunc _tmp11_;
				GEqualFunc _tmp12_;
				GDestroyNotify _tmp13_;
				GDestroyNotify _tmp14_;
				GHashTable* _tmp15_;
				GHashTable* _tmp16_;
				gchar* _tmp17_;
				DVBDevice* _tmp18_;
				guint _tmp19_;
				guint _tmp20_;
				DVBDevice* _tmp21_;
				guint _tmp22_;
				guint _tmp23_;
				gchar* _tmp24_;
				GHashTable** _tmp25_;
				gint _tmp25__length1;
				GHashTable* _tmp26_;
				GHashTable* _tmp27_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = self->priv->devices;
				_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
				_tmp8_ = _tmp7_;
				if (!(i < _tmp8_)) {
					break;
				}
				_tmp9_ = self->priv->devices;
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, i);
				dev = (DVBDevice*) _tmp10_;
				_tmp11_ = g_str_hash;
				_tmp12_ = g_str_equal;
				_tmp13_ = g_free;
				_tmp14_ = g_free;
				_tmp15_ = g_hash_table_new_full (_tmp11_, _tmp12_, _tmp13_, _tmp14_);
				map = _tmp15_;
				_tmp16_ = map;
				_tmp17_ = g_strdup ("device_file");
				_tmp18_ = dev;
				_tmp19_ = dvb_device_get_Adapter (_tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = dev;
				_tmp22_ = dvb_device_get_Frontend (_tmp21_);
				_tmp23_ = _tmp22_;
				_tmp24_ = g_strdup_printf ("/dev/dvb/adapter%u/frontend%u", _tmp20_, _tmp23_);
				g_hash_table_insert (_tmp16_, _tmp17_, _tmp24_);
				_tmp25_ = arr;
				_tmp25__length1 = arr_length1;
				_tmp26_ = map;
				_tmp27_ = _g_hash_table_ref0 (_tmp26_);
				_g_hash_table_unref0 (_tmp25_[i]);
				_tmp25_[i] = _tmp27_;
				_g_hash_table_unref0 (map);
				_g_object_unref0 (dev);
			}
		}
	}
	_tmp28_ = arr;
	_tmp28__length1 = arr_length1;
	if (result_length1) {
		*result_length1 = _tmp28__length1;
	}
	result = _tmp28_;
	return result;
}

/**
         * @adapter: the adapter
         * @frontend: the frontend
         * @info: return the AdapterInfo structure
         * @returns: #false if device cannot found, otherwise #true
         */
static gboolean
dvb_manager_real_GetAdapterInfo (DVBIDBusManager* base,
                                 guint adapter,
                                 guint frontend,
                                 DVBAdapterInfo* info,
                                 GError** error)
{
	DVBManager * self;
	DVBAdapterInfo _vala_info = {0};
	DVBDevice* dev = NULL;
	DVBDevice* _tmp0_;
	DVBDevice* _tmp1_;
	DVBDevice* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	DVBDevice* _tmp6_;
	DVBDevice* _tmp7_;
	DVBDevice* _tmp8_;
	gboolean result;
	self = (DVBManager*) base;
	dvb_adapter_info_destroy (&_vala_info);
	memset (&_vala_info, 0, sizeof (DVBAdapterInfo));
	_tmp0_ = dvb_manager_get_device (self, adapter, frontend);
	dev = _tmp0_;
	_tmp1_ = dev;
	if (_tmp1_ == NULL) {
		result = FALSE;
		_g_object_unref0 (dev);
		if (info) {
			*info = _vala_info;
		} else {
			dvb_adapter_info_destroy (&_vala_info);
		}
		return result;
	}
	_tmp2_ = dev;
	_tmp3_ = dvb_device_get_Name (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (_vala_info.name);
	_vala_info.name = _tmp5_;
	_tmp6_ = dev;
	_vala_info.type_t = dvb_device_isTerrestrial (_tmp6_);
	_tmp7_ = dev;
	_vala_info.type_s = dvb_device_isSatellite (_tmp7_);
	_tmp8_ = dev;
	_vala_info.type_c = dvb_device_isCable (_tmp8_);
	result = TRUE;
	_g_object_unref0 (dev);
	if (info) {
		*info = _vala_info;
	} else {
		dvb_adapter_info_destroy (&_vala_info);
	}
	return result;
}

/**
         * @returns: Whether the device has been added successfully
         *
         * Register device, create Recorder and ChannelList D-Bus service
         */
static void
_dvb_manager_on_device_removed_from_group_dvb_id_bus_device_group_device_removed (DVBIDBusDeviceGroup* _sender,
                                                                                  guint adapter,
                                                                                  guint frontend,
                                                                                  gpointer self)
{
	dvb_manager_on_device_removed_from_group ((DVBManager*) self, _sender, adapter, frontend);
}

gboolean
dvb_manager_add_device_group (DVBManager* self,
                              DVBDeviceGroup* devgroup,
                              gboolean store)
{
	guint group_id = 0U;
	guint _tmp0_;
	guint _tmp1_;
	DVBLoggingLogger* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	DVBAdapterType _tmp5_;
	DVBAdapterType _tmp6_;
	gchar* path = NULL;
	gchar* _tmp23_;
	GDBusConnection* _tmp24_;
	const gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (devgroup != NULL, FALSE);
	_tmp0_ = dvb_device_group_get_Id (devgroup);
	_tmp1_ = _tmp0_;
	group_id = _tmp1_;
	_tmp2_ = dvb_manager_log;
	_tmp3_ = dvb_device_group_get_size (devgroup);
	_tmp4_ = _tmp3_;
	dvb_logging_logger_debug (_tmp2_, "Manager.vala:397: Adding device group %u with %d devices", group_id, _tmp4_);
	_tmp5_ = dvb_device_group_get_Type (devgroup);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == DVB_ADAPTER_TYPE_UNKNOWN) {
		DVBLoggingLogger* _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
		_tmp7_ = dvb_manager_log;
		_tmp8_ = dvb_device_group_get_Id (devgroup);
		_tmp9_ = _tmp8_;
		dvb_logging_logger_warning (_tmp7_, "Manager.vala:401: Not adding device group %u of unknown type", _tmp9_);
		result = FALSE;
		return result;
	}
	{
		GeeHashMap* _tmp10_;
		_tmp10_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			GeeHashMap* _tmp11_;
			_tmp11_ = self->priv->groups;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, (gpointer) ((guintptr) group_id), devgroup);
		}
		__finally0:
		{
			GeeHashMap* _tmp12_;
			_tmp12_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp13_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp13_;
		}
	}
	if (store) {
		{
			DVBFactory* _tmp14_;
			DVBFactory* _tmp15_;
			DVBdatabaseConfigStore* _tmp16_;
			DVBdatabaseConfigStore* _tmp17_;
			_tmp14_ = dvb_factory_new ();
			_tmp15_ = _tmp14_;
			_tmp16_ = dvb_factory_get_config_store (_tmp15_);
			_tmp17_ = _tmp16_;
			dvb_database_config_store_add_device_group (_tmp17_, devgroup, &_inner_error0_);
			_g_object_unref0 (_tmp17_);
			_g_object_unref0 (_tmp15_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp18_ = FALSE;
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					goto __catch1_dvb_database_sql_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp18_;
			}
		}
		goto __finally1;
		__catch1_dvb_database_sql_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp19_;
			GError* _tmp20_;
			const gchar* _tmp21_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp19_ = dvb_manager_log;
			_tmp20_ = e;
			_tmp21_ = _tmp20_->message;
			dvb_logging_logger_error (_tmp19_, "Manager.vala:413: %s", _tmp21_);
			result = FALSE;
			_g_error_free0 (e);
			return result;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp22_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp22_;
		}
	}
	g_signal_connect_object ((DVBIDBusDeviceGroup*) devgroup, "device-removed", (GCallback) _dvb_manager_on_device_removed_from_group_dvb_id_bus_device_group_device_removed, self, 0);
	_tmp23_ = g_strdup_printf (DVB_CONSTANTS_DBUS_DEVICE_GROUP_PATH, group_id);
	path = _tmp23_;
	_tmp24_ = main_conn;
	_tmp25_ = path;
	dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_DEVICE_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp24_, _tmp25_, (DVBIDBusDeviceGroup*) devgroup);
	if (group_id > self->priv->device_group_counter) {
		self->priv->device_group_counter = group_id;
	}
	result = TRUE;
	_g_free0 (path);
	return result;
}

gboolean
dvb_manager_restore_device_group (DVBManager* self,
                                  DVBDeviceGroup* device_group,
                                  gboolean store)
{
	DVBLoggingLogger* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device_group != NULL, FALSE);
	_tmp0_ = dvb_manager_log;
	_tmp1_ = dvb_device_group_get_Id (device_group);
	_tmp2_ = _tmp1_;
	dvb_logging_logger_info (_tmp0_, "Manager.vala:430: Restoring group %u", _tmp2_);
	{
		DVBChannelList* _tmp3_;
		DVBChannelList* _tmp4_;
		DVBAdapterType _tmp5_;
		DVBAdapterType _tmp6_;
		_tmp3_ = dvb_device_group_get_Channels (device_group);
		_tmp4_ = _tmp3_;
		_tmp5_ = dvb_device_group_get_Type (device_group);
		_tmp6_ = _tmp5_;
		dvb_channel_list_load (_tmp4_, _tmp6_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = dvb_manager_log;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		dvb_logging_logger_error (_tmp7_, "Manager.vala:435: Error reading channels from file: %s", _tmp9_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp10_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp10_;
	}
	result = dvb_manager_add_device_group (self, device_group, FALSE);
	return result;
}

void
dvb_manager_restore_timers (DVBManager* self,
                            DVBDeviceGroup* device_group)
{
	DVBLoggingLogger* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	DVBdatabaseTimersStore* timers_store = NULL;
	DVBFactory* _tmp3_;
	DVBFactory* _tmp4_;
	DVBdatabaseTimersStore* _tmp5_;
	DVBdatabaseTimersStore* _tmp6_;
	GeeList* timers = NULL;
	guint32 max_id = 0U;
	DVBRecorder* rec = NULL;
	DVBRecorder* _tmp16_;
	DVBRecorder* _tmp17_;
	DVBRecorder* _tmp18_;
	DVBRecordingsStore* recstore = NULL;
	DVBRecordingsStore* _tmp44_;
	DVBRecordingsStore* _tmp45_;
	DVBRecordingsStore* _tmp46_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device_group != NULL);
	_tmp0_ = dvb_manager_log;
	_tmp1_ = dvb_device_group_get_Id (device_group);
	_tmp2_ = _tmp1_;
	dvb_logging_logger_info (_tmp0_, "Manager.vala:443: Restoring timers of device group %u", _tmp2_);
	_tmp3_ = dvb_factory_new ();
	_tmp4_ = _tmp3_;
	_tmp5_ = dvb_factory_get_timers_store (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	timers_store = _tmp6_;
	{
		GeeList* _tmp7_ = NULL;
		DVBdatabaseTimersStore* _tmp8_;
		GeeList* _tmp9_;
		GeeList* _tmp10_;
		_tmp8_ = timers_store;
		_tmp9_ = dvb_database_timers_store_get_all_timers_of_device_group (_tmp8_, device_group, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (timers);
			_g_object_unref0 (timers_store);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		_g_object_unref0 (timers);
		timers = _tmp10_;
		_g_object_unref0 (_tmp7_);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = dvb_manager_log;
		_tmp12_ = dvb_device_group_get_Id (device_group);
		_tmp13_ = _tmp12_;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		dvb_logging_logger_error (_tmp11_, "Manager.vala:451: Failed retrieving timers of group %u: %s", _tmp13_, _tmp15_);
		_g_error_free0 (e);
		_g_object_unref0 (timers);
		_g_object_unref0 (timers_store);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (timers);
		_g_object_unref0 (timers_store);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	max_id = (guint32) 0;
	_tmp16_ = dvb_device_group_get_recorder (device_group);
	_tmp17_ = _tmp16_;
	_tmp18_ = _g_object_ref0 (_tmp17_);
	rec = _tmp18_;
	{
		GeeList* _t_list = NULL;
		GeeList* _tmp19_;
		gint _t_size = 0;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _t_index = 0;
		_tmp19_ = timers;
		_t_list = _tmp19_;
		_tmp20_ = _t_list;
		_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
		_tmp22_ = _tmp21_;
		_t_size = _tmp22_;
		_t_index = -1;
		while (TRUE) {
			gint _tmp23_;
			gint _tmp24_;
			DVBTimer* t = NULL;
			GeeList* _tmp25_;
			gpointer _tmp26_;
			DVBTimer* _tmp27_;
			guint32 _tmp28_;
			guint32 _tmp29_;
			guint32 rec_id = 0U;
			DVBRecorder* _tmp33_;
			DVBTimer* _tmp34_;
			guint32 _tmp35_ = 0U;
			gboolean _tmp36_;
			_t_index = _t_index + 1;
			_tmp23_ = _t_index;
			_tmp24_ = _t_size;
			if (!(_tmp23_ < _tmp24_)) {
				break;
			}
			_tmp25_ = _t_list;
			_tmp26_ = gee_list_get (_tmp25_, _t_index);
			t = (DVBTimer*) _tmp26_;
			_tmp27_ = t;
			_tmp28_ = dvb_timer_get_Id (_tmp27_);
			_tmp29_ = _tmp28_;
			if (_tmp29_ > max_id) {
				DVBTimer* _tmp30_;
				guint32 _tmp31_;
				guint32 _tmp32_;
				_tmp30_ = t;
				_tmp31_ = dvb_timer_get_Id (_tmp30_);
				_tmp32_ = _tmp31_;
				max_id = _tmp32_;
			}
			_tmp33_ = rec;
			_tmp34_ = t;
			_tmp36_ = dvb_recorder_add_timer (_tmp33_, _tmp34_, &_tmp35_);
			rec_id = _tmp35_;
			if (!_tmp36_) {
				{
					DVBdatabaseTimersStore* _tmp37_;
					DVBTimer* _tmp38_;
					guint32 _tmp39_;
					guint32 _tmp40_;
					_tmp37_ = timers_store;
					_tmp38_ = t;
					_tmp39_ = dvb_timer_get_Id (_tmp38_);
					_tmp40_ = _tmp39_;
					dvb_database_timers_store_remove_timer_from_device_group (_tmp37_, (guint) _tmp40_, device_group, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch1_dvb_database_sql_error;
						}
						_g_object_unref0 (t);
						_g_object_unref0 (rec);
						_g_object_unref0 (timers);
						_g_object_unref0 (timers_store);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				goto __finally1;
				__catch1_dvb_database_sql_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp41_;
					GError* _tmp42_;
					const gchar* _tmp43_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp41_ = dvb_manager_log;
					_tmp42_ = e;
					_tmp43_ = _tmp42_->message;
					dvb_logging_logger_error (_tmp41_, "Manager.vala:465: Failed removing timer: %s", _tmp43_);
					_g_error_free0 (e);
				}
				__finally1:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (t);
					_g_object_unref0 (rec);
					_g_object_unref0 (timers);
					_g_object_unref0 (timers_store);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_object_unref0 (t);
		}
	}
	_tmp44_ = dvb_recordings_store_get_instance ();
	_tmp45_ = _g_object_ref0 (_tmp44_);
	recstore = _tmp45_;
	_tmp46_ = recstore;
	dvb_recordings_store_update_last_id (_tmp46_, max_id);
	_g_object_unref0 (recstore);
	_g_object_unref0 (rec);
	_g_object_unref0 (timers);
	_g_object_unref0 (timers_store);
}

void
dvb_manager_restore_device_group_and_timers (DVBManager* self,
                                             DVBDeviceGroup* device_group)
{
	DVBLoggingLogger* _tmp0_;
	GstRTSPMountPoints* points = NULL;
	GstRTSPServer* _tmp1_;
	GstRTSPMountPoints* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device_group != NULL);
	if (dvb_manager_restore_device_group (self, device_group, TRUE)) {
		dvb_manager_restore_timers (self, device_group);
	}
	_tmp0_ = dvb_manager_log;
	dvb_logging_logger_debug (_tmp0_, "Manager.vala:478: add media factory");
	_tmp1_ = dvb_rtsp_server_server;
	_tmp2_ = gst_rtsp_server_get_mount_points (_tmp1_);
	points = _tmp2_;
	{
		GeeIterator* _channel_it = NULL;
		DVBChannelList* _tmp3_;
		DVBChannelList* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp3_ = dvb_device_group_get_Channels (device_group);
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_channel_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			DVBChannel* channel = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			DVBMediaFactory* factory = NULL;
			DVBMediaFactory* _tmp9_;
			GstRTSPMountPoints* _tmp10_;
			guint _tmp11_;
			guint _tmp12_;
			DVBChannel* _tmp13_;
			guint _tmp14_;
			guint _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			DVBMediaFactory* _tmp18_;
			GstRTSPMediaFactory* _tmp19_;
			_tmp6_ = _channel_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _channel_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			channel = (DVBChannel*) _tmp8_;
			_tmp9_ = dvb_media_factory_new ();
			factory = _tmp9_;
			_tmp10_ = points;
			_tmp11_ = dvb_device_group_get_Id (device_group);
			_tmp12_ = _tmp11_;
			_tmp13_ = channel;
			_tmp14_ = dvb_channel_get_Sid (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strdup_printf ("/%u/%u", _tmp12_, _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = factory;
			_tmp19_ = _g_object_ref0 ((GstRTSPMediaFactory*) _tmp18_);
			gst_rtsp_mount_points_add_factory (_tmp10_, _tmp17_, _tmp19_);
			_g_free0 (_tmp17_);
			_g_object_unref0 (factory);
			_g_object_unref0 (channel);
		}
		_g_object_unref0 (_channel_it);
	}
	_g_object_unref0 (points);
}

DVBDeviceGroup*
dvb_manager_get_device_group_if_exists (DVBManager* self,
                                        guint group_id)
{
	DVBDeviceGroup* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	DVBDeviceGroup* result;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = NULL;
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			GeeHashMap* _tmp1_;
			_tmp1_ = self->priv->groups;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) group_id))) {
				GeeHashMap* _tmp2_;
				gpointer _tmp3_;
				_tmp2_ = self->priv->groups;
				_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) group_id));
				_g_object_unref0 (_result_);
				_result_ = (DVBDeviceGroup*) _tmp3_;
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp4_;
			_tmp4_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_result_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}

gboolean
dvb_manager_device_is_in_any_group (DVBManager* self,
                                    DVBDevice* device,
                                    DVBAdapterType type)
{
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	_result_ = FALSE;
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			{
				GeeIterator* _group_id_it = NULL;
				GeeHashMap* _tmp1_;
				GeeSet* _tmp2_;
				GeeSet* _tmp3_;
				GeeSet* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
				_tmp1_ = self->priv->groups;
				_tmp2_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_group_id_it = _tmp6_;
				while (TRUE) {
					GeeIterator* _tmp7_;
					guint group_id = 0U;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					DVBDeviceGroup* devgroup = NULL;
					GeeHashMap* _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					DVBDeviceGroup* _tmp13_;
					_tmp7_ = _group_id_it;
					if (!gee_iterator_next (_tmp7_)) {
						break;
					}
					_tmp8_ = _group_id_it;
					_tmp9_ = gee_iterator_get (_tmp8_);
					group_id = (guint) ((guintptr) _tmp9_);
					_tmp10_ = self->priv->groups;
					_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) group_id));
					devgroup = (DVBDeviceGroup*) _tmp11_;
					_tmp13_ = devgroup;
					if (dvb_device_group_contains (_tmp13_, device)) {
						DVBDeviceGroup* _tmp14_;
						DVBAdapterType _tmp15_;
						DVBAdapterType _tmp16_;
						_tmp14_ = devgroup;
						_tmp15_ = dvb_device_group_get_Type (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp12_ = _tmp16_ == type;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						_result_ = TRUE;
						_g_object_unref0 (devgroup);
						break;
					}
					_g_object_unref0 (devgroup);
				}
				_g_object_unref0 (_group_id_it);
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp17_;
			_tmp17_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp18_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp18_;
		}
	}
	result = _result_;
	return result;
}

DVBDevice*
dvb_manager_get_device (DVBManager* self,
                        guint adapter,
                        guint frontend)
{
	DVBDevice* ret = NULL;
	GError* _inner_error0_ = NULL;
	DVBDevice* result;
	g_return_val_if_fail (self != NULL, NULL);
	ret = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			{
				GeeArrayList* _d_list = NULL;
				GeeArrayList* _tmp1_;
				gint _d_size = 0;
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _d_index = 0;
				_tmp1_ = self->priv->devices;
				_d_list = _tmp1_;
				_tmp2_ = _d_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_d_size = _tmp4_;
				_d_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					DVBDevice* d = NULL;
					GeeArrayList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					DVBDevice* _tmp10_;
					guint _tmp11_;
					guint _tmp12_;
					_d_index = _d_index + 1;
					_tmp5_ = _d_index;
					_tmp6_ = _d_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _d_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _d_index);
					d = (DVBDevice*) _tmp8_;
					_tmp10_ = d;
					_tmp11_ = dvb_device_get_Adapter (_tmp10_);
					_tmp12_ = _tmp11_;
					if (_tmp12_ == adapter) {
						DVBDevice* _tmp13_;
						guint _tmp14_;
						guint _tmp15_;
						_tmp13_ = d;
						_tmp14_ = dvb_device_get_Frontend (_tmp13_);
						_tmp15_ = _tmp14_;
						_tmp9_ = _tmp15_ == frontend;
					} else {
						_tmp9_ = FALSE;
					}
					if (_tmp9_) {
						DVBDevice* _tmp16_;
						DVBDevice* _tmp17_;
						_tmp16_ = d;
						_tmp17_ = _g_object_ref0 (_tmp16_);
						_g_object_unref0 (ret);
						ret = _tmp17_;
						_g_object_unref0 (d);
						break;
					}
					_g_object_unref0 (d);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (ret);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = ret;
	return result;
}

static void
dvb_manager_on_scanner_destroyed (DVBManager* self,
                                  DVBScanner* scanner)
{
	guint adapter = 0U;
	DVBDevice* _tmp0_;
	DVBDevice* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint frontend = 0U;
	DVBDevice* _tmp4_;
	DVBDevice* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* path = NULL;
	gchar* _tmp8_;
	DVBLoggingLogger* _tmp12_;
	DVBDeviceGroup** devgroups = NULL;
	DVBDevice* _tmp13_;
	DVBDevice* _tmp14_;
	gint _tmp15_ = 0;
	DVBDeviceGroup** _tmp16_;
	gint devgroups_length1;
	gint _devgroups_size_;
	DVBDeviceGroup** _tmp17_;
	gint _tmp17__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (scanner != NULL);
	_tmp0_ = dvb_scanner_get_Device (scanner);
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_device_get_Adapter (_tmp1_);
	_tmp3_ = _tmp2_;
	adapter = _tmp3_;
	_tmp4_ = dvb_scanner_get_Device (scanner);
	_tmp5_ = _tmp4_;
	_tmp6_ = dvb_device_get_Frontend (_tmp5_);
	_tmp7_ = _tmp6_;
	frontend = _tmp7_;
	_tmp8_ = g_strdup_printf (DVB_CONSTANTS_DBUS_SCANNER_PATH, adapter, frontend);
	path = _tmp8_;
	{
		GeeHashMap* _tmp9_;
		_tmp9_ = self->priv->scanners;
		g_rec_mutex_lock (&self->priv->__lock_scanners);
		{
			GeeHashMap* _tmp10_;
			_tmp10_ = self->priv->scanners;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp10_, path, NULL);
		}
		__finally0:
		{
			GeeHashMap* _tmp11_;
			_tmp11_ = self->priv->scanners;
			g_rec_mutex_unlock (&self->priv->__lock_scanners);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp12_ = dvb_manager_log;
	dvb_logging_logger_debug (_tmp12_, "Manager.vala:531: Destroying scanner for adapter %u, frontend %u (%s)", adapter, frontend, path);
	_tmp13_ = dvb_scanner_get_Device (scanner);
	_tmp14_ = _tmp13_;
	_tmp16_ = dvb_manager_get_device_groups_of_device (self, _tmp14_, &_tmp15_);
	devgroups = _tmp16_;
	devgroups_length1 = _tmp15_;
	_devgroups_size_ = devgroups_length1;
	_tmp17_ = devgroups;
	_tmp17__length1 = devgroups_length1;
	{
		DVBDeviceGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
		group_collection = _tmp17_;
		group_collection_length1 = _tmp17__length1;
		for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
			DVBDeviceGroup* _tmp18_;
			DVBDeviceGroup* group = NULL;
			_tmp18_ = _g_object_ref0 (group_collection[group_it]);
			group = _tmp18_;
			{
				DVBDeviceGroup* _tmp19_;
				_tmp19_ = group;
				if (_tmp19_ != NULL) {
					DVBDeviceGroup* _tmp20_;
					_tmp20_ = group;
					dvb_device_group_start_epg_scanner (_tmp20_);
				}
				_g_object_unref0 (group);
			}
		}
	}
	devgroups = (_vala_array_free (devgroups, devgroups_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (path);
}

static DVBDeviceGroup**
dvb_manager_get_device_groups_of_device (DVBManager* self,
                                         DVBDevice* device,
                                         gint* result_length1)
{
	DVBDeviceGroup** ret = NULL;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DVBDeviceGroup** _tmp3_;
	gint ret_length1;
	gint _ret_size_;
	DVBDeviceGroup** _tmp22_;
	gint _tmp22__length1;
	GError* _inner_error0_ = NULL;
	DVBDeviceGroup** result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (device != NULL, NULL);
	_tmp0_ = self->priv->groups;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_new0 (DVBDeviceGroup*, _tmp2_ + 1);
	ret = _tmp3_;
	ret_length1 = _tmp2_;
	_ret_size_ = ret_length1;
	{
		GeeHashMap* _tmp4_;
		_tmp4_ = self->priv->groups;
		g_rec_mutex_lock (&self->priv->__lock_groups);
		{
			guint i = 0U;
			i = (guint) 0;
			{
				GeeIterator* _group_id_it = NULL;
				GeeHashMap* _tmp5_;
				GeeSet* _tmp6_;
				GeeSet* _tmp7_;
				GeeSet* _tmp8_;
				GeeIterator* _tmp9_;
				GeeIterator* _tmp10_;
				_tmp5_ = self->priv->groups;
				_tmp6_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = _tmp7_;
				_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
				_tmp10_ = _tmp9_;
				_g_object_unref0 (_tmp8_);
				_group_id_it = _tmp10_;
				while (TRUE) {
					GeeIterator* _tmp11_;
					guint group_id = 0U;
					GeeIterator* _tmp12_;
					gpointer _tmp13_;
					DVBDeviceGroup* devgroup = NULL;
					GeeHashMap* _tmp14_;
					gpointer _tmp15_;
					DVBDeviceGroup* _tmp16_;
					_tmp11_ = _group_id_it;
					if (!gee_iterator_next (_tmp11_)) {
						break;
					}
					_tmp12_ = _group_id_it;
					_tmp13_ = gee_iterator_get (_tmp12_);
					group_id = (guint) ((guintptr) _tmp13_);
					_tmp14_ = self->priv->groups;
					_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, (gpointer) ((guintptr) group_id));
					devgroup = (DVBDeviceGroup*) _tmp15_;
					_tmp16_ = devgroup;
					if (dvb_device_group_contains (_tmp16_, device)) {
						DVBDeviceGroup** _tmp17_;
						gint _tmp17__length1;
						DVBDeviceGroup* _tmp18_;
						DVBDeviceGroup* _tmp19_;
						guint _tmp20_;
						_tmp17_ = ret;
						_tmp17__length1 = ret_length1;
						_tmp18_ = devgroup;
						_tmp19_ = _g_object_ref0 (_tmp18_);
						_g_object_unref0 (_tmp17_[i]);
						_tmp17_[i] = _tmp19_;
						_tmp20_ = i;
						i = _tmp20_ + 1;
					}
					_g_object_unref0 (devgroup);
				}
				_g_object_unref0 (_group_id_it);
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp21_;
			_tmp21_ = self->priv->groups;
			g_rec_mutex_unlock (&self->priv->__lock_groups);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			ret = (_vala_array_free (ret, ret_length1, (GDestroyNotify) g_object_unref), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp22_ = ret;
	_tmp22__length1 = ret_length1;
	if (result_length1) {
		*result_length1 = _tmp22__length1;
	}
	result = _tmp22_;
	return result;
}

static void
dvb_manager_on_device_removed_from_group (DVBManager* self,
                                          DVBIDBusDeviceGroup* idevgroup,
                                          guint adapter,
                                          guint frontend)
{
	DVBDeviceGroup* devgroup = NULL;
	DVBDeviceGroup* _tmp0_;
	guint group_id = 0U;
	DVBDeviceGroup* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	DVBDeviceGroup* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (idevgroup != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (idevgroup, DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup));
	devgroup = _tmp0_;
	_tmp1_ = devgroup;
	_tmp2_ = dvb_device_group_get_Id (_tmp1_);
	_tmp3_ = _tmp2_;
	group_id = _tmp3_;
	_tmp4_ = devgroup;
	_tmp5_ = dvb_device_group_get_size (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == 0) {
		gboolean success = FALSE;
		{
			GeeHashMap* _tmp7_;
			_tmp7_ = self->priv->groups;
			g_rec_mutex_lock (&self->priv->__lock_groups);
			{
				GeeHashMap* _tmp8_;
				_tmp8_ = self->priv->groups;
				success = gee_abstract_map_unset ((GeeAbstractMap*) _tmp8_, (gpointer) ((guintptr) group_id), NULL);
			}
			__finally0:
			{
				GeeHashMap* _tmp9_;
				_tmp9_ = self->priv->groups;
				g_rec_mutex_unlock (&self->priv->__lock_groups);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (devgroup);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		if (success) {
			gboolean lastest = FALSE;
			DVBDeviceGroup* _tmp59_;
			lastest = FALSE;
			{
				gboolean _tmp10_ = FALSE;
				DVBFactory* _tmp11_;
				DVBFactory* _tmp12_;
				DVBdatabaseConfigStore* _tmp13_;
				DVBdatabaseConfigStore* _tmp14_;
				gboolean _tmp15_;
				_tmp11_ = dvb_factory_new ();
				_tmp12_ = _tmp11_;
				_tmp13_ = dvb_factory_get_config_store (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = dvb_database_config_store_is_last_device (_tmp14_, group_id, &_inner_error0_);
				_g_object_unref0 (_tmp14_);
				_g_object_unref0 (_tmp12_);
				_tmp10_ = _tmp15_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						goto __catch1_dvb_database_sql_error;
					}
					_g_object_unref0 (devgroup);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				lastest = _tmp10_;
			}
			goto __finally1;
			__catch1_dvb_database_sql_error:
			{
				GError* e = NULL;
				DVBLoggingLogger* _tmp16_;
				GError* _tmp17_;
				const gchar* _tmp18_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp16_ = dvb_manager_log;
				_tmp17_ = e;
				_tmp18_ = _tmp17_->message;
				dvb_logging_logger_error (_tmp16_, "Manager.vala:571: %s", _tmp18_);
				_g_error_free0 (e);
			}
			__finally1:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (devgroup);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			if (lastest) {
				GstRTSPMountPoints* points = NULL;
				GstRTSPServer* _tmp19_;
				GstRTSPMountPoints* _tmp20_;
				_tmp19_ = dvb_rtsp_server_server;
				_tmp20_ = gst_rtsp_server_get_mount_points (_tmp19_);
				points = _tmp20_;
				{
					GeeIterator* _channel_it = NULL;
					DVBDeviceGroup* _tmp21_;
					DVBChannelList* _tmp22_;
					DVBChannelList* _tmp23_;
					GeeIterator* _tmp24_;
					_tmp21_ = devgroup;
					_tmp22_ = dvb_device_group_get_Channels (_tmp21_);
					_tmp23_ = _tmp22_;
					_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
					_channel_it = _tmp24_;
					while (TRUE) {
						GeeIterator* _tmp25_;
						DVBChannel* channel = NULL;
						GeeIterator* _tmp26_;
						gpointer _tmp27_;
						GstRTSPMountPoints* _tmp28_;
						DVBDeviceGroup* _tmp29_;
						guint _tmp30_;
						guint _tmp31_;
						DVBChannel* _tmp32_;
						guint _tmp33_;
						guint _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						_tmp25_ = _channel_it;
						if (!gee_iterator_next (_tmp25_)) {
							break;
						}
						_tmp26_ = _channel_it;
						_tmp27_ = gee_iterator_get (_tmp26_);
						channel = (DVBChannel*) _tmp27_;
						_tmp28_ = points;
						_tmp29_ = devgroup;
						_tmp30_ = dvb_device_group_get_Id (_tmp29_);
						_tmp31_ = _tmp30_;
						_tmp32_ = channel;
						_tmp33_ = dvb_channel_get_Sid (_tmp32_);
						_tmp34_ = _tmp33_;
						_tmp35_ = g_strdup_printf ("/%u/%u", _tmp31_, _tmp34_);
						_tmp36_ = _tmp35_;
						gst_rtsp_mount_points_remove_factory (_tmp28_, _tmp36_);
						_g_free0 (_tmp36_);
						_g_object_unref0 (channel);
					}
					_g_object_unref0 (_channel_it);
				}
				{
					DVBFactory* _tmp37_;
					DVBFactory* _tmp38_;
					DVBdatabaseConfigStore* _tmp39_;
					DVBdatabaseConfigStore* _tmp40_;
					DVBDeviceGroup* _tmp41_;
					DVBFactory* _tmp42_;
					DVBFactory* _tmp43_;
					DVBdatabaseEPGStore* _tmp44_;
					DVBdatabaseEPGStore* _tmp45_;
					DVBDeviceGroup* _tmp46_;
					guint _tmp47_;
					guint _tmp48_;
					DVBFactory* _tmp49_;
					DVBFactory* _tmp50_;
					DVBdatabaseTimersStore* _tmp51_;
					DVBdatabaseTimersStore* _tmp52_;
					DVBDeviceGroup* _tmp53_;
					guint _tmp54_;
					guint _tmp55_;
					_tmp37_ = dvb_factory_new ();
					_tmp38_ = _tmp37_;
					_tmp39_ = dvb_factory_get_config_store (_tmp38_);
					_tmp40_ = _tmp39_;
					_tmp41_ = devgroup;
					dvb_database_config_store_remove_device_group (_tmp40_, _tmp41_, &_inner_error0_);
					_g_object_unref0 (_tmp40_);
					_g_object_unref0 (_tmp38_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch2_dvb_database_sql_error;
						}
						_g_object_unref0 (points);
						_g_object_unref0 (devgroup);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp42_ = dvb_factory_new ();
					_tmp43_ = _tmp42_;
					_tmp44_ = dvb_factory_get_epg_store (_tmp43_);
					_tmp45_ = _tmp44_;
					_tmp46_ = devgroup;
					_tmp47_ = dvb_device_group_get_Id (_tmp46_);
					_tmp48_ = _tmp47_;
					dvb_database_epg_store_remove_events_of_group (_tmp45_, _tmp48_, &_inner_error0_);
					_g_object_unref0 (_tmp45_);
					_g_object_unref0 (_tmp43_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch2_dvb_database_sql_error;
						}
						_g_object_unref0 (points);
						_g_object_unref0 (devgroup);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp49_ = dvb_factory_new ();
					_tmp50_ = _tmp49_;
					_tmp51_ = dvb_factory_get_timers_store (_tmp50_);
					_tmp52_ = _tmp51_;
					_tmp53_ = devgroup;
					_tmp54_ = dvb_device_group_get_Id (_tmp53_);
					_tmp55_ = _tmp54_;
					dvb_database_timers_store_remove_all_timers_from_device_group (_tmp52_, _tmp55_, &_inner_error0_);
					_g_object_unref0 (_tmp52_);
					_g_object_unref0 (_tmp50_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch2_dvb_database_sql_error;
						}
						_g_object_unref0 (points);
						_g_object_unref0 (devgroup);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				goto __finally2;
				__catch2_dvb_database_sql_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp56_;
					GError* _tmp57_;
					const gchar* _tmp58_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp56_ = dvb_manager_log;
					_tmp57_ = e;
					_tmp58_ = _tmp57_->message;
					dvb_logging_logger_error (_tmp56_, "Manager.vala:590: %s", _tmp58_);
					_g_error_free0 (e);
				}
				__finally2:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (points);
					_g_object_unref0 (devgroup);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_object_unref0 (points);
			}
			_tmp59_ = devgroup;
			dvb_device_group_destroy (_tmp59_);
			g_signal_emit_by_name ((DVBIDBusManager*) self, "group-removed", group_id);
		}
	}
	_g_object_unref0 (devgroup);
}

static DVBDeviceGroup*
dvb_manager_create_device_group_by_id (DVBManager* self,
                                       guint group_id)
{
	DVBdatabaseConfigStore* config_store = NULL;
	DVBFactory* _tmp0_;
	DVBFactory* _tmp1_;
	DVBdatabaseConfigStore* _tmp2_;
	DVBdatabaseConfigStore* _tmp3_;
	DVBDeviceGroup* group = NULL;
	DVBDeviceGroup* _tmp11_;
	DVBDeviceGroup* _tmp13_;
	DVBDeviceGroup* _tmp14_;
	DVBDeviceGroup* _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
	GError* _inner_error0_ = NULL;
	DVBDeviceGroup* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = dvb_factory_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_factory_get_config_store (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	config_store = _tmp3_;
	group = NULL;
	{
		DVBDeviceGroup* _tmp4_ = NULL;
		DVBdatabaseConfigStore* _tmp5_;
		DVBDeviceGroup* _tmp6_;
		DVBDeviceGroup* _tmp7_;
		_tmp5_ = config_store;
		_tmp6_ = dvb_database_config_store_get_device_group (_tmp5_, group_id, &_inner_error0_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (group);
			_g_object_unref0 (config_store);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp7_ = _tmp4_;
		_tmp4_ = NULL;
		_g_object_unref0 (group);
		group = _tmp7_;
		_g_object_unref0 (_tmp4_);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = dvb_manager_log;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		dvb_logging_logger_error (_tmp8_, "Manager.vala:607: Error restoring group %u: %s", group_id, _tmp10_);
		result = group;
		_g_error_free0 (e);
		_g_object_unref0 (config_store);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (group);
		_g_object_unref0 (config_store);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp11_ = group;
	if (_tmp11_ == NULL) {
		DVBLoggingLogger* _tmp12_;
		_tmp12_ = dvb_manager_log;
		dvb_logging_logger_debug (_tmp12_, "Manager.vala:612: device group is null");
	}
	_tmp13_ = group;
	dvb_manager_add_device_group (self, _tmp13_, FALSE);
	_tmp14_ = group;
	dvb_manager_restore_device_group_and_timers (self, _tmp14_);
	_tmp15_ = group;
	_tmp16_ = dvb_device_group_get_Id (_tmp15_);
	_tmp17_ = _tmp16_;
	g_signal_emit_by_name ((DVBIDBusManager*) self, "group-added", _tmp17_);
	result = group;
	_g_object_unref0 (config_store);
	return result;
}

static void
dvb_manager_first_add_device (DVBManager* self,
                              GUdevDevice* device)
{
	gchar* dev_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	guint adapter = 0U;
	guint frontend = 0U;
	DVBDevice* dvb_device = NULL;
	const gchar* _tmp3_;
	DVBDevice* _tmp4_;
	GeeArrayList* _tmp5_;
	DVBDevice* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = g_udev_device_get_device_file (device);
	_tmp1_ = g_strdup (_tmp0_);
	dev_file = _tmp1_;
	_tmp2_ = g_udev_device_get_property (device, "DVB_DEVICE_TYPE");
	if (g_strcmp0 (_tmp2_, "frontend") != 0) {
		_g_free0 (dev_file);
		return;
	}
	adapter = (guint) g_udev_device_get_property_as_uint64 (device, "DVB_ADAPTER_NUM");
	frontend = (guint) g_udev_device_get_property_as_uint64 (device, "DVB_DEVICE_NUM");
	_tmp3_ = dev_file;
	_tmp4_ = dvb_device_new_with_udev (device, _tmp3_, adapter, frontend);
	dvb_device = _tmp4_;
	_tmp5_ = self->priv->devices;
	_tmp6_ = dvb_device;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
	_g_object_unref0 (dvb_device);
	_g_free0 (dev_file);
}

static void
dvb_manager_on_udev_event (DVBManager* self,
                           const gchar* action,
                           GUdevDevice* device)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	g_return_if_fail (device != NULL);
	if (g_strcmp0 (action, "add") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (action, "remove") == 0;
	}
	if (_tmp0_) {
		gchar* dev_file = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		guint adapter = 0U;
		guint frontend = 0U;
		guint* group_ids = NULL;
		gint group_ids_length1 = 0;
		gint _group_ids_size_ = 0;
		gboolean found = FALSE;
		DVBdatabaseConfigStore* config_store = NULL;
		DVBFactory* _tmp4_;
		DVBFactory* _tmp5_;
		DVBdatabaseConfigStore* _tmp6_;
		DVBdatabaseConfigStore* _tmp7_;
		DVBLoggingLogger* _tmp15_;
		const gchar* _tmp16_;
		DVBLoggingLogger* _tmp69_;
		GeeArrayList* _tmp70_;
		gint _tmp71_;
		gint _tmp72_;
		_tmp1_ = g_udev_device_get_device_file (device);
		_tmp2_ = g_strdup (_tmp1_);
		dev_file = _tmp2_;
		_tmp3_ = g_udev_device_get_property (device, "DVB_DEVICE_TYPE");
		if (g_strcmp0 (_tmp3_, "frontend") != 0) {
			_g_free0 (dev_file);
			return;
		}
		adapter = (guint) g_udev_device_get_property_as_uint64 (device, "DVB_ADAPTER_NUM");
		frontend = (guint) g_udev_device_get_property_as_uint64 (device, "DVB_DEVICE_NUM");
		found = FALSE;
		_tmp4_ = dvb_factory_new ();
		_tmp5_ = _tmp4_;
		_tmp6_ = dvb_factory_get_config_store (_tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		config_store = _tmp7_;
		{
			gboolean _tmp8_ = FALSE;
			DVBdatabaseConfigStore* _tmp9_;
			guint* _tmp10_ = NULL;
			gint _tmp11_ = 0;
			gboolean _tmp12_;
			_tmp9_ = config_store;
			_tmp12_ = dvb_database_config_store_get_parent_groups (_tmp9_, adapter, frontend, &_tmp10_, &_tmp11_, &_inner_error0_);
			group_ids = (g_free (group_ids), NULL);
			group_ids = _tmp10_;
			group_ids_length1 = _tmp11_;
			_group_ids_size_ = group_ids_length1;
			_tmp8_ = _tmp12_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					goto __catch0_dvb_database_sql_error;
				}
				_g_object_unref0 (config_store);
				group_ids = (g_free (group_ids), NULL);
				_g_free0 (dev_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			found = _tmp8_;
		}
		goto __finally0;
		__catch0_dvb_database_sql_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->message;
			g_critical ("Manager.vala:651: %s", _tmp14_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (config_store);
			group_ids = (g_free (group_ids), NULL);
			_g_free0 (dev_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp15_ = dvb_manager_log;
		_tmp16_ = dev_file;
		dvb_logging_logger_debug (_tmp15_, "Manager.vala:654: %s device %s", action, _tmp16_);
		if (found) {
			guint* _tmp17_;
			gint _tmp17__length1;
			_tmp17_ = group_ids;
			_tmp17__length1 = group_ids_length1;
			{
				guint* group_id_collection = NULL;
				gint group_id_collection_length1 = 0;
				gint _group_id_collection_size_ = 0;
				gint group_id_it = 0;
				group_id_collection = _tmp17_;
				group_id_collection_length1 = _tmp17__length1;
				for (group_id_it = 0; group_id_it < group_id_collection_length1; group_id_it = group_id_it + 1) {
					guint group_id = 0U;
					group_id = group_id_collection[group_id_it];
					{
						DVBLoggingLogger* _tmp18_;
						DVBDeviceGroup* group = NULL;
						DVBDeviceGroup* _tmp19_;
						DVBDeviceGroup* _tmp20_;
						DVBDeviceGroup* _tmp22_;
						_tmp18_ = dvb_manager_log;
						dvb_logging_logger_debug (_tmp18_, "Manager.vala:658: DeviceGroup ID: %u", group_id);
						_tmp19_ = dvb_manager_get_device_group_if_exists (self, group_id);
						group = _tmp19_;
						_tmp20_ = group;
						if (_tmp20_ == NULL) {
							DVBDeviceGroup* _tmp21_;
							_tmp21_ = dvb_manager_create_device_group_by_id (self, group_id);
							_g_object_unref0 (group);
							group = _tmp21_;
						}
						_tmp22_ = group;
						if (_tmp22_ != NULL) {
							DVBDeviceGroup* _tmp23_;
							_tmp23_ = group;
							dvb_device_group_stop_epg_scanner (_tmp23_);
						}
						_g_object_unref0 (group);
					}
				}
			}
		}
		if (g_strcmp0 (action, "add") == 0) {
			DVBDevice* dvb_device = NULL;
			const gchar* _tmp24_;
			DVBDevice* _tmp25_;
			GeeArrayList* _tmp26_;
			DVBDevice* _tmp27_;
			_tmp24_ = dev_file;
			_tmp25_ = dvb_device_new_with_udev (device, _tmp24_, adapter, frontend);
			dvb_device = _tmp25_;
			_tmp26_ = self->priv->devices;
			_tmp27_ = dvb_device;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
			if (found) {
				guint* _tmp28_;
				gint _tmp28__length1;
				_tmp28_ = group_ids;
				_tmp28__length1 = group_ids_length1;
				{
					guint* group_id_collection = NULL;
					gint group_id_collection_length1 = 0;
					gint _group_id_collection_size_ = 0;
					gint group_id_it = 0;
					group_id_collection = _tmp28_;
					group_id_collection_length1 = _tmp28__length1;
					for (group_id_it = 0; group_id_it < group_id_collection_length1; group_id_it = group_id_it + 1) {
						guint group_id = 0U;
						group_id = group_id_collection[group_id_it];
						{
							DVBDeviceGroup* group = NULL;
							DVBDeviceGroup* _tmp29_;
							DVBDeviceGroup* _tmp30_;
							_tmp29_ = dvb_manager_get_device_group_if_exists (self, group_id);
							group = _tmp29_;
							_tmp30_ = group;
							if (_tmp30_ != NULL) {
								DVBDeviceGroup* _tmp31_;
								DVBDevice* _tmp32_;
								_tmp31_ = group;
								_tmp32_ = dvb_device;
								if (dvb_device_group_add (_tmp31_, _tmp32_)) {
									DVBDeviceGroup* _tmp33_;
									DVBDevice* _tmp34_;
									guint _tmp35_;
									guint _tmp36_;
									DVBDevice* _tmp37_;
									guint _tmp38_;
									guint _tmp39_;
									_tmp33_ = group;
									_tmp34_ = dvb_device;
									_tmp35_ = dvb_device_get_Adapter (_tmp34_);
									_tmp36_ = _tmp35_;
									_tmp37_ = dvb_device;
									_tmp38_ = dvb_device_get_Frontend (_tmp37_);
									_tmp39_ = _tmp38_;
									g_signal_emit_by_name ((DVBIDBusDeviceGroup*) _tmp33_, "device-added", _tmp36_, _tmp39_);
								}
							}
							_g_object_unref0 (group);
						}
					}
				}
			}
			_g_object_unref0 (dvb_device);
		} else {
			{
				GeeArrayList* _d_list = NULL;
				GeeArrayList* _tmp40_;
				gint _d_size = 0;
				GeeArrayList* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _d_index = 0;
				_tmp40_ = self->priv->devices;
				_d_list = _tmp40_;
				_tmp41_ = _d_list;
				_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
				_tmp43_ = _tmp42_;
				_d_size = _tmp43_;
				_d_index = -1;
				while (TRUE) {
					gint _tmp44_;
					gint _tmp45_;
					DVBDevice* d = NULL;
					GeeArrayList* _tmp46_;
					gpointer _tmp47_;
					gboolean _tmp48_ = FALSE;
					DVBDevice* _tmp49_;
					guint _tmp50_;
					guint _tmp51_;
					_d_index = _d_index + 1;
					_tmp44_ = _d_index;
					_tmp45_ = _d_size;
					if (!(_tmp44_ < _tmp45_)) {
						break;
					}
					_tmp46_ = _d_list;
					_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, _d_index);
					d = (DVBDevice*) _tmp47_;
					_tmp49_ = d;
					_tmp50_ = dvb_device_get_Frontend (_tmp49_);
					_tmp51_ = _tmp50_;
					if (_tmp51_ == frontend) {
						DVBDevice* _tmp52_;
						guint _tmp53_;
						guint _tmp54_;
						_tmp52_ = d;
						_tmp53_ = dvb_device_get_Adapter (_tmp52_);
						_tmp54_ = _tmp53_;
						_tmp48_ = _tmp54_ == adapter;
					} else {
						_tmp48_ = FALSE;
					}
					if (_tmp48_) {
						GeeArrayList* _tmp55_;
						DVBDevice* _tmp56_;
						_tmp55_ = self->priv->devices;
						_tmp56_ = d;
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp55_, _tmp56_);
					}
					if (found) {
						guint* _tmp57_;
						gint _tmp57__length1;
						_tmp57_ = group_ids;
						_tmp57__length1 = group_ids_length1;
						{
							guint* group_id_collection = NULL;
							gint group_id_collection_length1 = 0;
							gint _group_id_collection_size_ = 0;
							gint group_id_it = 0;
							group_id_collection = _tmp57_;
							group_id_collection_length1 = _tmp57__length1;
							for (group_id_it = 0; group_id_it < group_id_collection_length1; group_id_it = group_id_it + 1) {
								guint group_id = 0U;
								group_id = group_id_collection[group_id_it];
								{
									DVBDeviceGroup* group = NULL;
									DVBDeviceGroup* _tmp58_;
									DVBDeviceGroup* _tmp59_;
									_tmp58_ = dvb_manager_get_device_group_if_exists (self, group_id);
									group = _tmp58_;
									_tmp59_ = group;
									if (_tmp59_ != NULL) {
										DVBDeviceGroup* _tmp60_;
										DVBDevice* _tmp61_;
										_tmp60_ = group;
										_tmp61_ = d;
										if (dvb_device_group_remove (_tmp60_, _tmp61_)) {
											DVBDeviceGroup* _tmp62_;
											DVBDevice* _tmp63_;
											guint _tmp64_;
											guint _tmp65_;
											DVBDevice* _tmp66_;
											guint _tmp67_;
											guint _tmp68_;
											_tmp62_ = group;
											_tmp63_ = d;
											_tmp64_ = dvb_device_get_Adapter (_tmp63_);
											_tmp65_ = _tmp64_;
											_tmp66_ = d;
											_tmp67_ = dvb_device_get_Frontend (_tmp66_);
											_tmp68_ = _tmp67_;
											g_signal_emit_by_name ((DVBIDBusDeviceGroup*) _tmp62_, "device-removed", _tmp65_, _tmp68_);
										}
									}
									_g_object_unref0 (group);
								}
							}
						}
					}
					_g_object_unref0 (d);
				}
			}
		}
		_tmp69_ = dvb_manager_log;
		_tmp70_ = self->priv->devices;
		_tmp71_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp70_);
		_tmp72_ = _tmp71_;
		dvb_logging_logger_debug (_tmp69_, "Manager.vala:706: Numbers of devices %u", (guint) _tmp72_);
		if (found) {
			guint* _tmp73_;
			gint _tmp73__length1;
			_tmp73_ = group_ids;
			_tmp73__length1 = group_ids_length1;
			{
				guint* group_id_collection = NULL;
				gint group_id_collection_length1 = 0;
				gint _group_id_collection_size_ = 0;
				gint group_id_it = 0;
				group_id_collection = _tmp73_;
				group_id_collection_length1 = _tmp73__length1;
				for (group_id_it = 0; group_id_it < group_id_collection_length1; group_id_it = group_id_it + 1) {
					guint group_id = 0U;
					group_id = group_id_collection[group_id_it];
					{
						DVBDeviceGroup* group = NULL;
						DVBDeviceGroup* _tmp74_;
						DVBDeviceGroup* _tmp75_;
						_tmp74_ = dvb_manager_get_device_group_if_exists (self, group_id);
						group = _tmp74_;
						_tmp75_ = group;
						if (_tmp75_ != NULL) {
							DVBDeviceGroup* _tmp76_;
							_tmp76_ = group;
							dvb_device_group_start_epg_scanner (_tmp76_);
						}
						_g_object_unref0 (group);
					}
				}
			}
		}
		_g_object_unref0 (config_store);
		group_ids = (g_free (group_ids), NULL);
		_g_free0 (dev_file);
	}
}

DVBManager*
dvb_manager_construct (GType object_type)
{
	DVBManager * self = NULL;
	self = (DVBManager*) g_object_new (object_type, NULL);
	return self;
}

DVBManager*
dvb_manager_new (void)
{
	return dvb_manager_construct (DVB_TYPE_MANAGER);
}

GeeCollection*
dvb_manager_get_device_groups (DVBManager* self)
{
	GeeCollection* result;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->groups;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

GeeArrayList*
dvb_manager_get_devs (DVBManager* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->devices;
	result = _tmp0_;
	return result;
}

static DVBManagerScannerData*
dvb_manager_scanner_data_construct (GType object_type)
{
	DVBManagerScannerData * self = NULL;
	self = (DVBManagerScannerData*) g_object_new (object_type, NULL);
	return self;
}

static DVBManagerScannerData*
dvb_manager_scanner_data_new (void)
{
	return dvb_manager_scanner_data_construct (DVB_MANAGER_TYPE_SCANNER_DATA);
}

static void
dvb_manager_scanner_data_class_init (DVBManagerScannerDataClass * klass,
                                     gpointer klass_data)
{
	dvb_manager_scanner_data_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = dvb_manager_scanner_data_finalize;
}

static void
dvb_manager_scanner_data_instance_init (DVBManagerScannerData * self,
                                        gpointer klass)
{
}

static void
dvb_manager_scanner_data_finalize (GObject * obj)
{
	DVBManagerScannerData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_MANAGER_TYPE_SCANNER_DATA, DVBManagerScannerData);
	_g_object_unref0 (self->scanner);
	G_OBJECT_CLASS (dvb_manager_scanner_data_parent_class)->finalize (obj);
}

static GType
dvb_manager_scanner_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBManagerScannerDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_manager_scanner_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBManagerScannerData), 0, (GInstanceInitFunc) dvb_manager_scanner_data_instance_init, NULL };
	GType dvb_manager_scanner_data_type_id;
	dvb_manager_scanner_data_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBManagerScannerData", &g_define_type_info, 0);
	return dvb_manager_scanner_data_type_id;
}

static GType
dvb_manager_scanner_data_get_type (void)
{
	static volatile gsize dvb_manager_scanner_data_type_id__once = 0;
	if (g_once_init_enter (&dvb_manager_scanner_data_type_id__once)) {
		GType dvb_manager_scanner_data_type_id;
		dvb_manager_scanner_data_type_id = dvb_manager_scanner_data_get_type_once ();
		g_once_init_leave (&dvb_manager_scanner_data_type_id__once, dvb_manager_scanner_data_type_id);
	}
	return dvb_manager_scanner_data_type_id__once;
}

static void
_dvb_manager_on_udev_event_g_udev_client_uevent (GUdevClient* _sender,
                                                 const gchar* action,
                                                 GUdevDevice* device,
                                                 gpointer self)
{
	dvb_manager_on_udev_event ((DVBManager*) self, action, device);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static GObject *
dvb_manager_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBManager * self;
	gpointer _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeHashDataFunc _tmp2_;
	gpointer _tmp3_ = NULL;
	GDestroyNotify _tmp4_ = NULL;
	GeeEqualDataFunc _tmp5_;
	gpointer _tmp6_ = NULL;
	GDestroyNotify _tmp7_ = NULL;
	GeeEqualDataFunc _tmp8_;
	GeeHashMap* _tmp9_;
	GeeHashMap* _tmp10_;
	GeeArrayList* _tmp11_;
	GUdevClient* _tmp12_;
	GUdevClient* _tmp13_;
	GList* devs = NULL;
	GUdevClient* _tmp14_;
	GList* _tmp15_;
	GList* _tmp16_;
	parent_class = G_OBJECT_CLASS (dvb_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_MANAGER, DVBManager);
	_tmp2_ = gee_functions_get_hash_func_for (G_TYPE_STRING, &_tmp0_, &_tmp1_);
	_tmp5_ = gee_functions_get_equal_func_for (G_TYPE_STRING, &_tmp3_, &_tmp4_);
	_tmp8_ = gee_functions_get_equal_func_for (DVB_MANAGER_TYPE_SCANNER_DATA, &_tmp6_, &_tmp7_);
	_tmp9_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, DVB_MANAGER_TYPE_SCANNER_DATA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_, _tmp0_, _tmp1_, _tmp5_, _tmp3_, _tmp4_, _tmp8_, _tmp6_, _tmp7_);
	_g_object_unref0 (self->priv->scanners);
	self->priv->scanners = _tmp9_;
	_tmp10_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, DVB_TYPE_DEVICE_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->groups);
	self->priv->groups = _tmp10_;
	_tmp11_ = gee_array_list_new (DVB_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = _tmp11_;
	self->priv->device_group_counter = (guint) 0;
	_tmp12_ = g_udev_client_new (DVB_MANAGER_UDEV_SUBSYSTEMS);
	_g_object_unref0 (self->priv->udev_client);
	self->priv->udev_client = _tmp12_;
	_tmp13_ = self->priv->udev_client;
	g_signal_connect_object (_tmp13_, "uevent", (GCallback) _dvb_manager_on_udev_event_g_udev_client_uevent, self, 0);
	_tmp14_ = self->priv->udev_client;
	_tmp15_ = g_udev_client_query_by_subsystem (_tmp14_, "dvb");
	devs = _tmp15_;
	_tmp16_ = devs;
	{
		GList* dev_collection = NULL;
		GList* dev_it = NULL;
		dev_collection = _tmp16_;
		for (dev_it = dev_collection; dev_it != NULL; dev_it = dev_it->next) {
			GUdevDevice* _tmp17_;
			GUdevDevice* dev = NULL;
			_tmp17_ = _g_object_ref0 ((GUdevDevice*) dev_it->data);
			dev = _tmp17_;
			{
				GUdevDevice* _tmp18_;
				_tmp18_ = dev;
				dvb_manager_first_add_device (self, _tmp18_);
				_g_object_unref0 (dev);
			}
		}
	}
	(devs == NULL) ? NULL : (devs = (_g_list_free__g_object_unref0_ (devs), NULL));
	return obj;
}

static void
dvb_manager_class_init (DVBManagerClass * klass,
                        gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_manager_get_property;
	G_OBJECT_CLASS (klass)->constructor = dvb_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_MANAGER_DEVICE_GROUPS_PROPERTY, dvb_manager_properties[DVB_MANAGER_DEVICE_GROUPS_PROPERTY] = g_param_spec_object ("device-groups", "device-groups", "device-groups", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_MANAGER_DEVS_PROPERTY, dvb_manager_properties[DVB_MANAGER_DEVS_PROPERTY] = g_param_spec_object ("devs", "devs", "devs", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_manager_log = _tmp1_;
	g_rec_mutex_init (&dvb_manager_instance_mutex);
	dvb_manager_instance_mutex = dvb_manager_instance_mutex;
}

static void
dvb_manager_dvb_id_bus_manager_interface_init (DVBIDBusManagerIface * iface,
                                               gpointer iface_data)
{
	dvb_manager_dvb_id_bus_manager_parent_iface = g_type_interface_peek_parent (iface);
	iface->GetScannerForDevice = (gboolean (*) (DVBIDBusManager*, guint, guint, DVBAdapterType, char**, gchar**, GError**)) dvb_manager_real_GetScannerForDevice;
	iface->GetDeviceGroup = (gboolean (*) (DVBIDBusManager*, guint, char**, GError**)) dvb_manager_real_GetDeviceGroup;
	iface->GetRegisteredDeviceGroups = (char** (*) (DVBIDBusManager*, gint*, GError**)) dvb_manager_real_GetRegisteredDeviceGroups;
	iface->AddDeviceToNewGroup = (gboolean (*) (DVBIDBusManager*, guint, guint, DVBAdapterType, const gchar*, const gchar*, const gchar*, GError**)) dvb_manager_real_AddDeviceToNewGroup;
	iface->GetNameOfRegisteredDevice = (gboolean (*) (DVBIDBusManager*, guint, guint, gchar**, GError**)) dvb_manager_real_GetNameOfRegisteredDevice;
	iface->GetDeviceGroupSize = (gint (*) (DVBIDBusManager*, GError**)) dvb_manager_real_GetDeviceGroupSize;
	iface->GetChannelGroups = (DVBChannelGroupInfo* (*) (DVBIDBusManager*, gint*, GError**)) dvb_manager_real_GetChannelGroups;
	iface->AddChannelGroup = (gboolean (*) (DVBIDBusManager*, const gchar*, gint*, GError**)) dvb_manager_real_AddChannelGroup;
	iface->RemoveChannelGroup = (gboolean (*) (DVBIDBusManager*, gint, GError**)) dvb_manager_real_RemoveChannelGroup;
	iface->GetDevices = (GHashTable** (*) (DVBIDBusManager*, gint*, GError**)) dvb_manager_real_GetDevices;
	iface->GetAdapterInfo = (gboolean (*) (DVBIDBusManager*, guint, guint, DVBAdapterInfo*, GError**)) dvb_manager_real_GetAdapterInfo;
}

static void
dvb_manager_instance_init (DVBManager * self,
                           gpointer klass)
{
	self->priv = dvb_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_scanners);
	g_rec_mutex_init (&self->priv->__lock_groups);
	g_rec_mutex_init (&self->priv->__lock_devices);
}

static void
dvb_manager_finalize (GObject * obj)
{
	DVBManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_MANAGER, DVBManager);
	g_rec_mutex_clear (&self->priv->__lock_scanners);
	_g_object_unref0 (self->priv->scanners);
	g_rec_mutex_clear (&self->priv->__lock_groups);
	_g_object_unref0 (self->priv->groups);
	g_rec_mutex_clear (&self->priv->__lock_devices);
	_g_object_unref0 (self->priv->devices);
	_g_object_unref0 (self->priv->udev_client);
	G_OBJECT_CLASS (dvb_manager_parent_class)->finalize (obj);
}

static GType
dvb_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBManager), 0, (GInstanceInitFunc) dvb_manager_instance_init, NULL };
	static const GInterfaceInfo dvb_id_bus_manager_info = { (GInterfaceInitFunc) dvb_manager_dvb_id_bus_manager_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_manager_type_id;
	dvb_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBManager", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_manager_type_id, DVB_TYPE_ID_BUS_MANAGER, &dvb_id_bus_manager_info);
	DVBManager_private_offset = g_type_add_instance_private (dvb_manager_type_id, sizeof (DVBManagerPrivate));
	return dvb_manager_type_id;
}

GType
dvb_manager_get_type (void)
{
	static volatile gsize dvb_manager_type_id__once = 0;
	if (g_once_init_enter (&dvb_manager_type_id__once)) {
		GType dvb_manager_type_id;
		dvb_manager_type_id = dvb_manager_get_type_once ();
		g_once_init_leave (&dvb_manager_type_id__once, dvb_manager_type_id);
	}
	return dvb_manager_type_id__once;
}

static void
_vala_dvb_manager_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	DVBManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_MANAGER, DVBManager);
	switch (property_id) {
		case DVB_MANAGER_DEVICE_GROUPS_PROPERTY:
		g_value_take_object (value, dvb_manager_get_device_groups (self));
		break;
		case DVB_MANAGER_DEVS_PROPERTY:
		g_value_set_object (value, dvb_manager_get_devs (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

