/* Scanner.c generated by valac 0.56.18, the Vala compiler
 * generated from Scanner.vala, do not modify */

/*
 * Copyright (C) 2008-2010 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gst/gst.h>
#include <gee.h>
#include <cstuff.h>
#include <float.h>
#include <math.h>
#include <gst/mpegts/mpegts.h>

#define DVB_SCANNER_BASE_PIDS "16:17"
#define DVB_SCANNER_PIPELINE_TEMPLATE "dvbsrc name=dvbsrc adapter=%u frontend=%u stats-reporting-interval=100" \
" ! tsparse ! fakesink silent=true"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_ID_BUS_SCANNER (dvb_id_bus_scanner_get_type ())
#define DVB_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScanner))
#define DVB_IS_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_SCANNER))
#define DVB_ID_BUS_SCANNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScannerIface))

typedef struct _DVBIDBusScanner DVBIDBusScanner;
typedef struct _DVBIDBusScannerIface DVBIDBusScannerIface;

#define DVB_TYPE_ID_BUS_SCANNER_PROXY (dvb_id_bus_scanner_proxy_get_type ())

#define DVB_TYPE_SCANNER (dvb_scanner_get_type ())
#define DVB_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SCANNER, DVBScanner))
#define DVB_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SCANNER, DVBScannerClass))
#define DVB_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SCANNER))
#define DVB_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SCANNER))
#define DVB_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SCANNER, DVBScannerClass))

typedef struct _DVBScanner DVBScanner;
typedef struct _DVBScannerClass DVBScannerClass;
typedef struct _DVBScannerPrivate DVBScannerPrivate;

#define DVB_TYPE_CHANNEL_LIST (dvb_channel_list_get_type ())
#define DVB_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelList))
#define DVB_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))
#define DVB_IS_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_LIST))
#define DVB_IS_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_LIST))
#define DVB_CHANNEL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))

typedef struct _DVBChannelList DVBChannelList;
typedef struct _DVBChannelListClass DVBChannelListClass;

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_PARAMETER (dvb_parameter_get_type ())
#define DVB_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_PARAMETER, DVBParameter))
#define DVB_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_PARAMETER, DVBParameterClass))
#define DVB_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_PARAMETER))
#define DVB_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_PARAMETER))
#define DVB_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_PARAMETER, DVBParameterClass))

typedef struct _DVBParameter DVBParameter;
typedef struct _DVBParameterClass DVBParameterClass;
enum  {
	DVB_SCANNER_0_PROPERTY,
	DVB_SCANNER_DEVICE_PROPERTY,
	DVB_SCANNER_CHANNELS_PROPERTY,
	DVB_SCANNER_TYPE_PROPERTY,
	DVB_SCANNER_NUM_PROPERTIES
};
static GParamSpec* dvb_scanner_properties[DVB_SCANNER_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_DVB_TPARAMETER (dvb_dvb_tparameter_get_type ())
#define DVB_DVB_TPARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DVB_TPARAMETER, DVBDvbTParameter))
#define DVB_DVB_TPARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DVB_TPARAMETER, DVBDvbTParameterClass))
#define DVB_IS_DVB_TPARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DVB_TPARAMETER))
#define DVB_IS_DVB_TPARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DVB_TPARAMETER))
#define DVB_DVB_TPARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DVB_TPARAMETER, DVBDvbTParameterClass))

typedef struct _DVBDvbTParameter DVBDvbTParameter;
typedef struct _DVBDvbTParameterClass DVBDvbTParameterClass;

#define DVB_TYPE_DVB_CEUROPE_PARAMETER (dvb_dvb_ceurope_parameter_get_type ())
#define DVB_DVB_CEUROPE_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DVB_CEUROPE_PARAMETER, DVBDvbCEuropeParameter))
#define DVB_DVB_CEUROPE_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DVB_CEUROPE_PARAMETER, DVBDvbCEuropeParameterClass))
#define DVB_IS_DVB_CEUROPE_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DVB_CEUROPE_PARAMETER))
#define DVB_IS_DVB_CEUROPE_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DVB_CEUROPE_PARAMETER))
#define DVB_DVB_CEUROPE_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DVB_CEUROPE_PARAMETER, DVBDvbCEuropeParameterClass))

typedef struct _DVBDvbCEuropeParameter DVBDvbCEuropeParameter;
typedef struct _DVBDvbCEuropeParameterClass DVBDvbCEuropeParameterClass;

#define DVB_TYPE_DVB_SPARAMETER (dvb_dvb_sparameter_get_type ())
#define DVB_DVB_SPARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DVB_SPARAMETER, DVBDvbSParameter))
#define DVB_DVB_SPARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DVB_SPARAMETER, DVBDvbSParameterClass))
#define DVB_IS_DVB_SPARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DVB_SPARAMETER))
#define DVB_IS_DVB_SPARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DVB_SPARAMETER))
#define DVB_DVB_SPARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DVB_SPARAMETER, DVBDvbSParameterClass))

typedef struct _DVBDvbSParameter DVBDvbSParameter;
typedef struct _DVBDvbSParameterClass DVBDvbSParameterClass;

#define DVB_IO_TYPE_CHANNEL_LIST_WRITER (dvb_io_channel_list_writer_get_type ())
#define DVB_IO_CHANNEL_LIST_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_IO_TYPE_CHANNEL_LIST_WRITER, DVBioChannelListWriter))
#define DVB_IO_CHANNEL_LIST_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_IO_TYPE_CHANNEL_LIST_WRITER, DVBioChannelListWriterClass))
#define DVB_IO_IS_CHANNEL_LIST_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_IO_TYPE_CHANNEL_LIST_WRITER))
#define DVB_IO_IS_CHANNEL_LIST_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_IO_TYPE_CHANNEL_LIST_WRITER))
#define DVB_IO_CHANNEL_LIST_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_IO_TYPE_CHANNEL_LIST_WRITER, DVBioChannelListWriterClass))

typedef struct _DVBioChannelListWriter DVBioChannelListWriter;
typedef struct _DVBioChannelListWriterClass DVBioChannelListWriterClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;

#define DVB_IO_TYPE_SCANNING_LIST_READER (dvb_io_scanning_list_reader_get_type ())
#define DVB_IO_SCANNING_LIST_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_IO_TYPE_SCANNING_LIST_READER, DVBioScanningListReader))
#define DVB_IO_SCANNING_LIST_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_IO_TYPE_SCANNING_LIST_READER, DVBioScanningListReaderClass))
#define DVB_IO_IS_SCANNING_LIST_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_IO_TYPE_SCANNING_LIST_READER))
#define DVB_IO_IS_SCANNING_LIST_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_IO_TYPE_SCANNING_LIST_READER))
#define DVB_IO_SCANNING_LIST_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_IO_TYPE_SCANNING_LIST_READER, DVBioScanningListReaderClass))

typedef struct _DVBioScanningListReader DVBioScanningListReader;
typedef struct _DVBioScanningListReaderClass DVBioScanningListReaderClass;
typedef enum  {
	DVB_DVB_SRC_DELSYS_SYS_UNDEFINED,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B,
	DVB_DVB_SRC_DELSYS_SYS_DVBT,
	DVB_DVB_SRC_DELSYS_SYS_DSS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS2,
	DVB_DVB_SRC_DELSYS_SYS_DVBH,
	DVB_DVB_SRC_DELSYS_SYS_ISDBT,
	DVB_DVB_SRC_DELSYS_SYS_ISDBS,
	DVB_DVB_SRC_DELSYS_SYS_ISDBC,
	DVB_DVB_SRC_DELSYS_SYS_ATSC,
	DVB_DVB_SRC_DELSYS_SYS_ATSCMH,
	DVB_DVB_SRC_DELSYS_SYS_DTMB,
	DVB_DVB_SRC_DELSYS_SYS_CMMB,
	DVB_DVB_SRC_DELSYS_SYS_DAB,
	DVB_DVB_SRC_DELSYS_SYS_DVBT2,
	DVB_DVB_SRC_DELSYS_SYS_TURBO,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C
} DVBDvbSrcDelsys;

#define DVB_TYPE_DVB_SRC_DELSYS (dvb_dvb_src_delsys_get_type ())
#define __vala_GstMpegtsPatProgram_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsPatProgram_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define __vala_GstMpegtsSDTService_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsSDTService_free (var), NULL)))
#define __vala_GstMpegtsDescriptor_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsDescriptor_free (var), NULL)))
#define __vala_GstMpegtsNITStream_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsNITStream_free (var), NULL)))
#define __vala_GstMpegtsPMTStream_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsPMTStream_free (var), NULL)))
#define __vala_GstMpegtsSection_free0(var) ((var == NULL) ? NULL : (var = (_vala_GstMpegtsSection_free (var), NULL)))
enum  {
	DVB_SCANNER_DESTROYED_SIGNAL,
	DVB_SCANNER_NUM_SIGNALS
};
static guint dvb_scanner_signals[DVB_SCANNER_NUM_SIGNALS] = {0};

struct _DVBIDBusScannerIface {
	GTypeInterface parent_iface;
	void (*Run) (DVBIDBusScanner* self, GError** error);
	void (*Destroy) (DVBIDBusScanner* self, GError** error);
	gboolean (*WriteAllChannelsToFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
	gboolean (*WriteChannelsToFile) (DVBIDBusScanner* self, guint* channel_sids, gint channel_sids_length1, const gchar* path, GError** error);
	gboolean (*AddScanningData) (DVBIDBusScanner* self, GHashTable* data, GError** error);
	gboolean (*AddScanningDataFromFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
};

struct _DVBScanner {
	GObject parent_instance;
	DVBScannerPrivate * priv;
	DVBChannelList* channels;
	GstElement* pipeline;
};

struct _DVBScannerClass {
	GObjectClass parent_class;
};

struct _DVBScannerPrivate {
	DVBDevice* _Device;
	DVBAdapterType _Type;
	GRecMutex __lock_channels;
	GQueue* queue_scanning_params;
	DVBParameter* current_scanning_param;
	GeeHashSet* scanned_scanning_params;
	GeeArrayList* new_channels;
	GRecMutex __lock_new_channels;
	GSource* check_for_lock_source;
	GSource* wait_for_tables_source;
	GSource* start_scan_source;
	gboolean nit_arrived;
	gboolean sdt_arrived;
	gboolean pat_arrived;
	gboolean pmt_arrived;
	gboolean locked;
	GMainContext* context;
	GMainLoop* loop;
	GThread* worker_thread;
	gboolean running;
	guint bus_watch_id;
};

static gint DVBScanner_private_offset;
static gpointer dvb_scanner_parent_class = NULL;
static DVBLoggingLogger* dvb_scanner_log;
static DVBLoggingLogger* dvb_scanner_log = NULL;
static DVBIDBusScannerIface * dvb_scanner_dvb_id_bus_scanner_parent_iface = NULL;

VALA_EXTERN GType dvb_id_bus_scanner_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_scanner_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_id_bus_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusScanner, g_object_unref)
VALA_EXTERN GType dvb_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBScanner, g_object_unref)
VALA_EXTERN GType dvb_channel_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelList, g_object_unref)
VALA_EXTERN GType dvb_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDevice, g_object_unref)
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_parameter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBParameter, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_queue_free__g_object_unref0_ (GQueue* self);
VALA_EXTERN DVBScanner* dvb_scanner_new (DVBDevice* device,
                             DVBAdapterType type);
VALA_EXTERN DVBScanner* dvb_scanner_construct (GType object_type,
                                   DVBDevice* device,
                                   DVBAdapterType type);
static void dvb_scanner_real_Run (DVBIDBusScanner* base,
                           GError** error);
static void* dvb_scanner_worker (DVBScanner* self);
static gpointer _dvb_scanner_worker_gthread_func (gpointer self);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN DVBChannelList* dvb_channel_list_new (GFile* channels);
VALA_EXTERN DVBChannelList* dvb_channel_list_construct (GType object_type,
                                            GFile* channels);
VALA_EXTERN DVBDevice* dvb_scanner_get_Device (DVBScanner* self);
VALA_EXTERN guint dvb_device_get_Adapter (DVBDevice* self);
VALA_EXTERN guint dvb_device_get_Frontend (DVBDevice* self);
VALA_EXTERN gboolean dvb_scanner_bus_watch_func (DVBScanner* self,
                                     GstBus* bus,
                                     GstMessage* message);
static gboolean _dvb_scanner_bus_watch_func_gst_bus_func (GstBus* bus,
                                                   GstMessage* message,
                                                   gpointer self);
VALA_EXTERN void dvb_scanner_queue_start_scan (DVBScanner* self);
static void dvb_scanner_real_Destroy (DVBIDBusScanner* base,
                               GError** error);
VALA_EXTERN void dvb_scanner_do_destroy (DVBScanner* self);
VALA_EXTERN void dvb_scanner_destroy_start_scan_source (DVBScanner* self);
VALA_EXTERN void dvb_scanner_remove_check_for_lock_timeout (DVBScanner* self);
VALA_EXTERN void dvb_scanner_remove_wait_for_tables_timeout (DVBScanner* self);
VALA_EXTERN void dvb_scanner_clear_and_reset_all (DVBScanner* self);
VALA_EXTERN void dvb_channel_list_clear (DVBChannelList* self);
static gboolean dvb_scanner_real_AddScanningData (DVBIDBusScanner* base,
                                           GHashTable* data,
                                           GError** error);
VALA_EXTERN GType dvb_dvb_tparameter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDvbTParameter, g_object_unref)
VALA_EXTERN DVBDvbTParameter* dvb_dvb_tparameter_new (void);
VALA_EXTERN DVBDvbTParameter* dvb_dvb_tparameter_construct (GType object_type);
VALA_EXTERN gboolean dvb_parameter_add_scanning_data (DVBParameter* self,
                                          GHashTable* data);
VALA_EXTERN void dvb_scanner_add_to_queue (DVBScanner* self,
                               DVBParameter* param);
VALA_EXTERN GType dvb_dvb_ceurope_parameter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDvbCEuropeParameter, g_object_unref)
VALA_EXTERN DVBDvbCEuropeParameter* dvb_dvb_ceurope_parameter_new (void);
VALA_EXTERN DVBDvbCEuropeParameter* dvb_dvb_ceurope_parameter_construct (GType object_type);
VALA_EXTERN GType dvb_dvb_sparameter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDvbSParameter, g_object_unref)
VALA_EXTERN DVBDvbSParameter* dvb_dvb_sparameter_new (void);
VALA_EXTERN DVBDvbSParameter* dvb_dvb_sparameter_construct (GType object_type);
static gboolean dvb_scanner_real_WriteAllChannelsToFile (DVBIDBusScanner* base,
                                                  const gchar* path,
                                                  GError** error);
VALA_EXTERN GType dvb_io_channel_list_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBioChannelListWriter, g_object_unref)
VALA_EXTERN DVBioChannelListWriter* dvb_io_channel_list_writer_new (GFile* file);
VALA_EXTERN DVBioChannelListWriter* dvb_io_channel_list_writer_construct (GType object_type,
                                                              GFile* file);
VALA_EXTERN GType dvb_channel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannel, g_object_unref)
VALA_EXTERN void dvb_io_channel_list_writer_write (DVBioChannelListWriter* self,
                                       DVBChannel* channel,
                                       GError** error);
VALA_EXTERN gboolean dvb_io_channel_list_writer_close (DVBioChannelListWriter* self,
                                           GError** error);
static gboolean dvb_scanner_real_WriteChannelsToFile (DVBIDBusScanner* base,
                                               guint* channel_sids,
                                               gint channel_sids_length1,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN DVBChannel* dvb_channel_list_get_channel (DVBChannelList* self,
                                          guint sid);
VALA_EXTERN void dvb_logging_logger_warning (DVBLoggingLogger* self,
                                 const gchar* format,
                                 ...)  G_GNUC_PRINTF(2,3) ;
static gboolean dvb_scanner_real_AddScanningDataFromFile (DVBIDBusScanner* base,
                                                   const gchar* path,
                                                   GError** error);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean dvb_utils_is_readable_file (GFile* file);
VALA_EXTERN GType dvb_io_scanning_list_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBioScanningListReader, g_object_unref)
VALA_EXTERN DVBioScanningListReader* dvb_io_scanning_list_reader_new (const gchar* keyfile);
VALA_EXTERN DVBioScanningListReader* dvb_io_scanning_list_reader_construct (GType object_type,
                                                                const gchar* keyfile);
VALA_EXTERN void dvb_io_scanning_list_reader_read_data (DVBioScanningListReader* self,
                                            GError** error);
VALA_EXTERN GList* dvb_io_scanning_list_reader_get_Parameters (DVBioScanningListReader* self);
VALA_EXTERN void dvb_scanner_clear_queue (DVBScanner* self);
VALA_EXTERN GType dvb_dvb_src_delsys_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean dvb_isSupported (DVBDvbSrcDelsys delsys,
                          DVBAdapterType type);
VALA_EXTERN DVBDvbSrcDelsys dvb_parameter_get_Delsys (DVBParameter* self);
VALA_EXTERN DVBAdapterType dvb_scanner_get_Type (DVBScanner* self);
VALA_EXTERN gboolean dvb_parameter_equal (DVBParameter* self,
                              DVBParameter* param);
VALA_EXTERN guint dvb_parameter_get_Frequency (DVBParameter* self);
VALA_EXTERN gboolean dvb_scanner_start_scan (DVBScanner* self);
VALA_EXTERN void dvb_channel_list_remove (DVBChannelList* self,
                              guint sid);
VALA_EXTERN void dvb_parameter_prepare (DVBParameter* self,
                            GstElement* source);
VALA_EXTERN gboolean dvb_scanner_check_for_lock (DVBScanner* self);
static gboolean _dvb_scanner_check_for_lock_gsource_func (gpointer self);
VALA_EXTERN gboolean dvb_scanner_wait_for_tables (DVBScanner* self);
static gboolean _dvb_scanner_start_scan_gsource_func (gpointer self);
VALA_EXTERN void dvb_scanner_set_uint_property (GstElement* src,
                                    GstStructure* params,
                                    const gchar* key);
VALA_EXTERN void dvb_scanner_on_dvb_frontend_stats_structure (DVBScanner* self,
                                                  GstStructure* structure);
static gboolean _dvb_scanner_wait_for_tables_gsource_func (gpointer self);
VALA_EXTERN void dvb_scanner_on_dvb_read_failure_structure (DVBScanner* self);
VALA_EXTERN void dvb_scanner_on_pat_structure (DVBScanner* self,
                                   GstMpegtsSection* section);
static GstMpegtsPatProgram* _vala_GstMpegtsPatProgram_copy (GstMpegtsPatProgram* self);
static void _vala_GstMpegtsPatProgram_free (GstMpegtsPatProgram* self);
VALA_EXTERN void dvb_scanner_on_sdt_structure (DVBScanner* self,
                                   GstMpegtsSection* section);
static GstMpegtsSDTService* _vala_GstMpegtsSDTService_copy (GstMpegtsSDTService* self);
static void _vala_GstMpegtsSDTService_free (GstMpegtsSDTService* self);
VALA_EXTERN gboolean dvb_channel_list_contains (DVBChannelList* self,
                                    guint sid);
static void dvb_scanner_add_new_channel (DVBScanner* self,
                                  guint sid);
VALA_EXTERN void dvb_channel_set_Scrambled (DVBChannel* self,
                                gboolean value);
VALA_EXTERN void dvb_channel_set_TransportStreamId (DVBChannel* self,
                                        guint value);
static GstMpegtsDescriptor* _vala_GstMpegtsDescriptor_copy (GstMpegtsDescriptor* self);
static void _vala_GstMpegtsDescriptor_free (GstMpegtsDescriptor* self);
VALA_EXTERN void dvb_channel_set_Name (DVBChannel* self,
                           const gchar* value);
VALA_EXTERN void dvb_channel_set_Network (DVBChannel* self,
                              const gchar* value);
VALA_EXTERN void dvb_channel_set_ServiceType (DVBChannel* self,
                                  GstMpegtsDVBServiceType value);
VALA_EXTERN const gchar* dvb_channel_get_Name (DVBChannel* self);
VALA_EXTERN gboolean dvb_channel_get_Scrambled (DVBChannel* self);
VALA_EXTERN void dvb_scanner_on_nit_structure (DVBScanner* self,
                                   GstMpegtsSection* section);
static GstMpegtsNITStream* _vala_GstMpegtsNITStream_copy (GstMpegtsNITStream* self);
static void _vala_GstMpegtsNITStream_free (GstMpegtsNITStream* self);
VALA_EXTERN DVBDvbTParameter* dvb_dvb_tparameter_new_with_parameter (guint frequency,
                                                         guint bandwidth,
                                                         GstMpegtsTerrestrialGuardInterval interval,
                                                         GstMpegtsTerrestrialTransmissionMode transmission,
                                                         GstMpegtsTerrestrialHierarchy hierarchy,
                                                         GstMpegtsModulationType constellation,
                                                         GstMpegtsDVBCodeRate code_rate_lp,
                                                         GstMpegtsDVBCodeRate code_rate_hp);
VALA_EXTERN DVBDvbTParameter* dvb_dvb_tparameter_construct_with_parameter (GType object_type,
                                                               guint frequency,
                                                               guint bandwidth,
                                                               GstMpegtsTerrestrialGuardInterval interval,
                                                               GstMpegtsTerrestrialTransmissionMode transmission,
                                                               GstMpegtsTerrestrialHierarchy hierarchy,
                                                               GstMpegtsModulationType constellation,
                                                               GstMpegtsDVBCodeRate code_rate_lp,
                                                               GstMpegtsDVBCodeRate code_rate_hp);
VALA_EXTERN DVBParameter* dvb_channel_get_Param (DVBChannel* self);
VALA_EXTERN void dvb_channel_set_Param (DVBChannel* self,
                            DVBParameter* value);
VALA_EXTERN DVBDvbCEuropeParameter* dvb_dvb_ceurope_parameter_new_with_parameter (guint frequency,
                                                                      guint symbol_rate,
                                                                      GstMpegtsModulationType modulation,
                                                                      GstMpegtsDVBCodeRate inner_fec);
VALA_EXTERN DVBDvbCEuropeParameter* dvb_dvb_ceurope_parameter_construct_with_parameter (GType object_type,
                                                                            guint frequency,
                                                                            guint symbol_rate,
                                                                            GstMpegtsModulationType modulation,
                                                                            GstMpegtsDVBCodeRate inner_fec);
VALA_EXTERN DVBDvbSParameter* dvb_dvb_sparameter_new_with_parameter (guint frequency,
                                                         guint symbol_rate,
                                                         gfloat position,
                                                         GstMpegtsSatellitePolarizationType polarization,
                                                         GstMpegtsDVBCodeRate inner_fec);
VALA_EXTERN DVBDvbSParameter* dvb_dvb_sparameter_construct_with_parameter (GType object_type,
                                                               guint frequency,
                                                               guint symbol_rate,
                                                               gfloat position,
                                                               GstMpegtsSatellitePolarizationType polarization,
                                                               GstMpegtsDVBCodeRate inner_fec);
VALA_EXTERN void dvb_scanner_on_pmt_structure (DVBScanner* self,
                                   GstMpegtsSection* section);
static GstMpegtsPMTStream* _vala_GstMpegtsPMTStream_copy (GstMpegtsPMTStream* self);
static void _vala_GstMpegtsPMTStream_free (GstMpegtsPMTStream* self);
VALA_EXTERN void dvb_channel_set_VideoPID (DVBChannel* self,
                               guint value);
VALA_EXTERN GeeList* dvb_channel_get_AudioPIDs (DVBChannel* self);
static void _vala_GstMpegtsSection_free (GstMpegtsSection* self);
VALA_EXTERN gboolean dvb_channel_is_valid (DVBChannel* self);
VALA_EXTERN gboolean dvb_channel_is_radio (DVBChannel* self);
VALA_EXTERN const gchar* dvb_channel_get_Network (DVBChannel* self);
VALA_EXTERN gchar* dvb_channel_to_string (DVBChannel* self);
VALA_EXTERN DVBChannel* dvb_channel_new_without_schedule (void);
VALA_EXTERN DVBChannel* dvb_channel_construct_without_schedule (GType object_type);
VALA_EXTERN void dvb_channel_set_Sid (DVBChannel* self,
                          guint value);
VALA_EXTERN void dvb_channel_list_add (DVBChannelList* self,
                           DVBChannel* channel);
static void dvb_scanner_set_Device (DVBScanner* self,
                             DVBDevice* value);
VALA_EXTERN DVBChannelList* dvb_scanner_get_Channels (DVBScanner* self);
static void dvb_scanner_set_Type (DVBScanner* self,
                           DVBAdapterType value);
static GObject * dvb_scanner_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN void dvb_id_bus_scanner_Run (DVBIDBusScanner* self,
                             GError** error);
VALA_EXTERN void dvb_id_bus_scanner_Destroy (DVBIDBusScanner* self,
                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_AddScanningData (DVBIDBusScanner* self,
                                             GHashTable* data,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                    const gchar* path,
                                                    GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_WriteChannelsToFile (DVBIDBusScanner* self,
                                                 guint* channel_sids,
                                                 gint channel_sids_length1,
                                                 const gchar* path,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                     const gchar* path,
                                                     GError** error);
static void dvb_scanner_finalize (GObject * obj);
static GType dvb_scanner_get_type_once (void);
static void _vala_dvb_scanner_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_dvb_scanner_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dvb_scanner_get_instance_private (DVBScanner* self)
{
	return G_STRUCT_MEMBER_P (self, DVBScanner_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_queue_free__g_object_unref0_ (GQueue* self)
{
	g_queue_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

DVBScanner*
dvb_scanner_construct (GType object_type,
                       DVBDevice* device,
                       DVBAdapterType type)
{
	DVBScanner * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	self = (DVBScanner*) g_object_new (object_type, "Device", device, "Type", type, NULL);
	return self;
}

DVBScanner*
dvb_scanner_new (DVBDevice* device,
                 DVBAdapterType type)
{
	return dvb_scanner_construct (DVB_TYPE_SCANNER, device, type);
}

/**
         * Start the scanner
         */
static gpointer
_dvb_scanner_worker_gthread_func (gpointer self)
{
	gpointer result;
	result = dvb_scanner_worker ((DVBScanner*) self);
	g_object_unref (self);
	return result;
}

static gboolean
_dvb_scanner_bus_watch_func_gst_bus_func (GstBus* bus,
                                          GstMessage* message,
                                          gpointer self)
{
	gboolean result;
	result = dvb_scanner_bus_watch_func ((DVBScanner*) self, bus, message);
	return result;
}

static void
dvb_scanner_real_Run (DVBIDBusScanner* base,
                      GError** error)
{
	DVBScanner * self;
	GMainContext* _tmp0_;
	GMainLoop* _tmp1_;
	DVBChannelList* _tmp8_;
	GstBus* bus = NULL;
	GstElement* _tmp24_;
	GstBus* _tmp25_;
	GstBus* _tmp26_;
	GMainContext* _tmp27_;
	GstElement* _tmp28_;
	GError* _inner_error0_ = NULL;
	self = (DVBScanner*) base;
	if (self->priv->running) {
		return;
	}
	self->priv->running = TRUE;
	_tmp0_ = self->priv->context;
	_tmp1_ = g_main_loop_new (_tmp0_, FALSE);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp1_;
	{
		GThread* _tmp2_ = NULL;
		GThread* _tmp3_;
		GThread* _tmp4_;
		_tmp3_ = g_thread_try_new ("Scanner-Worker-Thread", _dvb_scanner_worker_gthread_func, g_object_ref (self), &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_thread_unref0 (self->priv->worker_thread);
		self->priv->worker_thread = _tmp4_;
		_g_thread_unref0 (_tmp2_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = dvb_scanner_log;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		dvb_logging_logger_error (_tmp5_, "Scanner.vala:116: Could not create thread: %s", _tmp7_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp8_ = dvb_channel_list_new (NULL);
	_g_object_unref0 (self->channels);
	self->channels = _tmp8_;
	{
		GstElement* _tmp9_ = NULL;
		DVBDevice* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		DVBDevice* _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GstElement* _tmp18_;
		GstElement* _tmp19_;
		GstElement* _tmp20_;
		_tmp10_ = self->priv->_Device;
		_tmp11_ = dvb_device_get_Adapter (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = self->priv->_Device;
		_tmp14_ = dvb_device_get_Frontend (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strdup_printf (DVB_SCANNER_PIPELINE_TEMPLATE, _tmp12_, _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = gst_parse_launch_full (_tmp17_, NULL, GST_PARSE_FLAG_NONE, &_inner_error0_);
		_tmp19_ = _tmp18_;
		_g_free0 (_tmp17_);
		_tmp9_ = _tmp19_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp20_ = _tmp9_;
		_tmp9_ = NULL;
		if (_tmp20_ != NULL) {
			g_object_ref_sink (_tmp20_);
		}
		_g_object_unref0 (self->pipeline);
		self->pipeline = _tmp20_;
		_g_object_unref0 (_tmp9_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp21_ = dvb_scanner_log;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		dvb_logging_logger_error (_tmp21_, "Scanner.vala:127: Could not create pipeline: %s", _tmp23_);
		_g_error_free0 (e);
		return;
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp24_ = self->pipeline;
	_tmp25_ = gst_element_get_bus (_tmp24_);
	bus = _tmp25_;
	_tmp26_ = bus;
	_tmp27_ = self->priv->context;
	self->priv->bus_watch_id = gst_bus_add_watch_context (_tmp26_, _dvb_scanner_bus_watch_func_gst_bus_func, self, _tmp27_);
	_tmp28_ = self->pipeline;
	gst_element_set_state (_tmp28_, GST_STATE_READY);
	dvb_scanner_queue_start_scan (self);
	_g_object_unref0 (bus);
}

/**
         * Abort scanning and cleanup
         */
static void
dvb_scanner_real_Destroy (DVBIDBusScanner* base,
                          GError** error)
{
	DVBScanner * self;
	self = (DVBScanner*) base;
	dvb_scanner_do_destroy (self);
}

void
dvb_scanner_do_destroy (DVBScanner* self)
{
	DVBChannelList* _tmp0_;
	GMainLoop* _tmp1_;
	g_return_if_fail (self != NULL);
	dvb_scanner_destroy_start_scan_source (self);
	dvb_scanner_remove_check_for_lock_timeout (self);
	dvb_scanner_remove_wait_for_tables_timeout (self);
	dvb_scanner_clear_and_reset_all (self);
	_tmp0_ = self->channels;
	dvb_channel_list_clear (_tmp0_);
	_g_object_unref0 (self->channels);
	self->channels = NULL;
	_tmp1_ = self->priv->loop;
	if (_tmp1_ != NULL) {
		GMainLoop* _tmp2_;
		GThread* _tmp3_;
		_tmp2_ = self->priv->loop;
		g_main_loop_quit (_tmp2_);
		_g_main_loop_unref0 (self->priv->loop);
		self->priv->loop = NULL;
		_tmp3_ = self->priv->worker_thread;
		self->priv->worker_thread = NULL;
		g_thread_join (_tmp3_);
		_g_thread_unref0 (self->priv->worker_thread);
		self->priv->worker_thread = NULL;
	}
	g_signal_emit (self, dvb_scanner_signals[DVB_SCANNER_DESTROYED_SIGNAL], 0);
}

/**
         * @data: all scanning parameter
         *
         * in progress
         */
static gboolean
dvb_scanner_real_AddScanningData (DVBIDBusScanner* base,
                                  GHashTable* data,
                                  GError** error)
{
	DVBScanner * self;
	GVariant* _var = NULL;
	gconstpointer _tmp0_;
	GVariant* _tmp1_;
	gboolean result;
	self = (DVBScanner*) base;
	g_return_val_if_fail (data != NULL, FALSE);
	_tmp0_ = g_hash_table_lookup (data, "delsys");
	_var = (GVariant*) _tmp0_;
	_tmp1_ = _var;
	if (_tmp1_ != NULL) {
		GVariant* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GQuark _tmp6_ = 0U;
		static GQuark _tmp5_label0 = 0;
		static GQuark _tmp5_label1 = 0;
		static GQuark _tmp5_label2 = 0;
		_tmp2_ = _var;
		_tmp3_ = g_variant_get_string (_tmp2_, NULL);
		_tmp4_ = _tmp3_;
		_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
		if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("DVBT")))) {
			switch (0) {
				default:
				{
					DVBDvbTParameter* param = NULL;
					DVBDvbTParameter* _tmp7_;
					DVBDvbTParameter* _tmp8_;
					_tmp7_ = dvb_dvb_tparameter_new ();
					param = _tmp7_;
					_tmp8_ = param;
					if (dvb_parameter_add_scanning_data ((DVBParameter*) _tmp8_, data)) {
						DVBDvbTParameter* _tmp9_;
						_tmp9_ = param;
						dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp9_);
						result = TRUE;
						_g_object_unref0 (param);
						return result;
					}
					_g_object_unref0 (param);
					break;
				}
			}
		} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("DVBC/ANNEX_A")))) {
			switch (0) {
				default:
				{
					DVBDvbCEuropeParameter* param = NULL;
					DVBDvbCEuropeParameter* _tmp10_;
					DVBDvbCEuropeParameter* _tmp11_;
					_tmp10_ = dvb_dvb_ceurope_parameter_new ();
					param = _tmp10_;
					_tmp11_ = param;
					if (dvb_parameter_add_scanning_data ((DVBParameter*) _tmp11_, data)) {
						DVBDvbCEuropeParameter* _tmp12_;
						_tmp12_ = param;
						dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp12_);
						result = TRUE;
						_g_object_unref0 (param);
						return result;
					}
					_g_object_unref0 (param);
					break;
				}
			}
		} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("DVBS")))) {
			switch (0) {
				default:
				{
					DVBDvbSParameter* param = NULL;
					DVBDvbSParameter* _tmp13_;
					DVBDvbSParameter* _tmp14_;
					_tmp13_ = dvb_dvb_sparameter_new ();
					param = _tmp13_;
					_tmp14_ = param;
					if (dvb_parameter_add_scanning_data ((DVBParameter*) _tmp14_, data)) {
						DVBDvbSParameter* _tmp15_;
						_tmp15_ = param;
						dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp15_);
						result = TRUE;
						_g_object_unref0 (param);
						return result;
					}
					_g_object_unref0 (param);
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

/**
         * @path: Location where the file will be stored
         *
         * Write all the channels stored in this.Channels to file
         */
static gboolean
dvb_scanner_real_WriteAllChannelsToFile (DVBIDBusScanner* base,
                                         const gchar* path,
                                         GError** error)
{
	DVBScanner * self;
	gboolean success = FALSE;
	DVBioChannelListWriter* writer = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DVBioChannelListWriter* _tmp2_;
	DVBioChannelListWriter* _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBScanner*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	success = TRUE;
	_tmp0_ = g_file_new_for_path (path);
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_io_channel_list_writer_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	writer = _tmp3_;
	{
		GeeIterator* _c_it = NULL;
		DVBChannelList* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp4_ = self->channels;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_c_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			DVBChannel* c = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			_tmp6_ = _c_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _c_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			c = (DVBChannel*) _tmp8_;
			{
				DVBioChannelListWriter* _tmp9_;
				DVBChannel* _tmp10_;
				_tmp9_ = writer;
				_tmp10_ = c;
				dvb_io_channel_list_writer_write (_tmp9_, _tmp10_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				DVBLoggingLogger* _tmp11_;
				GError* _tmp12_;
				const gchar* _tmp13_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp11_ = dvb_scanner_log;
				_tmp12_ = e;
				_tmp13_ = _tmp12_->message;
				dvb_logging_logger_error (_tmp11_, "Scanner.vala:213: Could not write to file: %s", _tmp13_);
				success = FALSE;
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_DBUS_ERROR) {
					gboolean _tmp14_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (c);
					_g_object_unref0 (_c_it);
					_g_object_unref0 (writer);
					return _tmp14_;
				} else {
					gboolean _tmp15_ = FALSE;
					_g_object_unref0 (c);
					_g_object_unref0 (_c_it);
					_g_object_unref0 (writer);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp15_;
				}
			}
			_g_object_unref0 (c);
		}
		_g_object_unref0 (_c_it);
	}
	{
		DVBioChannelListWriter* _tmp16_;
		_tmp16_ = writer;
		dvb_io_channel_list_writer_close (_tmp16_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = dvb_scanner_log;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		dvb_logging_logger_error (_tmp17_, "Scanner.vala:221: Could not close file handle: %s", _tmp19_);
		success = FALSE;
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp20_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (writer);
			return _tmp20_;
		} else {
			gboolean _tmp21_ = FALSE;
			_g_object_unref0 (writer);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp21_;
		}
	}
	result = success;
	_g_object_unref0 (writer);
	return result;
}

/**
         * @channel_sids: A list of channels' SIDs
         * @path: Location where the file will be stored
         *
         * Write the channels with the given SIDs to file @path
         */
static gboolean
dvb_scanner_real_WriteChannelsToFile (DVBIDBusScanner* base,
                                      guint* channel_sids,
                                      gint channel_sids_length1,
                                      const gchar* path,
                                      GError** error)
{
	DVBScanner * self;
	gboolean success = FALSE;
	DVBioChannelListWriter* writer = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DVBioChannelListWriter* _tmp2_;
	DVBioChannelListWriter* _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBScanner*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	success = TRUE;
	_tmp0_ = g_file_new_for_path (path);
	_tmp1_ = _tmp0_;
	_tmp2_ = dvb_io_channel_list_writer_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	writer = _tmp3_;
	{
		guint* sid_collection = NULL;
		gint sid_collection_length1 = 0;
		gint _sid_collection_size_ = 0;
		gint sid_it = 0;
		sid_collection = channel_sids;
		sid_collection_length1 = channel_sids_length1;
		for (sid_it = 0; sid_it < sid_collection_length1; sid_it = sid_it + 1) {
			guint sid = 0U;
			sid = sid_collection[sid_it];
			{
				DVBChannel* c = NULL;
				DVBChannelList* _tmp4_;
				DVBChannel* _tmp5_;
				DVBChannel* _tmp6_;
				_tmp4_ = self->channels;
				_tmp5_ = dvb_channel_list_get_channel (_tmp4_, sid);
				c = _tmp5_;
				_tmp6_ = c;
				if (_tmp6_ == NULL) {
					DVBLoggingLogger* _tmp7_;
					_tmp7_ = dvb_scanner_log;
					dvb_logging_logger_warning (_tmp7_, "Scanner.vala:242: Channel with SID 0x%x does not exist", sid);
					_g_object_unref0 (c);
					continue;
				}
				{
					DVBioChannelListWriter* _tmp8_;
					DVBChannel* _tmp9_;
					_tmp8_ = writer;
					_tmp9_ = c;
					dvb_io_channel_list_writer_write (_tmp8_, _tmp9_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp10_;
					GError* _tmp11_;
					const gchar* _tmp12_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp10_ = dvb_scanner_log;
					_tmp11_ = e;
					_tmp12_ = _tmp11_->message;
					dvb_logging_logger_error (_tmp10_, "Scanner.vala:248: Could not write to file: %s", _tmp12_);
					success = FALSE;
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_DBUS_ERROR) {
						gboolean _tmp13_ = FALSE;
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (c);
						_g_object_unref0 (writer);
						return _tmp13_;
					} else {
						gboolean _tmp14_ = FALSE;
						_g_object_unref0 (c);
						_g_object_unref0 (writer);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return _tmp14_;
					}
				}
				_g_object_unref0 (c);
			}
		}
	}
	{
		DVBioChannelListWriter* _tmp15_;
		_tmp15_ = writer;
		dvb_io_channel_list_writer_close (_tmp15_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = dvb_scanner_log;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		dvb_logging_logger_error (_tmp16_, "Scanner.vala:256: Could not close file handle: %s", _tmp18_);
		success = FALSE;
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp19_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (writer);
			return _tmp19_;
		} else {
			gboolean _tmp20_ = FALSE;
			_g_object_unref0 (writer);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp20_;
		}
	}
	result = success;
	_g_object_unref0 (writer);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
dvb_scanner_real_AddScanningDataFromFile (DVBIDBusScanner* base,
                                          const gchar* path,
                                          GError** error)
{
	DVBScanner * self;
	GFile* datafile = NULL;
	GFile* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	GFile* _tmp2_;
	DVBioScanningListReader* reader = NULL;
	DVBioScanningListReader* _tmp3_;
	GList* scanning_params = NULL;
	DVBioScanningListReader* _tmp10_;
	GList* _tmp11_;
	GList* _tmp12_;
	DVBLoggingLogger* _tmp13_;
	GList* _tmp14_;
	GList* _tmp15_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBScanner*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = g_file_new_for_path (path);
	datafile = _tmp0_;
	_tmp1_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp1_, "Scanner.vala:266: Reading scanning data from %s", path);
	_tmp2_ = datafile;
	if (!dvb_utils_is_readable_file (_tmp2_)) {
		result = FALSE;
		_g_object_unref0 (datafile);
		return result;
	}
	_tmp3_ = dvb_io_scanning_list_reader_new (path);
	reader = _tmp3_;
	{
		DVBioScanningListReader* _tmp4_;
		_tmp4_ = reader;
		dvb_io_scanning_list_reader_read_data (_tmp4_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp5_ = FALSE;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			_g_object_unref0 (reader);
			_g_object_unref0 (datafile);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp5_;
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		DVBLoggingLogger* _tmp6_;
		g_clear_error (&_inner_error0_);
		_tmp6_ = dvb_scanner_log;
		dvb_logging_logger_error (_tmp6_, "Scanner.vala:275: could not read init file");
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		DVBLoggingLogger* _tmp7_;
		g_clear_error (&_inner_error0_);
		_tmp7_ = dvb_scanner_log;
		dvb_logging_logger_error (_tmp7_, "Scanner.vala:277: could not read init file");
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp8_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (reader);
			_g_object_unref0 (datafile);
			return _tmp8_;
		} else {
			gboolean _tmp9_ = FALSE;
			_g_object_unref0 (reader);
			_g_object_unref0 (datafile);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp9_;
		}
	}
	_tmp10_ = reader;
	_tmp11_ = dvb_io_scanning_list_reader_get_Parameters (_tmp10_);
	_tmp12_ = _tmp11_;
	scanning_params = _tmp12_;
	_tmp13_ = dvb_scanner_log;
	_tmp14_ = scanning_params;
	dvb_logging_logger_debug (_tmp13_, "Scanner.vala:281: read %u scanning parameter", g_list_length (_tmp14_));
	_tmp15_ = scanning_params;
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp15_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			DVBParameter* _tmp16_;
			DVBParameter* s = NULL;
			_tmp16_ = _g_object_ref0 ((DVBParameter*) s_it->data);
			s = _tmp16_;
			{
				DVBParameter* _tmp17_;
				_tmp17_ = s;
				dvb_scanner_add_to_queue (self, _tmp17_);
				_g_object_unref0 (s);
			}
		}
	}
	result = TRUE;
	_g_object_unref0 (reader);
	_g_object_unref0 (datafile);
	return result;
}

static void*
dvb_scanner_worker (DVBScanner* self)
{
	GMainLoop* _tmp0_;
	void* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->loop;
	g_main_loop_run (_tmp0_);
	result = NULL;
	return result;
}

static gpointer
_g_source_ref0 (gpointer self)
{
	return self ? g_source_ref (self) : NULL;
}

void
dvb_scanner_clear_and_reset_all (DVBScanner* self)
{
	GstElement* _tmp0_;
	GeeHashSet* _tmp8_;
	GeeArrayList* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->pipeline;
	if (_tmp0_ != NULL) {
		GSource* bus_watch_source = NULL;
		GMainContext* _tmp1_;
		GSource* _tmp2_;
		GSource* _tmp3_;
		GSource* _tmp4_;
		DVBLoggingLogger* _tmp6_;
		GstElement* _tmp7_;
		_tmp1_ = self->priv->context;
		_tmp2_ = g_main_context_find_source_by_id (_tmp1_, self->priv->bus_watch_id);
		_tmp3_ = _g_source_ref0 (_tmp2_);
		bus_watch_source = _tmp3_;
		_tmp4_ = bus_watch_source;
		if (_tmp4_ != NULL) {
			GSource* _tmp5_;
			_tmp5_ = bus_watch_source;
			g_source_destroy (_tmp5_);
			self->priv->bus_watch_id = (guint) 0;
		}
		_tmp6_ = dvb_scanner_log;
		dvb_logging_logger_debug (_tmp6_, "Scanner.vala:306: Disposing pipeline");
		_tmp7_ = self->pipeline;
		gst_element_set_state (_tmp7_, GST_STATE_NULL);
		_g_object_unref0 (self->pipeline);
		self->pipeline = NULL;
		_g_source_unref0 (bus_watch_source);
	}
	_tmp8_ = self->priv->scanned_scanning_params;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp8_);
	dvb_scanner_clear_queue (self);
	_g_object_unref0 (self->priv->current_scanning_param);
	self->priv->current_scanning_param = NULL;
	_tmp9_ = self->priv->new_channels;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp9_);
	self->priv->running = FALSE;
}

void
dvb_scanner_clear_queue (DVBScanner* self)
{
	GQueue* _tmp3_;
	g_return_if_fail (self != NULL);
	while (TRUE) {
		GQueue* _tmp0_;
		DVBParameter* s = NULL;
		GQueue* _tmp1_;
		gpointer _tmp2_;
		_tmp0_ = self->priv->queue_scanning_params;
		if (!(!g_queue_is_empty (_tmp0_))) {
			break;
		}
		_tmp1_ = self->priv->queue_scanning_params;
		_tmp2_ = g_queue_pop_head (_tmp1_);
		s = (DVBParameter*) _tmp2_;
		_g_object_unref0 (s);
		s = NULL;
		_g_object_unref0 (s);
	}
	_tmp3_ = self->priv->queue_scanning_params;
	g_queue_clear (_tmp3_);
}

void
dvb_scanner_add_to_queue (DVBScanner* self,
                          DVBParameter* param)
{
	DVBDvbSrcDelsys _tmp0_;
	DVBDvbSrcDelsys _tmp1_;
	DVBAdapterType _tmp2_;
	gboolean eq = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (param != NULL);
	if (param == NULL) {
		return;
	}
	_tmp0_ = dvb_parameter_get_Delsys (param);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_Type;
	if (!dvb_isSupported (_tmp1_, _tmp2_)) {
		return;
	}
	eq = FALSE;
	{
		GeeIterator* _s_it = NULL;
		GeeHashSet* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp3_ = self->priv->scanned_scanning_params;
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
		_s_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			DVBParameter* s = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DVBParameter* _tmp8_;
			_tmp5_ = _s_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _s_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			s = (DVBParameter*) _tmp7_;
			_tmp8_ = s;
			if (dvb_parameter_equal (_tmp8_, param)) {
				eq = TRUE;
				_g_object_unref0 (s);
				break;
			}
			_g_object_unref0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	if (!eq) {
		DVBLoggingLogger* _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		GQueue* _tmp12_;
		DVBParameter* _tmp13_;
		GeeHashSet* _tmp14_;
		_tmp9_ = dvb_scanner_log;
		_tmp10_ = dvb_parameter_get_Frequency (param);
		_tmp11_ = _tmp10_;
		dvb_logging_logger_debug (_tmp9_, "Scanner.vala:342: Queueing new frequency %u", _tmp11_);
		_tmp12_ = self->priv->queue_scanning_params;
		_tmp13_ = _g_object_ref0 (param);
		g_queue_push_tail (_tmp12_, _tmp13_);
		_tmp14_ = self->priv->scanned_scanning_params;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, param);
	}
}

/**
         * Pick up the next tuning paramters from the queue
         * and start scanning with them
         */
static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static gboolean
_dvb_scanner_check_for_lock_gsource_func (gpointer self)
{
	gboolean result;
	result = dvb_scanner_check_for_lock ((DVBScanner*) self);
	return result;
}

gboolean
dvb_scanner_start_scan (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean all_tables = FALSE;
	DVBLoggingLogger* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	DVBParameter* _tmp14_;
	GQueue* _tmp19_;
	GQueue* _tmp36_;
	gpointer _tmp37_;
	guint freq = 0U;
	DVBParameter* _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	DVBLoggingLogger* _tmp41_;
	GQueue* _tmp42_;
	GstElement* _tmp43_;
	GstElement* dvbsrc = NULL;
	GstElement* _tmp44_;
	GstElement* _tmp45_;
	DVBParameter* _tmp46_;
	GstElement* _tmp47_;
	GSource* _tmp48_;
	GSource* _tmp49_;
	GSource* _tmp50_;
	GMainContext* _tmp51_;
	GstElement* _tmp52_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->sdt_arrived) {
		_tmp2_ = self->priv->nit_arrived;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = self->priv->pat_arrived;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = self->priv->pmt_arrived;
	} else {
		_tmp0_ = FALSE;
	}
	all_tables = _tmp0_;
	_tmp3_ = dvb_scanner_log;
	_tmp4_ = bool_to_string (all_tables);
	_tmp5_ = _tmp4_;
	_tmp6_ = bool_to_string (self->priv->pat_arrived);
	_tmp7_ = _tmp6_;
	_tmp8_ = bool_to_string (self->priv->sdt_arrived);
	_tmp9_ = _tmp8_;
	_tmp10_ = bool_to_string (self->priv->nit_arrived);
	_tmp11_ = _tmp10_;
	_tmp12_ = bool_to_string (self->priv->pmt_arrived);
	_tmp13_ = _tmp12_;
	dvb_logging_logger_debug (_tmp3_, "Scanner.vala:355: Received all tables: %s (pat: %s, sdt: %s, nit: %s, " \
"pmt: %s)", _tmp5_, _tmp7_, _tmp9_, _tmp11_, _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	self->priv->nit_arrived = FALSE;
	self->priv->sdt_arrived = FALSE;
	self->priv->pat_arrived = FALSE;
	self->priv->pmt_arrived = FALSE;
	self->priv->locked = FALSE;
	_tmp14_ = self->priv->current_scanning_param;
	if (_tmp14_ != NULL) {
		DVBParameter* _tmp15_;
		guint _tmp16_;
		guint _tmp17_;
		GQueue* _tmp18_;
		_tmp15_ = self->priv->current_scanning_param;
		_tmp16_ = dvb_parameter_get_Frequency (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = self->priv->queue_scanning_params;
		g_signal_emit_by_name ((DVBIDBusScanner*) self, "frequency-scanned", _tmp17_, _tmp18_->length);
	}
	_tmp19_ = self->priv->queue_scanning_params;
	if (g_queue_is_empty (_tmp19_)) {
		g_message ("Scanner.vala:371: Finished scanning");
		{
			GeeArrayList* _tmp20_;
			_tmp20_ = self->priv->new_channels;
			g_rec_mutex_lock (&self->priv->__lock_new_channels);
			{
				DVBLoggingLogger* _tmp21_;
				GeeArrayList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				_tmp21_ = dvb_scanner_log;
				_tmp22_ = self->priv->new_channels;
				_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
				_tmp24_ = _tmp23_;
				dvb_logging_logger_debug (_tmp21_, "Scanner.vala:375: %u channels still have missing or invalid informatio" \
"n", (guint) _tmp24_);
				{
					GeeArrayList* _sid_list = NULL;
					GeeArrayList* _tmp25_;
					gint _sid_size = 0;
					GeeArrayList* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					gint _sid_index = 0;
					_tmp25_ = self->priv->new_channels;
					_sid_list = _tmp25_;
					_tmp26_ = _sid_list;
					_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
					_tmp28_ = _tmp27_;
					_sid_size = _tmp28_;
					_sid_index = -1;
					while (TRUE) {
						gint _tmp29_;
						gint _tmp30_;
						guint sid = 0U;
						GeeArrayList* _tmp31_;
						gpointer _tmp32_;
						DVBChannelList* _tmp33_;
						_sid_index = _sid_index + 1;
						_tmp29_ = _sid_index;
						_tmp30_ = _sid_size;
						if (!(_tmp29_ < _tmp30_)) {
							break;
						}
						_tmp31_ = _sid_list;
						_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _sid_index);
						sid = (guint) ((guintptr) _tmp32_);
						_tmp33_ = self->channels;
						dvb_channel_list_remove (_tmp33_, sid);
					}
				}
			}
			__finally0:
			{
				GeeArrayList* _tmp34_;
				_tmp34_ = self->priv->new_channels;
				g_rec_mutex_unlock (&self->priv->__lock_new_channels);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp35_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp35_;
			}
		}
		dvb_scanner_clear_and_reset_all (self);
		g_signal_emit_by_name ((DVBIDBusScanner*) self, "finished");
		result = FALSE;
		return result;
	}
	_tmp36_ = self->priv->queue_scanning_params;
	_tmp37_ = g_queue_pop_head (_tmp36_);
	_g_object_unref0 (self->priv->current_scanning_param);
	self->priv->current_scanning_param = (DVBParameter*) _tmp37_;
	_tmp38_ = self->priv->current_scanning_param;
	_tmp39_ = dvb_parameter_get_Frequency (_tmp38_);
	_tmp40_ = _tmp39_;
	freq = _tmp40_;
	_tmp41_ = dvb_scanner_log;
	_tmp42_ = self->priv->queue_scanning_params;
	dvb_logging_logger_debug (_tmp41_, "Scanner.vala:391: Starting scanning frequency %u (%u left)", freq, g_queue_get_length (_tmp42_));
	_tmp43_ = self->pipeline;
	gst_element_set_state (_tmp43_, GST_STATE_READY);
	_tmp44_ = self->pipeline;
	_tmp45_ = gst_bin_get_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gst_bin_get_type (), GstBin), "dvbsrc");
	dvbsrc = _tmp45_;
	_tmp46_ = self->priv->current_scanning_param;
	_tmp47_ = dvbsrc;
	dvb_parameter_prepare (_tmp46_, _tmp47_);
	_tmp48_ = g_timeout_source_new_seconds ((guint) 20);
	_g_source_unref0 (self->priv->check_for_lock_source);
	self->priv->check_for_lock_source = _tmp48_;
	_tmp49_ = self->priv->check_for_lock_source;
	g_source_set_callback (_tmp49_, _dvb_scanner_check_for_lock_gsource_func, g_object_ref (self), g_object_unref);
	_tmp50_ = self->priv->check_for_lock_source;
	_tmp51_ = self->priv->context;
	g_source_attach (_tmp50_, _tmp51_);
	_tmp52_ = self->pipeline;
	gst_element_set_state (_tmp52_, GST_STATE_PLAYING);
	result = FALSE;
	_g_object_unref0 (dvbsrc);
	return result;
}

/**
         * Check if we received a lock with the currently
         * used tuning parameters
         */
gboolean
dvb_scanner_check_for_lock (DVBScanner* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!self->priv->locked) {
		GstElement* _tmp0_;
		_tmp0_ = self->pipeline;
		gst_element_set_state (_tmp0_, GST_STATE_READY);
		dvb_scanner_queue_start_scan (self);
	}
	result = FALSE;
	return result;
}

gboolean
dvb_scanner_wait_for_tables (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->sdt_arrived) {
		_tmp2_ = self->priv->nit_arrived;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = self->priv->pat_arrived;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = self->priv->pmt_arrived;
	} else {
		_tmp0_ = FALSE;
	}
	if (!_tmp0_) {
		GstElement* _tmp3_;
		_tmp3_ = self->pipeline;
		gst_element_set_state (_tmp3_, GST_STATE_READY);
		dvb_scanner_queue_start_scan (self);
	}
	result = FALSE;
	return result;
}

void
dvb_scanner_destroy_start_scan_source (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	GSource* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->start_scan_source;
	if (_tmp1_ != NULL) {
		GSource* _tmp2_;
		_tmp2_ = self->priv->start_scan_source;
		_tmp0_ = !g_source_is_destroyed (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GSource* _tmp3_;
		_tmp3_ = self->priv->start_scan_source;
		g_source_destroy (_tmp3_);
		_g_source_unref0 (self->priv->start_scan_source);
		self->priv->start_scan_source = NULL;
	}
}

void
dvb_scanner_remove_check_for_lock_timeout (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	GSource* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->check_for_lock_source;
	if (_tmp1_ != NULL) {
		GSource* _tmp2_;
		_tmp2_ = self->priv->check_for_lock_source;
		_tmp0_ = !g_source_is_destroyed (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GSource* _tmp3_;
		_tmp3_ = self->priv->check_for_lock_source;
		g_source_destroy (_tmp3_);
		_g_source_unref0 (self->priv->check_for_lock_source);
		self->priv->check_for_lock_source = NULL;
	}
}

void
dvb_scanner_remove_wait_for_tables_timeout (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	GSource* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->wait_for_tables_source;
	if (_tmp1_ != NULL) {
		GSource* _tmp2_;
		_tmp2_ = self->priv->wait_for_tables_source;
		_tmp0_ = !g_source_is_destroyed (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GSource* _tmp3_;
		_tmp3_ = self->priv->wait_for_tables_source;
		g_source_destroy (_tmp3_);
		_g_source_unref0 (self->priv->wait_for_tables_source);
		self->priv->wait_for_tables_source = NULL;
	}
}

static gboolean
_dvb_scanner_start_scan_gsource_func (gpointer self)
{
	gboolean result;
	result = dvb_scanner_start_scan ((DVBScanner*) self);
	return result;
}

void
dvb_scanner_queue_start_scan (DVBScanner* self)
{
	gboolean _tmp0_ = FALSE;
	GSource* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->start_scan_source;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GSource* _tmp2_;
		_tmp2_ = self->priv->start_scan_source;
		_tmp0_ = g_source_is_destroyed (_tmp2_);
	}
	if (_tmp0_) {
		DVBLoggingLogger* _tmp3_;
		GSource* _tmp4_;
		GSource* _tmp5_;
		GSource* _tmp6_;
		GMainContext* _tmp7_;
		_tmp3_ = dvb_scanner_log;
		dvb_logging_logger_debug (_tmp3_, "Scanner.vala:462: Queueing start_scan");
		_tmp4_ = g_idle_source_new ();
		_g_source_unref0 (self->priv->start_scan_source);
		self->priv->start_scan_source = _tmp4_;
		_tmp5_ = self->priv->start_scan_source;
		g_source_set_callback (_tmp5_, _dvb_scanner_start_scan_gsource_func, g_object_ref (self), g_object_unref);
		_tmp6_ = self->priv->start_scan_source;
		_tmp7_ = self->priv->context;
		g_source_attach (_tmp6_, _tmp7_);
	}
}

void
dvb_scanner_set_uint_property (GstElement* src,
                               GstStructure* params,
                               const gchar* key)
{
	guint val = 0U;
	guint _tmp0_ = 0U;
	g_return_if_fail (src != NULL);
	g_return_if_fail (params != NULL);
	g_return_if_fail (key != NULL);
	gst_structure_get_uint (params, key, &_tmp0_);
	val = _tmp0_;
	g_object_set ((GObject*) src, key, val, NULL);
}

static gboolean
_dvb_scanner_wait_for_tables_gsource_func (gpointer self)
{
	gboolean result;
	result = dvb_scanner_wait_for_tables ((DVBScanner*) self);
	return result;
}

void
dvb_scanner_on_dvb_frontend_stats_structure (DVBScanner* self,
                                             GstStructure* structure)
{
	gboolean has_lock = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _signal = 0;
	gint _tmp7_ = 0;
	gint _snr = 0;
	gint _tmp8_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (structure != NULL);
	gst_structure_get_boolean (structure, "lock", &_tmp0_);
	has_lock = _tmp0_;
	if (has_lock) {
		_tmp1_ = !self->priv->locked;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		DVBLoggingLogger* _tmp2_;
		GSource* _tmp3_;
		GSource* _tmp4_;
		GSource* _tmp5_;
		GMainContext* _tmp6_;
		_tmp2_ = dvb_scanner_log;
		dvb_logging_logger_debug (_tmp2_, "Scanner.vala:480: Got lock");
		dvb_scanner_remove_check_for_lock_timeout (self);
		_tmp3_ = g_timeout_source_new_seconds ((guint) 10);
		_g_source_unref0 (self->priv->wait_for_tables_source);
		self->priv->wait_for_tables_source = _tmp3_;
		_tmp4_ = self->priv->wait_for_tables_source;
		g_source_set_callback (_tmp4_, _dvb_scanner_wait_for_tables_gsource_func, g_object_ref (self), g_object_unref);
		_tmp5_ = self->priv->wait_for_tables_source;
		_tmp6_ = self->priv->context;
		g_source_attach (_tmp5_, _tmp6_);
		self->priv->locked = TRUE;
	}
	gst_structure_get_int (structure, "signal", &_tmp7_);
	_signal = _tmp7_;
	gst_structure_get_int (structure, "snr", &_tmp8_);
	_snr = _tmp8_;
	g_signal_emit_by_name ((DVBIDBusScanner*) self, "frontend-stats", _signal / ((gdouble) 0xffff), _snr / ((gdouble) 0xffff));
}

void
dvb_scanner_on_dvb_read_failure_structure (DVBScanner* self)
{
	DVBLoggingLogger* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = dvb_scanner_log;
	dvb_logging_logger_warning (_tmp0_, "Scanner.vala:498: Read failure");
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static GstMpegtsPatProgram*
_vala_GstMpegtsPatProgram_copy (GstMpegtsPatProgram* self)
{
	return g_boxed_copy (gst_mpegts_pat_program_get_type (), self);
}

static gpointer
__vala_GstMpegtsPatProgram_copy0 (gpointer self)
{
	return self ? _vala_GstMpegtsPatProgram_copy (self) : NULL;
}

static void
_vala_GstMpegtsPatProgram_free (GstMpegtsPatProgram* self)
{
	g_boxed_free (gst_mpegts_pat_program_get_type (), self);
}

void
dvb_scanner_on_pat_structure (DVBScanner* self,
                              GstMpegtsSection* section)
{
	DVBLoggingLogger* _tmp0_;
	GPtrArray* pats = NULL;
	GPtrArray* _tmp1_;
	GeeSet* pid_set = NULL;
	GeeHashSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GstMpegtsPatProgram* pat = NULL;
	GString* new_pids = NULL;
	GString* _tmp15_;
	gint i = 0;
	DVBLoggingLogger* _tmp31_;
	GeeSet* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	GString* _tmp35_;
	const gchar* _tmp36_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp0_, "Scanner.vala:507: Received PAT, version %d, section number %d, last se" \
"ction number %d", (gint) section->version_number, (gint) section->section_number, (gint) section->last_section_number);
	_tmp1_ = gst_mpegts_section_get_pat (section);
	pats = _tmp1_;
	_tmp2_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	pid_set = (GeeSet*) _tmp2_;
	_tmp3_ = pid_set;
	gee_collection_add ((GeeCollection*) _tmp3_, (gpointer) ((guintptr) 16));
	_tmp4_ = pid_set;
	gee_collection_add ((GeeCollection*) _tmp4_, (gpointer) ((guintptr) 17));
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				GPtrArray* _tmp10_;
				gconstpointer _tmp11_;
				GstMpegtsPatProgram* _tmp12_;
				guint pmt = 0U;
				GstMpegtsPatProgram* _tmp13_;
				GeeSet* _tmp14_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = pats;
				_tmp8_ = vala_g_ptr_array_get_length (_tmp7_);
				_tmp9_ = _tmp8_;
				if (!(i < _tmp9_)) {
					break;
				}
				_tmp10_ = pats;
				_tmp11_ = g_ptr_array_index (_tmp10_, (guint) i);
				_tmp12_ = __vala_GstMpegtsPatProgram_copy0 ((GstMpegtsPatProgram*) _tmp11_);
				__vala_GstMpegtsPatProgram_free0 (pat);
				pat = _tmp12_;
				_tmp13_ = pat;
				pmt = (guint) _tmp13_->network_or_program_map_PID;
				_tmp14_ = pid_set;
				gee_collection_add ((GeeCollection*) _tmp14_, (gpointer) ((guintptr) pmt));
			}
		}
	}
	_tmp15_ = g_string_new ("");
	new_pids = _tmp15_;
	i = 0;
	{
		GeeIterator* _pid_it = NULL;
		GeeSet* _tmp16_;
		GeeIterator* _tmp17_;
		_tmp16_ = pid_set;
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
		_pid_it = _tmp17_;
		while (TRUE) {
			GeeIterator* _tmp18_;
			guint pid = 0U;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			GeeSet* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gint _tmp30_;
			_tmp18_ = _pid_it;
			if (!gee_iterator_next (_tmp18_)) {
				break;
			}
			_tmp19_ = _pid_it;
			_tmp20_ = gee_iterator_get (_tmp19_);
			pid = (guint) ((guintptr) _tmp20_);
			_tmp21_ = pid_set;
			_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
			_tmp23_ = _tmp22_;
			if ((i + 1) == _tmp23_) {
				GString* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				_tmp24_ = new_pids;
				_tmp25_ = g_strdup_printf ("%u", pid);
				_tmp26_ = _tmp25_;
				g_string_append (_tmp24_, _tmp26_);
				_g_free0 (_tmp26_);
			} else {
				GString* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				_tmp27_ = new_pids;
				_tmp28_ = g_strdup_printf ("%u:", pid);
				_tmp29_ = _tmp28_;
				g_string_append (_tmp27_, _tmp29_);
				_g_free0 (_tmp29_);
			}
			_tmp30_ = i;
			i = _tmp30_ + 1;
		}
		_g_object_unref0 (_pid_it);
	}
	_tmp31_ = dvb_scanner_log;
	_tmp32_ = pid_set;
	_tmp33_ = gee_collection_get_size ((GeeCollection*) _tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = new_pids;
	_tmp36_ = _tmp35_->str;
	dvb_logging_logger_debug (_tmp31_, "Scanner.vala:536: Setting %d pids: %s", _tmp34_, _tmp36_);
	self->priv->pat_arrived = TRUE;
	_g_string_free0 (new_pids);
	__vala_GstMpegtsPatProgram_free0 (pat);
	_g_object_unref0 (pid_set);
	_g_ptr_array_unref0 (pats);
}

static GstMpegtsSDTService*
_vala_GstMpegtsSDTService_copy (GstMpegtsSDTService* self)
{
	return g_boxed_copy (gst_mpegts_sdt_service_get_type (), self);
}

static gpointer
__vala_GstMpegtsSDTService_copy0 (gpointer self)
{
	return self ? _vala_GstMpegtsSDTService_copy (self) : NULL;
}

static void
_vala_GstMpegtsSDTService_free (GstMpegtsSDTService* self)
{
	g_boxed_free (gst_mpegts_sdt_service_get_type (), self);
}

static GstMpegtsDescriptor*
_vala_GstMpegtsDescriptor_copy (GstMpegtsDescriptor* self)
{
	return g_boxed_copy (gst_mpegts_descriptor_get_type (), self);
}

static gpointer
__vala_GstMpegtsDescriptor_copy0 (gpointer self)
{
	return self ? _vala_GstMpegtsDescriptor_copy (self) : NULL;
}

static void
_vala_GstMpegtsDescriptor_free (GstMpegtsDescriptor* self)
{
	g_boxed_free (gst_mpegts_descriptor_get_type (), self);
}

void
dvb_scanner_on_sdt_structure (DVBScanner* self,
                              GstMpegtsSection* section)
{
	GstMpegtsSDT* sdt = NULL;
	GstMpegtsSDT* _tmp0_;
	GstMpegtsSDT* _tmp1_;
	guint tsid = 0U;
	guint onid = 0U;
	GstMpegtsSDT* _tmp2_;
	DVBLoggingLogger* _tmp3_;
	GstMpegtsSDTService* service = NULL;
	GstMpegtsSDT* _tmp55_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = gst_mpegts_section_get_sdt (section);
	sdt = _tmp0_;
	_tmp1_ = sdt;
	if (!_tmp1_->actual_ts) {
		return;
	}
	tsid = (guint) section->subtable_extension;
	_tmp2_ = sdt;
	onid = (guint) _tmp2_->original_network_id;
	_tmp3_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp3_, "Scanner.vala:553: Received SDT (0x%04x.0x%04x) , version %d, section n" \
"umber %d, last section number %d", onid, tsid, (gint) section->version_number, (gint) section->section_number, (gint) section->last_section_number);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GstMpegtsSDT* _tmp6_;
				GPtrArray* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				GstMpegtsSDT* _tmp10_;
				GPtrArray* _tmp11_;
				gconstpointer _tmp12_;
				GstMpegtsSDTService* _tmp13_;
				guint sid = 0U;
				GstMpegtsSDTService* _tmp14_;
				DVBChannelList* _tmp15_;
				DVBChannel* channel = NULL;
				DVBChannelList* _tmp16_;
				DVBChannel* _tmp17_;
				DVBChannel* _tmp18_;
				GstMpegtsSDTService* _tmp19_;
				DVBChannel* _tmp20_;
				GstMpegtsDescriptor* desc = NULL;
				DVBLoggingLogger* _tmp46_;
				DVBChannel* _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				DVBChannel* _tmp50_;
				gboolean _tmp51_;
				gboolean _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = sdt;
				_tmp7_ = _tmp6_->services;
				_tmp8_ = vala_g_ptr_array_get_length (_tmp7_);
				_tmp9_ = _tmp8_;
				if (!(i < _tmp9_)) {
					break;
				}
				_tmp10_ = sdt;
				_tmp11_ = _tmp10_->services;
				_tmp12_ = g_ptr_array_index (_tmp11_, (guint) i);
				_tmp13_ = __vala_GstMpegtsSDTService_copy0 ((GstMpegtsSDTService*) _tmp12_);
				__vala_GstMpegtsSDTService_free0 (service);
				service = _tmp13_;
				_tmp14_ = service;
				sid = (guint) _tmp14_->service_id;
				_tmp15_ = self->channels;
				if (!dvb_channel_list_contains (_tmp15_, sid)) {
					dvb_scanner_add_new_channel (self, sid);
				}
				_tmp16_ = self->channels;
				_tmp17_ = dvb_channel_list_get_channel (_tmp16_, sid);
				channel = _tmp17_;
				_tmp18_ = channel;
				_tmp19_ = service;
				dvb_channel_set_Scrambled (_tmp18_, _tmp19_->free_CA_mode);
				_tmp20_ = channel;
				dvb_channel_set_TransportStreamId (_tmp20_, tsid);
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp21_ = FALSE;
						_tmp21_ = TRUE;
						while (TRUE) {
							GstMpegtsSDTService* _tmp23_;
							GPtrArray* _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
							GstMpegtsSDTService* _tmp27_;
							GPtrArray* _tmp28_;
							gconstpointer _tmp29_;
							GstMpegtsDescriptor* _tmp30_;
							GstMpegtsDescriptor* _tmp31_;
							GstMpegtsDescriptor* _tmp36_;
							if (!_tmp21_) {
								gint _tmp22_;
								_tmp22_ = j;
								j = _tmp22_ + 1;
							}
							_tmp21_ = FALSE;
							_tmp23_ = service;
							_tmp24_ = _tmp23_->descriptors;
							_tmp25_ = vala_g_ptr_array_get_length (_tmp24_);
							_tmp26_ = _tmp25_;
							if (!(j < _tmp26_)) {
								break;
							}
							_tmp27_ = service;
							_tmp28_ = _tmp27_->descriptors;
							_tmp29_ = g_ptr_array_index (_tmp28_, (guint) j);
							_tmp30_ = __vala_GstMpegtsDescriptor_copy0 ((GstMpegtsDescriptor*) _tmp29_);
							__vala_GstMpegtsDescriptor_free0 (desc);
							desc = _tmp30_;
							_tmp31_ = desc;
							if (_tmp31_->tag == GST_MTS_DESC_DVB_EXTENSION) {
								DVBLoggingLogger* _tmp32_;
								GstMpegtsDescriptor* _tmp33_;
								_tmp32_ = dvb_scanner_log;
								_tmp33_ = desc;
								dvb_logging_logger_debug (_tmp32_, "Scanner.vala:576: Extentend descriptor 0x%02x", (guint) _tmp33_->tag_extension);
							} else {
								DVBLoggingLogger* _tmp34_;
								GstMpegtsDescriptor* _tmp35_;
								_tmp34_ = dvb_scanner_log;
								_tmp35_ = desc;
								dvb_logging_logger_debug (_tmp34_, "Scanner.vala:578: Descriptor 0x%02x", (guint) _tmp35_->tag);
							}
							_tmp36_ = desc;
							switch (_tmp36_->tag) {
								case GST_MTS_DESC_DVB_SERVICE:
								{
									{
										GstMpegtsDVBServiceType type = 0;
										gchar* name = NULL;
										gchar* provider = NULL;
										GstMpegtsDescriptor* _tmp37_;
										GstMpegtsDVBServiceType _tmp38_ = 0;
										gchar* _tmp39_ = NULL;
										gchar* _tmp40_ = NULL;
										DVBChannel* _tmp41_;
										const gchar* _tmp42_;
										DVBChannel* _tmp43_;
										const gchar* _tmp44_;
										DVBChannel* _tmp45_;
										_tmp37_ = desc;
										gst_mpegts_descriptor_parse_dvb_service (_tmp37_, &_tmp38_, &_tmp39_, &_tmp40_);
										type = _tmp38_;
										_g_free0 (name);
										name = _tmp39_;
										_g_free0 (provider);
										provider = _tmp40_;
										_tmp41_ = channel;
										_tmp42_ = name;
										dvb_channel_set_Name (_tmp41_, _tmp42_);
										_tmp43_ = channel;
										_tmp44_ = provider;
										dvb_channel_set_Network (_tmp43_, _tmp44_);
										_tmp45_ = channel;
										dvb_channel_set_ServiceType (_tmp45_, type);
										_g_free0 (provider);
										_g_free0 (name);
										break;
									}
								}
								default:
								{
									break;
								}
							}
						}
					}
				}
				_tmp46_ = dvb_scanner_log;
				_tmp47_ = channel;
				_tmp48_ = dvb_channel_get_Name (_tmp47_);
				_tmp49_ = _tmp48_;
				_tmp50_ = channel;
				_tmp51_ = dvb_channel_get_Scrambled (_tmp50_);
				_tmp52_ = _tmp51_;
				_tmp53_ = bool_to_string (_tmp52_);
				_tmp54_ = _tmp53_;
				dvb_logging_logger_debug (_tmp46_, "Scanner.vala:600: Found service 0x%04x, %s, scrambled: %s", sid, _tmp49_, _tmp54_);
				_g_free0 (_tmp54_);
				__vala_GstMpegtsDescriptor_free0 (desc);
				_g_object_unref0 (channel);
			}
		}
	}
	_tmp55_ = sdt;
	if (_tmp55_->actual_ts) {
		self->priv->sdt_arrived = TRUE;
	}
	__vala_GstMpegtsSDTService_free0 (service);
}

static GstMpegtsNITStream*
_vala_GstMpegtsNITStream_copy (GstMpegtsNITStream* self)
{
	return g_boxed_copy (gst_mpegts_nit_stream_get_type (), self);
}

static gpointer
__vala_GstMpegtsNITStream_copy0 (gpointer self)
{
	return self ? _vala_GstMpegtsNITStream_copy (self) : NULL;
}

static void
_vala_GstMpegtsNITStream_free (GstMpegtsNITStream* self)
{
	g_boxed_free (gst_mpegts_nit_stream_get_type (), self);
}

void
dvb_scanner_on_nit_structure (DVBScanner* self,
                              GstMpegtsSection* section)
{
	GstMpegtsNIT* nit = NULL;
	GstMpegtsNIT* _tmp0_;
	GstMpegtsNIT* _tmp1_;
	DVBLoggingLogger* _tmp2_;
	GstMpegtsDescriptor* desc = NULL;
	gchar* name = NULL;
	guint nid = 0U;
	GstMpegtsNIT* _tmp16_;
	const gchar* _tmp17_;
	DVBLoggingLogger* _tmp19_;
	const gchar* _tmp20_;
	GstMpegtsNITStream* stream = NULL;
	GstMpegtsNIT* _tmp117_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = gst_mpegts_section_get_nit (section);
	nit = _tmp0_;
	_tmp1_ = nit;
	if (!_tmp1_->actual_network) {
		return;
	}
	_tmp2_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp2_, "Scanner.vala:615: Received NIT, version %d, section number %d, last se" \
"ction number %d", (gint) section->version_number, (gint) section->section_number, (gint) section->last_section_number);
	name = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GstMpegtsNIT* _tmp5_;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				GstMpegtsNIT* _tmp9_;
				GPtrArray* _tmp10_;
				gconstpointer _tmp11_;
				GstMpegtsDescriptor* _tmp12_;
				GstMpegtsDescriptor* _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = nit;
				_tmp6_ = _tmp5_->descriptors;
				_tmp7_ = vala_g_ptr_array_get_length (_tmp6_);
				_tmp8_ = _tmp7_;
				if (!(i < _tmp8_)) {
					break;
				}
				_tmp9_ = nit;
				_tmp10_ = _tmp9_->descriptors;
				_tmp11_ = g_ptr_array_index (_tmp10_, (guint) i);
				_tmp12_ = __vala_GstMpegtsDescriptor_copy0 ((GstMpegtsDescriptor*) _tmp11_);
				__vala_GstMpegtsDescriptor_free0 (desc);
				desc = _tmp12_;
				_tmp13_ = desc;
				if (_tmp13_->tag == GST_MTS_DESC_DVB_NETWORK_NAME) {
					GstMpegtsDescriptor* _tmp14_;
					gchar* _tmp15_ = NULL;
					_tmp14_ = desc;
					gst_mpegts_descriptor_parse_dvb_network_name (_tmp14_, &_tmp15_);
					_g_free0 (name);
					name = _tmp15_;
					break;
				}
			}
		}
	}
	_tmp16_ = nit;
	nid = (guint) _tmp16_->network_id;
	_tmp17_ = name;
	if (_tmp17_ == NULL) {
		gchar* _tmp18_;
		_tmp18_ = g_strdup_printf ("%u", nid);
		_g_free0 (name);
		name = _tmp18_;
	}
	_tmp19_ = dvb_scanner_log;
	_tmp20_ = name;
	dvb_logging_logger_debug (_tmp19_, "Scanner.vala:632: Network name '%s', id = 0x%04x", _tmp20_, nid);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp21_ = FALSE;
			_tmp21_ = TRUE;
			while (TRUE) {
				GstMpegtsNIT* _tmp23_;
				GPtrArray* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				GstMpegtsNIT* _tmp27_;
				GPtrArray* _tmp28_;
				gconstpointer _tmp29_;
				GstMpegtsNITStream* _tmp30_;
				guint tsid = 0U;
				GstMpegtsNITStream* _tmp31_;
				guint onid = 0U;
				GstMpegtsNITStream* _tmp32_;
				DVBLoggingLogger* _tmp33_;
				if (!_tmp21_) {
					gint _tmp22_;
					_tmp22_ = i;
					i = _tmp22_ + 1;
				}
				_tmp21_ = FALSE;
				_tmp23_ = nit;
				_tmp24_ = _tmp23_->streams;
				_tmp25_ = vala_g_ptr_array_get_length (_tmp24_);
				_tmp26_ = _tmp25_;
				if (!(i < _tmp26_)) {
					break;
				}
				_tmp27_ = nit;
				_tmp28_ = _tmp27_->streams;
				_tmp29_ = g_ptr_array_index (_tmp28_, (guint) i);
				_tmp30_ = __vala_GstMpegtsNITStream_copy0 ((GstMpegtsNITStream*) _tmp29_);
				__vala_GstMpegtsNITStream_free0 (stream);
				stream = _tmp30_;
				_tmp31_ = stream;
				tsid = (guint) _tmp31_->transport_stream_id;
				_tmp32_ = stream;
				onid = (guint) _tmp32_->original_network_id;
				_tmp33_ = dvb_scanner_log;
				dvb_logging_logger_debug (_tmp33_, "Scanner.vala:641: Received TS 0x%04x, on_id = 0x%04x", tsid, onid);
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp34_ = FALSE;
						_tmp34_ = TRUE;
						while (TRUE) {
							GstMpegtsNITStream* _tmp36_;
							GPtrArray* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							GstMpegtsNITStream* _tmp40_;
							GPtrArray* _tmp41_;
							gconstpointer _tmp42_;
							GstMpegtsDescriptor* _tmp43_;
							GstMpegtsDescriptor* _tmp44_;
							GstMpegtsDescriptor* _tmp49_;
							if (!_tmp34_) {
								gint _tmp35_;
								_tmp35_ = j;
								j = _tmp35_ + 1;
							}
							_tmp34_ = FALSE;
							_tmp36_ = stream;
							_tmp37_ = _tmp36_->descriptors;
							_tmp38_ = vala_g_ptr_array_get_length (_tmp37_);
							_tmp39_ = _tmp38_;
							if (!(j < _tmp39_)) {
								break;
							}
							_tmp40_ = stream;
							_tmp41_ = _tmp40_->descriptors;
							_tmp42_ = g_ptr_array_index (_tmp41_, (guint) j);
							_tmp43_ = __vala_GstMpegtsDescriptor_copy0 ((GstMpegtsDescriptor*) _tmp42_);
							__vala_GstMpegtsDescriptor_free0 (desc);
							desc = _tmp43_;
							_tmp44_ = desc;
							if (_tmp44_->tag == GST_MTS_DESC_DVB_EXTENSION) {
								DVBLoggingLogger* _tmp45_;
								GstMpegtsDescriptor* _tmp46_;
								_tmp45_ = dvb_scanner_log;
								_tmp46_ = desc;
								dvb_logging_logger_debug (_tmp45_, "Scanner.vala:648: Extentend desriptor 0x%02x", (guint) _tmp46_->tag_extension);
							} else {
								DVBLoggingLogger* _tmp47_;
								GstMpegtsDescriptor* _tmp48_;
								_tmp47_ = dvb_scanner_log;
								_tmp48_ = desc;
								dvb_logging_logger_debug (_tmp47_, "Scanner.vala:650: Desriptor 0x%02x", (guint) _tmp48_->tag);
							}
							_tmp49_ = desc;
							switch (_tmp49_->tag) {
								case GST_MTS_DESC_DVB_TERRESTRIAL_DELIVERY_SYSTEM:
								{
									GstMpegtsTerrestrialDeliverySystemDescriptor tdesc = {0};
									GstMpegtsDescriptor* _tmp50_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp51_ = {0};
									GstMpegtsDVBCodeRate ratehp = 0;
									GstMpegtsDVBCodeRate ratelp = 0;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp52_;
									DVBDvbTParameter* dvbtp = NULL;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp55_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp56_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp57_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp58_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp59_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp60_;
									DVBDvbTParameter* _tmp61_;
									DVBParameter* _tmp62_;
									guint _tmp63_;
									guint _tmp64_;
									GstMpegtsTerrestrialDeliverySystemDescriptor _tmp65_;
									_tmp50_ = desc;
									gst_mpegts_descriptor_parse_terrestrial_delivery_system (_tmp50_, &_tmp51_);
									tdesc = _tmp51_;
									_tmp52_ = tdesc;
									if (_tmp52_.priority) {
										GstMpegtsTerrestrialDeliverySystemDescriptor _tmp53_;
										_tmp53_ = tdesc;
										ratehp = _tmp53_.code_rate_hp;
										ratelp = GST_MPEGTS_FEC_NONE;
									} else {
										GstMpegtsTerrestrialDeliverySystemDescriptor _tmp54_;
										ratehp = GST_MPEGTS_FEC_NONE;
										_tmp54_ = tdesc;
										ratelp = _tmp54_.code_rate_lp;
									}
									_tmp55_ = tdesc;
									_tmp56_ = tdesc;
									_tmp57_ = tdesc;
									_tmp58_ = tdesc;
									_tmp59_ = tdesc;
									_tmp60_ = tdesc;
									_tmp61_ = dvb_dvb_tparameter_new_with_parameter ((guint) _tmp55_.frequency, (guint) _tmp56_.bandwidth, _tmp57_.guard_interval, _tmp58_.transmission_mode, _tmp59_.hierarchy, _tmp60_.constellation, ratelp, ratehp);
									dvbtp = _tmp61_;
									_tmp62_ = self->priv->current_scanning_param;
									_tmp63_ = dvb_parameter_get_Frequency (_tmp62_);
									_tmp64_ = _tmp63_;
									_tmp65_ = tdesc;
									if (_tmp64_ == ((guint) _tmp65_.frequency)) {
										DVBDvbTParameter* _tmp81_;
										DVBParameter* _tmp82_;
										{
											DVBChannelList* _tmp66_;
											_tmp66_ = self->channels;
											g_rec_mutex_lock (&self->priv->__lock_channels);
											{
												{
													GeeIterator* _channel_it = NULL;
													DVBChannelList* _tmp67_;
													GeeIterator* _tmp68_;
													_tmp67_ = self->channels;
													_tmp68_ = gee_iterable_iterator ((GeeIterable*) _tmp67_);
													_channel_it = _tmp68_;
													while (TRUE) {
														GeeIterator* _tmp69_;
														DVBChannel* channel = NULL;
														GeeIterator* _tmp70_;
														gpointer _tmp71_;
														DVBChannel* _tmp72_;
														DVBParameter* _tmp73_;
														DVBParameter* _tmp74_;
														guint _tmp75_;
														guint _tmp76_;
														GstMpegtsTerrestrialDeliverySystemDescriptor _tmp77_;
														_tmp69_ = _channel_it;
														if (!gee_iterator_next (_tmp69_)) {
															break;
														}
														_tmp70_ = _channel_it;
														_tmp71_ = gee_iterator_get (_tmp70_);
														channel = (DVBChannel*) _tmp71_;
														_tmp72_ = channel;
														_tmp73_ = dvb_channel_get_Param (_tmp72_);
														_tmp74_ = _tmp73_;
														_tmp75_ = dvb_parameter_get_Frequency (_tmp74_);
														_tmp76_ = _tmp75_;
														_tmp77_ = tdesc;
														if (_tmp76_ == ((guint) _tmp77_.frequency)) {
															DVBChannel* _tmp78_;
															DVBDvbTParameter* _tmp79_;
															_tmp78_ = channel;
															_tmp79_ = dvbtp;
															dvb_channel_set_Param (_tmp78_, (DVBParameter*) _tmp79_);
														}
														_g_object_unref0 (channel);
													}
													_g_object_unref0 (_channel_it);
												}
											}
											__finally0:
											{
												DVBChannelList* _tmp80_;
												_tmp80_ = self->channels;
												g_rec_mutex_unlock (&self->priv->__lock_channels);
											}
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												_g_object_unref0 (dvbtp);
												__vala_GstMpegtsNITStream_free0 (stream);
												_g_free0 (name);
												__vala_GstMpegtsDescriptor_free0 (desc);
												g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
												g_clear_error (&_inner_error0_);
												return;
											}
										}
										_tmp81_ = dvbtp;
										_tmp82_ = _g_object_ref0 ((DVBParameter*) _tmp81_);
										_g_object_unref0 (self->priv->current_scanning_param);
										self->priv->current_scanning_param = _tmp82_;
									} else {
										DVBDvbTParameter* _tmp83_;
										_tmp83_ = dvbtp;
										dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp83_);
									}
									_g_object_unref0 (dvbtp);
									break;
								}
								case GST_MTS_DESC_DVB_CABLE_DELIVERY_SYSTEM:
								{
									GstMpegtsCableDeliverySystemDescriptor cdesc = {0};
									GstMpegtsDescriptor* _tmp84_;
									GstMpegtsCableDeliverySystemDescriptor _tmp85_ = {0};
									DVBDvbCEuropeParameter* dvbcp = NULL;
									GstMpegtsCableDeliverySystemDescriptor _tmp86_;
									GstMpegtsCableDeliverySystemDescriptor _tmp87_;
									GstMpegtsCableDeliverySystemDescriptor _tmp88_;
									GstMpegtsCableDeliverySystemDescriptor _tmp89_;
									DVBDvbCEuropeParameter* _tmp90_;
									DVBParameter* _tmp91_;
									guint _tmp92_;
									guint _tmp93_;
									GstMpegtsCableDeliverySystemDescriptor _tmp94_;
									_tmp84_ = desc;
									gst_mpegts_descriptor_parse_cable_delivery_system (_tmp84_, &_tmp85_);
									cdesc = _tmp85_;
									_tmp86_ = cdesc;
									_tmp87_ = cdesc;
									_tmp88_ = cdesc;
									_tmp89_ = cdesc;
									_tmp90_ = dvb_dvb_ceurope_parameter_new_with_parameter ((guint) _tmp86_.frequency, (guint) _tmp87_.symbol_rate, _tmp88_.modulation, _tmp89_.fec_inner);
									dvbcp = _tmp90_;
									_tmp91_ = self->priv->current_scanning_param;
									_tmp92_ = dvb_parameter_get_Frequency (_tmp91_);
									_tmp93_ = _tmp92_;
									_tmp94_ = cdesc;
									if (_tmp93_ == ((guint) _tmp94_.frequency)) {
										DVBDvbCEuropeParameter* _tmp95_;
										DVBParameter* _tmp96_;
										_tmp95_ = dvbcp;
										_tmp96_ = _g_object_ref0 ((DVBParameter*) _tmp95_);
										_g_object_unref0 (self->priv->current_scanning_param);
										self->priv->current_scanning_param = _tmp96_;
									} else {
										DVBDvbCEuropeParameter* _tmp97_;
										_tmp97_ = dvbcp;
										dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp97_);
									}
									_g_object_unref0 (dvbcp);
									break;
								}
								case GST_MTS_DESC_DVB_SATELLITE_DELIVERY_SYSTEM:
								{
									GstMpegtsSatelliteDeliverySystemDescriptor sdesc = {0};
									GstMpegtsDescriptor* _tmp98_;
									GstMpegtsSatelliteDeliverySystemDescriptor _tmp99_ = {0};
									gfloat position = 0.0F;
									GstMpegtsSatelliteDeliverySystemDescriptor _tmp100_;
									_tmp98_ = desc;
									gst_mpegts_descriptor_parse_satellite_delivery_system (_tmp98_, &_tmp99_);
									sdesc = _tmp99_;
									_tmp100_ = sdesc;
									if (!_tmp100_.modulation_system) {
										GstMpegtsSatelliteDeliverySystemDescriptor _tmp101_;
										_tmp101_ = sdesc;
										if (_tmp101_.modulation_type != GST_MPEGTS_MODULATION_QPSK) {
										} else {
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp102_;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp103_;
											DVBLoggingLogger* _tmp104_;
											DVBDvbSParameter* dvbsp = NULL;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp105_;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp106_;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp107_;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp108_;
											DVBDvbSParameter* _tmp109_;
											DVBParameter* _tmp110_;
											guint _tmp111_;
											guint _tmp112_;
											GstMpegtsSatelliteDeliverySystemDescriptor _tmp113_;
											_tmp102_ = sdesc;
											position = _tmp102_.orbital_position;
											_tmp103_ = sdesc;
											if (!_tmp103_.west_east) {
												position *= (gfloat) -1;
											}
											_tmp104_ = dvb_scanner_log;
											dvb_logging_logger_debug (_tmp104_, "Scanner.vala:712: Orbital position: %f", (gdouble) position);
											_tmp105_ = sdesc;
											_tmp106_ = sdesc;
											_tmp107_ = sdesc;
											_tmp108_ = sdesc;
											_tmp109_ = dvb_dvb_sparameter_new_with_parameter ((guint) _tmp105_.frequency, (guint) _tmp106_.symbol_rate, position, _tmp107_.polarization, _tmp108_.fec_inner);
											dvbsp = _tmp109_;
											_tmp110_ = self->priv->current_scanning_param;
											_tmp111_ = dvb_parameter_get_Frequency (_tmp110_);
											_tmp112_ = _tmp111_;
											_tmp113_ = sdesc;
											if (_tmp112_ == ((guint) _tmp113_.frequency)) {
												DVBDvbSParameter* _tmp114_;
												DVBParameter* _tmp115_;
												_tmp114_ = dvbsp;
												_tmp115_ = _g_object_ref0 ((DVBParameter*) _tmp114_);
												_g_object_unref0 (self->priv->current_scanning_param);
												self->priv->current_scanning_param = _tmp115_;
											} else {
												DVBDvbSParameter* _tmp116_;
												_tmp116_ = dvbsp;
												dvb_scanner_add_to_queue (self, (DVBParameter*) _tmp116_);
											}
											_g_object_unref0 (dvbsp);
										}
									} else {
									}
									break;
								}
								default:
								{
									break;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp117_ = nit;
	if (_tmp117_->actual_network) {
		self->priv->nit_arrived = TRUE;
	}
	__vala_GstMpegtsNITStream_free0 (stream);
	_g_free0 (name);
	__vala_GstMpegtsDescriptor_free0 (desc);
}

static GstMpegtsPMTStream*
_vala_GstMpegtsPMTStream_copy (GstMpegtsPMTStream* self)
{
	return g_boxed_copy (gst_mpegts_pmt_stream_get_type (), self);
}

static gpointer
__vala_GstMpegtsPMTStream_copy0 (gpointer self)
{
	return self ? _vala_GstMpegtsPMTStream_copy (self) : NULL;
}

static void
_vala_GstMpegtsPMTStream_free (GstMpegtsPMTStream* self)
{
	g_boxed_free (gst_mpegts_pmt_stream_get_type (), self);
}

void
dvb_scanner_on_pmt_structure (DVBScanner* self,
                              GstMpegtsSection* section)
{
	DVBLoggingLogger* _tmp0_;
	GstMpegtsPMT* pmt = NULL;
	GstMpegtsPMT* _tmp1_;
	guint program_number = 0U;
	GstMpegtsPMT* _tmp2_;
	DVBChannelList* _tmp3_;
	DVBChannel* dvb_channel = NULL;
	DVBChannelList* _tmp4_;
	DVBChannel* _tmp5_;
	GstMpegtsPMTStream* stream = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp0_, "Scanner.vala:741: Received PMT, version %d, section number %d, last se" \
"ction number %d", (gint) section->version_number, (gint) section->section_number, (gint) section->last_section_number);
	_tmp1_ = gst_mpegts_section_get_pmt (section);
	pmt = _tmp1_;
	_tmp2_ = pmt;
	program_number = (guint) _tmp2_->program_number;
	_tmp3_ = self->channels;
	if (!dvb_channel_list_contains (_tmp3_, program_number)) {
		dvb_scanner_add_new_channel (self, program_number);
	}
	_tmp4_ = self->channels;
	_tmp5_ = dvb_channel_list_get_channel (_tmp4_, program_number);
	dvb_channel = _tmp5_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				GstMpegtsPMT* _tmp8_;
				GPtrArray* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GstMpegtsPMT* _tmp12_;
				GPtrArray* _tmp13_;
				gconstpointer _tmp14_;
				GstMpegtsPMTStream* _tmp15_;
				guint pid = 0U;
				GstMpegtsPMTStream* _tmp16_;
				GstMpegtsPMTStream* _tmp17_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = pmt;
				_tmp9_ = _tmp8_->streams;
				_tmp10_ = vala_g_ptr_array_get_length (_tmp9_);
				_tmp11_ = _tmp10_;
				if (!(i < _tmp11_)) {
					break;
				}
				_tmp12_ = pmt;
				_tmp13_ = _tmp12_->streams;
				_tmp14_ = g_ptr_array_index (_tmp13_, (guint) i);
				_tmp15_ = __vala_GstMpegtsPMTStream_copy0 ((GstMpegtsPMTStream*) _tmp14_);
				__vala_GstMpegtsPMTStream_free0 (stream);
				stream = _tmp15_;
				_tmp16_ = stream;
				pid = (guint) _tmp16_->pid;
				_tmp17_ = stream;
				switch (_tmp17_->stream_type) {
					case GST_MPEGTS_STREAM_TYPE_VIDEO_MPEG1:
					case GST_MPEGTS_STREAM_TYPE_VIDEO_MPEG2:
					case GST_MPEGTS_STREAM_TYPE_VIDEO_H264:
					{
						DVBLoggingLogger* _tmp18_;
						DVBChannel* _tmp19_;
						_tmp18_ = dvb_scanner_log;
						dvb_logging_logger_debug (_tmp18_, "Scanner.vala:764: Found video PID 0x%04x for channel 0x%04x", pid, program_number);
						_tmp19_ = dvb_channel;
						dvb_channel_set_VideoPID (_tmp19_, pid);
						break;
					}
					case GST_MPEGTS_STREAM_TYPE_AUDIO_MPEG1:
					case GST_MPEGTS_STREAM_TYPE_AUDIO_MPEG2:
					case GST_MPEGTS_STREAM_TYPE_AUDIO_AAC_ADTS:
					case GST_MPEGTS_STREAM_TYPE_AUDIO_AAC_LATM:
					case 0x81:
					case 0x87:
					{
						DVBLoggingLogger* _tmp20_;
						DVBChannel* _tmp21_;
						GeeList* _tmp22_;
						GeeList* _tmp23_;
						_tmp20_ = dvb_scanner_log;
						dvb_logging_logger_debug (_tmp20_, "Scanner.vala:774: Found audio PID 0x%04x for channel 0x%04x", pid, program_number);
						_tmp21_ = dvb_channel;
						_tmp22_ = dvb_channel_get_AudioPIDs (_tmp21_);
						_tmp23_ = _tmp22_;
						if (!gee_collection_contains ((GeeCollection*) _tmp23_, (gpointer) ((guintptr) pid))) {
							DVBChannel* _tmp24_;
							GeeList* _tmp25_;
							GeeList* _tmp26_;
							_tmp24_ = dvb_channel;
							_tmp25_ = dvb_channel_get_AudioPIDs (_tmp24_);
							_tmp26_ = _tmp25_;
							gee_collection_add ((GeeCollection*) _tmp26_, (gpointer) ((guintptr) pid));
						}
						break;
					}
					case GST_MPEGTS_STREAM_TYPE_PRIVATE_PES_PACKETS:
					{
						gboolean _tmp27_ = FALSE;
						gboolean _tmp28_ = FALSE;
						GstMpegtsPMTStream* _tmp29_;
						GPtrArray* _tmp30_;
						GstMpegtsDescriptor* _tmp31_;
						_tmp29_ = stream;
						_tmp30_ = _tmp29_->descriptors;
						_tmp31_ = gst_mpegts_find_descriptor (_tmp30_, (guint8) GST_MTS_DESC_DVB_DTS);
						if (_tmp31_ != NULL) {
							_tmp28_ = TRUE;
						} else {
							GstMpegtsPMTStream* _tmp32_;
							GPtrArray* _tmp33_;
							GstMpegtsDescriptor* _tmp34_;
							_tmp32_ = stream;
							_tmp33_ = _tmp32_->descriptors;
							_tmp34_ = gst_mpegts_find_descriptor (_tmp33_, (guint8) GST_MTS_DESC_DVB_AC3);
							_tmp28_ = _tmp34_ != NULL;
						}
						if (_tmp28_) {
							_tmp27_ = TRUE;
						} else {
							GstMpegtsPMTStream* _tmp35_;
							GPtrArray* _tmp36_;
							GstMpegtsDescriptor* _tmp37_;
							_tmp35_ = stream;
							_tmp36_ = _tmp35_->descriptors;
							_tmp37_ = gst_mpegts_find_descriptor (_tmp36_, (guint8) GST_MTS_DESC_DVB_ENHANCED_AC3);
							_tmp27_ = _tmp37_ != NULL;
						}
						if (_tmp27_) {
							DVBLoggingLogger* _tmp38_;
							DVBChannel* _tmp39_;
							GeeList* _tmp40_;
							GeeList* _tmp41_;
							_tmp38_ = dvb_scanner_log;
							dvb_logging_logger_debug (_tmp38_, "Scanner.vala:785: Found audio PID 0x%04x for channel 0x%04x", pid, program_number);
							_tmp39_ = dvb_channel;
							_tmp40_ = dvb_channel_get_AudioPIDs (_tmp39_);
							_tmp41_ = _tmp40_;
							if (!gee_collection_contains ((GeeCollection*) _tmp41_, (gpointer) ((guintptr) pid))) {
								DVBChannel* _tmp42_;
								GeeList* _tmp43_;
								GeeList* _tmp44_;
								_tmp42_ = dvb_channel;
								_tmp43_ = dvb_channel_get_AudioPIDs (_tmp42_);
								_tmp44_ = _tmp43_;
								gee_collection_add ((GeeCollection*) _tmp44_, (gpointer) ((guintptr) pid));
							}
						}
						break;
					}
					default:
					{
						DVBLoggingLogger* _tmp45_;
						GstMpegtsPMTStream* _tmp46_;
						_tmp45_ = dvb_scanner_log;
						_tmp46_ = stream;
						dvb_logging_logger_debug (_tmp45_, "Scanner.vala:793: Other stream type: 0x%04x", (guint) _tmp46_->stream_type);
						break;
					}
				}
			}
		}
	}
	self->priv->pmt_arrived = TRUE;
	__vala_GstMpegtsPMTStream_free0 (stream);
	_g_object_unref0 (dvb_channel);
}

static void
_vala_GstMpegtsSection_free (GstMpegtsSection* self)
{
	g_boxed_free (gst_mpegts_section_get_type (), self);
}

gboolean
dvb_scanner_bus_watch_func (DVBScanner* self,
                            GstBus* bus,
                            GstMessage* message)
{
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_ = FALSE;
	gboolean _tmp76_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	switch (message->type) {
		case GST_MESSAGE_ELEMENT:
		{
			{
				GstMpegtsSection* section = NULL;
				GstMpegtsSection* _tmp0_;
				GstMpegtsSection* _tmp1_;
				_tmp0_ = gst_message_parse_mpegts_section (message);
				section = _tmp0_;
				_tmp1_ = section;
				if (_tmp1_ == NULL) {
					GstStructure* structure = NULL;
					GstStructure* _tmp2_;
					gchar* structure_name = NULL;
					GstStructure* _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
					const gchar* _tmp6_;
					_tmp2_ = gst_message_get_structure (message);
					structure = _tmp2_;
					_tmp3_ = structure;
					_tmp4_ = gst_structure_get_name (_tmp3_);
					_tmp5_ = g_strdup (_tmp4_);
					structure_name = _tmp5_;
					_tmp6_ = structure_name;
					if (g_strcmp0 (_tmp6_, "dvb-frontend-stats") == 0) {
						GstStructure* _tmp7_;
						_tmp7_ = structure;
						dvb_scanner_on_dvb_frontend_stats_structure (self, _tmp7_);
					} else {
						const gchar* _tmp8_;
						_tmp8_ = structure_name;
						if (g_strcmp0 (_tmp8_, "dvb-read-failure") == 0) {
							dvb_scanner_on_dvb_read_failure_structure (self);
						} else {
							result = TRUE;
							_g_free0 (structure_name);
							__vala_GstMpegtsSection_free0 (section);
							return result;
						}
					}
					_g_free0 (structure_name);
				} else {
					GstMpegtsSection* _tmp9_;
					_tmp9_ = section;
					switch (_tmp9_->section_type) {
						case GST_MPEGTS_SECTION_PAT:
						{
							{
								GstMpegtsSection* _tmp10_;
								_tmp10_ = section;
								dvb_scanner_on_pat_structure (self, _tmp10_);
								break;
							}
						}
						case GST_MPEGTS_SECTION_PMT:
						{
							{
								GstMpegtsSection* _tmp11_;
								_tmp11_ = section;
								dvb_scanner_on_pmt_structure (self, _tmp11_);
								break;
							}
						}
						case GST_MPEGTS_SECTION_NIT:
						{
							{
								GstMpegtsSection* _tmp12_;
								_tmp12_ = section;
								dvb_scanner_on_nit_structure (self, _tmp12_);
								break;
							}
						}
						case GST_MPEGTS_SECTION_SDT:
						{
							{
								GstMpegtsSection* _tmp13_;
								_tmp13_ = section;
								dvb_scanner_on_sdt_structure (self, _tmp13_);
								break;
							}
						}
						default:
						{
							{
								result = TRUE;
								__vala_GstMpegtsSection_free0 (section);
								return result;
							}
						}
					}
				}
				__vala_GstMpegtsSection_free0 (section);
				break;
			}
		}
		case GST_MESSAGE_ERROR:
		{
			{
				GError* gerror = NULL;
				gchar* debug = NULL;
				GError* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
				DVBLoggingLogger* _tmp16_;
				GError* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gst_message_parse_error (message, &_tmp14_, &_tmp15_);
				_g_error_free0 (gerror);
				gerror = _tmp14_;
				_g_free0 (debug);
				debug = _tmp15_;
				_tmp16_ = dvb_scanner_log;
				_tmp17_ = gerror;
				_tmp18_ = _tmp17_->message;
				_tmp19_ = debug;
				dvb_logging_logger_warning (_tmp16_, "Scanner.vala:845: %s %s", _tmp18_, _tmp19_);
				result = TRUE;
				_g_free0 (debug);
				_g_error_free0 (gerror);
				return result;
			}
		}
		default:
		{
			result = TRUE;
			return result;
		}
	}
	if (self->priv->nit_arrived) {
		_tmp22_ = self->priv->sdt_arrived;
	} else {
		_tmp22_ = FALSE;
	}
	if (_tmp22_) {
		_tmp21_ = self->priv->pat_arrived;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		_tmp20_ = self->priv->pmt_arrived;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		{
			GeeArrayList* _tmp23_;
			_tmp23_ = self->priv->new_channels;
			g_rec_mutex_lock (&self->priv->__lock_new_channels);
			{
				GeeArrayList* del_channels = NULL;
				GeeArrayList* _tmp24_;
				_tmp24_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
				del_channels = _tmp24_;
				{
					GeeArrayList* _sid_list = NULL;
					GeeArrayList* _tmp25_;
					gint _sid_size = 0;
					GeeArrayList* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					gint _sid_index = 0;
					_tmp25_ = self->priv->new_channels;
					_sid_list = _tmp25_;
					_tmp26_ = _sid_list;
					_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
					_tmp28_ = _tmp27_;
					_sid_size = _tmp28_;
					_sid_index = -1;
					while (TRUE) {
						gint _tmp29_;
						gint _tmp30_;
						guint sid = 0U;
						GeeArrayList* _tmp31_;
						gpointer _tmp32_;
						DVBChannel* channel = NULL;
						DVBChannelList* _tmp33_;
						DVBChannel* _tmp34_;
						DVBChannel* _tmp35_;
						_sid_index = _sid_index + 1;
						_tmp29_ = _sid_index;
						_tmp30_ = _sid_size;
						if (!(_tmp29_ < _tmp30_)) {
							break;
						}
						_tmp31_ = _sid_list;
						_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _sid_index);
						sid = (guint) ((guintptr) _tmp32_);
						_tmp33_ = self->channels;
						_tmp34_ = dvb_channel_list_get_channel (_tmp33_, sid);
						channel = _tmp34_;
						_tmp35_ = channel;
						if (dvb_channel_is_valid (_tmp35_)) {
							const gchar* _tmp36_ = NULL;
							DVBChannel* _tmp37_;
							gchar* type = NULL;
							gchar* _tmp38_;
							DVBLoggingLogger* _tmp39_;
							DVBChannel* _tmp40_;
							const gchar* _tmp41_;
							const gchar* _tmp42_;
							DVBChannel* _tmp43_;
							DVBParameter* _tmp44_;
							DVBParameter* _tmp45_;
							guint _tmp46_;
							guint _tmp47_;
							DVBChannel* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
							DVBChannel* _tmp51_;
							const gchar* _tmp52_;
							const gchar* _tmp53_;
							const gchar* _tmp54_;
							DVBChannel* _tmp55_;
							gboolean _tmp56_;
							gboolean _tmp57_;
							GeeArrayList* _tmp58_;
							_tmp37_ = channel;
							if (dvb_channel_is_radio (_tmp37_)) {
								_tmp36_ = "Radio";
							} else {
								_tmp36_ = "TV";
							}
							_tmp38_ = g_strdup (_tmp36_);
							type = _tmp38_;
							_tmp39_ = dvb_scanner_log;
							_tmp40_ = channel;
							_tmp41_ = dvb_channel_get_Name (_tmp40_);
							_tmp42_ = _tmp41_;
							dvb_logging_logger_debug (_tmp39_, "Scanner.vala:864: Channel added: %s", _tmp42_);
							_tmp43_ = channel;
							_tmp44_ = dvb_channel_get_Param (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp46_ = dvb_parameter_get_Frequency (_tmp45_);
							_tmp47_ = _tmp46_;
							_tmp48_ = channel;
							_tmp49_ = dvb_channel_get_Name (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp51_ = channel;
							_tmp52_ = dvb_channel_get_Network (_tmp51_);
							_tmp53_ = _tmp52_;
							_tmp54_ = type;
							_tmp55_ = channel;
							_tmp56_ = dvb_channel_get_Scrambled (_tmp55_);
							_tmp57_ = _tmp56_;
							g_signal_emit_by_name ((DVBIDBusScanner*) self, "channel-added", _tmp47_, sid, _tmp50_, _tmp53_, _tmp54_, _tmp57_);
							_tmp58_ = del_channels;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, (gpointer) ((guintptr) sid));
							_g_free0 (type);
						} else {
							DVBLoggingLogger* _tmp59_;
							DVBChannel* _tmp60_;
							gchar* _tmp61_;
							gchar* _tmp62_;
							_tmp59_ = dvb_scanner_log;
							_tmp60_ = channel;
							_tmp61_ = dvb_channel_to_string (_tmp60_);
							_tmp62_ = _tmp61_;
							dvb_logging_logger_debug (_tmp59_, "Scanner.vala:871: Channel 0x%x is not valid: %s", sid, _tmp62_);
							_g_free0 (_tmp62_);
							self->priv->pmt_arrived = FALSE;
						}
						_g_object_unref0 (channel);
					}
				}
				{
					GeeArrayList* _sid_list = NULL;
					GeeArrayList* _tmp63_;
					gint _sid_size = 0;
					GeeArrayList* _tmp64_;
					gint _tmp65_;
					gint _tmp66_;
					gint _sid_index = 0;
					_tmp63_ = del_channels;
					_sid_list = _tmp63_;
					_tmp64_ = _sid_list;
					_tmp65_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp64_);
					_tmp66_ = _tmp65_;
					_sid_size = _tmp66_;
					_sid_index = -1;
					while (TRUE) {
						gint _tmp67_;
						gint _tmp68_;
						guint sid = 0U;
						GeeArrayList* _tmp69_;
						gpointer _tmp70_;
						GeeArrayList* _tmp71_;
						_sid_index = _sid_index + 1;
						_tmp67_ = _sid_index;
						_tmp68_ = _sid_size;
						if (!(_tmp67_ < _tmp68_)) {
							break;
						}
						_tmp69_ = _sid_list;
						_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, _sid_index);
						sid = (guint) ((guintptr) _tmp70_);
						_tmp71_ = self->priv->new_channels;
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp71_, (gpointer) ((guintptr) sid));
					}
				}
				_g_object_unref0 (del_channels);
			}
			__finally0:
			{
				GeeArrayList* _tmp72_;
				_tmp72_ = self->priv->new_channels;
				g_rec_mutex_unlock (&self->priv->__lock_new_channels);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp73_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp73_;
			}
		}
	}
	if (self->priv->sdt_arrived) {
		_tmp76_ = self->priv->nit_arrived;
	} else {
		_tmp76_ = FALSE;
	}
	if (_tmp76_) {
		_tmp75_ = self->priv->pat_arrived;
	} else {
		_tmp75_ = FALSE;
	}
	if (_tmp75_) {
		_tmp74_ = self->priv->pmt_arrived;
	} else {
		_tmp74_ = FALSE;
	}
	if (_tmp74_) {
		dvb_scanner_remove_wait_for_tables_timeout (self);
		dvb_scanner_queue_start_scan (self);
	}
	result = TRUE;
	return result;
}

static void
dvb_scanner_add_new_channel (DVBScanner* self,
                             guint sid)
{
	DVBLoggingLogger* _tmp0_;
	DVBChannel* new_channel = NULL;
	DVBChannel* _tmp1_;
	DVBParameter* _tmp2_;
	DVBChannelList* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = dvb_scanner_log;
	dvb_logging_logger_debug (_tmp0_, "Scanner.vala:897: Adding new channel with SID 0x%x", sid);
	_tmp1_ = dvb_channel_new_without_schedule ();
	new_channel = _tmp1_;
	dvb_channel_set_Sid (new_channel, sid);
	_tmp2_ = self->priv->current_scanning_param;
	dvb_channel_set_Param (new_channel, _tmp2_);
	_tmp3_ = self->channels;
	dvb_channel_list_add (_tmp3_, new_channel);
	{
		GeeArrayList* _tmp4_;
		_tmp4_ = self->priv->new_channels;
		g_rec_mutex_lock (&self->priv->__lock_new_channels);
		{
			GeeArrayList* _tmp5_;
			_tmp5_ = self->priv->new_channels;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, (gpointer) ((guintptr) sid));
		}
		__finally0:
		{
			GeeArrayList* _tmp6_;
			_tmp6_ = self->priv->new_channels;
			g_rec_mutex_unlock (&self->priv->__lock_new_channels);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (new_channel);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_g_object_unref0 (new_channel);
}

DVBDevice*
dvb_scanner_get_Device (DVBScanner* self)
{
	DVBDevice* result;
	DVBDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Device;
	result = _tmp0_;
	return result;
}

static void
dvb_scanner_set_Device (DVBScanner* self,
                        DVBDevice* value)
{
	DVBDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_scanner_get_Device (self);
	if (old_value != value) {
		DVBDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_Device);
		self->priv->_Device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_scanner_properties[DVB_SCANNER_DEVICE_PROPERTY]);
	}
}

DVBChannelList*
dvb_scanner_get_Channels (DVBScanner* self)
{
	DVBChannelList* result;
	DVBChannelList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->channels;
	result = _tmp0_;
	return result;
}

DVBAdapterType
dvb_scanner_get_Type (DVBScanner* self)
{
	DVBAdapterType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_Type;
	return result;
}

static void
dvb_scanner_set_Type (DVBScanner* self,
                      DVBAdapterType value)
{
	DVBAdapterType old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_scanner_get_Type (self);
	if (old_value != value) {
		self->priv->_Type = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_scanner_properties[DVB_SCANNER_TYPE_PROPERTY]);
	}
}

static GObject *
dvb_scanner_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBScanner * self;
	GeeHashSet* _tmp0_;
	GeeArrayList* _tmp1_;
	GQueue* _tmp2_;
	GMainContext* _tmp3_;
	parent_class = G_OBJECT_CLASS (dvb_scanner_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SCANNER, DVBScanner);
	_tmp0_ = gee_hash_set_new (DVB_TYPE_PARAMETER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->scanned_scanning_params);
	self->priv->scanned_scanning_params = _tmp0_;
	_tmp1_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->new_channels);
	self->priv->new_channels = _tmp1_;
	_tmp2_ = g_queue_new ();
	(self->priv->queue_scanning_params == NULL) ? NULL : (self->priv->queue_scanning_params = (_g_queue_free__g_object_unref0_ (self->priv->queue_scanning_params), NULL));
	self->priv->queue_scanning_params = _tmp2_;
	_tmp3_ = g_main_context_new ();
	_g_main_context_unref0 (self->priv->context);
	self->priv->context = _tmp3_;
	self->priv->running = FALSE;
	return obj;
}

static void
dvb_scanner_class_init (DVBScannerClass * klass,
                        gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_scanner_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBScanner_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_scanner_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_scanner_set_property;
	G_OBJECT_CLASS (klass)->constructor = dvb_scanner_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_scanner_finalize;
	/**
	         * The DVB device the scanner should use
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_SCANNER_DEVICE_PROPERTY, dvb_scanner_properties[DVB_SCANNER_DEVICE_PROPERTY] = g_param_spec_object ("Device", "Device", "Device", DVB_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_SCANNER_CHANNELS_PROPERTY, dvb_scanner_properties[DVB_SCANNER_CHANNELS_PROPERTY] = g_param_spec_object ("Channels", "Channels", "Channels", DVB_TYPE_CHANNEL_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_SCANNER_TYPE_PROPERTY, dvb_scanner_properties[DVB_SCANNER_TYPE_PROPERTY] = g_param_spec_enum ("Type", "Type", "Type", DVB_TYPE_ADAPTER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	         * Emitted when the Destroy () method is called
	         */
	dvb_scanner_signals[DVB_SCANNER_DESTROYED_SIGNAL] = g_signal_new ("destroyed", DVB_TYPE_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_scanner_log = _tmp1_;
}

static void
dvb_scanner_dvb_id_bus_scanner_interface_init (DVBIDBusScannerIface * iface,
                                               gpointer iface_data)
{
	dvb_scanner_dvb_id_bus_scanner_parent_iface = g_type_interface_peek_parent (iface);
	iface->Run = (void (*) (DVBIDBusScanner*, GError**)) dvb_scanner_real_Run;
	iface->Destroy = (void (*) (DVBIDBusScanner*, GError**)) dvb_scanner_real_Destroy;
	iface->AddScanningData = (gboolean (*) (DVBIDBusScanner*, GHashTable*, GError**)) dvb_scanner_real_AddScanningData;
	iface->WriteAllChannelsToFile = (gboolean (*) (DVBIDBusScanner*, const gchar*, GError**)) dvb_scanner_real_WriteAllChannelsToFile;
	iface->WriteChannelsToFile = (gboolean (*) (DVBIDBusScanner*, guint*, gint, const gchar*, GError**)) dvb_scanner_real_WriteChannelsToFile;
	iface->AddScanningDataFromFile = (gboolean (*) (DVBIDBusScanner*, const gchar*, GError**)) dvb_scanner_real_AddScanningDataFromFile;
}

static void
dvb_scanner_instance_init (DVBScanner * self,
                           gpointer klass)
{
	self->priv = dvb_scanner_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_channels);
	g_rec_mutex_init (&self->priv->__lock_new_channels);
}

static void
dvb_scanner_finalize (GObject * obj)
{
	DVBScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SCANNER, DVBScanner);
	_g_object_unref0 (self->priv->_Device);
	g_rec_mutex_clear (&self->priv->__lock_channels);
	_g_object_unref0 (self->channels);
	_g_object_unref0 (self->pipeline);
	(self->priv->queue_scanning_params == NULL) ? NULL : (self->priv->queue_scanning_params = (_g_queue_free__g_object_unref0_ (self->priv->queue_scanning_params), NULL));
	_g_object_unref0 (self->priv->current_scanning_param);
	_g_object_unref0 (self->priv->scanned_scanning_params);
	g_rec_mutex_clear (&self->priv->__lock_new_channels);
	_g_object_unref0 (self->priv->new_channels);
	_g_source_unref0 (self->priv->check_for_lock_source);
	_g_source_unref0 (self->priv->wait_for_tables_source);
	_g_source_unref0 (self->priv->start_scan_source);
	_g_main_context_unref0 (self->priv->context);
	_g_main_loop_unref0 (self->priv->loop);
	_g_thread_unref0 (self->priv->worker_thread);
	G_OBJECT_CLASS (dvb_scanner_parent_class)->finalize (obj);
}

/**
     * A class responsible for scanning for new channels
     */
static GType
dvb_scanner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBScanner), 0, (GInstanceInitFunc) dvb_scanner_instance_init, NULL };
	static const GInterfaceInfo dvb_id_bus_scanner_info = { (GInterfaceInitFunc) dvb_scanner_dvb_id_bus_scanner_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_scanner_type_id;
	dvb_scanner_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBScanner", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_scanner_type_id, DVB_TYPE_ID_BUS_SCANNER, &dvb_id_bus_scanner_info);
	DVBScanner_private_offset = g_type_add_instance_private (dvb_scanner_type_id, sizeof (DVBScannerPrivate));
	return dvb_scanner_type_id;
}

GType
dvb_scanner_get_type (void)
{
	static volatile gsize dvb_scanner_type_id__once = 0;
	if (g_once_init_enter (&dvb_scanner_type_id__once)) {
		GType dvb_scanner_type_id;
		dvb_scanner_type_id = dvb_scanner_get_type_once ();
		g_once_init_leave (&dvb_scanner_type_id__once, dvb_scanner_type_id);
	}
	return dvb_scanner_type_id__once;
}

static void
_vala_dvb_scanner_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	DVBScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_SCANNER, DVBScanner);
	switch (property_id) {
		case DVB_SCANNER_DEVICE_PROPERTY:
		g_value_set_object (value, dvb_scanner_get_Device (self));
		break;
		case DVB_SCANNER_CHANNELS_PROPERTY:
		g_value_set_object (value, dvb_scanner_get_Channels (self));
		break;
		case DVB_SCANNER_TYPE_PROPERTY:
		g_value_set_enum (value, dvb_scanner_get_Type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_scanner_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	DVBScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_SCANNER, DVBScanner);
	switch (property_id) {
		case DVB_SCANNER_DEVICE_PROPERTY:
		dvb_scanner_set_Device (self, g_value_get_object (value));
		break;
		case DVB_SCANNER_TYPE_PROPERTY:
		dvb_scanner_set_Type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

