/* Settings.c generated by valac 0.56.18, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
 * Copyright (C) 2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define DVB_SETTINGS_TIMERS_SECTION "timers"
#define DVB_SETTINGS_MARGIN_START "margin_start"
#define DVB_SETTINGS_MARGIN_END "margin_end"
#define DVB_SETTINGS_EPG_SECTION "epg"
#define DVB_SETTINGS_SCAN_INTERVAL "scan_interval"
#define DVB_SETTINGS_STREAMING_SECTION "streaming"
#define DVB_SETTINGS_INTERFACE "interface"
#define DVB_SETTINGS_DEFAULT_MARGIN_START 5
#define DVB_SETTINGS_DEFAULT_MARGIN_END 5
#define DVB_SETTINGS_DEFAULT_SCAN_INTERVAL 30
#define DVB_SETTINGS_DEFAULT_INTERFACE "lo"
#define DVB_SETTINGS_DEFAULT_SETTINGS "[timers]\n" \
"        margin_start=5\n" \
"        margin_end=5\n" \
"        [epg]\n" \
"        scan_interval=30\n" \
"        [streaming]\n" \
"        interface=lo"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_SETTINGS (dvb_settings_get_type ())
#define DVB_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SETTINGS, DVBSettings))
#define DVB_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SETTINGS, DVBSettingsClass))
#define DVB_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SETTINGS))
#define DVB_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SETTINGS))
#define DVB_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SETTINGS, DVBSettingsClass))

typedef struct _DVBSettings DVBSettings;
typedef struct _DVBSettingsClass DVBSettingsClass;
typedef struct _DVBSettingsPrivate DVBSettingsPrivate;
enum  {
	DVB_SETTINGS_0_PROPERTY,
	DVB_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* dvb_settings_properties[DVB_SETTINGS_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DVBSettings {
	GObject parent_instance;
	DVBSettingsPrivate * priv;
};

struct _DVBSettingsClass {
	GObjectClass parent_class;
};

struct _DVBSettingsPrivate {
	GKeyFile* keyfile;
};

static gint DVBSettings_private_offset;
static gpointer dvb_settings_parent_class = NULL;
static DVBLoggingLogger* dvb_settings_log;
static DVBLoggingLogger* dvb_settings_log = NULL;

VALA_EXTERN GType dvb_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBSettings, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN gint dvb_settings_get_epg_scan_interval (DVBSettings* self);
VALA_EXTERN gint dvb_settings_get_integer (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               GError** error);
VALA_EXTERN void dvb_logging_logger_warning (DVBLoggingLogger* self,
                                 const gchar* format,
                                 ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gint dvb_settings_get_timers_margin_start (DVBSettings* self);
VALA_EXTERN gint dvb_settings_get_timers_margin_end (DVBSettings* self);
VALA_EXTERN gchar* dvb_settings_get_streaming_interface (DVBSettings* self);
VALA_EXTERN gchar* dvb_settings_get_string (DVBSettings* self,
                                const gchar* group_name,
                                const gchar* key,
                                GError** error);
VALA_EXTERN GFile* dvb_settings_get_settings_file (DVBSettings* self);
VALA_EXTERN gboolean dvb_settings_load (DVBSettings* self);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean dvb_settings_save (DVBSettings* self);
VALA_EXTERN gboolean dvb_settings_get_boolean (DVBSettings* self,
                                   const gchar* group_name,
                                   const gchar* key,
                                   GError** error);
VALA_EXTERN gdouble dvb_settings_get_double (DVBSettings* self,
                                 const gchar* group_name,
                                 const gchar* key,
                                 GError** error);
VALA_EXTERN gchar** dvb_settings_get_string_list (DVBSettings* self,
                                      const gchar* group_name,
                                      const gchar* key,
                                      gint* result_length1,
                                      GError** error);
VALA_EXTERN gboolean* dvb_settings_get_boolean_list (DVBSettings* self,
                                         const gchar* group_name,
                                         const gchar* key,
                                         gint* result_length1,
                                         GError** error);
VALA_EXTERN gint* dvb_settings_get_integer_list (DVBSettings* self,
                                     const gchar* group_name,
                                     const gchar* key,
                                     gint* result_length1,
                                     GError** error);
VALA_EXTERN gdouble* dvb_settings_get_double_list (DVBSettings* self,
                                       const gchar* group_name,
                                       const gchar* key,
                                       gint* result_length1,
                                       GError** error);
VALA_EXTERN void dvb_settings_set_string (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              const gchar* val,
                              GError** error);
VALA_EXTERN void dvb_settings_set_boolean (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gboolean val,
                               GError** error);
VALA_EXTERN void dvb_settings_set_double (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              gdouble val,
                              GError** error);
VALA_EXTERN void dvb_settings_set_integer (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gint val,
                               GError** error);
VALA_EXTERN void dvb_settings_set_string_list (DVBSettings* self,
                                   const gchar* group_name,
                                   const gchar* key,
                                   gchar** val,
                                   gint val_length1,
                                   GError** error);
VALA_EXTERN void dvb_settings_set_boolean_list (DVBSettings* self,
                                    const gchar* group_name,
                                    const gchar* key,
                                    gboolean* val,
                                    gint val_length1,
                                    GError** error);
VALA_EXTERN void dvb_settings_set_double_list (DVBSettings* self,
                                   const gchar* group_name,
                                   const gchar* key,
                                   gdouble* val,
                                   gint val_length1,
                                   GError** error);
VALA_EXTERN void dvb_settings_set_integer_list (DVBSettings* self,
                                    const gchar* group_name,
                                    const gchar* key,
                                    gint* val,
                                    gint val_length1,
                                    GError** error);
VALA_EXTERN DVBSettings* dvb_settings_new (void);
VALA_EXTERN DVBSettings* dvb_settings_construct (GType object_type);
static GObject * dvb_settings_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void dvb_settings_finalize (GObject * obj);
static GType dvb_settings_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dvb_settings_get_instance_private (DVBSettings* self)
{
	return G_STRUCT_MEMBER_P (self, DVBSettings_private_offset);
}

gint
dvb_settings_get_epg_scan_interval (DVBSettings* self)
{
	gint val = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint _tmp0_ = 0;
		_tmp0_ = dvb_settings_get_integer (self, DVB_SETTINGS_EPG_SECTION, DVB_SETTINGS_SCAN_INTERVAL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp1_ = -1;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		val = _tmp0_;
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = dvb_settings_log;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		dvb_logging_logger_warning (_tmp2_, "Settings.vala:64: %s", _tmp4_);
		val = DVB_SETTINGS_DEFAULT_SCAN_INTERVAL;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp5_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = val * 60;
	return result;
}

gint
dvb_settings_get_timers_margin_start (DVBSettings* self)
{
	gint start_margin = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint _tmp0_ = 0;
		_tmp0_ = dvb_settings_get_integer (self, DVB_SETTINGS_TIMERS_SECTION, DVB_SETTINGS_MARGIN_START, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp1_ = -1;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		start_margin = _tmp0_;
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = dvb_settings_log;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		dvb_logging_logger_warning (_tmp2_, "Settings.vala:75: %s", _tmp4_);
		start_margin = DVB_SETTINGS_DEFAULT_MARGIN_START;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp5_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = start_margin;
	return result;
}

gint
dvb_settings_get_timers_margin_end (DVBSettings* self)
{
	gint end_margin = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint _tmp0_ = 0;
		_tmp0_ = dvb_settings_get_integer (self, DVB_SETTINGS_TIMERS_SECTION, DVB_SETTINGS_MARGIN_END, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp1_ = -1;
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		end_margin = _tmp0_;
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = dvb_settings_log;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		dvb_logging_logger_warning (_tmp2_, "Settings.vala:86: %s", _tmp4_);
		end_margin = DVB_SETTINGS_DEFAULT_MARGIN_END;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp5_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = end_margin;
	return result;
}

gchar*
dvb_settings_get_streaming_interface (DVBSettings* self)
{
	gchar* val = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = dvb_settings_get_string (self, DVB_SETTINGS_STREAMING_SECTION, DVB_SETTINGS_INTERFACE, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch0_g_key_file_error;
			}
			_g_free0 (val);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (val);
		val = _tmp2_;
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = dvb_settings_log;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		dvb_logging_logger_warning (_tmp3_, "Settings.vala:97: %s", _tmp5_);
		_tmp6_ = g_strdup (DVB_SETTINGS_DEFAULT_INTERFACE);
		_g_free0 (val);
		val = _tmp6_;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (val);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = val;
	return result;
}

GFile*
dvb_settings_get_settings_file (DVBSettings* self)
{
	GFile* config_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* our_config = NULL;
	GFile* _tmp2_;
	GFile* settings_file = NULL;
	GFile* _tmp3_;
	GFile* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_file_new_for_path (_tmp0_);
	config_dir = _tmp1_;
	_tmp2_ = g_file_get_child (config_dir, "gnome-dvb-daemon");
	our_config = _tmp2_;
	_tmp3_ = g_file_get_child (our_config, "settings.ini");
	settings_file = _tmp3_;
	result = settings_file;
	_g_object_unref0 (our_config);
	_g_object_unref0 (config_dir);
	return result;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

gboolean
dvb_settings_load (DVBSettings* self)
{
	GFile* settings_file = NULL;
	GFile* _tmp0_;
	gboolean success = FALSE;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = dvb_settings_get_settings_file (self);
	settings_file = _tmp0_;
	success = TRUE;
	_tmp1_ = settings_file;
	if (!g_file_query_exists (_tmp1_, NULL)) {
		GFileOutputStream* stream = NULL;
		stream = NULL;
		{
			GFileOutputStream* _tmp2_ = NULL;
			GFile* _tmp3_;
			GFileOutputStream* _tmp4_;
			GFileOutputStream* _tmp5_;
			_tmp3_ = settings_file;
			_tmp4_ = g_file_create (_tmp3_, 0, NULL, &_inner_error0_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp5_ = _tmp2_;
			_tmp2_ = NULL;
			_g_object_unref0 (stream);
			stream = _tmp5_;
			_g_object_unref0 (_tmp2_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp6_;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp6_ = dvb_settings_log;
			_tmp7_ = settings_file;
			_tmp8_ = g_file_get_path (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = e;
			_tmp11_ = _tmp10_->message;
			dvb_logging_logger_error (_tmp6_, "Settings.vala:120: Could not create file %s: %s", _tmp9_, _tmp11_);
			_g_free0 (_tmp9_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (stream);
			_g_object_unref0 (settings_file);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp12_ = FALSE;
			_g_object_unref0 (stream);
			_g_object_unref0 (settings_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp12_;
		}
		{
			GFileOutputStream* _tmp13_;
			guint8* _tmp14_;
			gint _tmp14__length1;
			gint _tmp15_ = 0;
			guint8* _tmp16_;
			gint _tmp16__length1;
			_tmp13_ = stream;
			_tmp14_ = string_get_data (DVB_SETTINGS_DEFAULT_SETTINGS, &_tmp15_);
			_tmp14__length1 = _tmp15_;
			_tmp16_ = _tmp14_;
			_tmp16__length1 = _tmp14__length1;
			g_output_stream_write ((GOutputStream*) _tmp13_, _tmp16_, (gsize) _tmp16__length1, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp17_;
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GError* _tmp21_;
			const gchar* _tmp22_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp17_ = dvb_settings_log;
			_tmp18_ = settings_file;
			_tmp19_ = g_file_get_path (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = e;
			_tmp22_ = _tmp21_->message;
			dvb_logging_logger_error (_tmp17_, "Settings.vala:128: Could not write to file %s: %s", _tmp20_, _tmp22_);
			_g_free0 (_tmp20_);
			success = FALSE;
			_g_error_free0 (e);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp23_ = FALSE;
			_g_object_unref0 (stream);
			_g_object_unref0 (settings_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp23_;
		}
		{
			GFileOutputStream* _tmp24_;
			_tmp24_ = stream;
			g_output_stream_close ((GOutputStream*) _tmp24_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp25_;
			GError* _tmp26_;
			const gchar* _tmp27_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp25_ = dvb_settings_log;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			dvb_logging_logger_error (_tmp25_, "Settings.vala:136: %s", _tmp27_);
			success = FALSE;
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp28_ = FALSE;
			_g_object_unref0 (stream);
			_g_object_unref0 (settings_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp28_;
		}
		_g_object_unref0 (stream);
	}
	if (success) {
		{
			GKeyFile* _tmp29_;
			GFile* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			_tmp29_ = self->priv->keyfile;
			_tmp30_ = settings_file;
			_tmp31_ = g_file_get_path (_tmp30_);
			_tmp32_ = _tmp31_;
			g_key_file_load_from_file (_tmp29_, _tmp32_, 0, &_inner_error0_);
			_g_free0 (_tmp32_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp33_ = FALSE;
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
					goto __catch3_g_key_file_error;
				}
				if (_inner_error0_->domain == G_FILE_ERROR) {
					goto __catch3_g_file_error;
				}
				_g_object_unref0 (settings_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp33_;
			}
		}
		goto __finally3;
		__catch3_g_key_file_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp34_;
			GError* _tmp35_;
			const gchar* _tmp36_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp34_ = dvb_settings_log;
			_tmp35_ = e;
			_tmp36_ = _tmp35_->message;
			dvb_logging_logger_error (_tmp34_, "Settings.vala:145: Could not load settings: %s", _tmp36_);
			success = FALSE;
			_g_error_free0 (e);
		}
		goto __finally3;
		__catch3_g_file_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp37_;
			GError* _tmp38_;
			const gchar* _tmp39_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp37_ = dvb_settings_log;
			_tmp38_ = e;
			_tmp39_ = _tmp38_->message;
			dvb_logging_logger_error (_tmp37_, "Settings.vala:148: Could not load settings: %s", _tmp39_);
			success = FALSE;
			_g_error_free0 (e);
		}
		__finally3:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp40_ = FALSE;
			_g_object_unref0 (settings_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp40_;
		}
	}
	result = success;
	_g_object_unref0 (settings_file);
	return result;
}

gboolean
dvb_settings_save (DVBSettings* self)
{
	GFile* settings_file = NULL;
	GFile* _tmp0_;
	GFileOutputStream* stream = NULL;
	gchar* data = NULL;
	gsize data_len = 0UL;
	GKeyFile* _tmp12_;
	gsize _tmp13_ = 0UL;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = dvb_settings_get_settings_file (self);
	settings_file = _tmp0_;
	stream = NULL;
	{
		GFileOutputStream* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileOutputStream* _tmp3_;
		GFileOutputStream* _tmp4_;
		_tmp2_ = settings_file;
		_tmp3_ = g_file_replace (_tmp2_, NULL, TRUE, 0, NULL, &_inner_error0_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (stream);
		stream = _tmp4_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp5_;
		GFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = dvb_settings_log;
		_tmp6_ = settings_file;
		_tmp7_ = g_file_get_path (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		dvb_logging_logger_error (_tmp5_, "Settings.vala:163: Could not replace file %s: %s", _tmp8_, _tmp10_);
		_g_free0 (_tmp8_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (stream);
		_g_object_unref0 (settings_file);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp11_ = FALSE;
		_g_object_unref0 (stream);
		_g_object_unref0 (settings_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp11_;
	}
	data = NULL;
	_tmp12_ = self->priv->keyfile;
	_tmp14_ = g_key_file_to_data (_tmp12_, &_tmp13_, NULL);
	data_len = _tmp13_;
	_g_free0 (data);
	data = _tmp14_;
	{
		GFileOutputStream* _tmp15_;
		const gchar* _tmp16_;
		guint8* _tmp17_;
		gint _tmp17__length1;
		gint _tmp18_ = 0;
		guint8* _tmp19_;
		gint _tmp19__length1;
		_tmp15_ = stream;
		_tmp16_ = data;
		_tmp17_ = string_get_data (_tmp16_, &_tmp18_);
		_tmp17__length1 = _tmp18_;
		_tmp19_ = _tmp17_;
		_tmp19__length1 = _tmp17__length1;
		g_output_stream_write_all ((GOutputStream*) _tmp15_, _tmp19_, (gsize) _tmp19__length1, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp20_;
		GFile* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp20_ = dvb_settings_log;
		_tmp21_ = settings_file;
		_tmp22_ = g_file_get_path (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = e;
		_tmp25_ = _tmp24_->message;
		dvb_logging_logger_error (_tmp20_, "Settings.vala:175: Could not write to file %s: %s", _tmp23_, _tmp25_);
		_g_free0 (_tmp23_);
		result = FALSE;
		_g_error_free0 (e);
		_g_free0 (data);
		_g_object_unref0 (stream);
		_g_object_unref0 (settings_file);
		return result;
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp26_ = FALSE;
		_g_free0 (data);
		_g_object_unref0 (stream);
		_g_object_unref0 (settings_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp26_;
	}
	{
		GFileOutputStream* _tmp27_;
		_tmp27_ = stream;
		g_output_stream_close ((GOutputStream*) _tmp27_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp28_ = dvb_settings_log;
		_tmp29_ = e;
		_tmp30_ = _tmp29_->message;
		dvb_logging_logger_error (_tmp28_, "Settings.vala:184: %s", _tmp30_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp31_ = FALSE;
		_g_free0 (data);
		_g_object_unref0 (stream);
		_g_object_unref0 (settings_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp31_;
	}
	result = FALSE;
	_g_free0 (data);
	_g_object_unref0 (stream);
	_g_object_unref0 (settings_file);
	return result;
}

gchar*
dvb_settings_get_string (DVBSettings* self,
                         const gchar* group_name,
                         const gchar* key,
                         GError** error)
{
	gchar* _tmp0_ = NULL;
	GKeyFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group_name != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp1_ = self->priv->keyfile;
	_tmp2_ = g_key_file_get_string (_tmp1_, group_name, key, &_inner_error0_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp3_;
	_g_free0 (_tmp0_);
	return result;
}

gboolean
dvb_settings_get_boolean (DVBSettings* self,
                          const gchar* group_name,
                          const gchar* key,
                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	GKeyFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (group_name != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp1_ = self->priv->keyfile;
	_tmp0_ = g_key_file_get_boolean (_tmp1_, group_name, key, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			gboolean _tmp2_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp2_;
		} else {
			gboolean _tmp3_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = _tmp0_;
	return result;
}

gint
dvb_settings_get_integer (DVBSettings* self,
                          const gchar* group_name,
                          const gchar* key,
                          GError** error)
{
	gint _tmp0_ = 0;
	GKeyFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (group_name != NULL, 0);
	g_return_val_if_fail (key != NULL, 0);
	_tmp1_ = self->priv->keyfile;
	_tmp0_ = g_key_file_get_integer (_tmp1_, group_name, key, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			gint _tmp2_ = -1;
			g_propagate_error (error, _inner_error0_);
			return _tmp2_;
		} else {
			gint _tmp3_ = -1;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = _tmp0_;
	return result;
}

gdouble
dvb_settings_get_double (DVBSettings* self,
                         const gchar* group_name,
                         const gchar* key,
                         GError** error)
{
	gdouble _tmp0_ = 0.0;
	GKeyFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (group_name != NULL, 0.0);
	g_return_val_if_fail (key != NULL, 0.0);
	_tmp1_ = self->priv->keyfile;
	_tmp0_ = g_key_file_get_double (_tmp1_, group_name, key, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			gdouble _tmp2_ = -1.0;
			g_propagate_error (error, _inner_error0_);
			return _tmp2_;
		} else {
			gdouble _tmp3_ = -1.0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = _tmp0_;
	return result;
}

gchar**
dvb_settings_get_string_list (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              gint* result_length1,
                              GError** error)
{
	gchar** _tmp0_ = NULL;
	GKeyFile* _tmp1_;
	gsize _tmp2_ = 0;
	gchar** _tmp3_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group_name != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp1_ = self->priv->keyfile;
	_tmp3_ = g_key_file_get_string_list (_tmp1_, group_name, key, &_tmp2_, &_inner_error0_);
	_tmp0_ = _tmp3_;
	_tmp0__length1 = _tmp2_;
	__tmp0__size_ = _tmp0__length1;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp4__length1 = _tmp0__length1;
	_tmp0_ = NULL;
	_tmp0__length1 = 0;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gboolean*
dvb_settings_get_boolean_list (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gint* result_length1,
                               GError** error)
{
	gboolean* _tmp0_ = NULL;
	GKeyFile* _tmp1_;
	gsize _tmp2_ = 0;
	gboolean* _tmp3_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	gboolean* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group_name != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp1_ = self->priv->keyfile;
	_tmp3_ = g_key_file_get_boolean_list (_tmp1_, group_name, key, &_tmp2_, &_inner_error0_);
	_tmp0_ = _tmp3_;
	_tmp0__length1 = _tmp2_;
	__tmp0__size_ = _tmp0__length1;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp4__length1 = _tmp0__length1;
	_tmp0_ = NULL;
	_tmp0__length1 = 0;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	_tmp0_ = (g_free (_tmp0_), NULL);
	return result;
}

gint*
dvb_settings_get_integer_list (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gint* result_length1,
                               GError** error)
{
	gint* _tmp0_ = NULL;
	GKeyFile* _tmp1_;
	gsize _tmp2_ = 0;
	gint* _tmp3_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint* _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	gint* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group_name != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp1_ = self->priv->keyfile;
	_tmp3_ = g_key_file_get_integer_list (_tmp1_, group_name, key, &_tmp2_, &_inner_error0_);
	_tmp0_ = _tmp3_;
	_tmp0__length1 = _tmp2_;
	__tmp0__size_ = _tmp0__length1;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp4__length1 = _tmp0__length1;
	_tmp0_ = NULL;
	_tmp0__length1 = 0;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	_tmp0_ = (g_free (_tmp0_), NULL);
	return result;
}

gdouble*
dvb_settings_get_double_list (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              gint* result_length1,
                              GError** error)
{
	gdouble* _tmp0_ = NULL;
	GKeyFile* _tmp1_;
	gsize _tmp2_ = 0;
	gdouble* _tmp3_;
	gint _tmp0__length1;
	gint __tmp0__size_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	gdouble* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group_name != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp1_ = self->priv->keyfile;
	_tmp3_ = g_key_file_get_double_list (_tmp1_, group_name, key, &_tmp2_, &_inner_error0_);
	_tmp0_ = _tmp3_;
	_tmp0__length1 = _tmp2_;
	__tmp0__size_ = _tmp0__length1;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = _tmp0_;
	_tmp4__length1 = _tmp0__length1;
	_tmp0_ = NULL;
	_tmp0__length1 = 0;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	_tmp0_ = (g_free (_tmp0_), NULL);
	return result;
}

void
dvb_settings_set_string (DVBSettings* self,
                         const gchar* group_name,
                         const gchar* key,
                         const gchar* val,
                         GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_string (_tmp0_, group_name, key, val);
}

void
dvb_settings_set_boolean (DVBSettings* self,
                          const gchar* group_name,
                          const gchar* key,
                          gboolean val,
                          GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_boolean (_tmp0_, group_name, key, val);
}

void
dvb_settings_set_double (DVBSettings* self,
                         const gchar* group_name,
                         const gchar* key,
                         gdouble val,
                         GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_double (_tmp0_, group_name, key, val);
}

void
dvb_settings_set_integer (DVBSettings* self,
                          const gchar* group_name,
                          const gchar* key,
                          gint val,
                          GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_integer (_tmp0_, group_name, key, val);
}

void
dvb_settings_set_string_list (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              gchar** val,
                              gint val_length1,
                              GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_string_list (_tmp0_, group_name, key, (const gchar* const*) val, (gint) val_length1);
}

void
dvb_settings_set_boolean_list (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gboolean* val,
                               gint val_length1,
                               GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_boolean_list (_tmp0_, group_name, key, val, (gint) val_length1);
}

void
dvb_settings_set_double_list (DVBSettings* self,
                              const gchar* group_name,
                              const gchar* key,
                              gdouble* val,
                              gint val_length1,
                              GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_double_list (_tmp0_, group_name, key, val, (gint) val_length1);
}

void
dvb_settings_set_integer_list (DVBSettings* self,
                               const gchar* group_name,
                               const gchar* key,
                               gint* val,
                               gint val_length1,
                               GError** error)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group_name != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_integer_list (_tmp0_, group_name, key, val, (gint) val_length1);
}

DVBSettings*
dvb_settings_construct (GType object_type)
{
	DVBSettings * self = NULL;
	self = (DVBSettings*) g_object_new (object_type, NULL);
	return self;
}

DVBSettings*
dvb_settings_new (void)
{
	return dvb_settings_construct (DVB_TYPE_SETTINGS);
}

static GObject *
dvb_settings_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBSettings * self;
	GKeyFile* _tmp0_;
	parent_class = G_OBJECT_CLASS (dvb_settings_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SETTINGS, DVBSettings);
	_tmp0_ = g_key_file_new ();
	_g_key_file_unref0 (self->priv->keyfile);
	self->priv->keyfile = _tmp0_;
	return obj;
}

static void
dvb_settings_class_init (DVBSettingsClass * klass,
                         gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBSettings_private_offset);
	G_OBJECT_CLASS (klass)->constructor = dvb_settings_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_settings_finalize;
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_settings_log = _tmp1_;
}

static void
dvb_settings_instance_init (DVBSettings * self,
                            gpointer klass)
{
	self->priv = dvb_settings_get_instance_private (self);
}

static void
dvb_settings_finalize (GObject * obj)
{
	DVBSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SETTINGS, DVBSettings);
	_g_key_file_unref0 (self->priv->keyfile);
	G_OBJECT_CLASS (dvb_settings_parent_class)->finalize (obj);
}

static GType
dvb_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBSettings), 0, (GInstanceInitFunc) dvb_settings_instance_init, NULL };
	GType dvb_settings_type_id;
	dvb_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBSettings", &g_define_type_info, 0);
	DVBSettings_private_offset = g_type_add_instance_private (dvb_settings_type_id, sizeof (DVBSettingsPrivate));
	return dvb_settings_type_id;
}

GType
dvb_settings_get_type (void)
{
	static volatile gsize dvb_settings_type_id__once = 0;
	if (g_once_init_enter (&dvb_settings_type_id__once)) {
		GType dvb_settings_type_id;
		dvb_settings_type_id = dvb_settings_get_type_once ();
		g_once_init_leave (&dvb_settings_type_id__once, dvb_settings_type_id);
	}
	return dvb_settings_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

