/* SqliteDatabase.c generated by valac 0.56.18, the Vala compiler
 * generated from SqliteDatabase.vala, do not modify */

/*
 * Copyright (C) 2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE (dvb_database_sqlite_sqlite_database_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))

typedef struct _DVBdatabasesqliteSqliteDatabase DVBdatabasesqliteSqliteDatabase;
typedef struct _DVBdatabasesqliteSqliteDatabaseClass DVBdatabasesqliteSqliteDatabaseClass;
typedef struct _DVBdatabasesqliteSqliteDatabasePrivate DVBdatabasesqliteSqliteDatabasePrivate;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())
enum  {
	DVB_DATABASE_SQLITE_SQLITE_DATABASE_0_PROPERTY,
	DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY,
	DVB_DATABASE_SQLITE_SQLITE_DATABASE_NUM_PROPERTIES
};
static GParamSpec* dvb_database_sqlite_sqlite_database_properties[DVB_DATABASE_SQLITE_SQLITE_DATABASE_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabasesqliteSqliteDatabase {
	GObject parent_instance;
	DVBdatabasesqliteSqliteDatabasePrivate * priv;
	sqlite3* db;
};

struct _DVBdatabasesqliteSqliteDatabaseClass {
	GObjectClass parent_class;
	void (*create) (DVBdatabasesqliteSqliteDatabase* self, GError** error);
	void (*upgrade) (DVBdatabasesqliteSqliteDatabase* self, gint old_version, gint new_version, GError** error);
	void (*on_open) (DVBdatabasesqliteSqliteDatabase* self);
};

struct _DVBdatabasesqliteSqliteDatabasePrivate {
	GFile* _database_file;
	gint new_version;
};

static gint DVBdatabasesqliteSqliteDatabase_private_offset;
static gpointer dvb_database_sqlite_sqlite_database_parent_class = NULL;
static DVBLoggingLogger* dvb_database_sqlite_sqlite_database_log;
static DVBLoggingLogger* dvb_database_sqlite_sqlite_database_log = NULL;

VALA_EXTERN GType dvb_database_sqlite_sqlite_database_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabasesqliteSqliteDatabase, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void dvb_database_sqlite_sqlite_database_create (DVBdatabasesqliteSqliteDatabase* self,
                                                 GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_upgrade (DVBdatabasesqliteSqliteDatabase* self,
                                                  gint old_version,
                                                  gint new_version,
                                                  GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_on_open (DVBdatabasesqliteSqliteDatabase* self);
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBdatabasesqliteSqliteDatabase* dvb_database_sqlite_sqlite_database_construct (GType object_type,
                                                                                GFile* dbfile,
                                                                                gint version);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_open (DVBdatabasesqliteSqliteDatabase* self,
                                               GError** error);
VALA_EXTERN GFile* dvb_database_sqlite_sqlite_database_get_database_file (DVBdatabasesqliteSqliteDatabase* self);
VALA_EXTERN void dvb_utils_mkdirs (GFile* directory,
                       GError** error);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_database_sqlite_sqlite_database_throw_last_error (DVBdatabasesqliteSqliteDatabase* self,
                                                           const gchar* errmsg,
                                                           GError** error);
VALA_EXTERN gint dvb_database_sqlite_sqlite_database_get_version (DVBdatabasesqliteSqliteDatabase* self);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_database_sqlite_sqlite_database_set_version (DVBdatabasesqliteSqliteDatabase* self,
                                                      gint version);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_set_journal_mode (DVBdatabasesqliteSqliteDatabase* self);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_exec_sql (DVBdatabasesqliteSqliteDatabase* self,
                                                   const gchar* sql,
                                                   GError** error);
VALA_EXTERN gint dvb_database_sqlite_sqlite_database_simple_query_int (DVBdatabasesqliteSqliteDatabase* self,
                                                           const gchar* sql,
                                                           GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_begin_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                            GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_end_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                          GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_throw_last_error_reset (DVBdatabasesqliteSqliteDatabase* self,
                                                                 sqlite3_stmt* stmnt,
                                                                 GError** error);
static void dvb_database_sqlite_sqlite_database_real_create (DVBdatabasesqliteSqliteDatabase* self,
                                                      GError** error);
static void dvb_database_sqlite_sqlite_database_real_upgrade (DVBdatabasesqliteSqliteDatabase* self,
                                                       gint old_version,
                                                       gint new_version,
                                                       GError** error);
static void dvb_database_sqlite_sqlite_database_real_on_open (DVBdatabasesqliteSqliteDatabase* self);
static void dvb_database_sqlite_sqlite_database_set_database_file (DVBdatabasesqliteSqliteDatabase* self,
                                                            GFile* value);
static void dvb_database_sqlite_sqlite_database_finalize (GObject * obj);
static GType dvb_database_sqlite_sqlite_database_get_type_once (void);
static void _vala_dvb_database_sqlite_sqlite_database_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec);
static void _vala_dvb_database_sqlite_sqlite_database_set_property (GObject * object,
                                                             guint property_id,
                                                             const GValue * value,
                                                             GParamSpec * pspec);

static inline gpointer
dvb_database_sqlite_sqlite_database_get_instance_private (DVBdatabasesqliteSqliteDatabase* self)
{
	return G_STRUCT_MEMBER_P (self, DVBdatabasesqliteSqliteDatabase_private_offset);
}

DVBdatabasesqliteSqliteDatabase*
dvb_database_sqlite_sqlite_database_construct (GType object_type,
                                               GFile* dbfile,
                                               gint version)
{
	DVBdatabasesqliteSqliteDatabase * self = NULL;
	g_return_val_if_fail (dbfile != NULL, NULL);
	self = (DVBdatabasesqliteSqliteDatabase*) g_object_new (object_type, "database-file", dbfile, NULL);
	self->priv->new_version = version;
	return self;
}

/**
         * Open database and create or upgrade tables if neccessary
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
dvb_database_sqlite_sqlite_database_open (DVBdatabasesqliteSqliteDatabase* self,
                                          GError** error)
{
	sqlite3* _tmp0_;
	GFile* dbfile = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean create_tables = FALSE;
	GFile* _tmp3_;
	GFile* dbfile_dir = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	sqlite3* _tmp14_ = NULL;
	gint _tmp15_;
	gboolean _tmp16_;
	gint version = 0;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->db;
	if (_tmp0_ != NULL) {
		return;
	}
	_tmp1_ = self->priv->_database_file;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	dbfile = _tmp2_;
	_tmp3_ = dbfile;
	create_tables = !g_file_query_exists (_tmp3_, NULL);
	_tmp4_ = dbfile;
	_tmp5_ = g_file_get_parent (_tmp4_);
	dbfile_dir = _tmp5_;
	_tmp6_ = dbfile_dir;
	if (!g_file_query_exists (_tmp6_, NULL)) {
		{
			GFile* _tmp7_;
			_tmp7_ = dbfile_dir;
			dvb_utils_mkdirs (_tmp7_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = dvb_database_sqlite_sqlite_database_log;
			_tmp9_ = e;
			_tmp10_ = _tmp9_->message;
			dvb_logging_logger_error (_tmp8_, "SqliteDatabase.vala:54: Could not create directory: %s", _tmp10_);
			_g_error_free0 (e);
			_g_object_unref0 (dbfile_dir);
			_g_object_unref0 (dbfile);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				return;
			} else {
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp11_ = dbfile;
	_tmp12_ = g_file_get_path (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp15_ = sqlite3_open (_tmp13_, &_tmp14_);
	_sqlite3_close0 (self->db);
	self->db = _tmp14_;
	_tmp16_ = _tmp15_ != SQLITE_OK;
	_g_free0 (_tmp13_);
	if (_tmp16_) {
		dvb_database_sqlite_sqlite_database_throw_last_error (self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				return;
			} else {
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	version = dvb_database_sqlite_sqlite_database_get_version (self);
	if (create_tables) {
		DVBLoggingLogger* _tmp17_;
		_tmp17_ = dvb_database_sqlite_sqlite_database_log;
		dvb_logging_logger_debug (_tmp17_, "SqliteDatabase.vala:66: Creating tables");
		dvb_database_sqlite_sqlite_database_create (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				return;
			} else {
				_g_object_unref0 (dbfile_dir);
				_g_object_unref0 (dbfile);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	} else {
		if (self->priv->new_version > version) {
			DVBLoggingLogger* _tmp18_;
			_tmp18_ = dvb_database_sqlite_sqlite_database_log;
			dvb_logging_logger_debug (_tmp18_, "SqliteDatabase.vala:69: Updating tables");
			dvb_database_sqlite_sqlite_database_upgrade (self, version, self->priv->new_version, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (dbfile_dir);
					_g_object_unref0 (dbfile);
					return;
				} else {
					_g_object_unref0 (dbfile_dir);
					_g_object_unref0 (dbfile);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
	}
	dvb_database_sqlite_sqlite_database_set_version (self, self->priv->new_version);
	dvb_database_sqlite_sqlite_database_set_journal_mode (self);
	dvb_database_sqlite_sqlite_database_on_open (self);
	_g_object_unref0 (dbfile_dir);
	_g_object_unref0 (dbfile);
}

/**
         * Set database version
         */
void
dvb_database_sqlite_sqlite_database_set_version (DVBdatabasesqliteSqliteDatabase* self,
                                                 gint version)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = g_strdup_printf ("PRAGMA user_version = %d", version);
		_tmp1_ = _tmp0_;
		dvb_database_sqlite_sqlite_database_exec_sql (self, _tmp1_, &_inner_error0_);
		_g_free0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = dvb_database_sqlite_sqlite_database_log;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		dvb_logging_logger_error (_tmp2_, "SqliteDatabase.vala:85: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
dvb_database_sqlite_sqlite_database_set_journal_mode (DVBdatabasesqliteSqliteDatabase* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		dvb_database_sqlite_sqlite_database_exec_sql (self, "PRAGMA journal_mode = TRUNCATE", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = dvb_database_sqlite_sqlite_database_log;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		dvb_logging_logger_error (_tmp0_, "SqliteDatabase.vala:93: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
         * Get database version
         */
gint
dvb_database_sqlite_sqlite_database_get_version (DVBdatabasesqliteSqliteDatabase* self)
{
	gint version = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	version = 0;
	{
		gint _tmp0_ = 0;
		_tmp0_ = dvb_database_sqlite_sqlite_database_simple_query_int (self, "PRAGMA user_version", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp1_ = -1;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		version = _tmp0_;
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = dvb_database_sqlite_sqlite_database_log;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		dvb_logging_logger_error (_tmp2_, "SqliteDatabase.vala:105: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp5_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = version;
	return result;
}

gint
dvb_database_sqlite_sqlite_database_simple_query_int (DVBdatabasesqliteSqliteDatabase* self,
                                                      const gchar* sql,
                                                      GError** error)
{
	sqlite3_stmt* st = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint ret = 0;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp0_ = self->db;
	sqlite3_prepare (_tmp0_, sql, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (st);
	st = _tmp1_;
	ret = 0;
	_tmp2_ = st;
	if (sqlite3_step (_tmp2_) == SQLITE_ROW) {
		sqlite3_stmt* _tmp3_;
		_tmp3_ = st;
		ret = sqlite3_column_int (_tmp3_, 0);
	} else {
		dvb_database_sqlite_sqlite_database_throw_last_error (self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gint _tmp4_ = -1;
				g_propagate_error (error, _inner_error0_);
				_sqlite3_finalize0 (st);
				return _tmp4_;
			} else {
				gint _tmp5_ = -1;
				_sqlite3_finalize0 (st);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp5_;
			}
		}
	}
	result = ret;
	_sqlite3_finalize0 (st);
	return result;
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
	sqlite_errmsg = _tmp0_;
	ec = _tmp1_;
	if ((&_vala_errmsg) != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = sqlite_errmsg;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_vala_errmsg);
		_vala_errmsg = _tmp3_;
	} else {
		_g_free0 (_vala_errmsg);
		_vala_errmsg = NULL;
	}
	_tmp4_ = sqlite_errmsg;
	sqlite3_free ((void*) _tmp4_);
	result = ec;
	if (errmsg) {
		*errmsg = _vala_errmsg;
	} else {
		_g_free0 (_vala_errmsg);
	}
	return result;
}

void
dvb_database_sqlite_sqlite_database_exec_sql (DVBdatabasesqliteSqliteDatabase* self,
                                              const gchar* sql,
                                              GError** error)
{
	gchar* errmsg = NULL;
	gint val = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sql != NULL);
	_tmp0_ = self->db;
	_tmp2_ = _sqlite3_exec (_tmp0_, sql, NULL, NULL, &_tmp1_);
	_g_free0 (errmsg);
	errmsg = _tmp1_;
	val = _tmp2_;
	if (val != SQLITE_OK) {
		dvb_database_sqlite_sqlite_database_throw_last_error (self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (errmsg);
				return;
			} else {
				_g_free0 (errmsg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_g_free0 (errmsg);
}

void
dvb_database_sqlite_sqlite_database_begin_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                       GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	dvb_database_sqlite_sqlite_database_exec_sql (self, "BEGIN;", &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_database_sqlite_sqlite_database_end_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                     GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	dvb_database_sqlite_sqlite_database_exec_sql (self, "END;", &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_database_sqlite_sqlite_database_throw_last_error_reset (DVBdatabasesqliteSqliteDatabase* self,
                                                            sqlite3_stmt* stmnt,
                                                            GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (stmnt != NULL);
	sqlite3_reset (stmnt);
	dvb_database_sqlite_sqlite_database_throw_last_error (self, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_database_sqlite_sqlite_database_throw_last_error (DVBdatabasesqliteSqliteDatabase* self,
                                                      const gchar* errmsg,
                                                      GError** error)
{
	gint code = 0;
	sqlite3* _tmp0_;
	gchar* msg = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->db;
	code = sqlite3_errcode (_tmp0_);
	if (errmsg == NULL) {
		sqlite3* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->db;
		_tmp2_ = sqlite3_errmsg (_tmp1_);
		_tmp3_ = g_strdup_printf ("SqlError: %d: %s", code, _tmp2_);
		_g_free0 (msg);
		msg = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (errmsg);
		_g_free0 (msg);
		msg = _tmp4_;
	}
	switch (code) {
		case 1:
		{
			const gchar* _tmp5_;
			GError* _tmp6_;
			_tmp5_ = msg;
			_tmp6_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_ERROR, _tmp5_);
			_inner_error0_ = _tmp6_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 2:
		{
			const gchar* _tmp7_;
			GError* _tmp8_;
			_tmp7_ = msg;
			_tmp8_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_INTERNAL, _tmp7_);
			_inner_error0_ = _tmp8_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 3:
		{
			const gchar* _tmp9_;
			GError* _tmp10_;
			_tmp9_ = msg;
			_tmp10_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_PERM, _tmp9_);
			_inner_error0_ = _tmp10_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 4:
		{
			const gchar* _tmp11_;
			GError* _tmp12_;
			_tmp11_ = msg;
			_tmp12_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_ABORT, _tmp11_);
			_inner_error0_ = _tmp12_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 5:
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
			_tmp13_ = msg;
			_tmp14_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_BUSY, _tmp13_);
			_inner_error0_ = _tmp14_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 6:
		{
			const gchar* _tmp15_;
			GError* _tmp16_;
			_tmp15_ = msg;
			_tmp16_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_LOCKED, _tmp15_);
			_inner_error0_ = _tmp16_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 7:
		{
			const gchar* _tmp17_;
			GError* _tmp18_;
			_tmp17_ = msg;
			_tmp18_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_NOMEM, _tmp17_);
			_inner_error0_ = _tmp18_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 8:
		{
			const gchar* _tmp19_;
			GError* _tmp20_;
			_tmp19_ = msg;
			_tmp20_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_READONLY, _tmp19_);
			_inner_error0_ = _tmp20_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 9:
		{
			const gchar* _tmp21_;
			GError* _tmp22_;
			_tmp21_ = msg;
			_tmp22_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_INTERRUPT, _tmp21_);
			_inner_error0_ = _tmp22_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 10:
		{
			const gchar* _tmp23_;
			GError* _tmp24_;
			_tmp23_ = msg;
			_tmp24_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_IOERR, _tmp23_);
			_inner_error0_ = _tmp24_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 11:
		{
			const gchar* _tmp25_;
			GError* _tmp26_;
			_tmp25_ = msg;
			_tmp26_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_CORRUPT, _tmp25_);
			_inner_error0_ = _tmp26_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 12:
		{
			const gchar* _tmp27_;
			GError* _tmp28_;
			_tmp27_ = msg;
			_tmp28_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_NOTFOUND, _tmp27_);
			_inner_error0_ = _tmp28_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 13:
		{
			const gchar* _tmp29_;
			GError* _tmp30_;
			_tmp29_ = msg;
			_tmp30_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_FULL, _tmp29_);
			_inner_error0_ = _tmp30_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 14:
		{
			const gchar* _tmp31_;
			GError* _tmp32_;
			_tmp31_ = msg;
			_tmp32_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_CANTOPEN, _tmp31_);
			_inner_error0_ = _tmp32_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 15:
		{
			const gchar* _tmp33_;
			GError* _tmp34_;
			_tmp33_ = msg;
			_tmp34_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_PROTOCOL, _tmp33_);
			_inner_error0_ = _tmp34_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 16:
		{
			const gchar* _tmp35_;
			GError* _tmp36_;
			_tmp35_ = msg;
			_tmp36_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_EMPTY, _tmp35_);
			_inner_error0_ = _tmp36_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 17:
		{
			const gchar* _tmp37_;
			GError* _tmp38_;
			_tmp37_ = msg;
			_tmp38_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_SCHEMA, _tmp37_);
			_inner_error0_ = _tmp38_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 18:
		{
			const gchar* _tmp39_;
			GError* _tmp40_;
			_tmp39_ = msg;
			_tmp40_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_TOOBIG, _tmp39_);
			_inner_error0_ = _tmp40_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 19:
		{
			const gchar* _tmp41_;
			GError* _tmp42_;
			_tmp41_ = msg;
			_tmp42_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_CONSTRAINT, _tmp41_);
			_inner_error0_ = _tmp42_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 20:
		{
			const gchar* _tmp43_;
			GError* _tmp44_;
			_tmp43_ = msg;
			_tmp44_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_MISMATCH, _tmp43_);
			_inner_error0_ = _tmp44_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 21:
		{
			const gchar* _tmp45_;
			GError* _tmp46_;
			_tmp45_ = msg;
			_tmp46_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_MISUSE, _tmp45_);
			_inner_error0_ = _tmp46_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 22:
		{
			const gchar* _tmp47_;
			GError* _tmp48_;
			_tmp47_ = msg;
			_tmp48_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_NOLFS, _tmp47_);
			_inner_error0_ = _tmp48_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 23:
		{
			const gchar* _tmp49_;
			GError* _tmp50_;
			_tmp49_ = msg;
			_tmp50_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_AUTH, _tmp49_);
			_inner_error0_ = _tmp50_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 24:
		{
			const gchar* _tmp51_;
			GError* _tmp52_;
			_tmp51_ = msg;
			_tmp52_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_FORMAT, _tmp51_);
			_inner_error0_ = _tmp52_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 25:
		{
			const gchar* _tmp53_;
			GError* _tmp54_;
			_tmp53_ = msg;
			_tmp54_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_RANGE, _tmp53_);
			_inner_error0_ = _tmp54_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		case 26:
		{
			const gchar* _tmp55_;
			GError* _tmp56_;
			_tmp55_ = msg;
			_tmp56_ = g_error_new_literal (DVB_DATABASE_SQL_ERROR, DVB_DATABASE_SQL_ERROR_NOTADB, _tmp55_);
			_inner_error0_ = _tmp56_;
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		default:
		{
			break;
		}
	}
	_g_free0 (msg);
}

/**
         * Called when the database is created for the first time.
         * Put the commands required to create all tables here.
         */
static void
dvb_database_sqlite_sqlite_database_real_create (DVBdatabasesqliteSqliteDatabase* self,
                                                 GError** error)
{
	g_critical ("Type `%s' does not implement abstract method `dvb_database_sqlite_sqlite_database_create'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
dvb_database_sqlite_sqlite_database_create (DVBdatabasesqliteSqliteDatabase* self,
                                            GError** error)
{
	DVBdatabasesqliteSqliteDatabaseClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS (self);
	if (_klass_->create) {
		_klass_->create (self, error);
	}
}

/**
         * Called when the database needs to be upgraded.
         */
static void
dvb_database_sqlite_sqlite_database_real_upgrade (DVBdatabasesqliteSqliteDatabase* self,
                                                  gint old_version,
                                                  gint new_version,
                                                  GError** error)
{
	g_critical ("Type `%s' does not implement abstract method `dvb_database_sqlite_sqlite_database_upgrade'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
dvb_database_sqlite_sqlite_database_upgrade (DVBdatabasesqliteSqliteDatabase* self,
                                             gint old_version,
                                             gint new_version,
                                             GError** error)
{
	DVBdatabasesqliteSqliteDatabaseClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS (self);
	if (_klass_->upgrade) {
		_klass_->upgrade (self, old_version, new_version, error);
	}
}

/**
          * Called when the database has been opened.
          */
static void
dvb_database_sqlite_sqlite_database_real_on_open (DVBdatabasesqliteSqliteDatabase* self)
{
	g_critical ("Type `%s' does not implement abstract method `dvb_database_sqlite_sqlite_database_on_open'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
dvb_database_sqlite_sqlite_database_on_open (DVBdatabasesqliteSqliteDatabase* self)
{
	DVBdatabasesqliteSqliteDatabaseClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS (self);
	if (_klass_->on_open) {
		_klass_->on_open (self);
	}
}

GFile*
dvb_database_sqlite_sqlite_database_get_database_file (DVBdatabasesqliteSqliteDatabase* self)
{
	GFile* result;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_database_file;
	result = _tmp0_;
	return result;
}

static void
dvb_database_sqlite_sqlite_database_set_database_file (DVBdatabasesqliteSqliteDatabase* self,
                                                       GFile* value)
{
	GFile* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_database_sqlite_sqlite_database_get_database_file (self);
	if (old_value != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_database_file);
		self->priv->_database_file = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_database_sqlite_sqlite_database_properties[DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY]);
	}
}

static void
dvb_database_sqlite_sqlite_database_class_init (DVBdatabasesqliteSqliteDatabaseClass * klass,
                                                gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_database_sqlite_sqlite_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBdatabasesqliteSqliteDatabase_private_offset);
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->create = (void (*) (DVBdatabasesqliteSqliteDatabase*, GError**)) dvb_database_sqlite_sqlite_database_real_create;
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->upgrade = (void (*) (DVBdatabasesqliteSqliteDatabase*, gint, gint, GError**)) dvb_database_sqlite_sqlite_database_real_upgrade;
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->on_open = (void (*) (DVBdatabasesqliteSqliteDatabase*)) dvb_database_sqlite_sqlite_database_real_on_open;
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_database_sqlite_sqlite_database_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_database_sqlite_sqlite_database_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_database_sqlite_sqlite_database_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY, dvb_database_sqlite_sqlite_database_properties[DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY] = g_param_spec_object ("database-file", "database-file", "database-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_database_sqlite_sqlite_database_log = _tmp1_;
}

static void
dvb_database_sqlite_sqlite_database_instance_init (DVBdatabasesqliteSqliteDatabase * self,
                                                   gpointer klass)
{
	self->priv = dvb_database_sqlite_sqlite_database_get_instance_private (self);
}

static void
dvb_database_sqlite_sqlite_database_finalize (GObject * obj)
{
	DVBdatabasesqliteSqliteDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase);
	_g_object_unref0 (self->priv->_database_file);
	_sqlite3_close0 (self->db);
	G_OBJECT_CLASS (dvb_database_sqlite_sqlite_database_parent_class)->finalize (obj);
}

static GType
dvb_database_sqlite_sqlite_database_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBdatabasesqliteSqliteDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_database_sqlite_sqlite_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBdatabasesqliteSqliteDatabase), 0, (GInstanceInitFunc) dvb_database_sqlite_sqlite_database_instance_init, NULL };
	GType dvb_database_sqlite_sqlite_database_type_id;
	dvb_database_sqlite_sqlite_database_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBdatabasesqliteSqliteDatabase", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	DVBdatabasesqliteSqliteDatabase_private_offset = g_type_add_instance_private (dvb_database_sqlite_sqlite_database_type_id, sizeof (DVBdatabasesqliteSqliteDatabasePrivate));
	return dvb_database_sqlite_sqlite_database_type_id;
}

GType
dvb_database_sqlite_sqlite_database_get_type (void)
{
	static volatile gsize dvb_database_sqlite_sqlite_database_type_id__once = 0;
	if (g_once_init_enter (&dvb_database_sqlite_sqlite_database_type_id__once)) {
		GType dvb_database_sqlite_sqlite_database_type_id;
		dvb_database_sqlite_sqlite_database_type_id = dvb_database_sqlite_sqlite_database_get_type_once ();
		g_once_init_leave (&dvb_database_sqlite_sqlite_database_type_id__once, dvb_database_sqlite_sqlite_database_type_id);
	}
	return dvb_database_sqlite_sqlite_database_type_id__once;
}

static void
_vala_dvb_database_sqlite_sqlite_database_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec)
{
	DVBdatabasesqliteSqliteDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase);
	switch (property_id) {
		case DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY:
		g_value_set_object (value, dvb_database_sqlite_sqlite_database_get_database_file (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_database_sqlite_sqlite_database_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec)
{
	DVBdatabasesqliteSqliteDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase);
	switch (property_id) {
		case DVB_DATABASE_SQLITE_SQLITE_DATABASE_DATABASE_FILE_PROPERTY:
		dvb_database_sqlite_sqlite_database_set_database_file (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

