/* IDBusManager.c generated by valac 0.56.18, the Vala compiler
 * generated from IDBusManager.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_CHANNEL_GROUP_INFO (dvb_channel_group_info_get_type ())
typedef struct _DVBChannelGroupInfo DVBChannelGroupInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_ADAPTER_INFO (dvb_adapter_info_get_type ())
typedef struct _DVBAdapterInfo DVBAdapterInfo;

#define DVB_TYPE_ID_BUS_MANAGER (dvb_id_bus_manager_get_type ())
#define DVB_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManager))
#define DVB_IS_ID_BUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_MANAGER))
#define DVB_ID_BUS_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_MANAGER, DVBIDBusManagerIface))

typedef struct _DVBIDBusManager DVBIDBusManager;
typedef struct _DVBIDBusManagerIface DVBIDBusManagerIface;

#define DVB_TYPE_ID_BUS_MANAGER_PROXY (dvb_id_bus_manager_proxy_get_type ())
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())
enum  {
	DVB_ID_BUS_MANAGER_GROUP_ADDED_SIGNAL,
	DVB_ID_BUS_MANAGER_GROUP_REMOVED_SIGNAL,
	DVB_ID_BUS_MANAGER_NUM_SIGNALS
};
static guint dvb_id_bus_manager_signals[DVB_ID_BUS_MANAGER_NUM_SIGNALS] = {0};
typedef GDBusProxy DVBIDBusManagerProxy;
typedef GDBusProxyClass DVBIDBusManagerProxyClass;

struct _DVBChannelGroupInfo {
	gint id;
	gchar* name;
};

struct _DVBAdapterInfo {
	gchar* name;
	gboolean type_t;
	gboolean type_s;
	gboolean type_c;
};

struct _DVBIDBusManagerIface {
	GTypeInterface parent_iface;
	gboolean (*GetScannerForDevice) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, char** opath, gchar** dbusiface, GError** error);
	char** (*GetRegisteredDeviceGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetDeviceGroup) (DVBIDBusManager* self, guint group_id, char** opath, GError** error);
	gboolean (*AddDeviceToNewGroup) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterType type, const gchar* channels_conf, const gchar* recordings_dir, const gchar* name, GError** error);
	gboolean (*GetNameOfRegisteredDevice) (DVBIDBusManager* self, guint adapter, guint frontend, gchar** name, GError** error);
	gint (*GetDeviceGroupSize) (DVBIDBusManager* self, GError** error);
	DVBChannelGroupInfo* (*GetChannelGroups) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*AddChannelGroup) (DVBIDBusManager* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*RemoveChannelGroup) (DVBIDBusManager* self, gint channel_group_id, GError** error);
	GHashTable** (*GetDevices) (DVBIDBusManager* self, gint* result_length1, GError** error);
	gboolean (*GetAdapterInfo) (DVBIDBusManager* self, guint adapter, guint frontend, DVBAdapterInfo* info, GError** error);
};

VALA_EXTERN GType dvb_channel_group_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBChannelGroupInfo* dvb_channel_group_info_dup (const DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_free (DVBChannelGroupInfo* self);
VALA_EXTERN void dvb_channel_group_info_copy (const DVBChannelGroupInfo* self,
                                  DVBChannelGroupInfo* dest);
VALA_EXTERN void dvb_channel_group_info_destroy (DVBChannelGroupInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBChannelGroupInfo, dvb_channel_group_info_destroy)
VALA_EXTERN GType dvb_adapter_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBAdapterInfo* dvb_adapter_info_dup (const DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_free (DVBAdapterInfo* self);
VALA_EXTERN void dvb_adapter_info_copy (const DVBAdapterInfo* self,
                            DVBAdapterInfo* dest);
VALA_EXTERN void dvb_adapter_info_destroy (DVBAdapterInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBAdapterInfo, dvb_adapter_info_destroy)
VALA_EXTERN GType dvb_id_bus_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_manager_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_id_bus_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusManager, g_object_unref)
VALA_EXTERN gboolean dvb_id_bus_manager_GetScannerForDevice (DVBIDBusManager* self,
                                                 guint adapter,
                                                 guint frontend,
                                                 DVBAdapterType type,
                                                 char** opath,
                                                 gchar** dbusiface,
                                                 GError** error);
VALA_EXTERN char** dvb_id_bus_manager_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                     gint* result_length1,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetDeviceGroup (DVBIDBusManager* self,
                                            guint group_id,
                                            char** opath,
                                            GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_AddDeviceToNewGroup (DVBIDBusManager* self,
                                                 guint adapter,
                                                 guint frontend,
                                                 DVBAdapterType type,
                                                 const gchar* channels_conf,
                                                 const gchar* recordings_dir,
                                                 const gchar* name,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                       guint adapter,
                                                       guint frontend,
                                                       gchar** name,
                                                       GError** error);
VALA_EXTERN gint dvb_id_bus_manager_GetDeviceGroupSize (DVBIDBusManager* self,
                                            GError** error);
VALA_EXTERN DVBChannelGroupInfo* dvb_id_bus_manager_GetChannelGroups (DVBIDBusManager* self,
                                                          gint* result_length1,
                                                          GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_AddChannelGroup (DVBIDBusManager* self,
                                             const gchar* name,
                                             gint* channel_group_id,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_RemoveChannelGroup (DVBIDBusManager* self,
                                                gint channel_group_id,
                                                GError** error);
VALA_EXTERN GHashTable** dvb_id_bus_manager_GetDevices (DVBIDBusManager* self,
                                            gint* result_length1,
                                            GError** error);
VALA_EXTERN gboolean dvb_id_bus_manager_GetAdapterInfo (DVBIDBusManager* self,
                                            guint adapter,
                                            guint frontend,
                                            DVBAdapterInfo* info,
                                            GError** error);
static GType dvb_id_bus_manager_get_type_once (void);
static void dvb_id_bus_manager_proxy_g_signal (GDBusProxy* proxy,
                                        const gchar* sender_name,
                                        const gchar* signal_name,
                                        GVariant* parameters);
static void _dbus_handle_dvb_id_bus_manager_group_added (DVBIDBusManager* self,
                                                  GVariant* parameters);
static void _dbus_handle_dvb_id_bus_manager_group_removed (DVBIDBusManager* self,
                                                    GVariant* parameters);
static gboolean dvb_id_bus_manager_proxy_GetScannerForDevice (DVBIDBusManager* self,
                                                       guint adapter,
                                                       guint frontend,
                                                       DVBAdapterType type,
                                                       char** opath,
                                                       gchar** dbusiface,
                                                       GError** error);
static char** dvb_id_bus_manager_proxy_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                           gint* result_length1,
                                                           GError** error);
static gboolean dvb_id_bus_manager_proxy_GetDeviceGroup (DVBIDBusManager* self,
                                                  guint group_id,
                                                  char** opath,
                                                  GError** error);
static gboolean dvb_id_bus_manager_proxy_AddDeviceToNewGroup (DVBIDBusManager* self,
                                                       guint adapter,
                                                       guint frontend,
                                                       DVBAdapterType type,
                                                       const gchar* channels_conf,
                                                       const gchar* recordings_dir,
                                                       const gchar* name,
                                                       GError** error);
static gboolean dvb_id_bus_manager_proxy_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                             guint adapter,
                                                             guint frontend,
                                                             gchar** name,
                                                             GError** error);
static gint dvb_id_bus_manager_proxy_GetDeviceGroupSize (DVBIDBusManager* self,
                                                  GError** error);
static DVBChannelGroupInfo* dvb_id_bus_manager_proxy_GetChannelGroups (DVBIDBusManager* self,
                                                                gint* result_length1,
                                                                GError** error);
static gboolean dvb_id_bus_manager_proxy_AddChannelGroup (DVBIDBusManager* self,
                                                   const gchar* name,
                                                   gint* channel_group_id,
                                                   GError** error);
static gboolean dvb_id_bus_manager_proxy_RemoveChannelGroup (DVBIDBusManager* self,
                                                      gint channel_group_id,
                                                      GError** error);
static GHashTable** dvb_id_bus_manager_proxy_GetDevices (DVBIDBusManager* self,
                                                  gint* result_length1,
                                                  GError** error);
static gboolean dvb_id_bus_manager_proxy_GetAdapterInfo (DVBIDBusManager* self,
                                                  guint adapter,
                                                  guint frontend,
                                                  DVBAdapterInfo* info,
                                                  GError** error);
static void dvb_id_bus_manager_proxy_dvb_id_bus_manager_interface_init (DVBIDBusManagerIface* iface);
static void _dbus_dvb_id_bus_manager_GetScannerForDevice (DVBIDBusManager* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetDeviceGroup (DVBIDBusManager* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_AddDeviceToNewGroup (DVBIDBusManager* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetDeviceGroupSize (DVBIDBusManager* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _vala_DVBChannelGroupInfo_array_free (DVBChannelGroupInfo * array,
                                           gssize array_length);
static void _dbus_dvb_id_bus_manager_GetChannelGroups (DVBIDBusManager* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_AddChannelGroup (DVBIDBusManager* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_RemoveChannelGroup (DVBIDBusManager* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetDevices (DVBIDBusManager* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_manager_GetAdapterInfo (DVBIDBusManager* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void dvb_id_bus_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* method_name,
                                                    GVariant* parameters,
                                                    GDBusMethodInvocation* invocation,
                                                    gpointer user_data);
static GVariant* dvb_id_bus_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data);
static gboolean dvb_id_bus_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GVariant* value,
                                                         GError** error,
                                                         gpointer user_data);
static void _dbus_dvb_id_bus_manager_group_added (GObject* _sender,
                                           guint group_id,
                                           gpointer* _data);
static void _dbus_dvb_id_bus_manager_group_removed (GObject* _sender,
                                             guint group_id,
                                             gpointer* _data);
static void _dvb_id_bus_manager_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_adapter = {-1, "adapter", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_frontend = {-1, "frontend", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_type = {-1, "type", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_opath = {-1, "opath", "o", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_dbusiface = {-1, "dbusiface", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_in[] = {&_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_adapter, &_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_frontend, &_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_type, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_opath, &_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_dbusiface, &_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetScannerForDevice = {-1, "GetScannerForDevice", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetScannerForDevice_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_result = {-1, "result", "ao", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetRegisteredDeviceGroups = {-1, "GetRegisteredDeviceGroups", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetRegisteredDeviceGroups_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_group_id = {-1, "group_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_opath = {-1, "opath", "o", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_in[] = {&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_group_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_opath, &_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetDeviceGroup = {-1, "GetDeviceGroup", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroup_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_adapter = {-1, "adapter", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_frontend = {-1, "frontend", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_type = {-1, "type", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_channels_conf = {-1, "channels_conf", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_recordings_dir = {-1, "recordings_dir", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_in[] = {&_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_adapter, &_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_frontend, &_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_type, &_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_channels_conf, &_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_recordings_dir, &_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_name, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_out[] = {&_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_AddDeviceToNewGroup = {-1, "AddDeviceToNewGroup", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_AddDeviceToNewGroup_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_adapter = {-1, "adapter", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_frontend = {-1, "frontend", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_in[] = {&_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_adapter, &_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_frontend, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_name, &_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetNameOfRegisteredDevice = {-1, "GetNameOfRegisteredDevice", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetNameOfRegisteredDevice_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_result = {-1, "result", "i", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetDeviceGroupSize = {-1, "GetDeviceGroupSize", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDeviceGroupSize_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_result = {-1, "result", "a(is)", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetChannelGroups = {-1, "GetChannelGroups", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetChannelGroups_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_channel_group_id = {-1, "channel_group_id", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_in[] = {&_dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_name, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_out[] = {&_dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_channel_group_id, &_dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_AddChannelGroup = {-1, "AddChannelGroup", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_AddChannelGroup_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_channel_group_id = {-1, "channel_group_id", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_in[] = {&_dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_channel_group_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_out[] = {&_dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_RemoveChannelGroup = {-1, "RemoveChannelGroup", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_RemoveChannelGroup_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetDevices_result = {-1, "result", "aa{ss}", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDevices_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetDevices_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetDevices_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetDevices = {-1, "GetDevices", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDevices_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetDevices_out), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_adapter = {-1, "adapter", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_frontend = {-1, "frontend", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_info = {-1, "info", "(sbbb)", NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_in[] = {&_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_adapter, &_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_frontend, NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_out[] = {&_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_info, &_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_manager_dbus_method_info_GetAdapterInfo = {-1, "GetAdapterInfo", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_in), (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_GetAdapterInfo_out), NULL};
static const GDBusMethodInfo * const _dvb_id_bus_manager_dbus_method_info[] = {&_dvb_id_bus_manager_dbus_method_info_GetScannerForDevice, &_dvb_id_bus_manager_dbus_method_info_GetRegisteredDeviceGroups, &_dvb_id_bus_manager_dbus_method_info_GetDeviceGroup, &_dvb_id_bus_manager_dbus_method_info_AddDeviceToNewGroup, &_dvb_id_bus_manager_dbus_method_info_GetNameOfRegisteredDevice, &_dvb_id_bus_manager_dbus_method_info_GetDeviceGroupSize, &_dvb_id_bus_manager_dbus_method_info_GetChannelGroups, &_dvb_id_bus_manager_dbus_method_info_AddChannelGroup, &_dvb_id_bus_manager_dbus_method_info_RemoveChannelGroup, &_dvb_id_bus_manager_dbus_method_info_GetDevices, &_dvb_id_bus_manager_dbus_method_info_GetAdapterInfo, NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_group_added_group_id = {-1, "group_id", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_group_added[] = {&_dvb_id_bus_manager_dbus_arg_info_group_added_group_id, NULL};
static const GDBusSignalInfo _dvb_id_bus_manager_dbus_signal_info_group_added = {-1, "GroupAdded", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_group_added), NULL};
static const GDBusArgInfo _dvb_id_bus_manager_dbus_arg_info_group_removed_group_id = {-1, "group_id", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_manager_dbus_arg_info_group_removed[] = {&_dvb_id_bus_manager_dbus_arg_info_group_removed_group_id, NULL};
static const GDBusSignalInfo _dvb_id_bus_manager_dbus_signal_info_group_removed = {-1, "GroupRemoved", (GDBusArgInfo **) (&_dvb_id_bus_manager_dbus_arg_info_group_removed), NULL};
static const GDBusSignalInfo * const _dvb_id_bus_manager_dbus_signal_info[] = {&_dvb_id_bus_manager_dbus_signal_info_group_added, &_dvb_id_bus_manager_dbus_signal_info_group_removed, NULL};
static const GDBusPropertyInfo * const _dvb_id_bus_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dvb_id_bus_manager_dbus_interface_info = {-1, "org.gnome.DVB.Manager", (GDBusMethodInfo **) (&_dvb_id_bus_manager_dbus_method_info), (GDBusSignalInfo **) (&_dvb_id_bus_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_dvb_id_bus_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _dvb_id_bus_manager_dbus_interface_vtable = {dvb_id_bus_manager_dbus_interface_method_call, dvb_id_bus_manager_dbus_interface_get_property, dvb_id_bus_manager_dbus_interface_set_property};

void
dvb_channel_group_info_copy (const DVBChannelGroupInfo* self,
                             DVBChannelGroupInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	(*dest).id = (*self).id;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
}

void
dvb_channel_group_info_destroy (DVBChannelGroupInfo* self)
{
	_g_free0 ((*self).name);
}

DVBChannelGroupInfo*
dvb_channel_group_info_dup (const DVBChannelGroupInfo* self)
{
	DVBChannelGroupInfo* dup;
	dup = g_new0 (DVBChannelGroupInfo, 1);
	dvb_channel_group_info_copy (self, dup);
	return dup;
}

void
dvb_channel_group_info_free (DVBChannelGroupInfo* self)
{
	dvb_channel_group_info_destroy (self);
	g_free (self);
}

static GType
dvb_channel_group_info_get_type_once (void)
{
	GType dvb_channel_group_info_type_id;
	dvb_channel_group_info_type_id = g_boxed_type_register_static ("DVBChannelGroupInfo", (GBoxedCopyFunc) dvb_channel_group_info_dup, (GBoxedFreeFunc) dvb_channel_group_info_free);
	return dvb_channel_group_info_type_id;
}

GType
dvb_channel_group_info_get_type (void)
{
	static volatile gsize dvb_channel_group_info_type_id__once = 0;
	if (g_once_init_enter (&dvb_channel_group_info_type_id__once)) {
		GType dvb_channel_group_info_type_id;
		dvb_channel_group_info_type_id = dvb_channel_group_info_get_type_once ();
		g_once_init_leave (&dvb_channel_group_info_type_id__once, dvb_channel_group_info_type_id);
	}
	return dvb_channel_group_info_type_id__once;
}

void
dvb_adapter_info_copy (const DVBAdapterInfo* self,
                       DVBAdapterInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	(*dest).type_t = (*self).type_t;
	(*dest).type_s = (*self).type_s;
	(*dest).type_c = (*self).type_c;
}

void
dvb_adapter_info_destroy (DVBAdapterInfo* self)
{
	_g_free0 ((*self).name);
}

DVBAdapterInfo*
dvb_adapter_info_dup (const DVBAdapterInfo* self)
{
	DVBAdapterInfo* dup;
	dup = g_new0 (DVBAdapterInfo, 1);
	dvb_adapter_info_copy (self, dup);
	return dup;
}

void
dvb_adapter_info_free (DVBAdapterInfo* self)
{
	dvb_adapter_info_destroy (self);
	g_free (self);
}

static GType
dvb_adapter_info_get_type_once (void)
{
	GType dvb_adapter_info_type_id;
	dvb_adapter_info_type_id = g_boxed_type_register_static ("DVBAdapterInfo", (GBoxedCopyFunc) dvb_adapter_info_dup, (GBoxedFreeFunc) dvb_adapter_info_free);
	return dvb_adapter_info_type_id;
}

GType
dvb_adapter_info_get_type (void)
{
	static volatile gsize dvb_adapter_info_type_id__once = 0;
	if (g_once_init_enter (&dvb_adapter_info_type_id__once)) {
		GType dvb_adapter_info_type_id;
		dvb_adapter_info_type_id = dvb_adapter_info_get_type_once ();
		g_once_init_leave (&dvb_adapter_info_type_id__once, dvb_adapter_info_type_id);
	}
	return dvb_adapter_info_type_id__once;
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @type: the type
         * @opath: Object path of the scanner service
         * @dbusiface: DBus interface of the scanner service
         * @returns: TRUE on success
         *
         * Get the object path of the channel scanner for this device.
         */
gboolean
dvb_id_bus_manager_GetScannerForDevice (DVBIDBusManager* self,
                                        guint adapter,
                                        guint frontend,
                                        DVBAdapterType type,
                                        char** opath,
                                        gchar** dbusiface,
                                        GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetScannerForDevice) {
		return _iface_->GetScannerForDevice (self, adapter, frontend, type, opath, dbusiface, error);
	}
	return FALSE;
}

/**
         * @returns: Device groups' DBus path
         */
char**
dvb_id_bus_manager_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                              gint* result_length1,
                                              GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetRegisteredDeviceGroups) {
		return _iface_->GetRegisteredDeviceGroups (self, result_length1, error);
	}
	return NULL;
}

/**
         * @group_id: A group ID
         * @opath: Device group's DBus path
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_manager_GetDeviceGroup (DVBIDBusManager* self,
                                   guint group_id,
                                   char** opath,
                                   GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetDeviceGroup) {
		return _iface_->GetDeviceGroup (self, group_id, opath, error);
	}
	return FALSE;
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @type: the type of the group
         * @channels_conf: Path to channels.conf for this device
         * @recordings_dir: Path where the recordings should be stored
         * @name: Name of group
         * @returns: TRUE when the device has been registered successfully
         *
         * Creates a new DeviceGroup and new DVB device whereas the
         * DVB device is the reference device of this group (i.e.
         * all other devices of this group will inherit the settings
         * of the reference device).
         */
gboolean
dvb_id_bus_manager_AddDeviceToNewGroup (DVBIDBusManager* self,
                                        guint adapter,
                                        guint frontend,
                                        DVBAdapterType type,
                                        const gchar* channels_conf,
                                        const gchar* recordings_dir,
                                        const gchar* name,
                                        GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->AddDeviceToNewGroup) {
		return _iface_->AddDeviceToNewGroup (self, adapter, frontend, type, channels_conf, recordings_dir, name, error);
	}
	return FALSE;
}

/**
         * @adapter: Adapter of device
         * @frontend: Frontend of device
         * @name: The name of the device or "Unknown"
         * @returns: TRUE on success
         *
         * The device must be part of group, otherwise "Unknown"
         * is returned.
         */
gboolean
dvb_id_bus_manager_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                              guint adapter,
                                              guint frontend,
                                              gchar** name,
                                              GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetNameOfRegisteredDevice) {
		return _iface_->GetNameOfRegisteredDevice (self, adapter, frontend, name, error);
	}
	return FALSE;
}

/**
         * @returns: the numner of configured device groups
         */
gint
dvb_id_bus_manager_GetDeviceGroupSize (DVBIDBusManager* self,
                                       GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetDeviceGroupSize) {
		return _iface_->GetDeviceGroupSize (self, error);
	}
	return -1;
}

/**
         * @returns: ID and name of each channel group
         */
DVBChannelGroupInfo*
dvb_id_bus_manager_GetChannelGroups (DVBIDBusManager* self,
                                     gint* result_length1,
                                     GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetChannelGroups) {
		return _iface_->GetChannelGroups (self, result_length1, error);
	}
	return NULL;
}

/**
         * @name: Name of the new group
         * @channel_group_id: ID of the ChannelGroup
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_manager_AddChannelGroup (DVBIDBusManager* self,
                                    const gchar* name,
                                    gint* channel_group_id,
                                    GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->AddChannelGroup) {
		return _iface_->AddChannelGroup (self, name, channel_group_id, error);
	}
	return FALSE;
}

/**
         * @channel_group_id: ID of the ChannelGroup
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_manager_RemoveChannelGroup (DVBIDBusManager* self,
                                       gint channel_group_id,
                                       GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->RemoveChannelGroup) {
		return _iface_->RemoveChannelGroup (self, channel_group_id, error);
	}
	return FALSE;
}

/**
         * @returns: informations about all connected
         * devices retrieved via udev
         */
GHashTable**
dvb_id_bus_manager_GetDevices (DVBIDBusManager* self,
                               gint* result_length1,
                               GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetDevices) {
		return _iface_->GetDevices (self, result_length1, error);
	}
	return NULL;
}

/**
         * @info: type and name of adapter
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_manager_GetAdapterInfo (DVBIDBusManager* self,
                                   guint adapter,
                                   guint frontend,
                                   DVBAdapterInfo* info,
                                   GError** error)
{
	DVBIDBusManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_MANAGER_GET_INTERFACE (self);
	if (_iface_->GetAdapterInfo) {
		return _iface_->GetAdapterInfo (self, adapter, frontend, info, error);
	}
	return FALSE;
}

static void
dvb_id_bus_manager_default_init (DVBIDBusManagerIface * iface,
                                 gpointer iface_data)
{
	dvb_id_bus_manager_signals[DVB_ID_BUS_MANAGER_GROUP_ADDED_SIGNAL] = g_signal_new ("group-added", DVB_TYPE_ID_BUS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	dvb_id_bus_manager_signals[DVB_ID_BUS_MANAGER_GROUP_REMOVED_SIGNAL] = g_signal_new ("group-removed", DVB_TYPE_ID_BUS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
}

static GType
dvb_id_bus_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBIDBusManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_id_bus_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_id_bus_manager_type_id;
	dvb_id_bus_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBIDBusManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_id_bus_manager_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (dvb_id_bus_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dvb_id_bus_manager_proxy_get_type);
	g_type_set_qdata (dvb_id_bus_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.DVB.Manager");
	g_type_set_qdata (dvb_id_bus_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_dvb_id_bus_manager_dbus_interface_info));
	g_type_set_qdata (dvb_id_bus_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dvb_id_bus_manager_register_object);
	return dvb_id_bus_manager_type_id;
}

GType
dvb_id_bus_manager_get_type (void)
{
	static volatile gsize dvb_id_bus_manager_type_id__once = 0;
	if (g_once_init_enter (&dvb_id_bus_manager_type_id__once)) {
		GType dvb_id_bus_manager_type_id;
		dvb_id_bus_manager_type_id = dvb_id_bus_manager_get_type_once ();
		g_once_init_leave (&dvb_id_bus_manager_type_id__once, dvb_id_bus_manager_type_id);
	}
	return dvb_id_bus_manager_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DVBIDBusManagerProxy, dvb_id_bus_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DVB_TYPE_ID_BUS_MANAGER, dvb_id_bus_manager_proxy_dvb_id_bus_manager_interface_init) )
static void
dvb_id_bus_manager_proxy_class_init (DVBIDBusManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = dvb_id_bus_manager_proxy_g_signal;
}

static void
_dbus_handle_dvb_id_bus_manager_group_added (DVBIDBusManager* self,
                                             GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint group_id = 0U;
	GVariant* _tmp116_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp116_ = g_variant_iter_next_value (&_arguments_iter);
	group_id = g_variant_get_uint32 (_tmp116_);
	g_variant_unref (_tmp116_);
	g_signal_emit_by_name (self, "group-added", group_id);
}

static void
_dbus_handle_dvb_id_bus_manager_group_removed (DVBIDBusManager* self,
                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint group_id = 0U;
	GVariant* _tmp117_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp117_ = g_variant_iter_next_value (&_arguments_iter);
	group_id = g_variant_get_uint32 (_tmp117_);
	g_variant_unref (_tmp117_);
	g_signal_emit_by_name (self, "group-removed", group_id);
}

static void
dvb_id_bus_manager_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters)
{
	if (strcmp (signal_name, "GroupAdded") == 0) {
		_dbus_handle_dvb_id_bus_manager_group_added ((DVBIDBusManager*) proxy, parameters);
	} else if (strcmp (signal_name, "GroupRemoved") == 0) {
		_dbus_handle_dvb_id_bus_manager_group_removed ((DVBIDBusManager*) proxy, parameters);
	}
}

static void
dvb_id_bus_manager_proxy_init (DVBIDBusManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_dvb_id_bus_manager_dbus_interface_info));
}

static gboolean
dvb_id_bus_manager_proxy_GetScannerForDevice (DVBIDBusManager* self,
                                              guint adapter,
                                              guint frontend,
                                              DVBAdapterType type,
                                              char** opath,
                                              gchar** dbusiface,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	char* _vala_opath = NULL;
	GVariant* _tmp120_;
	gchar* _vala_dbusiface = NULL;
	GVariant* _tmp121_;
	gboolean _result = FALSE;
	GVariant* _tmp122_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetScannerForDevice");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (adapter));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frontend));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp118_ = FALSE;
		return _tmp118_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp119_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp119_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp120_ = g_variant_iter_next_value (&_reply_iter);
	_vala_opath = g_variant_dup_string (_tmp120_, NULL);
	g_variant_unref (_tmp120_);
	*opath = _vala_opath;
	_tmp121_ = g_variant_iter_next_value (&_reply_iter);
	_vala_dbusiface = g_variant_dup_string (_tmp121_, NULL);
	g_variant_unref (_tmp121_);
	*dbusiface = _vala_dbusiface;
	_tmp122_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp122_);
	g_variant_unref (_tmp122_);
	g_object_unref (_reply_message);
	return _result;
}

static char**
dvb_id_bus_manager_proxy_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                    gint* result_length1,
                                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	char** _result = NULL;
	gint _result_length1;
	GVariant* _tmp123_;
	char** _tmp124_;
	gint _tmp124__length;
	gint _tmp124__size;
	gint _tmp124__length1;
	GVariantIter _tmp125_;
	GVariant* _tmp126_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetRegisteredDeviceGroups");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp123_ = g_variant_iter_next_value (&_reply_iter);
	_tmp124_ = g_new (char*, 5);
	_tmp124__length = 0;
	_tmp124__size = 4;
	_tmp124__length1 = 0;
	g_variant_iter_init (&_tmp125_, _tmp123_);
	for (; (_tmp126_ = g_variant_iter_next_value (&_tmp125_)) != NULL; _tmp124__length1++) {
		if (_tmp124__size == _tmp124__length) {
			_tmp124__size = 2 * _tmp124__size;
			_tmp124_ = g_renew (char*, _tmp124_, _tmp124__size + 1);
		}
		_tmp124_[_tmp124__length++] = g_variant_dup_string (_tmp126_, NULL);
		g_variant_unref (_tmp126_);
	}
	_result_length1 = _tmp124__length1;
	_tmp124_[_tmp124__length] = NULL;
	_result = _tmp124_;
	g_variant_unref (_tmp123_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_GetDeviceGroup (DVBIDBusManager* self,
                                         guint group_id,
                                         char** opath,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	char* _vala_opath = NULL;
	GVariant* _tmp129_;
	gboolean _result = FALSE;
	GVariant* _tmp130_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetDeviceGroup");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (group_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp127_ = FALSE;
		return _tmp127_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp128_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp128_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp129_ = g_variant_iter_next_value (&_reply_iter);
	_vala_opath = g_variant_dup_string (_tmp129_, NULL);
	g_variant_unref (_tmp129_);
	*opath = _vala_opath;
	_tmp130_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp130_);
	g_variant_unref (_tmp130_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_AddDeviceToNewGroup (DVBIDBusManager* self,
                                              guint adapter,
                                              guint frontend,
                                              DVBAdapterType type,
                                              const gchar* channels_conf,
                                              const gchar* recordings_dir,
                                              const gchar* name,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp133_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "AddDeviceToNewGroup");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (adapter));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frontend));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (type));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (channels_conf));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (recordings_dir));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp131_ = FALSE;
		return _tmp131_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp132_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp132_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp133_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp133_);
	g_variant_unref (_tmp133_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                    guint adapter,
                                                    guint frontend,
                                                    gchar** name,
                                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_name = NULL;
	GVariant* _tmp136_;
	gboolean _result = FALSE;
	GVariant* _tmp137_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetNameOfRegisteredDevice");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (adapter));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frontend));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp134_ = FALSE;
		return _tmp134_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp135_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp135_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp136_ = g_variant_iter_next_value (&_reply_iter);
	_vala_name = g_variant_dup_string (_tmp136_, NULL);
	g_variant_unref (_tmp136_);
	*name = _vala_name;
	_tmp137_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp137_);
	g_variant_unref (_tmp137_);
	g_object_unref (_reply_message);
	return _result;
}

static gint
dvb_id_bus_manager_proxy_GetDeviceGroupSize (DVBIDBusManager* self,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint _result = 0;
	GVariant* _tmp140_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetDeviceGroupSize");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gint _tmp138_ = 0;
		return _tmp138_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gint _tmp139_ = 0;
		g_object_unref (_reply_message);
		return _tmp139_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp140_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_int32 (_tmp140_);
	g_variant_unref (_tmp140_);
	g_object_unref (_reply_message);
	return _result;
}

static DVBChannelGroupInfo*
dvb_id_bus_manager_proxy_GetChannelGroups (DVBIDBusManager* self,
                                           gint* result_length1,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DVBChannelGroupInfo* _result = NULL;
	gint _result_length1;
	GVariant* _tmp141_;
	DVBChannelGroupInfo* _tmp142_;
	gint _tmp142__length;
	gint _tmp142__size;
	gint _tmp142__length1;
	GVariantIter _tmp143_;
	GVariant* _tmp144_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetChannelGroups");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp141_ = g_variant_iter_next_value (&_reply_iter);
	_tmp142_ = g_new (DVBChannelGroupInfo, 5);
	_tmp142__length = 0;
	_tmp142__size = 4;
	_tmp142__length1 = 0;
	g_variant_iter_init (&_tmp143_, _tmp141_);
	for (; (_tmp144_ = g_variant_iter_next_value (&_tmp143_)) != NULL; _tmp142__length1++) {
		DVBChannelGroupInfo _tmp145_;
		GVariantIter _tmp146_;
		GVariant* _tmp147_;
		GVariant* _tmp148_;
		if (_tmp142__size == _tmp142__length) {
			_tmp142__size = 2 * _tmp142__size;
			_tmp142_ = g_renew (DVBChannelGroupInfo, _tmp142_, _tmp142__size + 1);
		}
		g_variant_iter_init (&_tmp146_, _tmp144_);
		_tmp147_ = g_variant_iter_next_value (&_tmp146_);
		_tmp145_.id = g_variant_get_int32 (_tmp147_);
		g_variant_unref (_tmp147_);
		_tmp148_ = g_variant_iter_next_value (&_tmp146_);
		_tmp145_.name = g_variant_dup_string (_tmp148_, NULL);
		g_variant_unref (_tmp148_);
		_tmp142_[_tmp142__length++] = _tmp145_;
		g_variant_unref (_tmp144_);
	}
	_result_length1 = _tmp142__length1;
	_result = _tmp142_;
	g_variant_unref (_tmp141_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_AddChannelGroup (DVBIDBusManager* self,
                                          const gchar* name,
                                          gint* channel_group_id,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint _vala_channel_group_id = 0;
	GVariant* _tmp151_;
	gboolean _result = FALSE;
	GVariant* _tmp152_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "AddChannelGroup");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp149_ = FALSE;
		return _tmp149_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp150_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp150_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp151_ = g_variant_iter_next_value (&_reply_iter);
	_vala_channel_group_id = g_variant_get_int32 (_tmp151_);
	g_variant_unref (_tmp151_);
	*channel_group_id = _vala_channel_group_id;
	_tmp152_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp152_);
	g_variant_unref (_tmp152_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_RemoveChannelGroup (DVBIDBusManager* self,
                                             gint channel_group_id,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp155_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "RemoveChannelGroup");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (channel_group_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp153_ = FALSE;
		return _tmp153_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp154_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp154_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp155_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp155_);
	g_variant_unref (_tmp155_);
	g_object_unref (_reply_message);
	return _result;
}

static GHashTable**
dvb_id_bus_manager_proxy_GetDevices (DVBIDBusManager* self,
                                     gint* result_length1,
                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable** _result = NULL;
	gint _result_length1;
	GVariant* _tmp156_;
	GHashTable** _tmp157_;
	gint _tmp157__length;
	gint _tmp157__size;
	gint _tmp157__length1;
	GVariantIter _tmp158_;
	GVariant* _tmp159_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetDevices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp156_ = g_variant_iter_next_value (&_reply_iter);
	_tmp157_ = g_new (GHashTable*, 5);
	_tmp157__length = 0;
	_tmp157__size = 4;
	_tmp157__length1 = 0;
	g_variant_iter_init (&_tmp158_, _tmp156_);
	for (; (_tmp159_ = g_variant_iter_next_value (&_tmp158_)) != NULL; _tmp157__length1++) {
		GHashTable* _tmp160_;
		GVariantIter _tmp161_;
		GVariant* _tmp162_;
		GVariant* _tmp163_;
		if (_tmp157__size == _tmp157__length) {
			_tmp157__size = 2 * _tmp157__size;
			_tmp157_ = g_renew (GHashTable*, _tmp157_, _tmp157__size + 1);
		}
		_tmp160_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
		g_variant_iter_init (&_tmp161_, _tmp159_);
		while (g_variant_iter_loop (&_tmp161_, "{?*}", &_tmp162_, &_tmp163_)) {
			g_hash_table_insert (_tmp160_, g_variant_dup_string (_tmp162_, NULL), g_variant_dup_string (_tmp163_, NULL));
		}
		_tmp157_[_tmp157__length++] = _tmp160_;
		g_variant_unref (_tmp159_);
	}
	_result_length1 = _tmp157__length1;
	_tmp157_[_tmp157__length] = NULL;
	_result = _tmp157_;
	g_variant_unref (_tmp156_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_manager_proxy_GetAdapterInfo (DVBIDBusManager* self,
                                         guint adapter,
                                         guint frontend,
                                         DVBAdapterInfo* info,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DVBAdapterInfo _vala_info = {0};
	GVariant* _tmp166_;
	DVBAdapterInfo _tmp167_;
	GVariantIter _tmp168_;
	GVariant* _tmp169_;
	GVariant* _tmp170_;
	GVariant* _tmp171_;
	GVariant* _tmp172_;
	gboolean _result = FALSE;
	GVariant* _tmp173_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Manager", "GetAdapterInfo");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (adapter));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frontend));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp164_ = FALSE;
		return _tmp164_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp165_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp165_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp166_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp168_, _tmp166_);
	_tmp169_ = g_variant_iter_next_value (&_tmp168_);
	_tmp167_.name = g_variant_dup_string (_tmp169_, NULL);
	g_variant_unref (_tmp169_);
	_tmp170_ = g_variant_iter_next_value (&_tmp168_);
	_tmp167_.type_t = g_variant_get_boolean (_tmp170_);
	g_variant_unref (_tmp170_);
	_tmp171_ = g_variant_iter_next_value (&_tmp168_);
	_tmp167_.type_s = g_variant_get_boolean (_tmp171_);
	g_variant_unref (_tmp171_);
	_tmp172_ = g_variant_iter_next_value (&_tmp168_);
	_tmp167_.type_c = g_variant_get_boolean (_tmp172_);
	g_variant_unref (_tmp172_);
	_vala_info = _tmp167_;
	g_variant_unref (_tmp166_);
	*info = _vala_info;
	_tmp173_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp173_);
	g_variant_unref (_tmp173_);
	g_object_unref (_reply_message);
	return _result;
}

static void
dvb_id_bus_manager_proxy_dvb_id_bus_manager_interface_init (DVBIDBusManagerIface* iface)
{
	iface->GetScannerForDevice = dvb_id_bus_manager_proxy_GetScannerForDevice;
	iface->GetRegisteredDeviceGroups = dvb_id_bus_manager_proxy_GetRegisteredDeviceGroups;
	iface->GetDeviceGroup = dvb_id_bus_manager_proxy_GetDeviceGroup;
	iface->AddDeviceToNewGroup = dvb_id_bus_manager_proxy_AddDeviceToNewGroup;
	iface->GetNameOfRegisteredDevice = dvb_id_bus_manager_proxy_GetNameOfRegisteredDevice;
	iface->GetDeviceGroupSize = dvb_id_bus_manager_proxy_GetDeviceGroupSize;
	iface->GetChannelGroups = dvb_id_bus_manager_proxy_GetChannelGroups;
	iface->AddChannelGroup = dvb_id_bus_manager_proxy_AddChannelGroup;
	iface->RemoveChannelGroup = dvb_id_bus_manager_proxy_RemoveChannelGroup;
	iface->GetDevices = dvb_id_bus_manager_proxy_GetDevices;
	iface->GetAdapterInfo = dvb_id_bus_manager_proxy_GetAdapterInfo;
}

static void
_dbus_dvb_id_bus_manager_GetScannerForDevice (DVBIDBusManager* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint adapter = 0U;
	GVariant* _tmp174_;
	guint frontend = 0U;
	GVariant* _tmp175_;
	DVBAdapterType type = 0;
	GVariant* _tmp176_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	char* opath = NULL;
	gchar* dbusiface = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp174_ = g_variant_iter_next_value (&_arguments_iter);
	adapter = g_variant_get_uint32 (_tmp174_);
	g_variant_unref (_tmp174_);
	_tmp175_ = g_variant_iter_next_value (&_arguments_iter);
	frontend = g_variant_get_uint32 (_tmp175_);
	g_variant_unref (_tmp175_);
	_tmp176_ = g_variant_iter_next_value (&_arguments_iter);
	type = g_variant_get_int32 (_tmp176_);
	g_variant_unref (_tmp176_);
	result = dvb_id_bus_manager_GetScannerForDevice (self, adapter, frontend, type, &opath, &dbusiface, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_object_path (opath));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (dbusiface));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (opath);
	_g_free0 (dbusiface);
}

static void
_dbus_dvb_id_bus_manager_GetRegisteredDeviceGroups (DVBIDBusManager* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	char** result;
	gint result_length1 = 0;
	char** _tmp177_;
	GVariantBuilder _tmp178_;
	gint _tmp179_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_manager_GetRegisteredDeviceGroups (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp177_ = result;
	g_variant_builder_init (&_tmp178_, G_VARIANT_TYPE ("ao"));
	for (_tmp179_ = 0; _tmp179_ < result_length1; _tmp179_++) {
		g_variant_builder_add_value (&_tmp178_, g_variant_new_object_path (*_tmp177_));
		_tmp177_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp178_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_manager_GetDeviceGroup (DVBIDBusManager* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint group_id = 0U;
	GVariant* _tmp180_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	char* opath = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp180_ = g_variant_iter_next_value (&_arguments_iter);
	group_id = g_variant_get_uint32 (_tmp180_);
	g_variant_unref (_tmp180_);
	result = dvb_id_bus_manager_GetDeviceGroup (self, group_id, &opath, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_object_path (opath));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (opath);
}

static void
_dbus_dvb_id_bus_manager_AddDeviceToNewGroup (DVBIDBusManager* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint adapter = 0U;
	GVariant* _tmp181_;
	guint frontend = 0U;
	GVariant* _tmp182_;
	DVBAdapterType type = 0;
	GVariant* _tmp183_;
	gchar* channels_conf = NULL;
	GVariant* _tmp184_;
	gchar* recordings_dir = NULL;
	GVariant* _tmp185_;
	gchar* name = NULL;
	GVariant* _tmp186_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp181_ = g_variant_iter_next_value (&_arguments_iter);
	adapter = g_variant_get_uint32 (_tmp181_);
	g_variant_unref (_tmp181_);
	_tmp182_ = g_variant_iter_next_value (&_arguments_iter);
	frontend = g_variant_get_uint32 (_tmp182_);
	g_variant_unref (_tmp182_);
	_tmp183_ = g_variant_iter_next_value (&_arguments_iter);
	type = g_variant_get_int32 (_tmp183_);
	g_variant_unref (_tmp183_);
	_tmp184_ = g_variant_iter_next_value (&_arguments_iter);
	channels_conf = g_variant_dup_string (_tmp184_, NULL);
	g_variant_unref (_tmp184_);
	_tmp185_ = g_variant_iter_next_value (&_arguments_iter);
	recordings_dir = g_variant_dup_string (_tmp185_, NULL);
	g_variant_unref (_tmp185_);
	_tmp186_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp186_, NULL);
	g_variant_unref (_tmp186_);
	result = dvb_id_bus_manager_AddDeviceToNewGroup (self, adapter, frontend, type, channels_conf, recordings_dir, name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (channels_conf);
	_g_free0 (recordings_dir);
	_g_free0 (name);
	;
}

static void
_dbus_dvb_id_bus_manager_GetNameOfRegisteredDevice (DVBIDBusManager* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint adapter = 0U;
	GVariant* _tmp187_;
	guint frontend = 0U;
	GVariant* _tmp188_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* name = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp187_ = g_variant_iter_next_value (&_arguments_iter);
	adapter = g_variant_get_uint32 (_tmp187_);
	g_variant_unref (_tmp187_);
	_tmp188_ = g_variant_iter_next_value (&_arguments_iter);
	frontend = g_variant_get_uint32 (_tmp188_);
	g_variant_unref (_tmp188_);
	result = dvb_id_bus_manager_GetNameOfRegisteredDevice (self, adapter, frontend, &name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_dvb_id_bus_manager_GetDeviceGroupSize (DVBIDBusManager* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_manager_GetDeviceGroupSize (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_vala_DVBChannelGroupInfo_array_free (DVBChannelGroupInfo * array,
                                      gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			dvb_channel_group_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_dvb_id_bus_manager_GetChannelGroups (DVBIDBusManager* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DVBChannelGroupInfo* result;
	gint result_length1 = 0;
	DVBChannelGroupInfo* _tmp189_;
	GVariantBuilder _tmp190_;
	gint _tmp191_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_manager_GetChannelGroups (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp189_ = result;
	g_variant_builder_init (&_tmp190_, G_VARIANT_TYPE ("a(is)"));
	for (_tmp191_ = 0; _tmp191_ < result_length1; _tmp191_++) {
		GVariantBuilder _tmp192_;
		g_variant_builder_init (&_tmp192_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp192_, g_variant_new_int32 ((*_tmp189_).id));
		g_variant_builder_add_value (&_tmp192_, g_variant_new_string ((*_tmp189_).name));
		g_variant_builder_add_value (&_tmp190_, g_variant_builder_end (&_tmp192_));
		_tmp189_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp190_));
	result = (_vala_DVBChannelGroupInfo_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_manager_AddChannelGroup (DVBIDBusManager* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp193_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint channel_group_id = 0;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp193_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp193_, NULL);
	g_variant_unref (_tmp193_);
	result = dvb_id_bus_manager_AddChannelGroup (self, name, &channel_group_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (channel_group_id));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (name);
	;
}

static void
_dbus_dvb_id_bus_manager_RemoveChannelGroup (DVBIDBusManager* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint channel_group_id = 0;
	GVariant* _tmp194_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp194_ = g_variant_iter_next_value (&_arguments_iter);
	channel_group_id = g_variant_get_int32 (_tmp194_);
	g_variant_unref (_tmp194_);
	result = dvb_id_bus_manager_RemoveChannelGroup (self, channel_group_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_manager_GetDevices (DVBIDBusManager* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	gint result_length1 = 0;
	GHashTable** _tmp195_;
	GVariantBuilder _tmp196_;
	gint _tmp197_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_manager_GetDevices (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp195_ = result;
	g_variant_builder_init (&_tmp196_, G_VARIANT_TYPE ("aa{ss}"));
	for (_tmp197_ = 0; _tmp197_ < result_length1; _tmp197_++) {
		GVariantBuilder _tmp198_;
		GHashTableIter _tmp199_;
		gpointer _tmp200_;
		gpointer _tmp201_;
		g_hash_table_iter_init (&_tmp199_, *_tmp195_);
		g_variant_builder_init (&_tmp198_, G_VARIANT_TYPE ("a{ss}"));
		while (g_hash_table_iter_next (&_tmp199_, &_tmp200_, &_tmp201_)) {
			gchar* _key;
			gchar* _value;
			_key = (gchar*) _tmp200_;
			_value = (gchar*) _tmp201_;
			g_variant_builder_add (&_tmp198_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
		}
		g_variant_builder_add_value (&_tmp196_, g_variant_builder_end (&_tmp198_));
		_tmp195_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp196_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_manager_GetAdapterInfo (DVBIDBusManager* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint adapter = 0U;
	GVariant* _tmp202_;
	guint frontend = 0U;
	GVariant* _tmp203_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DVBAdapterInfo info = {0};
	GVariantBuilder _tmp204_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp202_ = g_variant_iter_next_value (&_arguments_iter);
	adapter = g_variant_get_uint32 (_tmp202_);
	g_variant_unref (_tmp202_);
	_tmp203_ = g_variant_iter_next_value (&_arguments_iter);
	frontend = g_variant_get_uint32 (_tmp203_);
	g_variant_unref (_tmp203_);
	result = dvb_id_bus_manager_GetAdapterInfo (self, adapter, frontend, &info, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp204_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string (info.name));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_boolean (info.type_t));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_boolean (info.type_s));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_boolean (info.type_c));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp204_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	dvb_adapter_info_destroy (&info);
}

static void
dvb_id_bus_manager_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetScannerForDevice") == 0) {
		_dbus_dvb_id_bus_manager_GetScannerForDevice (object, parameters, invocation);
	} else if (strcmp (method_name, "GetRegisteredDeviceGroups") == 0) {
		_dbus_dvb_id_bus_manager_GetRegisteredDeviceGroups (object, parameters, invocation);
	} else if (strcmp (method_name, "GetDeviceGroup") == 0) {
		_dbus_dvb_id_bus_manager_GetDeviceGroup (object, parameters, invocation);
	} else if (strcmp (method_name, "AddDeviceToNewGroup") == 0) {
		_dbus_dvb_id_bus_manager_AddDeviceToNewGroup (object, parameters, invocation);
	} else if (strcmp (method_name, "GetNameOfRegisteredDevice") == 0) {
		_dbus_dvb_id_bus_manager_GetNameOfRegisteredDevice (object, parameters, invocation);
	} else if (strcmp (method_name, "GetDeviceGroupSize") == 0) {
		_dbus_dvb_id_bus_manager_GetDeviceGroupSize (object, parameters, invocation);
	} else if (strcmp (method_name, "GetChannelGroups") == 0) {
		_dbus_dvb_id_bus_manager_GetChannelGroups (object, parameters, invocation);
	} else if (strcmp (method_name, "AddChannelGroup") == 0) {
		_dbus_dvb_id_bus_manager_AddChannelGroup (object, parameters, invocation);
	} else if (strcmp (method_name, "RemoveChannelGroup") == 0) {
		_dbus_dvb_id_bus_manager_RemoveChannelGroup (object, parameters, invocation);
	} else if (strcmp (method_name, "GetDevices") == 0) {
		_dbus_dvb_id_bus_manager_GetDevices (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAdapterInfo") == 0) {
		_dbus_dvb_id_bus_manager_GetAdapterInfo (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
dvb_id_bus_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
dvb_id_bus_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GVariant* value,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_dvb_id_bus_manager_group_added (GObject* _sender,
                                      guint group_id,
                                      gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (group_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Manager", "GroupAdded", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_manager_group_removed (GObject* _sender,
                                        guint group_id,
                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (group_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Manager", "GroupRemoved", _arguments, NULL);
}

guint
dvb_id_bus_manager_register_object (gpointer object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dvb_id_bus_manager_dbus_interface_info), &_dvb_id_bus_manager_dbus_interface_vtable, data, _dvb_id_bus_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "group-added", (GCallback) _dbus_dvb_id_bus_manager_group_added, data);
	g_signal_connect (object, "group-removed", (GCallback) _dbus_dvb_id_bus_manager_group_removed, data);
	return result;
}

static void
_dvb_id_bus_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_manager_group_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_manager_group_removed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

