/* IDBusRecorder.c generated by valac 0.56.18, the Vala compiler
 * generated from IDBusRecorder.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_TIMER_INFO (dvb_timer_info_get_type ())
typedef struct _DVBTimerInfo DVBTimerInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_ID_BUS_RECORDER (dvb_id_bus_recorder_get_type ())
#define DVB_ID_BUS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_RECORDER, DVBIDBusRecorder))
#define DVB_IS_ID_BUS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_RECORDER))
#define DVB_ID_BUS_RECORDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_RECORDER, DVBIDBusRecorderIface))

typedef struct _DVBIDBusRecorder DVBIDBusRecorder;
typedef struct _DVBIDBusRecorderIface DVBIDBusRecorderIface;

#define DVB_TYPE_ID_BUS_RECORDER_PROXY (dvb_id_bus_recorder_proxy_get_type ())
typedef enum  {
	DVB_OVERLAP_TYPE_UNKNOWN,
	DVB_OVERLAP_TYPE_NONE,
	DVB_OVERLAP_TYPE_PARTIAL,
	DVB_OVERLAP_TYPE_COMPLETE
} DVBOverlapType;

#define DVB_TYPE_OVERLAP_TYPE (dvb_overlap_type_get_type ())
enum  {
	DVB_ID_BUS_RECORDER_RECORDING_STARTED_SIGNAL,
	DVB_ID_BUS_RECORDER_RECORDING_FINISHED_SIGNAL,
	DVB_ID_BUS_RECORDER_CHANGED_SIGNAL,
	DVB_ID_BUS_RECORDER_NUM_SIGNALS
};
static guint dvb_id_bus_recorder_signals[DVB_ID_BUS_RECORDER_NUM_SIGNALS] = {0};
typedef GDBusProxy DVBIDBusRecorderProxy;
typedef GDBusProxyClass DVBIDBusRecorderProxyClass;

struct _DVBTimerInfo {
	guint32 id;
	guint duration;
	gboolean active;
	gchar* channel_name;
	gchar* title;
};

struct _DVBIDBusRecorderIface {
	GTypeInterface parent_iface;
	gboolean (*AddTimer) (DVBIDBusRecorder* self, guint channel, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, guint duration, guint32* timer_id, GError** error);
	gboolean (*AddTimerWithMargin) (DVBIDBusRecorder* self, guint channel, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, guint duration, guint32* timer_id, GError** error);
	gboolean (*AddTimerForEPGEvent) (DVBIDBusRecorder* self, guint event_id, guint channel_sid, guint32* timer_id, GError** error);
	gboolean (*DeleteTimer) (DVBIDBusRecorder* self, guint32 timer_id, GError** error);
	guint32* (*GetTimers) (DVBIDBusRecorder* self, gint* result_length1, GError** error);
	gboolean (*GetStartTime) (DVBIDBusRecorder* self, guint32 timer_id, guint32** start_time, gint* start_time_length1, GError** error);
	gboolean (*SetStartTime) (DVBIDBusRecorder* self, guint32 timer_id, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, GError** error);
	gboolean (*GetEndTime) (DVBIDBusRecorder* self, guint32 timer_id, guint** end_time, gint* end_time_length1, GError** error);
	gboolean (*GetDuration) (DVBIDBusRecorder* self, guint32 timer_id, guint* duration, GError** error);
	gboolean (*SetDuration) (DVBIDBusRecorder* self, guint32 timer_id, guint duration, GError** error);
	gboolean (*GetChannelName) (DVBIDBusRecorder* self, guint32 timer_id, gchar** name, GError** error);
	gboolean (*GetTitle) (DVBIDBusRecorder* self, guint32 timer_id, gchar** title, GError** error);
	gboolean (*GetAllInformations) (DVBIDBusRecorder* self, guint32 timer_id, DVBTimerInfo* info, GError** error);
	guint32* (*GetActiveTimers) (DVBIDBusRecorder* self, gint* result_length1, GError** error);
	gboolean (*IsTimerActive) (DVBIDBusRecorder* self, guint32 timer_id, GError** error);
	gboolean (*HasTimer) (DVBIDBusRecorder* self, guint start_year, guint start_month, guint start_day, guint start_hour, guint start_minute, guint duration, GError** error);
	DVBOverlapType (*HasTimerForEvent) (DVBIDBusRecorder* self, guint event_id, guint channel_sid, GError** error);
};

VALA_EXTERN GType dvb_timer_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBTimerInfo* dvb_timer_info_dup (const DVBTimerInfo* self);
VALA_EXTERN void dvb_timer_info_free (DVBTimerInfo* self);
VALA_EXTERN void dvb_timer_info_copy (const DVBTimerInfo* self,
                          DVBTimerInfo* dest);
VALA_EXTERN void dvb_timer_info_destroy (DVBTimerInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBTimerInfo, dvb_timer_info_destroy)
VALA_EXTERN GType dvb_id_bus_recorder_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_recorder_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType dvb_overlap_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_id_bus_recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusRecorder, g_object_unref)
VALA_EXTERN gboolean dvb_id_bus_recorder_AddTimer (DVBIDBusRecorder* self,
                                       guint channel,
                                       gint start_year,
                                       gint start_month,
                                       gint start_day,
                                       gint start_hour,
                                       gint start_minute,
                                       guint duration,
                                       guint32* timer_id,
                                       GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_AddTimerWithMargin (DVBIDBusRecorder* self,
                                                 guint channel,
                                                 gint start_year,
                                                 gint start_month,
                                                 gint start_day,
                                                 gint start_hour,
                                                 gint start_minute,
                                                 guint duration,
                                                 guint32* timer_id,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                                  guint event_id,
                                                  guint channel_sid,
                                                  guint32* timer_id,
                                                  GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_DeleteTimer (DVBIDBusRecorder* self,
                                          guint32 timer_id,
                                          GError** error);
VALA_EXTERN guint32* dvb_id_bus_recorder_GetTimers (DVBIDBusRecorder* self,
                                        gint* result_length1,
                                        GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetStartTime (DVBIDBusRecorder* self,
                                           guint32 timer_id,
                                           guint32** start_time,
                                           gint* start_time_length1,
                                           GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_SetStartTime (DVBIDBusRecorder* self,
                                           guint32 timer_id,
                                           gint start_year,
                                           gint start_month,
                                           gint start_day,
                                           gint start_hour,
                                           gint start_minute,
                                           GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetEndTime (DVBIDBusRecorder* self,
                                         guint32 timer_id,
                                         guint** end_time,
                                         gint* end_time_length1,
                                         GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetDuration (DVBIDBusRecorder* self,
                                          guint32 timer_id,
                                          guint* duration,
                                          GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_SetDuration (DVBIDBusRecorder* self,
                                          guint32 timer_id,
                                          guint duration,
                                          GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetChannelName (DVBIDBusRecorder* self,
                                             guint32 timer_id,
                                             gchar** name,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetTitle (DVBIDBusRecorder* self,
                                       guint32 timer_id,
                                       gchar** title,
                                       GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_GetAllInformations (DVBIDBusRecorder* self,
                                                 guint32 timer_id,
                                                 DVBTimerInfo* info,
                                                 GError** error);
VALA_EXTERN guint32* dvb_id_bus_recorder_GetActiveTimers (DVBIDBusRecorder* self,
                                              gint* result_length1,
                                              GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_IsTimerActive (DVBIDBusRecorder* self,
                                            guint32 timer_id,
                                            GError** error);
VALA_EXTERN gboolean dvb_id_bus_recorder_HasTimer (DVBIDBusRecorder* self,
                                       guint start_year,
                                       guint start_month,
                                       guint start_day,
                                       guint start_hour,
                                       guint start_minute,
                                       guint duration,
                                       GError** error);
VALA_EXTERN DVBOverlapType dvb_id_bus_recorder_HasTimerForEvent (DVBIDBusRecorder* self,
                                                     guint event_id,
                                                     guint channel_sid,
                                                     GError** error);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GType dvb_id_bus_recorder_get_type_once (void);
static void dvb_id_bus_recorder_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters);
static void _dbus_handle_dvb_id_bus_recorder_recording_started (DVBIDBusRecorder* self,
                                                         GVariant* parameters);
static void _dbus_handle_dvb_id_bus_recorder_recording_finished (DVBIDBusRecorder* self,
                                                          GVariant* parameters);
static void _dbus_handle_dvb_id_bus_recorder_changed (DVBIDBusRecorder* self,
                                               GVariant* parameters);
static gboolean dvb_id_bus_recorder_proxy_AddTimer (DVBIDBusRecorder* self,
                                             guint channel,
                                             gint start_year,
                                             gint start_month,
                                             gint start_day,
                                             gint start_hour,
                                             gint start_minute,
                                             guint duration,
                                             guint32* timer_id,
                                             GError** error);
static gboolean dvb_id_bus_recorder_proxy_AddTimerWithMargin (DVBIDBusRecorder* self,
                                                       guint channel,
                                                       gint start_year,
                                                       gint start_month,
                                                       gint start_day,
                                                       gint start_hour,
                                                       gint start_minute,
                                                       guint duration,
                                                       guint32* timer_id,
                                                       GError** error);
static gboolean dvb_id_bus_recorder_proxy_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                                        guint event_id,
                                                        guint channel_sid,
                                                        guint32* timer_id,
                                                        GError** error);
static gboolean dvb_id_bus_recorder_proxy_DeleteTimer (DVBIDBusRecorder* self,
                                                guint32 timer_id,
                                                GError** error);
static guint32* dvb_id_bus_recorder_proxy_GetTimers (DVBIDBusRecorder* self,
                                              gint* result_length1,
                                              GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetStartTime (DVBIDBusRecorder* self,
                                                 guint32 timer_id,
                                                 guint32** start_time,
                                                 gint* start_time_length1,
                                                 GError** error);
static gboolean dvb_id_bus_recorder_proxy_SetStartTime (DVBIDBusRecorder* self,
                                                 guint32 timer_id,
                                                 gint start_year,
                                                 gint start_month,
                                                 gint start_day,
                                                 gint start_hour,
                                                 gint start_minute,
                                                 GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetEndTime (DVBIDBusRecorder* self,
                                               guint32 timer_id,
                                               guint** end_time,
                                               gint* end_time_length1,
                                               GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetDuration (DVBIDBusRecorder* self,
                                                guint32 timer_id,
                                                guint* duration,
                                                GError** error);
static gboolean dvb_id_bus_recorder_proxy_SetDuration (DVBIDBusRecorder* self,
                                                guint32 timer_id,
                                                guint duration,
                                                GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetChannelName (DVBIDBusRecorder* self,
                                                   guint32 timer_id,
                                                   gchar** name,
                                                   GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetTitle (DVBIDBusRecorder* self,
                                             guint32 timer_id,
                                             gchar** title,
                                             GError** error);
static gboolean dvb_id_bus_recorder_proxy_GetAllInformations (DVBIDBusRecorder* self,
                                                       guint32 timer_id,
                                                       DVBTimerInfo* info,
                                                       GError** error);
static guint32* dvb_id_bus_recorder_proxy_GetActiveTimers (DVBIDBusRecorder* self,
                                                    gint* result_length1,
                                                    GError** error);
static gboolean dvb_id_bus_recorder_proxy_IsTimerActive (DVBIDBusRecorder* self,
                                                  guint32 timer_id,
                                                  GError** error);
static gboolean dvb_id_bus_recorder_proxy_HasTimer (DVBIDBusRecorder* self,
                                             guint start_year,
                                             guint start_month,
                                             guint start_day,
                                             guint start_hour,
                                             guint start_minute,
                                             guint duration,
                                             GError** error);
static DVBOverlapType dvb_id_bus_recorder_proxy_HasTimerForEvent (DVBIDBusRecorder* self,
                                                           guint event_id,
                                                           guint channel_sid,
                                                           GError** error);
static void dvb_id_bus_recorder_proxy_dvb_id_bus_recorder_interface_init (DVBIDBusRecorderIface* iface);
static void _dbus_dvb_id_bus_recorder_AddTimer (DVBIDBusRecorder* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_AddTimerWithMargin (DVBIDBusRecorder* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_DeleteTimer (DVBIDBusRecorder* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetTimers (DVBIDBusRecorder* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetStartTime (DVBIDBusRecorder* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_SetStartTime (DVBIDBusRecorder* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetEndTime (DVBIDBusRecorder* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetDuration (DVBIDBusRecorder* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_SetDuration (DVBIDBusRecorder* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetChannelName (DVBIDBusRecorder* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetTitle (DVBIDBusRecorder* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetAllInformations (DVBIDBusRecorder* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_GetActiveTimers (DVBIDBusRecorder* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_IsTimerActive (DVBIDBusRecorder* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_HasTimer (DVBIDBusRecorder* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recorder_HasTimerForEvent (DVBIDBusRecorder* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void dvb_id_bus_recorder_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data);
static GVariant* dvb_id_bus_recorder_dbus_interface_get_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GError** error,
                                                           gpointer user_data);
static gboolean dvb_id_bus_recorder_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data);
static void _dbus_dvb_id_bus_recorder_recording_started (GObject* _sender,
                                                  guint32 timer_id,
                                                  gpointer* _data);
static void _dbus_dvb_id_bus_recorder_recording_finished (GObject* _sender,
                                                   guint32 recording_id,
                                                   gpointer* _data);
static void _dbus_dvb_id_bus_recorder_changed (GObject* _sender,
                                        guint32 timer_id,
                                        guint type,
                                        gpointer* _data);
static void _dvb_id_bus_recorder_unregister_object (gpointer user_data);

static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_channel = {-1, "channel", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_year = {-1, "start_year", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_month = {-1, "start_month", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_day = {-1, "start_day", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_hour = {-1, "start_hour", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_minute = {-1, "start_minute", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_duration = {-1, "duration", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimer_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimer_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimer_channel, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_year, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_month, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_day, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_hour, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_start_minute, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_duration, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimer_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimer_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_AddTimer_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_AddTimer = {-1, "AddTimer", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimer_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimer_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_channel = {-1, "channel", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_year = {-1, "start_year", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_month = {-1, "start_month", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_day = {-1, "start_day", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_hour = {-1, "start_hour", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_minute = {-1, "start_minute", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_duration = {-1, "duration", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_channel, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_year, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_month, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_day, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_hour, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_start_minute, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_duration, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_AddTimerWithMargin = {-1, "AddTimerWithMargin", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimerWithMargin_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_event_id = {-1, "event_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_channel_sid = {-1, "channel_sid", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_event_id, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_channel_sid, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_AddTimerForEPGEvent = {-1, "AddTimerForEPGEvent", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_AddTimerForEPGEvent_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_DeleteTimer = {-1, "DeleteTimer", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_DeleteTimer_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetTimers_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetTimers_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetTimers_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetTimers_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetTimers = {-1, "GetTimers", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetTimers_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetTimers_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetStartTime_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetStartTime_start_time = {-1, "start_time", "au", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetStartTime_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetStartTime_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetStartTime_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetStartTime_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetStartTime_start_time, &_dvb_id_bus_recorder_dbus_arg_info_GetStartTime_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetStartTime = {-1, "GetStartTime", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetStartTime_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetStartTime_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_year = {-1, "start_year", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_month = {-1, "start_month", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_day = {-1, "start_day", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_hour = {-1, "start_hour", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_minute = {-1, "start_minute", "i", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_year, &_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_month, &_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_day, &_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_hour, &_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_start_minute, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_SetStartTime_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_SetStartTime = {-1, "SetStartTime", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_SetStartTime_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetEndTime_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetEndTime_end_time = {-1, "end_time", "au", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetEndTime_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetEndTime_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetEndTime_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetEndTime_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetEndTime_end_time, &_dvb_id_bus_recorder_dbus_arg_info_GetEndTime_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetEndTime = {-1, "GetEndTime", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetEndTime_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetEndTime_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetDuration_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetDuration_duration = {-1, "duration", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetDuration_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetDuration_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetDuration_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetDuration_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetDuration_duration, &_dvb_id_bus_recorder_dbus_arg_info_GetDuration_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetDuration = {-1, "GetDuration", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetDuration_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetDuration_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetDuration_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetDuration_duration = {-1, "duration", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_SetDuration_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_SetDuration_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_SetDuration_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_SetDuration_duration, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_SetDuration_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_SetDuration_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_SetDuration = {-1, "SetDuration", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_SetDuration_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_SetDuration_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetChannelName_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetChannelName_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetChannelName_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetChannelName_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetChannelName_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetChannelName_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetChannelName_name, &_dvb_id_bus_recorder_dbus_arg_info_GetChannelName_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetChannelName = {-1, "GetChannelName", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetChannelName_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetChannelName_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetTitle_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetTitle_title = {-1, "title", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetTitle_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetTitle_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetTitle_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetTitle_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetTitle_title, &_dvb_id_bus_recorder_dbus_arg_info_GetTitle_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetTitle = {-1, "GetTitle", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetTitle_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetTitle_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_info = {-1, "info", "(uubss)", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_info, &_dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetAllInformations = {-1, "GetAllInformations", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetAllInformations_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_GetActiveTimers = {-1, "GetActiveTimers", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_GetActiveTimers_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_timer_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_IsTimerActive = {-1, "IsTimerActive", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_IsTimerActive_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_year = {-1, "start_year", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_month = {-1, "start_month", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_day = {-1, "start_day", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_hour = {-1, "start_hour", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_minute = {-1, "start_minute", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_duration = {-1, "duration", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimer_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_HasTimer_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_year, &_dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_month, &_dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_day, &_dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_hour, &_dvb_id_bus_recorder_dbus_arg_info_HasTimer_start_minute, &_dvb_id_bus_recorder_dbus_arg_info_HasTimer_duration, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_HasTimer_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_HasTimer_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_HasTimer = {-1, "HasTimer", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_HasTimer_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_HasTimer_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_event_id = {-1, "event_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_channel_sid = {-1, "channel_sid", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_result = {-1, "result", "i", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_in[] = {&_dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_event_id, &_dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_channel_sid, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_out[] = {&_dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recorder_dbus_method_info_HasTimerForEvent = {-1, "HasTimerForEvent", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_in), (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_HasTimerForEvent_out), NULL};
static const GDBusMethodInfo * const _dvb_id_bus_recorder_dbus_method_info[] = {&_dvb_id_bus_recorder_dbus_method_info_AddTimer, &_dvb_id_bus_recorder_dbus_method_info_AddTimerWithMargin, &_dvb_id_bus_recorder_dbus_method_info_AddTimerForEPGEvent, &_dvb_id_bus_recorder_dbus_method_info_DeleteTimer, &_dvb_id_bus_recorder_dbus_method_info_GetTimers, &_dvb_id_bus_recorder_dbus_method_info_GetStartTime, &_dvb_id_bus_recorder_dbus_method_info_SetStartTime, &_dvb_id_bus_recorder_dbus_method_info_GetEndTime, &_dvb_id_bus_recorder_dbus_method_info_GetDuration, &_dvb_id_bus_recorder_dbus_method_info_SetDuration, &_dvb_id_bus_recorder_dbus_method_info_GetChannelName, &_dvb_id_bus_recorder_dbus_method_info_GetTitle, &_dvb_id_bus_recorder_dbus_method_info_GetAllInformations, &_dvb_id_bus_recorder_dbus_method_info_GetActiveTimers, &_dvb_id_bus_recorder_dbus_method_info_IsTimerActive, &_dvb_id_bus_recorder_dbus_method_info_HasTimer, &_dvb_id_bus_recorder_dbus_method_info_HasTimerForEvent, NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_recording_started_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_recording_started[] = {&_dvb_id_bus_recorder_dbus_arg_info_recording_started_timer_id, NULL};
static const GDBusSignalInfo _dvb_id_bus_recorder_dbus_signal_info_recording_started = {-1, "RecordingStarted", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_recording_started), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_recording_finished_recording_id = {-1, "recording_id", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_recording_finished[] = {&_dvb_id_bus_recorder_dbus_arg_info_recording_finished_recording_id, NULL};
static const GDBusSignalInfo _dvb_id_bus_recorder_dbus_signal_info_recording_finished = {-1, "RecordingFinished", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_recording_finished), NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_changed_timer_id = {-1, "timer_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recorder_dbus_arg_info_changed_type = {-1, "type", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recorder_dbus_arg_info_changed[] = {&_dvb_id_bus_recorder_dbus_arg_info_changed_timer_id, &_dvb_id_bus_recorder_dbus_arg_info_changed_type, NULL};
static const GDBusSignalInfo _dvb_id_bus_recorder_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_dvb_id_bus_recorder_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _dvb_id_bus_recorder_dbus_signal_info[] = {&_dvb_id_bus_recorder_dbus_signal_info_recording_started, &_dvb_id_bus_recorder_dbus_signal_info_recording_finished, &_dvb_id_bus_recorder_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo * const _dvb_id_bus_recorder_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dvb_id_bus_recorder_dbus_interface_info = {-1, "org.gnome.DVB.Recorder", (GDBusMethodInfo **) (&_dvb_id_bus_recorder_dbus_method_info), (GDBusSignalInfo **) (&_dvb_id_bus_recorder_dbus_signal_info), (GDBusPropertyInfo **) (&_dvb_id_bus_recorder_dbus_property_info), NULL};
static const GDBusInterfaceVTable _dvb_id_bus_recorder_dbus_interface_vtable = {dvb_id_bus_recorder_dbus_interface_method_call, dvb_id_bus_recorder_dbus_interface_get_property, dvb_id_bus_recorder_dbus_interface_set_property};

void
dvb_timer_info_copy (const DVBTimerInfo* self,
                     DVBTimerInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	(*dest).id = (*self).id;
	(*dest).duration = (*self).duration;
	(*dest).active = (*self).active;
	_tmp0_ = (*self).channel_name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).channel_name);
	(*dest).channel_name = _tmp1_;
	_tmp2_ = (*self).title;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp3_;
}

void
dvb_timer_info_destroy (DVBTimerInfo* self)
{
	_g_free0 ((*self).channel_name);
	_g_free0 ((*self).title);
}

DVBTimerInfo*
dvb_timer_info_dup (const DVBTimerInfo* self)
{
	DVBTimerInfo* dup;
	dup = g_new0 (DVBTimerInfo, 1);
	dvb_timer_info_copy (self, dup);
	return dup;
}

void
dvb_timer_info_free (DVBTimerInfo* self)
{
	dvb_timer_info_destroy (self);
	g_free (self);
}

static GType
dvb_timer_info_get_type_once (void)
{
	GType dvb_timer_info_type_id;
	dvb_timer_info_type_id = g_boxed_type_register_static ("DVBTimerInfo", (GBoxedCopyFunc) dvb_timer_info_dup, (GBoxedFreeFunc) dvb_timer_info_free);
	return dvb_timer_info_type_id;
}

GType
dvb_timer_info_get_type (void)
{
	static volatile gsize dvb_timer_info_type_id__once = 0;
	if (g_once_init_enter (&dvb_timer_info_type_id__once)) {
		GType dvb_timer_info_type_id;
		dvb_timer_info_type_id = dvb_timer_info_get_type_once ();
		g_once_init_leave (&dvb_timer_info_type_id__once, dvb_timer_info_type_id);
	}
	return dvb_timer_info_type_id__once;
}

/**
         * @channel: Channel number
         * @start_year: The year when the recording should start
         * @start_month: The month when recording should start
         * @start_day: The day when recording should start
         * @start_hour: The hour when recording should start
         * @start_minute: The minute when recording should start
         * @duration: How long the channel should be recorded (in minutes)
         * @timer_id: The new timer's id on success, or 0 if timer couldn't
         * be created
         * @returns: TRUE on success
         *
         * Add a new timer
         */
gboolean
dvb_id_bus_recorder_AddTimer (DVBIDBusRecorder* self,
                              guint channel,
                              gint start_year,
                              gint start_month,
                              gint start_day,
                              gint start_hour,
                              gint start_minute,
                              guint duration,
                              guint32* timer_id,
                              GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->AddTimer) {
		return _iface_->AddTimer (self, channel, start_year, start_month, start_day, start_hour, start_minute, duration, timer_id, error);
	}
	return FALSE;
}

/**
         * Works the same way as AddTimer() but adds a margin before and
         * after the timer.
         */
gboolean
dvb_id_bus_recorder_AddTimerWithMargin (DVBIDBusRecorder* self,
                                        guint channel,
                                        gint start_year,
                                        gint start_month,
                                        gint start_day,
                                        gint start_hour,
                                        gint start_minute,
                                        guint duration,
                                        guint32* timer_id,
                                        GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->AddTimerWithMargin) {
		return _iface_->AddTimerWithMargin (self, channel, start_year, start_month, start_day, start_hour, start_minute, duration, timer_id, error);
	}
	return FALSE;
}

/**
         * @event_id: id of the EPG event
         * @channel_sid: SID of channel
         * @timer_id: The new timer's id on success, or 0 if timer couldn't
         * be created
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                         guint event_id,
                                         guint channel_sid,
                                         guint32* timer_id,
                                         GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->AddTimerForEPGEvent) {
		return _iface_->AddTimerForEPGEvent (self, event_id, channel_sid, timer_id, error);
	}
	return FALSE;
}

/**
         * @timer_id: The id of the timer you want to delete
         * @returns: TRUE on success
         *
         * Delete timer. If the id belongs to the currently
         * active timer recording is aborted.
         */
gboolean
dvb_id_bus_recorder_DeleteTimer (DVBIDBusRecorder* self,
                                 guint32 timer_id,
                                 GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->DeleteTimer) {
		return _iface_->DeleteTimer (self, timer_id, error);
	}
	return FALSE;
}

/**
         * dvb_recorder_GetTimers
         * @returns: A list of all timer ids
         */
guint32*
dvb_id_bus_recorder_GetTimers (DVBIDBusRecorder* self,
                               gint* result_length1,
                               GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetTimers) {
		return _iface_->GetTimers (self, result_length1, error);
	}
	return NULL;
}

/**
         * @timer_id: Timer's id
         * @start_time: An array of length 5, where index 0 = year, 1 = month,
         * 2 = day, 3 = hour and 4 = minute.
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_GetStartTime (DVBIDBusRecorder* self,
                                  guint32 timer_id,
                                  guint32** start_time,
                                  gint* start_time_length1,
                                  GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetStartTime) {
		return _iface_->GetStartTime (self, timer_id, start_time, start_time_length1, error);
	}
	return FALSE;
}

/**
         * @timer_id: The new timer's id on success, or 0 if timer couldn't
         * @start_year: The year when the recording should start
         * @start_month: The month when recording should start
         * @start_day: The day when recording should start
         * @start_hour: The hour when recording should start
         * @start_minute: The minute when recording should start
         * @duration: How long the channel should be recorded (in minutes)
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_SetStartTime (DVBIDBusRecorder* self,
                                  guint32 timer_id,
                                  gint start_year,
                                  gint start_month,
                                  gint start_day,
                                  gint start_hour,
                                  gint start_minute,
                                  GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->SetStartTime) {
		return _iface_->SetStartTime (self, timer_id, start_year, start_month, start_day, start_hour, start_minute, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @end_time: Same as dvb_recorder_GetStartTime()
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_GetEndTime (DVBIDBusRecorder* self,
                                guint32 timer_id,
                                guint** end_time,
                                gint* end_time_length1,
                                GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetEndTime) {
		return _iface_->GetEndTime (self, timer_id, end_time, end_time_length1, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @duration: Duration in seconds or 0 if there's no timer with
         * the given id
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_GetDuration (DVBIDBusRecorder* self,
                                 guint32 timer_id,
                                 guint* duration,
                                 GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetDuration) {
		return _iface_->GetDuration (self, timer_id, duration, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @duration: Duration in minutes
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_SetDuration (DVBIDBusRecorder* self,
                                 guint32 timer_id,
                                 guint duration,
                                 GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->SetDuration) {
		return _iface_->SetDuration (self, timer_id, duration, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @name: The name of the channel the timer belongs to or an
         * empty string when a timer with the given id doesn't exist
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_GetChannelName (DVBIDBusRecorder* self,
                                    guint32 timer_id,
                                    gchar** name,
                                    GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetChannelName) {
		return _iface_->GetChannelName (self, timer_id, name, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @title: The name of the show the timer belongs to or an
         * empty string if the timer doesn't exist or has no information
         * about the title of the show
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recorder_GetTitle (DVBIDBusRecorder* self,
                              guint32 timer_id,
                              gchar** title,
                              GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetTitle) {
		return _iface_->GetTitle (self, timer_id, title, error);
	}
	return FALSE;
}

/**
         * @timer_id: Timer's id
         * @returns: TRUE on success
         *
         * This method can be used to retrieve all informations
         * about a particular timer at once
         */
gboolean
dvb_id_bus_recorder_GetAllInformations (DVBIDBusRecorder* self,
                                        guint32 timer_id,
                                        DVBTimerInfo* info,
                                        GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetAllInformations) {
		return _iface_->GetAllInformations (self, timer_id, info, error);
	}
	return FALSE;
}

/**
         * @returns: The currently active timers
         */
guint32*
dvb_id_bus_recorder_GetActiveTimers (DVBIDBusRecorder* self,
                                     gint* result_length1,
                                     GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->GetActiveTimers) {
		return _iface_->GetActiveTimers (self, result_length1, error);
	}
	return NULL;
}

/**
         * @timer_id: Timer's id
         * @returns: TRUE if timer is currently active
         */
gboolean
dvb_id_bus_recorder_IsTimerActive (DVBIDBusRecorder* self,
                                   guint32 timer_id,
                                   GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->IsTimerActive) {
		return _iface_->IsTimerActive (self, timer_id, error);
	}
	return FALSE;
}

/**
         * @returns: TRUE if a timer is already scheduled in the given
         * period of time
         */
gboolean
dvb_id_bus_recorder_HasTimer (DVBIDBusRecorder* self,
                              guint start_year,
                              guint start_month,
                              guint start_day,
                              guint start_hour,
                              guint start_minute,
                              guint duration,
                              GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->HasTimer) {
		return _iface_->HasTimer (self, start_year, start_month, start_day, start_hour, start_minute, duration, error);
	}
	return FALSE;
}

/**
         * Checks if a timer overlaps with the given event
         */
DVBOverlapType
dvb_id_bus_recorder_HasTimerForEvent (DVBIDBusRecorder* self,
                                      guint event_id,
                                      guint channel_sid,
                                      GError** error)
{
	DVBIDBusRecorderIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = DVB_ID_BUS_RECORDER_GET_INTERFACE (self);
	if (_iface_->HasTimerForEvent) {
		return _iface_->HasTimerForEvent (self, event_id, channel_sid, error);
	}
	return 0;
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint32 arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
}

static void
dvb_id_bus_recorder_default_init (DVBIDBusRecorderIface * iface,
                                  gpointer iface_data)
{
	dvb_id_bus_recorder_signals[DVB_ID_BUS_RECORDER_RECORDING_STARTED_SIGNAL] = g_signal_new ("recording-started", DVB_TYPE_ID_BUS_RECORDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	dvb_id_bus_recorder_signals[DVB_ID_BUS_RECORDER_RECORDING_FINISHED_SIGNAL] = g_signal_new ("recording-finished", DVB_TYPE_ID_BUS_RECORDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	/**
	         * @type: 0: added, 1: deleted, 2: updated
	         */
	dvb_id_bus_recorder_signals[DVB_ID_BUS_RECORDER_CHANGED_SIGNAL] = g_signal_new ("changed", DVB_TYPE_ID_BUS_RECORDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
}

static GType
dvb_id_bus_recorder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBIDBusRecorderIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_id_bus_recorder_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_id_bus_recorder_type_id;
	dvb_id_bus_recorder_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBIDBusRecorder", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_id_bus_recorder_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (dvb_id_bus_recorder_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dvb_id_bus_recorder_proxy_get_type);
	g_type_set_qdata (dvb_id_bus_recorder_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.DVB.Recorder");
	g_type_set_qdata (dvb_id_bus_recorder_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_dvb_id_bus_recorder_dbus_interface_info));
	g_type_set_qdata (dvb_id_bus_recorder_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dvb_id_bus_recorder_register_object);
	return dvb_id_bus_recorder_type_id;
}

GType
dvb_id_bus_recorder_get_type (void)
{
	static volatile gsize dvb_id_bus_recorder_type_id__once = 0;
	if (g_once_init_enter (&dvb_id_bus_recorder_type_id__once)) {
		GType dvb_id_bus_recorder_type_id;
		dvb_id_bus_recorder_type_id = dvb_id_bus_recorder_get_type_once ();
		g_once_init_leave (&dvb_id_bus_recorder_type_id__once, dvb_id_bus_recorder_type_id);
	}
	return dvb_id_bus_recorder_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DVBIDBusRecorderProxy, dvb_id_bus_recorder_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DVB_TYPE_ID_BUS_RECORDER, dvb_id_bus_recorder_proxy_dvb_id_bus_recorder_interface_init) )
static void
dvb_id_bus_recorder_proxy_class_init (DVBIDBusRecorderProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = dvb_id_bus_recorder_proxy_g_signal;
}

static void
_dbus_handle_dvb_id_bus_recorder_recording_started (DVBIDBusRecorder* self,
                                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp205_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp205_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp205_);
	g_variant_unref (_tmp205_);
	g_signal_emit_by_name (self, "recording-started", timer_id);
}

static void
_dbus_handle_dvb_id_bus_recorder_recording_finished (DVBIDBusRecorder* self,
                                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 recording_id = 0U;
	GVariant* _tmp206_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp206_ = g_variant_iter_next_value (&_arguments_iter);
	recording_id = g_variant_get_uint32 (_tmp206_);
	g_variant_unref (_tmp206_);
	g_signal_emit_by_name (self, "recording-finished", recording_id);
}

static void
_dbus_handle_dvb_id_bus_recorder_changed (DVBIDBusRecorder* self,
                                          GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp207_;
	guint type = 0U;
	GVariant* _tmp208_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp207_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp207_);
	g_variant_unref (_tmp207_);
	_tmp208_ = g_variant_iter_next_value (&_arguments_iter);
	type = g_variant_get_uint32 (_tmp208_);
	g_variant_unref (_tmp208_);
	g_signal_emit_by_name (self, "changed", timer_id, type);
}

static void
dvb_id_bus_recorder_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters)
{
	if (strcmp (signal_name, "RecordingStarted") == 0) {
		_dbus_handle_dvb_id_bus_recorder_recording_started ((DVBIDBusRecorder*) proxy, parameters);
	} else if (strcmp (signal_name, "RecordingFinished") == 0) {
		_dbus_handle_dvb_id_bus_recorder_recording_finished ((DVBIDBusRecorder*) proxy, parameters);
	} else if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_dvb_id_bus_recorder_changed ((DVBIDBusRecorder*) proxy, parameters);
	}
}

static void
dvb_id_bus_recorder_proxy_init (DVBIDBusRecorderProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_dvb_id_bus_recorder_dbus_interface_info));
}

static gboolean
dvb_id_bus_recorder_proxy_AddTimer (DVBIDBusRecorder* self,
                                    guint channel,
                                    gint start_year,
                                    gint start_month,
                                    gint start_day,
                                    gint start_hour,
                                    gint start_minute,
                                    guint duration,
                                    guint32* timer_id,
                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _vala_timer_id = 0U;
	GVariant* _tmp211_;
	gboolean _result = FALSE;
	GVariant* _tmp212_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "AddTimer");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (channel));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_year));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_month));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_day));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_hour));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_minute));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (duration));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp209_ = FALSE;
		return _tmp209_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp210_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp210_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp211_ = g_variant_iter_next_value (&_reply_iter);
	_vala_timer_id = g_variant_get_uint32 (_tmp211_);
	g_variant_unref (_tmp211_);
	*timer_id = _vala_timer_id;
	_tmp212_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp212_);
	g_variant_unref (_tmp212_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_AddTimerWithMargin (DVBIDBusRecorder* self,
                                              guint channel,
                                              gint start_year,
                                              gint start_month,
                                              gint start_day,
                                              gint start_hour,
                                              gint start_minute,
                                              guint duration,
                                              guint32* timer_id,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _vala_timer_id = 0U;
	GVariant* _tmp215_;
	gboolean _result = FALSE;
	GVariant* _tmp216_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "AddTimerWithMargin");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (channel));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_year));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_month));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_day));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_hour));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_minute));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (duration));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp213_ = FALSE;
		return _tmp213_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp214_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp214_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp215_ = g_variant_iter_next_value (&_reply_iter);
	_vala_timer_id = g_variant_get_uint32 (_tmp215_);
	g_variant_unref (_tmp215_);
	*timer_id = _vala_timer_id;
	_tmp216_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp216_);
	g_variant_unref (_tmp216_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                               guint event_id,
                                               guint channel_sid,
                                               guint32* timer_id,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _vala_timer_id = 0U;
	GVariant* _tmp219_;
	gboolean _result = FALSE;
	GVariant* _tmp220_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "AddTimerForEPGEvent");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (event_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (channel_sid));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp217_ = FALSE;
		return _tmp217_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp218_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp218_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp219_ = g_variant_iter_next_value (&_reply_iter);
	_vala_timer_id = g_variant_get_uint32 (_tmp219_);
	g_variant_unref (_tmp219_);
	*timer_id = _vala_timer_id;
	_tmp220_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp220_);
	g_variant_unref (_tmp220_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_DeleteTimer (DVBIDBusRecorder* self,
                                       guint32 timer_id,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp223_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "DeleteTimer");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp221_ = FALSE;
		return _tmp221_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp222_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp222_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp223_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp223_);
	g_variant_unref (_tmp223_);
	g_object_unref (_reply_message);
	return _result;
}

static guint32*
dvb_id_bus_recorder_proxy_GetTimers (DVBIDBusRecorder* self,
                                     gint* result_length1,
                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32* _result = NULL;
	gint _result_length1;
	GVariant* _tmp224_;
	guint32* _tmp225_;
	gint _tmp225__length;
	gint _tmp225__size;
	gint _tmp225__length1;
	GVariantIter _tmp226_;
	GVariant* _tmp227_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetTimers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp224_ = g_variant_iter_next_value (&_reply_iter);
	_tmp225_ = g_new (guint32, 5);
	_tmp225__length = 0;
	_tmp225__size = 4;
	_tmp225__length1 = 0;
	g_variant_iter_init (&_tmp226_, _tmp224_);
	for (; (_tmp227_ = g_variant_iter_next_value (&_tmp226_)) != NULL; _tmp225__length1++) {
		if (_tmp225__size == _tmp225__length) {
			_tmp225__size = 2 * _tmp225__size;
			_tmp225_ = g_renew (guint32, _tmp225_, _tmp225__size + 1);
		}
		_tmp225_[_tmp225__length++] = g_variant_get_uint32 (_tmp227_);
		g_variant_unref (_tmp227_);
	}
	_result_length1 = _tmp225__length1;
	_result = _tmp225_;
	g_variant_unref (_tmp224_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetStartTime (DVBIDBusRecorder* self,
                                        guint32 timer_id,
                                        guint32** start_time,
                                        gint* start_time_length1,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32* _vala_start_time = NULL;
	gint _vala_start_time_length1;
	GVariant* _tmp230_;
	guint32* _tmp231_;
	gint _tmp231__length;
	gint _tmp231__size;
	gint _tmp231__length1;
	GVariantIter _tmp232_;
	GVariant* _tmp233_;
	gboolean _result = FALSE;
	GVariant* _tmp234_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetStartTime");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp228_ = FALSE;
		return _tmp228_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp229_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp229_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_start_time_length1 = 0;
	_tmp230_ = g_variant_iter_next_value (&_reply_iter);
	_tmp231_ = g_new (guint32, 5);
	_tmp231__length = 0;
	_tmp231__size = 4;
	_tmp231__length1 = 0;
	g_variant_iter_init (&_tmp232_, _tmp230_);
	for (; (_tmp233_ = g_variant_iter_next_value (&_tmp232_)) != NULL; _tmp231__length1++) {
		if (_tmp231__size == _tmp231__length) {
			_tmp231__size = 2 * _tmp231__size;
			_tmp231_ = g_renew (guint32, _tmp231_, _tmp231__size + 1);
		}
		_tmp231_[_tmp231__length++] = g_variant_get_uint32 (_tmp233_);
		g_variant_unref (_tmp233_);
	}
	_vala_start_time_length1 = _tmp231__length1;
	_vala_start_time = _tmp231_;
	g_variant_unref (_tmp230_);
	*start_time = _vala_start_time;
	*start_time_length1 = _vala_start_time_length1;
	_tmp234_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp234_);
	g_variant_unref (_tmp234_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_SetStartTime (DVBIDBusRecorder* self,
                                        guint32 timer_id,
                                        gint start_year,
                                        gint start_month,
                                        gint start_day,
                                        gint start_hour,
                                        gint start_minute,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp237_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "SetStartTime");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_year));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_month));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_day));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_hour));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (start_minute));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp235_ = FALSE;
		return _tmp235_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp236_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp236_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp237_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp237_);
	g_variant_unref (_tmp237_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetEndTime (DVBIDBusRecorder* self,
                                      guint32 timer_id,
                                      guint** end_time,
                                      gint* end_time_length1,
                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint* _vala_end_time = NULL;
	gint _vala_end_time_length1;
	GVariant* _tmp240_;
	guint* _tmp241_;
	gint _tmp241__length;
	gint _tmp241__size;
	gint _tmp241__length1;
	GVariantIter _tmp242_;
	GVariant* _tmp243_;
	gboolean _result = FALSE;
	GVariant* _tmp244_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetEndTime");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp238_ = FALSE;
		return _tmp238_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp239_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp239_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_end_time_length1 = 0;
	_tmp240_ = g_variant_iter_next_value (&_reply_iter);
	_tmp241_ = g_new (guint, 5);
	_tmp241__length = 0;
	_tmp241__size = 4;
	_tmp241__length1 = 0;
	g_variant_iter_init (&_tmp242_, _tmp240_);
	for (; (_tmp243_ = g_variant_iter_next_value (&_tmp242_)) != NULL; _tmp241__length1++) {
		if (_tmp241__size == _tmp241__length) {
			_tmp241__size = 2 * _tmp241__size;
			_tmp241_ = g_renew (guint, _tmp241_, _tmp241__size + 1);
		}
		_tmp241_[_tmp241__length++] = g_variant_get_uint32 (_tmp243_);
		g_variant_unref (_tmp243_);
	}
	_vala_end_time_length1 = _tmp241__length1;
	_vala_end_time = _tmp241_;
	g_variant_unref (_tmp240_);
	*end_time = _vala_end_time;
	*end_time_length1 = _vala_end_time_length1;
	_tmp244_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp244_);
	g_variant_unref (_tmp244_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetDuration (DVBIDBusRecorder* self,
                                       guint32 timer_id,
                                       guint* duration,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint _vala_duration = 0U;
	GVariant* _tmp247_;
	gboolean _result = FALSE;
	GVariant* _tmp248_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetDuration");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp245_ = FALSE;
		return _tmp245_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp246_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp246_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp247_ = g_variant_iter_next_value (&_reply_iter);
	_vala_duration = g_variant_get_uint32 (_tmp247_);
	g_variant_unref (_tmp247_);
	*duration = _vala_duration;
	_tmp248_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp248_);
	g_variant_unref (_tmp248_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_SetDuration (DVBIDBusRecorder* self,
                                       guint32 timer_id,
                                       guint duration,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp251_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "SetDuration");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (duration));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp249_ = FALSE;
		return _tmp249_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp250_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp250_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp251_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp251_);
	g_variant_unref (_tmp251_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetChannelName (DVBIDBusRecorder* self,
                                          guint32 timer_id,
                                          gchar** name,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_name = NULL;
	GVariant* _tmp254_;
	gboolean _result = FALSE;
	GVariant* _tmp255_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetChannelName");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp252_ = FALSE;
		return _tmp252_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp253_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp253_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp254_ = g_variant_iter_next_value (&_reply_iter);
	_vala_name = g_variant_dup_string (_tmp254_, NULL);
	g_variant_unref (_tmp254_);
	*name = _vala_name;
	_tmp255_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp255_);
	g_variant_unref (_tmp255_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetTitle (DVBIDBusRecorder* self,
                                    guint32 timer_id,
                                    gchar** title,
                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_title = NULL;
	GVariant* _tmp258_;
	gboolean _result = FALSE;
	GVariant* _tmp259_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetTitle");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp256_ = FALSE;
		return _tmp256_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp257_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp257_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp258_ = g_variant_iter_next_value (&_reply_iter);
	_vala_title = g_variant_dup_string (_tmp258_, NULL);
	g_variant_unref (_tmp258_);
	*title = _vala_title;
	_tmp259_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp259_);
	g_variant_unref (_tmp259_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_GetAllInformations (DVBIDBusRecorder* self,
                                              guint32 timer_id,
                                              DVBTimerInfo* info,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DVBTimerInfo _vala_info = {0};
	GVariant* _tmp262_;
	DVBTimerInfo _tmp263_;
	GVariantIter _tmp264_;
	GVariant* _tmp265_;
	GVariant* _tmp266_;
	GVariant* _tmp267_;
	GVariant* _tmp268_;
	GVariant* _tmp269_;
	gboolean _result = FALSE;
	GVariant* _tmp270_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetAllInformations");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp260_ = FALSE;
		return _tmp260_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp261_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp261_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp262_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp264_, _tmp262_);
	_tmp265_ = g_variant_iter_next_value (&_tmp264_);
	_tmp263_.id = g_variant_get_uint32 (_tmp265_);
	g_variant_unref (_tmp265_);
	_tmp266_ = g_variant_iter_next_value (&_tmp264_);
	_tmp263_.duration = g_variant_get_uint32 (_tmp266_);
	g_variant_unref (_tmp266_);
	_tmp267_ = g_variant_iter_next_value (&_tmp264_);
	_tmp263_.active = g_variant_get_boolean (_tmp267_);
	g_variant_unref (_tmp267_);
	_tmp268_ = g_variant_iter_next_value (&_tmp264_);
	_tmp263_.channel_name = g_variant_dup_string (_tmp268_, NULL);
	g_variant_unref (_tmp268_);
	_tmp269_ = g_variant_iter_next_value (&_tmp264_);
	_tmp263_.title = g_variant_dup_string (_tmp269_, NULL);
	g_variant_unref (_tmp269_);
	_vala_info = _tmp263_;
	g_variant_unref (_tmp262_);
	*info = _vala_info;
	_tmp270_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp270_);
	g_variant_unref (_tmp270_);
	g_object_unref (_reply_message);
	return _result;
}

static guint32*
dvb_id_bus_recorder_proxy_GetActiveTimers (DVBIDBusRecorder* self,
                                           gint* result_length1,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32* _result = NULL;
	gint _result_length1;
	GVariant* _tmp271_;
	guint32* _tmp272_;
	gint _tmp272__length;
	gint _tmp272__size;
	gint _tmp272__length1;
	GVariantIter _tmp273_;
	GVariant* _tmp274_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "GetActiveTimers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp271_ = g_variant_iter_next_value (&_reply_iter);
	_tmp272_ = g_new (guint32, 5);
	_tmp272__length = 0;
	_tmp272__size = 4;
	_tmp272__length1 = 0;
	g_variant_iter_init (&_tmp273_, _tmp271_);
	for (; (_tmp274_ = g_variant_iter_next_value (&_tmp273_)) != NULL; _tmp272__length1++) {
		if (_tmp272__size == _tmp272__length) {
			_tmp272__size = 2 * _tmp272__size;
			_tmp272_ = g_renew (guint32, _tmp272_, _tmp272__size + 1);
		}
		_tmp272_[_tmp272__length++] = g_variant_get_uint32 (_tmp274_);
		g_variant_unref (_tmp274_);
	}
	_result_length1 = _tmp272__length1;
	_result = _tmp272_;
	g_variant_unref (_tmp271_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_IsTimerActive (DVBIDBusRecorder* self,
                                         guint32 timer_id,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp277_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "IsTimerActive");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp275_ = FALSE;
		return _tmp275_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp276_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp276_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp277_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp277_);
	g_variant_unref (_tmp277_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recorder_proxy_HasTimer (DVBIDBusRecorder* self,
                                    guint start_year,
                                    guint start_month,
                                    guint start_day,
                                    guint start_hour,
                                    guint start_minute,
                                    guint duration,
                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp280_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "HasTimer");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (start_year));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (start_month));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (start_day));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (start_hour));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (start_minute));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (duration));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp278_ = FALSE;
		return _tmp278_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp279_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp279_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp280_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp280_);
	g_variant_unref (_tmp280_);
	g_object_unref (_reply_message);
	return _result;
}

static DVBOverlapType
dvb_id_bus_recorder_proxy_HasTimerForEvent (DVBIDBusRecorder* self,
                                            guint event_id,
                                            guint channel_sid,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DVBOverlapType _result = 0;
	GVariant* _tmp281_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Recorder", "HasTimerForEvent");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (event_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (channel_sid));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return 0;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return 0;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp281_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_int32 (_tmp281_);
	g_variant_unref (_tmp281_);
	g_object_unref (_reply_message);
	return _result;
}

static void
dvb_id_bus_recorder_proxy_dvb_id_bus_recorder_interface_init (DVBIDBusRecorderIface* iface)
{
	iface->AddTimer = dvb_id_bus_recorder_proxy_AddTimer;
	iface->AddTimerWithMargin = dvb_id_bus_recorder_proxy_AddTimerWithMargin;
	iface->AddTimerForEPGEvent = dvb_id_bus_recorder_proxy_AddTimerForEPGEvent;
	iface->DeleteTimer = dvb_id_bus_recorder_proxy_DeleteTimer;
	iface->GetTimers = dvb_id_bus_recorder_proxy_GetTimers;
	iface->GetStartTime = dvb_id_bus_recorder_proxy_GetStartTime;
	iface->SetStartTime = dvb_id_bus_recorder_proxy_SetStartTime;
	iface->GetEndTime = dvb_id_bus_recorder_proxy_GetEndTime;
	iface->GetDuration = dvb_id_bus_recorder_proxy_GetDuration;
	iface->SetDuration = dvb_id_bus_recorder_proxy_SetDuration;
	iface->GetChannelName = dvb_id_bus_recorder_proxy_GetChannelName;
	iface->GetTitle = dvb_id_bus_recorder_proxy_GetTitle;
	iface->GetAllInformations = dvb_id_bus_recorder_proxy_GetAllInformations;
	iface->GetActiveTimers = dvb_id_bus_recorder_proxy_GetActiveTimers;
	iface->IsTimerActive = dvb_id_bus_recorder_proxy_IsTimerActive;
	iface->HasTimer = dvb_id_bus_recorder_proxy_HasTimer;
	iface->HasTimerForEvent = dvb_id_bus_recorder_proxy_HasTimerForEvent;
}

static void
_dbus_dvb_id_bus_recorder_AddTimer (DVBIDBusRecorder* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint channel = 0U;
	GVariant* _tmp282_;
	gint start_year = 0;
	GVariant* _tmp283_;
	gint start_month = 0;
	GVariant* _tmp284_;
	gint start_day = 0;
	GVariant* _tmp285_;
	gint start_hour = 0;
	GVariant* _tmp286_;
	gint start_minute = 0;
	GVariant* _tmp287_;
	guint duration = 0U;
	GVariant* _tmp288_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 timer_id = 0U;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp282_ = g_variant_iter_next_value (&_arguments_iter);
	channel = g_variant_get_uint32 (_tmp282_);
	g_variant_unref (_tmp282_);
	_tmp283_ = g_variant_iter_next_value (&_arguments_iter);
	start_year = g_variant_get_int32 (_tmp283_);
	g_variant_unref (_tmp283_);
	_tmp284_ = g_variant_iter_next_value (&_arguments_iter);
	start_month = g_variant_get_int32 (_tmp284_);
	g_variant_unref (_tmp284_);
	_tmp285_ = g_variant_iter_next_value (&_arguments_iter);
	start_day = g_variant_get_int32 (_tmp285_);
	g_variant_unref (_tmp285_);
	_tmp286_ = g_variant_iter_next_value (&_arguments_iter);
	start_hour = g_variant_get_int32 (_tmp286_);
	g_variant_unref (_tmp286_);
	_tmp287_ = g_variant_iter_next_value (&_arguments_iter);
	start_minute = g_variant_get_int32 (_tmp287_);
	g_variant_unref (_tmp287_);
	_tmp288_ = g_variant_iter_next_value (&_arguments_iter);
	duration = g_variant_get_uint32 (_tmp288_);
	g_variant_unref (_tmp288_);
	result = dvb_id_bus_recorder_AddTimer (self, channel, start_year, start_month, start_day, start_hour, start_minute, duration, &timer_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_AddTimerWithMargin (DVBIDBusRecorder* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint channel = 0U;
	GVariant* _tmp289_;
	gint start_year = 0;
	GVariant* _tmp290_;
	gint start_month = 0;
	GVariant* _tmp291_;
	gint start_day = 0;
	GVariant* _tmp292_;
	gint start_hour = 0;
	GVariant* _tmp293_;
	gint start_minute = 0;
	GVariant* _tmp294_;
	guint duration = 0U;
	GVariant* _tmp295_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 timer_id = 0U;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp289_ = g_variant_iter_next_value (&_arguments_iter);
	channel = g_variant_get_uint32 (_tmp289_);
	g_variant_unref (_tmp289_);
	_tmp290_ = g_variant_iter_next_value (&_arguments_iter);
	start_year = g_variant_get_int32 (_tmp290_);
	g_variant_unref (_tmp290_);
	_tmp291_ = g_variant_iter_next_value (&_arguments_iter);
	start_month = g_variant_get_int32 (_tmp291_);
	g_variant_unref (_tmp291_);
	_tmp292_ = g_variant_iter_next_value (&_arguments_iter);
	start_day = g_variant_get_int32 (_tmp292_);
	g_variant_unref (_tmp292_);
	_tmp293_ = g_variant_iter_next_value (&_arguments_iter);
	start_hour = g_variant_get_int32 (_tmp293_);
	g_variant_unref (_tmp293_);
	_tmp294_ = g_variant_iter_next_value (&_arguments_iter);
	start_minute = g_variant_get_int32 (_tmp294_);
	g_variant_unref (_tmp294_);
	_tmp295_ = g_variant_iter_next_value (&_arguments_iter);
	duration = g_variant_get_uint32 (_tmp295_);
	g_variant_unref (_tmp295_);
	result = dvb_id_bus_recorder_AddTimerWithMargin (self, channel, start_year, start_month, start_day, start_hour, start_minute, duration, &timer_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_AddTimerForEPGEvent (DVBIDBusRecorder* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint event_id = 0U;
	GVariant* _tmp296_;
	guint channel_sid = 0U;
	GVariant* _tmp297_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 timer_id = 0U;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp296_ = g_variant_iter_next_value (&_arguments_iter);
	event_id = g_variant_get_uint32 (_tmp296_);
	g_variant_unref (_tmp296_);
	_tmp297_ = g_variant_iter_next_value (&_arguments_iter);
	channel_sid = g_variant_get_uint32 (_tmp297_);
	g_variant_unref (_tmp297_);
	result = dvb_id_bus_recorder_AddTimerForEPGEvent (self, event_id, channel_sid, &timer_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_DeleteTimer (DVBIDBusRecorder* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp298_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp298_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp298_);
	g_variant_unref (_tmp298_);
	result = dvb_id_bus_recorder_DeleteTimer (self, timer_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_GetTimers (DVBIDBusRecorder* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32* result;
	gint result_length1 = 0;
	guint32* _tmp299_;
	GVariantBuilder _tmp300_;
	gint _tmp301_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_recorder_GetTimers (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp299_ = result;
	g_variant_builder_init (&_tmp300_, G_VARIANT_TYPE ("au"));
	for (_tmp301_ = 0; _tmp301_ < result_length1; _tmp301_++) {
		g_variant_builder_add_value (&_tmp300_, g_variant_new_uint32 (*_tmp299_));
		_tmp299_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp300_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_GetStartTime (DVBIDBusRecorder* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp302_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32* start_time = NULL;
	gint start_time_length1 = 0;
	guint32* _tmp303_;
	GVariantBuilder _tmp304_;
	gint _tmp305_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp302_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp302_);
	g_variant_unref (_tmp302_);
	result = dvb_id_bus_recorder_GetStartTime (self, timer_id, &start_time, &start_time_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp303_ = start_time;
	g_variant_builder_init (&_tmp304_, G_VARIANT_TYPE ("au"));
	for (_tmp305_ = 0; _tmp305_ < start_time_length1; _tmp305_++) {
		g_variant_builder_add_value (&_tmp304_, g_variant_new_uint32 (*_tmp303_));
		_tmp303_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp304_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	start_time = (g_free (start_time), NULL);
}

static void
_dbus_dvb_id_bus_recorder_SetStartTime (DVBIDBusRecorder* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp306_;
	gint start_year = 0;
	GVariant* _tmp307_;
	gint start_month = 0;
	GVariant* _tmp308_;
	gint start_day = 0;
	GVariant* _tmp309_;
	gint start_hour = 0;
	GVariant* _tmp310_;
	gint start_minute = 0;
	GVariant* _tmp311_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp306_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp306_);
	g_variant_unref (_tmp306_);
	_tmp307_ = g_variant_iter_next_value (&_arguments_iter);
	start_year = g_variant_get_int32 (_tmp307_);
	g_variant_unref (_tmp307_);
	_tmp308_ = g_variant_iter_next_value (&_arguments_iter);
	start_month = g_variant_get_int32 (_tmp308_);
	g_variant_unref (_tmp308_);
	_tmp309_ = g_variant_iter_next_value (&_arguments_iter);
	start_day = g_variant_get_int32 (_tmp309_);
	g_variant_unref (_tmp309_);
	_tmp310_ = g_variant_iter_next_value (&_arguments_iter);
	start_hour = g_variant_get_int32 (_tmp310_);
	g_variant_unref (_tmp310_);
	_tmp311_ = g_variant_iter_next_value (&_arguments_iter);
	start_minute = g_variant_get_int32 (_tmp311_);
	g_variant_unref (_tmp311_);
	result = dvb_id_bus_recorder_SetStartTime (self, timer_id, start_year, start_month, start_day, start_hour, start_minute, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_GetEndTime (DVBIDBusRecorder* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp312_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* end_time = NULL;
	gint end_time_length1 = 0;
	guint* _tmp313_;
	GVariantBuilder _tmp314_;
	gint _tmp315_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp312_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp312_);
	g_variant_unref (_tmp312_);
	result = dvb_id_bus_recorder_GetEndTime (self, timer_id, &end_time, &end_time_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp313_ = end_time;
	g_variant_builder_init (&_tmp314_, G_VARIANT_TYPE ("au"));
	for (_tmp315_ = 0; _tmp315_ < end_time_length1; _tmp315_++) {
		g_variant_builder_add_value (&_tmp314_, g_variant_new_uint32 (*_tmp313_));
		_tmp313_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp314_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	end_time = (g_free (end_time), NULL);
}

static void
_dbus_dvb_id_bus_recorder_GetDuration (DVBIDBusRecorder* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp316_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint duration = 0U;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp316_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp316_);
	g_variant_unref (_tmp316_);
	result = dvb_id_bus_recorder_GetDuration (self, timer_id, &duration, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (duration));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_SetDuration (DVBIDBusRecorder* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp317_;
	guint duration = 0U;
	GVariant* _tmp318_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp317_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp317_);
	g_variant_unref (_tmp317_);
	_tmp318_ = g_variant_iter_next_value (&_arguments_iter);
	duration = g_variant_get_uint32 (_tmp318_);
	g_variant_unref (_tmp318_);
	result = dvb_id_bus_recorder_SetDuration (self, timer_id, duration, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_GetChannelName (DVBIDBusRecorder* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp319_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* name = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp319_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp319_);
	g_variant_unref (_tmp319_);
	result = dvb_id_bus_recorder_GetChannelName (self, timer_id, &name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_dvb_id_bus_recorder_GetTitle (DVBIDBusRecorder* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp320_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* title = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp320_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp320_);
	g_variant_unref (_tmp320_);
	result = dvb_id_bus_recorder_GetTitle (self, timer_id, &title, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (title));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (title);
}

static void
_dbus_dvb_id_bus_recorder_GetAllInformations (DVBIDBusRecorder* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp321_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DVBTimerInfo info = {0};
	GVariantBuilder _tmp322_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp321_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp321_);
	g_variant_unref (_tmp321_);
	result = dvb_id_bus_recorder_GetAllInformations (self, timer_id, &info, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp322_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp322_, g_variant_new_uint32 (info.id));
	g_variant_builder_add_value (&_tmp322_, g_variant_new_uint32 (info.duration));
	g_variant_builder_add_value (&_tmp322_, g_variant_new_boolean (info.active));
	g_variant_builder_add_value (&_tmp322_, g_variant_new_string (info.channel_name));
	g_variant_builder_add_value (&_tmp322_, g_variant_new_string (info.title));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp322_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	dvb_timer_info_destroy (&info);
}

static void
_dbus_dvb_id_bus_recorder_GetActiveTimers (DVBIDBusRecorder* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32* result;
	gint result_length1 = 0;
	guint32* _tmp323_;
	GVariantBuilder _tmp324_;
	gint _tmp325_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_recorder_GetActiveTimers (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp323_ = result;
	g_variant_builder_init (&_tmp324_, G_VARIANT_TYPE ("au"));
	for (_tmp325_ = 0; _tmp325_ < result_length1; _tmp325_++) {
		g_variant_builder_add_value (&_tmp324_, g_variant_new_uint32 (*_tmp323_));
		_tmp323_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp324_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_IsTimerActive (DVBIDBusRecorder* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 timer_id = 0U;
	GVariant* _tmp326_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp326_ = g_variant_iter_next_value (&_arguments_iter);
	timer_id = g_variant_get_uint32 (_tmp326_);
	g_variant_unref (_tmp326_);
	result = dvb_id_bus_recorder_IsTimerActive (self, timer_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_HasTimer (DVBIDBusRecorder* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint start_year = 0U;
	GVariant* _tmp327_;
	guint start_month = 0U;
	GVariant* _tmp328_;
	guint start_day = 0U;
	GVariant* _tmp329_;
	guint start_hour = 0U;
	GVariant* _tmp330_;
	guint start_minute = 0U;
	GVariant* _tmp331_;
	guint duration = 0U;
	GVariant* _tmp332_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp327_ = g_variant_iter_next_value (&_arguments_iter);
	start_year = g_variant_get_uint32 (_tmp327_);
	g_variant_unref (_tmp327_);
	_tmp328_ = g_variant_iter_next_value (&_arguments_iter);
	start_month = g_variant_get_uint32 (_tmp328_);
	g_variant_unref (_tmp328_);
	_tmp329_ = g_variant_iter_next_value (&_arguments_iter);
	start_day = g_variant_get_uint32 (_tmp329_);
	g_variant_unref (_tmp329_);
	_tmp330_ = g_variant_iter_next_value (&_arguments_iter);
	start_hour = g_variant_get_uint32 (_tmp330_);
	g_variant_unref (_tmp330_);
	_tmp331_ = g_variant_iter_next_value (&_arguments_iter);
	start_minute = g_variant_get_uint32 (_tmp331_);
	g_variant_unref (_tmp331_);
	_tmp332_ = g_variant_iter_next_value (&_arguments_iter);
	duration = g_variant_get_uint32 (_tmp332_);
	g_variant_unref (_tmp332_);
	result = dvb_id_bus_recorder_HasTimer (self, start_year, start_month, start_day, start_hour, start_minute, duration, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recorder_HasTimerForEvent (DVBIDBusRecorder* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint event_id = 0U;
	GVariant* _tmp333_;
	guint channel_sid = 0U;
	GVariant* _tmp334_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DVBOverlapType result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp333_ = g_variant_iter_next_value (&_arguments_iter);
	event_id = g_variant_get_uint32 (_tmp333_);
	g_variant_unref (_tmp333_);
	_tmp334_ = g_variant_iter_next_value (&_arguments_iter);
	channel_sid = g_variant_get_uint32 (_tmp334_);
	g_variant_unref (_tmp334_);
	result = dvb_id_bus_recorder_HasTimerForEvent (self, event_id, channel_sid, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
dvb_id_bus_recorder_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "AddTimer") == 0) {
		_dbus_dvb_id_bus_recorder_AddTimer (object, parameters, invocation);
	} else if (strcmp (method_name, "AddTimerWithMargin") == 0) {
		_dbus_dvb_id_bus_recorder_AddTimerWithMargin (object, parameters, invocation);
	} else if (strcmp (method_name, "AddTimerForEPGEvent") == 0) {
		_dbus_dvb_id_bus_recorder_AddTimerForEPGEvent (object, parameters, invocation);
	} else if (strcmp (method_name, "DeleteTimer") == 0) {
		_dbus_dvb_id_bus_recorder_DeleteTimer (object, parameters, invocation);
	} else if (strcmp (method_name, "GetTimers") == 0) {
		_dbus_dvb_id_bus_recorder_GetTimers (object, parameters, invocation);
	} else if (strcmp (method_name, "GetStartTime") == 0) {
		_dbus_dvb_id_bus_recorder_GetStartTime (object, parameters, invocation);
	} else if (strcmp (method_name, "SetStartTime") == 0) {
		_dbus_dvb_id_bus_recorder_SetStartTime (object, parameters, invocation);
	} else if (strcmp (method_name, "GetEndTime") == 0) {
		_dbus_dvb_id_bus_recorder_GetEndTime (object, parameters, invocation);
	} else if (strcmp (method_name, "GetDuration") == 0) {
		_dbus_dvb_id_bus_recorder_GetDuration (object, parameters, invocation);
	} else if (strcmp (method_name, "SetDuration") == 0) {
		_dbus_dvb_id_bus_recorder_SetDuration (object, parameters, invocation);
	} else if (strcmp (method_name, "GetChannelName") == 0) {
		_dbus_dvb_id_bus_recorder_GetChannelName (object, parameters, invocation);
	} else if (strcmp (method_name, "GetTitle") == 0) {
		_dbus_dvb_id_bus_recorder_GetTitle (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAllInformations") == 0) {
		_dbus_dvb_id_bus_recorder_GetAllInformations (object, parameters, invocation);
	} else if (strcmp (method_name, "GetActiveTimers") == 0) {
		_dbus_dvb_id_bus_recorder_GetActiveTimers (object, parameters, invocation);
	} else if (strcmp (method_name, "IsTimerActive") == 0) {
		_dbus_dvb_id_bus_recorder_IsTimerActive (object, parameters, invocation);
	} else if (strcmp (method_name, "HasTimer") == 0) {
		_dbus_dvb_id_bus_recorder_HasTimer (object, parameters, invocation);
	} else if (strcmp (method_name, "HasTimerForEvent") == 0) {
		_dbus_dvb_id_bus_recorder_HasTimerForEvent (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
dvb_id_bus_recorder_dbus_interface_get_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
dvb_id_bus_recorder_dbus_interface_set_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GVariant* value,
                                                 GError** error,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_dvb_id_bus_recorder_recording_started (GObject* _sender,
                                             guint32 timer_id,
                                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Recorder", "RecordingStarted", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_recorder_recording_finished (GObject* _sender,
                                              guint32 recording_id,
                                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (recording_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Recorder", "RecordingFinished", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_recorder_changed (GObject* _sender,
                                   guint32 timer_id,
                                   guint type,
                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timer_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Recorder", "Changed", _arguments, NULL);
}

guint
dvb_id_bus_recorder_register_object (gpointer object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dvb_id_bus_recorder_dbus_interface_info), &_dvb_id_bus_recorder_dbus_interface_vtable, data, _dvb_id_bus_recorder_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "recording-started", (GCallback) _dbus_dvb_id_bus_recorder_recording_started, data);
	g_signal_connect (object, "recording-finished", (GCallback) _dbus_dvb_id_bus_recorder_recording_finished, data);
	g_signal_connect (object, "changed", (GCallback) _dbus_dvb_id_bus_recorder_changed, data);
	return result;
}

static void
_dvb_id_bus_recorder_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_recorder_recording_started, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_recorder_recording_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_recorder_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

