/* IDBusRecordingsStore.c generated by valac 0.56.18, the Vala compiler
 * generated from IDBusRecordingsStore.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_RECORDING_INFO (dvb_recording_info_get_type ())
typedef struct _DVBRecordingInfo DVBRecordingInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_ID_BUS_RECORDINGS_STORE (dvb_id_bus_recordings_store_get_type ())
#define DVB_ID_BUS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE, DVBIDBusRecordingsStore))
#define DVB_IS_ID_BUS_RECORDINGS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE))
#define DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_RECORDINGS_STORE, DVBIDBusRecordingsStoreIface))

typedef struct _DVBIDBusRecordingsStore DVBIDBusRecordingsStore;
typedef struct _DVBIDBusRecordingsStoreIface DVBIDBusRecordingsStoreIface;

#define DVB_TYPE_ID_BUS_RECORDINGS_STORE_PROXY (dvb_id_bus_recordings_store_proxy_get_type ())
enum  {
	DVB_ID_BUS_RECORDINGS_STORE_CHANGED_SIGNAL,
	DVB_ID_BUS_RECORDINGS_STORE_NUM_SIGNALS
};
static guint dvb_id_bus_recordings_store_signals[DVB_ID_BUS_RECORDINGS_STORE_NUM_SIGNALS] = {0};
typedef GDBusProxy DVBIDBusRecordingsStoreProxy;
typedef GDBusProxyClass DVBIDBusRecordingsStoreProxyClass;

struct _DVBRecordingInfo {
	guint32 id;
	gchar* name;
	gchar* description;
	gint64 length;
	gint64 start_timestamp;
	gchar* channel;
	gchar* location;
};

struct _DVBIDBusRecordingsStoreIface {
	GTypeInterface parent_iface;
	guint32* (*GetRecordings) (DVBIDBusRecordingsStore* self, gint* result_length1, GError** error);
	gboolean (*GetLocation) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** location, GError** error);
	gboolean (*GetName) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** name, GError** error);
	gboolean (*GetDescription) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** description, GError** error);
	gboolean (*GetStartTime) (DVBIDBusRecordingsStore* self, guint32 rec_id, guint** start_time, gint* start_time_length1, GError** error);
	gboolean (*GetStartTimestamp) (DVBIDBusRecordingsStore* self, guint32 rec_id, gint64* timestamp, GError** error);
	gboolean (*GetLength) (DVBIDBusRecordingsStore* self, guint32 rec_id, gint64* length, GError** error);
	gboolean (*Delete) (DVBIDBusRecordingsStore* self, guint32 rec_id, GError** error);
	gboolean (*GetChannelName) (DVBIDBusRecordingsStore* self, guint32 rec_id, gchar** name, GError** error);
	gboolean (*GetAllInformations) (DVBIDBusRecordingsStore* self, guint32 rec_id, DVBRecordingInfo* infos, GError** error);
};

VALA_EXTERN GType dvb_recording_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBRecordingInfo* dvb_recording_info_dup (const DVBRecordingInfo* self);
VALA_EXTERN void dvb_recording_info_free (DVBRecordingInfo* self);
VALA_EXTERN void dvb_recording_info_copy (const DVBRecordingInfo* self,
                              DVBRecordingInfo* dest);
VALA_EXTERN void dvb_recording_info_destroy (DVBRecordingInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBRecordingInfo, dvb_recording_info_destroy)
VALA_EXTERN GType dvb_id_bus_recordings_store_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_recordings_store_register_object (void* object,
                                                   GDBusConnection* connection,
                                                   const gchar* path,
                                                   GError** error);
VALA_EXTERN GType dvb_id_bus_recordings_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusRecordingsStore, g_object_unref)
VALA_EXTERN guint32* dvb_id_bus_recordings_store_GetRecordings (DVBIDBusRecordingsStore* self,
                                                    gint* result_length1,
                                                    GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetLocation (DVBIDBusRecordingsStore* self,
                                                  guint32 rec_id,
                                                  gchar** location,
                                                  GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetName (DVBIDBusRecordingsStore* self,
                                              guint32 rec_id,
                                              gchar** name,
                                              GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetDescription (DVBIDBusRecordingsStore* self,
                                                     guint32 rec_id,
                                                     gchar** description,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetStartTime (DVBIDBusRecordingsStore* self,
                                                   guint32 rec_id,
                                                   guint** start_time,
                                                   gint* start_time_length1,
                                                   GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                                        guint32 rec_id,
                                                        gint64* timestamp,
                                                        GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetLength (DVBIDBusRecordingsStore* self,
                                                guint32 rec_id,
                                                gint64* length,
                                                GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_Delete (DVBIDBusRecordingsStore* self,
                                             guint32 rec_id,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetChannelName (DVBIDBusRecordingsStore* self,
                                                     guint32 rec_id,
                                                     gchar** name,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_recordings_store_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                         guint32 rec_id,
                                                         DVBRecordingInfo* infos,
                                                         GError** error);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GType dvb_id_bus_recordings_store_get_type_once (void);
static void dvb_id_bus_recordings_store_proxy_g_signal (GDBusProxy* proxy,
                                                 const gchar* sender_name,
                                                 const gchar* signal_name,
                                                 GVariant* parameters);
static void _dbus_handle_dvb_id_bus_recordings_store_changed (DVBIDBusRecordingsStore* self,
                                                       GVariant* parameters);
static guint32* dvb_id_bus_recordings_store_proxy_GetRecordings (DVBIDBusRecordingsStore* self,
                                                          gint* result_length1,
                                                          GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetLocation (DVBIDBusRecordingsStore* self,
                                                        guint32 rec_id,
                                                        gchar** location,
                                                        GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetName (DVBIDBusRecordingsStore* self,
                                                    guint32 rec_id,
                                                    gchar** name,
                                                    GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetDescription (DVBIDBusRecordingsStore* self,
                                                           guint32 rec_id,
                                                           gchar** description,
                                                           GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetStartTime (DVBIDBusRecordingsStore* self,
                                                         guint32 rec_id,
                                                         guint** start_time,
                                                         gint* start_time_length1,
                                                         GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                                              guint32 rec_id,
                                                              gint64* timestamp,
                                                              GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetLength (DVBIDBusRecordingsStore* self,
                                                      guint32 rec_id,
                                                      gint64* length,
                                                      GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_Delete (DVBIDBusRecordingsStore* self,
                                                   guint32 rec_id,
                                                   GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetChannelName (DVBIDBusRecordingsStore* self,
                                                           guint32 rec_id,
                                                           gchar** name,
                                                           GError** error);
static gboolean dvb_id_bus_recordings_store_proxy_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                               guint32 rec_id,
                                                               DVBRecordingInfo* infos,
                                                               GError** error);
static void dvb_id_bus_recordings_store_proxy_dvb_id_bus_recordings_store_interface_init (DVBIDBusRecordingsStoreIface* iface);
static void _dbus_dvb_id_bus_recordings_store_GetRecordings (DVBIDBusRecordingsStore* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetLocation (DVBIDBusRecordingsStore* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetName (DVBIDBusRecordingsStore* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetDescription (DVBIDBusRecordingsStore* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetStartTime (DVBIDBusRecordingsStore* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetLength (DVBIDBusRecordingsStore* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_Delete (DVBIDBusRecordingsStore* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetChannelName (DVBIDBusRecordingsStore* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_recordings_store_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void dvb_id_bus_recordings_store_dbus_interface_method_call (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* method_name,
                                                             GVariant* parameters,
                                                             GDBusMethodInvocation* invocation,
                                                             gpointer user_data);
static GVariant* dvb_id_bus_recordings_store_dbus_interface_get_property (GDBusConnection* connection,
                                                                   const gchar* sender,
                                                                   const gchar* object_path,
                                                                   const gchar* interface_name,
                                                                   const gchar* property_name,
                                                                   GError** error,
                                                                   gpointer user_data);
static gboolean dvb_id_bus_recordings_store_dbus_interface_set_property (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* property_name,
                                                                  GVariant* value,
                                                                  GError** error,
                                                                  gpointer user_data);
static void _dbus_dvb_id_bus_recordings_store_changed (GObject* _sender,
                                                guint32 rec_id,
                                                guint type,
                                                gpointer* _data);
static void _dvb_id_bus_recordings_store_unregister_object (gpointer user_data);

static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetRecordings = {-1, "GetRecordings", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetRecordings_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_location = {-1, "location", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_location, &_dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetLocation = {-1, "GetLocation", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetLocation_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetName_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetName_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetName_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetName_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetName_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetName_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetName_name, &_dvb_id_bus_recordings_store_dbus_arg_info_GetName_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetName = {-1, "GetName", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetName_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetName_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_description = {-1, "description", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_description, &_dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetDescription = {-1, "GetDescription", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetDescription_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_start_time = {-1, "start_time", "au", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_start_time, &_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetStartTime = {-1, "GetStartTime", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTime_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_timestamp = {-1, "timestamp", "x", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_timestamp, &_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetStartTimestamp = {-1, "GetStartTimestamp", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetStartTimestamp_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLength_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLength_length = {-1, "length", "x", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetLength_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetLength_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetLength_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetLength_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetLength_length, &_dvb_id_bus_recordings_store_dbus_arg_info_GetLength_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetLength = {-1, "GetLength", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetLength_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetLength_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_Delete_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_Delete_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_Delete_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_Delete_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_Delete_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_Delete_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_Delete = {-1, "Delete", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_Delete_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_Delete_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_name, &_dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetChannelName = {-1, "GetChannelName", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetChannelName_out), NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_infos = {-1, "infos", "(ussxxss)", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_in[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_rec_id, NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_out[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_infos, &_dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_recordings_store_dbus_method_info_GetAllInformations = {-1, "GetAllInformations", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_in), (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_GetAllInformations_out), NULL};
static const GDBusMethodInfo * const _dvb_id_bus_recordings_store_dbus_method_info[] = {&_dvb_id_bus_recordings_store_dbus_method_info_GetRecordings, &_dvb_id_bus_recordings_store_dbus_method_info_GetLocation, &_dvb_id_bus_recordings_store_dbus_method_info_GetName, &_dvb_id_bus_recordings_store_dbus_method_info_GetDescription, &_dvb_id_bus_recordings_store_dbus_method_info_GetStartTime, &_dvb_id_bus_recordings_store_dbus_method_info_GetStartTimestamp, &_dvb_id_bus_recordings_store_dbus_method_info_GetLength, &_dvb_id_bus_recordings_store_dbus_method_info_Delete, &_dvb_id_bus_recordings_store_dbus_method_info_GetChannelName, &_dvb_id_bus_recordings_store_dbus_method_info_GetAllInformations, NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_changed_rec_id = {-1, "rec_id", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_recordings_store_dbus_arg_info_changed_type = {-1, "type", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_recordings_store_dbus_arg_info_changed[] = {&_dvb_id_bus_recordings_store_dbus_arg_info_changed_rec_id, &_dvb_id_bus_recordings_store_dbus_arg_info_changed_type, NULL};
static const GDBusSignalInfo _dvb_id_bus_recordings_store_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_dvb_id_bus_recordings_store_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _dvb_id_bus_recordings_store_dbus_signal_info[] = {&_dvb_id_bus_recordings_store_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo * const _dvb_id_bus_recordings_store_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dvb_id_bus_recordings_store_dbus_interface_info = {-1, "org.gnome.DVB.RecordingsStore", (GDBusMethodInfo **) (&_dvb_id_bus_recordings_store_dbus_method_info), (GDBusSignalInfo **) (&_dvb_id_bus_recordings_store_dbus_signal_info), (GDBusPropertyInfo **) (&_dvb_id_bus_recordings_store_dbus_property_info), NULL};
static const GDBusInterfaceVTable _dvb_id_bus_recordings_store_dbus_interface_vtable = {dvb_id_bus_recordings_store_dbus_interface_method_call, dvb_id_bus_recordings_store_dbus_interface_get_property, dvb_id_bus_recordings_store_dbus_interface_set_property};

void
dvb_recording_info_copy (const DVBRecordingInfo* self,
                         DVBRecordingInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	(*dest).id = (*self).id;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp3_;
	(*dest).length = (*self).length;
	(*dest).start_timestamp = (*self).start_timestamp;
	_tmp4_ = (*self).channel;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).channel);
	(*dest).channel = _tmp5_;
	_tmp6_ = (*self).location;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).location);
	(*dest).location = _tmp7_;
}

void
dvb_recording_info_destroy (DVBRecordingInfo* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).description);
	_g_free0 ((*self).channel);
	_g_free0 ((*self).location);
}

DVBRecordingInfo*
dvb_recording_info_dup (const DVBRecordingInfo* self)
{
	DVBRecordingInfo* dup;
	dup = g_new0 (DVBRecordingInfo, 1);
	dvb_recording_info_copy (self, dup);
	return dup;
}

void
dvb_recording_info_free (DVBRecordingInfo* self)
{
	dvb_recording_info_destroy (self);
	g_free (self);
}

static GType
dvb_recording_info_get_type_once (void)
{
	GType dvb_recording_info_type_id;
	dvb_recording_info_type_id = g_boxed_type_register_static ("DVBRecordingInfo", (GBoxedCopyFunc) dvb_recording_info_dup, (GBoxedFreeFunc) dvb_recording_info_free);
	return dvb_recording_info_type_id;
}

GType
dvb_recording_info_get_type (void)
{
	static volatile gsize dvb_recording_info_type_id__once = 0;
	if (g_once_init_enter (&dvb_recording_info_type_id__once)) {
		GType dvb_recording_info_type_id;
		dvb_recording_info_type_id = dvb_recording_info_get_type_once ();
		g_once_init_leave (&dvb_recording_info_type_id__once, dvb_recording_info_type_id);
	}
	return dvb_recording_info_type_id__once;
}

/**
         * @returns: A list of ids for all recordings
         */
guint32*
dvb_id_bus_recordings_store_GetRecordings (DVBIDBusRecordingsStore* self,
                                           gint* result_length1,
                                           GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetRecordings) {
		return _iface_->GetRecordings (self, result_length1, error);
	}
	return NULL;
}

/**
         * @rec_id: The id of the recording
         * @location: The location of the recording on the filesystem
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetLocation (DVBIDBusRecordingsStore* self,
                                         guint32 rec_id,
                                         gchar** location,
                                         GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetLocation) {
		return _iface_->GetLocation (self, rec_id, location, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @name: The name of the recording (e.g. the name of
         * a TV show)
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetName (DVBIDBusRecordingsStore* self,
                                     guint32 rec_id,
                                     gchar** name,
                                     GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetName) {
		return _iface_->GetName (self, rec_id, name, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @description: A short text describing the recorded item
         * (e.g. the description from EPG)
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetDescription (DVBIDBusRecordingsStore* self,
                                            guint32 rec_id,
                                            gchar** description,
                                            GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetDescription) {
		return _iface_->GetDescription (self, rec_id, description, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @start_time: The starting time of the recording
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetStartTime (DVBIDBusRecordingsStore* self,
                                          guint32 rec_id,
                                          guint** start_time,
                                          gint* start_time_length1,
                                          GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetStartTime) {
		return _iface_->GetStartTime (self, rec_id, start_time, start_time_length1, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @timestamp: Start time as UNIX timestamp
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                               guint32 rec_id,
                                               gint64* timestamp,
                                               GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetStartTimestamp) {
		return _iface_->GetStartTimestamp (self, rec_id, timestamp, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @length: The length of the recording in seconds
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetLength (DVBIDBusRecordingsStore* self,
                                       guint32 rec_id,
                                       gint64* length,
                                       GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetLength) {
		return _iface_->GetLength (self, rec_id, length, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @returns: TRUE on success, FALSE otherwises
         *
         * Delete the recording. This deletes all files in the directory
         * created by the Recorder
         */
gboolean
dvb_id_bus_recordings_store_Delete (DVBIDBusRecordingsStore* self,
                                    guint32 rec_id,
                                    GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->Delete) {
		return _iface_->Delete (self, rec_id, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @name: The channel's name or an empty string if
         * rec_id doesn't exist
         * @returns: TRUE on success
         */
gboolean
dvb_id_bus_recordings_store_GetChannelName (DVBIDBusRecordingsStore* self,
                                            guint32 rec_id,
                                            gchar** name,
                                            GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetChannelName) {
		return _iface_->GetChannelName (self, rec_id, name, error);
	}
	return FALSE;
}

/**
         * @rec_id: The id of the recording
         * @returns: TRUE on success
         *
         * This method can be used to retrieve all informations
         * about a particular recording at once
         */
gboolean
dvb_id_bus_recordings_store_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                guint32 rec_id,
                                                DVBRecordingInfo* infos,
                                                GError** error)
{
	DVBIDBusRecordingsStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_RECORDINGS_STORE_GET_INTERFACE (self);
	if (_iface_->GetAllInformations) {
		return _iface_->GetAllInformations (self, rec_id, infos, error);
	}
	return FALSE;
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint32 arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
}

static void
dvb_id_bus_recordings_store_default_init (DVBIDBusRecordingsStoreIface * iface,
                                          gpointer iface_data)
{
	/**
	         * @type: 0: added, 1: deleted, 2: updated
	         */
	dvb_id_bus_recordings_store_signals[DVB_ID_BUS_RECORDINGS_STORE_CHANGED_SIGNAL] = g_signal_new ("changed", DVB_TYPE_ID_BUS_RECORDINGS_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
}

static GType
dvb_id_bus_recordings_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBIDBusRecordingsStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_id_bus_recordings_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_id_bus_recordings_store_type_id;
	dvb_id_bus_recordings_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBIDBusRecordingsStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_id_bus_recordings_store_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (dvb_id_bus_recordings_store_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dvb_id_bus_recordings_store_proxy_get_type);
	g_type_set_qdata (dvb_id_bus_recordings_store_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.DVB.RecordingsStore");
	g_type_set_qdata (dvb_id_bus_recordings_store_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_dvb_id_bus_recordings_store_dbus_interface_info));
	g_type_set_qdata (dvb_id_bus_recordings_store_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dvb_id_bus_recordings_store_register_object);
	return dvb_id_bus_recordings_store_type_id;
}

GType
dvb_id_bus_recordings_store_get_type (void)
{
	static volatile gsize dvb_id_bus_recordings_store_type_id__once = 0;
	if (g_once_init_enter (&dvb_id_bus_recordings_store_type_id__once)) {
		GType dvb_id_bus_recordings_store_type_id;
		dvb_id_bus_recordings_store_type_id = dvb_id_bus_recordings_store_get_type_once ();
		g_once_init_leave (&dvb_id_bus_recordings_store_type_id__once, dvb_id_bus_recordings_store_type_id);
	}
	return dvb_id_bus_recordings_store_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DVBIDBusRecordingsStoreProxy, dvb_id_bus_recordings_store_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DVB_TYPE_ID_BUS_RECORDINGS_STORE, dvb_id_bus_recordings_store_proxy_dvb_id_bus_recordings_store_interface_init) )
static void
dvb_id_bus_recordings_store_proxy_class_init (DVBIDBusRecordingsStoreProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = dvb_id_bus_recordings_store_proxy_g_signal;
}

static void
_dbus_handle_dvb_id_bus_recordings_store_changed (DVBIDBusRecordingsStore* self,
                                                  GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp335_;
	guint type = 0U;
	GVariant* _tmp336_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp335_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp335_);
	g_variant_unref (_tmp335_);
	_tmp336_ = g_variant_iter_next_value (&_arguments_iter);
	type = g_variant_get_uint32 (_tmp336_);
	g_variant_unref (_tmp336_);
	g_signal_emit_by_name (self, "changed", rec_id, type);
}

static void
dvb_id_bus_recordings_store_proxy_g_signal (GDBusProxy* proxy,
                                            const gchar* sender_name,
                                            const gchar* signal_name,
                                            GVariant* parameters)
{
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_dvb_id_bus_recordings_store_changed ((DVBIDBusRecordingsStore*) proxy, parameters);
	}
}

static void
dvb_id_bus_recordings_store_proxy_init (DVBIDBusRecordingsStoreProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_dvb_id_bus_recordings_store_dbus_interface_info));
}

static guint32*
dvb_id_bus_recordings_store_proxy_GetRecordings (DVBIDBusRecordingsStore* self,
                                                 gint* result_length1,
                                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32* _result = NULL;
	gint _result_length1;
	GVariant* _tmp337_;
	guint32* _tmp338_;
	gint _tmp338__length;
	gint _tmp338__size;
	gint _tmp338__length1;
	GVariantIter _tmp339_;
	GVariant* _tmp340_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetRecordings");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp337_ = g_variant_iter_next_value (&_reply_iter);
	_tmp338_ = g_new (guint32, 5);
	_tmp338__length = 0;
	_tmp338__size = 4;
	_tmp338__length1 = 0;
	g_variant_iter_init (&_tmp339_, _tmp337_);
	for (; (_tmp340_ = g_variant_iter_next_value (&_tmp339_)) != NULL; _tmp338__length1++) {
		if (_tmp338__size == _tmp338__length) {
			_tmp338__size = 2 * _tmp338__size;
			_tmp338_ = g_renew (guint32, _tmp338_, _tmp338__size + 1);
		}
		_tmp338_[_tmp338__length++] = g_variant_get_uint32 (_tmp340_);
		g_variant_unref (_tmp340_);
	}
	_result_length1 = _tmp338__length1;
	_result = _tmp338_;
	g_variant_unref (_tmp337_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetLocation (DVBIDBusRecordingsStore* self,
                                               guint32 rec_id,
                                               gchar** location,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_location = NULL;
	GVariant* _tmp343_;
	gboolean _result = FALSE;
	GVariant* _tmp344_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetLocation");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp341_ = FALSE;
		return _tmp341_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp342_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp342_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp343_ = g_variant_iter_next_value (&_reply_iter);
	_vala_location = g_variant_dup_string (_tmp343_, NULL);
	g_variant_unref (_tmp343_);
	*location = _vala_location;
	_tmp344_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp344_);
	g_variant_unref (_tmp344_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetName (DVBIDBusRecordingsStore* self,
                                           guint32 rec_id,
                                           gchar** name,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_name = NULL;
	GVariant* _tmp347_;
	gboolean _result = FALSE;
	GVariant* _tmp348_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetName");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp345_ = FALSE;
		return _tmp345_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp346_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp346_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp347_ = g_variant_iter_next_value (&_reply_iter);
	_vala_name = g_variant_dup_string (_tmp347_, NULL);
	g_variant_unref (_tmp347_);
	*name = _vala_name;
	_tmp348_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp348_);
	g_variant_unref (_tmp348_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetDescription (DVBIDBusRecordingsStore* self,
                                                  guint32 rec_id,
                                                  gchar** description,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_description = NULL;
	GVariant* _tmp351_;
	gboolean _result = FALSE;
	GVariant* _tmp352_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetDescription");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp349_ = FALSE;
		return _tmp349_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp350_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp350_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp351_ = g_variant_iter_next_value (&_reply_iter);
	_vala_description = g_variant_dup_string (_tmp351_, NULL);
	g_variant_unref (_tmp351_);
	*description = _vala_description;
	_tmp352_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp352_);
	g_variant_unref (_tmp352_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetStartTime (DVBIDBusRecordingsStore* self,
                                                guint32 rec_id,
                                                guint** start_time,
                                                gint* start_time_length1,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint* _vala_start_time = NULL;
	gint _vala_start_time_length1;
	GVariant* _tmp355_;
	guint* _tmp356_;
	gint _tmp356__length;
	gint _tmp356__size;
	gint _tmp356__length1;
	GVariantIter _tmp357_;
	GVariant* _tmp358_;
	gboolean _result = FALSE;
	GVariant* _tmp359_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetStartTime");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp353_ = FALSE;
		return _tmp353_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp354_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp354_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_start_time_length1 = 0;
	_tmp355_ = g_variant_iter_next_value (&_reply_iter);
	_tmp356_ = g_new (guint, 5);
	_tmp356__length = 0;
	_tmp356__size = 4;
	_tmp356__length1 = 0;
	g_variant_iter_init (&_tmp357_, _tmp355_);
	for (; (_tmp358_ = g_variant_iter_next_value (&_tmp357_)) != NULL; _tmp356__length1++) {
		if (_tmp356__size == _tmp356__length) {
			_tmp356__size = 2 * _tmp356__size;
			_tmp356_ = g_renew (guint, _tmp356_, _tmp356__size + 1);
		}
		_tmp356_[_tmp356__length++] = g_variant_get_uint32 (_tmp358_);
		g_variant_unref (_tmp358_);
	}
	_vala_start_time_length1 = _tmp356__length1;
	_vala_start_time = _tmp356_;
	g_variant_unref (_tmp355_);
	*start_time = _vala_start_time;
	*start_time_length1 = _vala_start_time_length1;
	_tmp359_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp359_);
	g_variant_unref (_tmp359_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                                     guint32 rec_id,
                                                     gint64* timestamp,
                                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint64 _vala_timestamp = 0LL;
	GVariant* _tmp362_;
	gboolean _result = FALSE;
	GVariant* _tmp363_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetStartTimestamp");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp360_ = FALSE;
		return _tmp360_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp361_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp361_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp362_ = g_variant_iter_next_value (&_reply_iter);
	_vala_timestamp = g_variant_get_int64 (_tmp362_);
	g_variant_unref (_tmp362_);
	*timestamp = _vala_timestamp;
	_tmp363_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp363_);
	g_variant_unref (_tmp363_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetLength (DVBIDBusRecordingsStore* self,
                                             guint32 rec_id,
                                             gint64* length,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint64 _vala_length = 0LL;
	GVariant* _tmp366_;
	gboolean _result = FALSE;
	GVariant* _tmp367_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetLength");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp364_ = FALSE;
		return _tmp364_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp365_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp365_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp366_ = g_variant_iter_next_value (&_reply_iter);
	_vala_length = g_variant_get_int64 (_tmp366_);
	g_variant_unref (_tmp366_);
	*length = _vala_length;
	_tmp367_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp367_);
	g_variant_unref (_tmp367_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_Delete (DVBIDBusRecordingsStore* self,
                                          guint32 rec_id,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp370_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "Delete");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp368_ = FALSE;
		return _tmp368_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp369_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp369_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp370_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp370_);
	g_variant_unref (_tmp370_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetChannelName (DVBIDBusRecordingsStore* self,
                                                  guint32 rec_id,
                                                  gchar** name,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _vala_name = NULL;
	GVariant* _tmp373_;
	gboolean _result = FALSE;
	GVariant* _tmp374_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetChannelName");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp371_ = FALSE;
		return _tmp371_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp372_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp372_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp373_ = g_variant_iter_next_value (&_reply_iter);
	_vala_name = g_variant_dup_string (_tmp373_, NULL);
	g_variant_unref (_tmp373_);
	*name = _vala_name;
	_tmp374_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp374_);
	g_variant_unref (_tmp374_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_recordings_store_proxy_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                      guint32 rec_id,
                                                      DVBRecordingInfo* infos,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	DVBRecordingInfo _vala_infos = {0};
	GVariant* _tmp377_;
	DVBRecordingInfo _tmp378_;
	GVariantIter _tmp379_;
	GVariant* _tmp380_;
	GVariant* _tmp381_;
	GVariant* _tmp382_;
	GVariant* _tmp383_;
	GVariant* _tmp384_;
	GVariant* _tmp385_;
	GVariant* _tmp386_;
	gboolean _result = FALSE;
	GVariant* _tmp387_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.RecordingsStore", "GetAllInformations");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp375_ = FALSE;
		return _tmp375_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp376_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp376_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp377_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp379_, _tmp377_);
	_tmp380_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.id = g_variant_get_uint32 (_tmp380_);
	g_variant_unref (_tmp380_);
	_tmp381_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.name = g_variant_dup_string (_tmp381_, NULL);
	g_variant_unref (_tmp381_);
	_tmp382_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.description = g_variant_dup_string (_tmp382_, NULL);
	g_variant_unref (_tmp382_);
	_tmp383_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.length = g_variant_get_int64 (_tmp383_);
	g_variant_unref (_tmp383_);
	_tmp384_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.start_timestamp = g_variant_get_int64 (_tmp384_);
	g_variant_unref (_tmp384_);
	_tmp385_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.channel = g_variant_dup_string (_tmp385_, NULL);
	g_variant_unref (_tmp385_);
	_tmp386_ = g_variant_iter_next_value (&_tmp379_);
	_tmp378_.location = g_variant_dup_string (_tmp386_, NULL);
	g_variant_unref (_tmp386_);
	_vala_infos = _tmp378_;
	g_variant_unref (_tmp377_);
	*infos = _vala_infos;
	_tmp387_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp387_);
	g_variant_unref (_tmp387_);
	g_object_unref (_reply_message);
	return _result;
}

static void
dvb_id_bus_recordings_store_proxy_dvb_id_bus_recordings_store_interface_init (DVBIDBusRecordingsStoreIface* iface)
{
	iface->GetRecordings = dvb_id_bus_recordings_store_proxy_GetRecordings;
	iface->GetLocation = dvb_id_bus_recordings_store_proxy_GetLocation;
	iface->GetName = dvb_id_bus_recordings_store_proxy_GetName;
	iface->GetDescription = dvb_id_bus_recordings_store_proxy_GetDescription;
	iface->GetStartTime = dvb_id_bus_recordings_store_proxy_GetStartTime;
	iface->GetStartTimestamp = dvb_id_bus_recordings_store_proxy_GetStartTimestamp;
	iface->GetLength = dvb_id_bus_recordings_store_proxy_GetLength;
	iface->Delete = dvb_id_bus_recordings_store_proxy_Delete;
	iface->GetChannelName = dvb_id_bus_recordings_store_proxy_GetChannelName;
	iface->GetAllInformations = dvb_id_bus_recordings_store_proxy_GetAllInformations;
}

static void
_dbus_dvb_id_bus_recordings_store_GetRecordings (DVBIDBusRecordingsStore* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32* result;
	gint result_length1 = 0;
	guint32* _tmp388_;
	GVariantBuilder _tmp389_;
	gint _tmp390_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = dvb_id_bus_recordings_store_GetRecordings (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp388_ = result;
	g_variant_builder_init (&_tmp389_, G_VARIANT_TYPE ("au"));
	for (_tmp390_ = 0; _tmp390_ < result_length1; _tmp390_++) {
		g_variant_builder_add_value (&_tmp389_, g_variant_new_uint32 (*_tmp388_));
		_tmp388_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp389_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recordings_store_GetLocation (DVBIDBusRecordingsStore* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp391_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* location = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp391_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp391_);
	g_variant_unref (_tmp391_);
	result = dvb_id_bus_recordings_store_GetLocation (self, rec_id, &location, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (location));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (location);
}

static void
_dbus_dvb_id_bus_recordings_store_GetName (DVBIDBusRecordingsStore* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp392_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* name = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp392_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp392_);
	g_variant_unref (_tmp392_);
	result = dvb_id_bus_recordings_store_GetName (self, rec_id, &name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_dvb_id_bus_recordings_store_GetDescription (DVBIDBusRecordingsStore* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp393_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* description = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp393_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp393_);
	g_variant_unref (_tmp393_);
	result = dvb_id_bus_recordings_store_GetDescription (self, rec_id, &description, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (description));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (description);
}

static void
_dbus_dvb_id_bus_recordings_store_GetStartTime (DVBIDBusRecordingsStore* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp394_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* start_time = NULL;
	gint start_time_length1 = 0;
	guint* _tmp395_;
	GVariantBuilder _tmp396_;
	gint _tmp397_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp394_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp394_);
	g_variant_unref (_tmp394_);
	result = dvb_id_bus_recordings_store_GetStartTime (self, rec_id, &start_time, &start_time_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp395_ = start_time;
	g_variant_builder_init (&_tmp396_, G_VARIANT_TYPE ("au"));
	for (_tmp397_ = 0; _tmp397_ < start_time_length1; _tmp397_++) {
		g_variant_builder_add_value (&_tmp396_, g_variant_new_uint32 (*_tmp395_));
		_tmp395_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp396_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	start_time = (g_free (start_time), NULL);
}

static void
_dbus_dvb_id_bus_recordings_store_GetStartTimestamp (DVBIDBusRecordingsStore* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp398_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint64 timestamp = 0LL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp398_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp398_);
	g_variant_unref (_tmp398_);
	result = dvb_id_bus_recordings_store_GetStartTimestamp (self, rec_id, &timestamp, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int64 (timestamp));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recordings_store_GetLength (DVBIDBusRecordingsStore* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp399_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint64 length = 0LL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp399_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp399_);
	g_variant_unref (_tmp399_);
	result = dvb_id_bus_recordings_store_GetLength (self, rec_id, &length, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int64 (length));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recordings_store_Delete (DVBIDBusRecordingsStore* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp400_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp400_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp400_);
	g_variant_unref (_tmp400_);
	result = dvb_id_bus_recordings_store_Delete (self, rec_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_recordings_store_GetChannelName (DVBIDBusRecordingsStore* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp401_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* name = NULL;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp401_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp401_);
	g_variant_unref (_tmp401_);
	result = dvb_id_bus_recordings_store_GetChannelName (self, rec_id, &name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (name);
}

static void
_dbus_dvb_id_bus_recordings_store_GetAllInformations (DVBIDBusRecordingsStore* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 rec_id = 0U;
	GVariant* _tmp402_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	DVBRecordingInfo infos = {0};
	GVariantBuilder _tmp403_;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp402_ = g_variant_iter_next_value (&_arguments_iter);
	rec_id = g_variant_get_uint32 (_tmp402_);
	g_variant_unref (_tmp402_);
	result = dvb_id_bus_recordings_store_GetAllInformations (self, rec_id, &infos, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp403_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp403_, g_variant_new_uint32 (infos.id));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_string (infos.name));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_string (infos.description));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_int64 (infos.length));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_int64 (infos.start_timestamp));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_string (infos.channel));
	g_variant_builder_add_value (&_tmp403_, g_variant_new_string (infos.location));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp403_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	dvb_recording_info_destroy (&infos);
}

static void
dvb_id_bus_recordings_store_dbus_interface_method_call (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* method_name,
                                                        GVariant* parameters,
                                                        GDBusMethodInvocation* invocation,
                                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetRecordings") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetRecordings (object, parameters, invocation);
	} else if (strcmp (method_name, "GetLocation") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetLocation (object, parameters, invocation);
	} else if (strcmp (method_name, "GetName") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetName (object, parameters, invocation);
	} else if (strcmp (method_name, "GetDescription") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetDescription (object, parameters, invocation);
	} else if (strcmp (method_name, "GetStartTime") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetStartTime (object, parameters, invocation);
	} else if (strcmp (method_name, "GetStartTimestamp") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetStartTimestamp (object, parameters, invocation);
	} else if (strcmp (method_name, "GetLength") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetLength (object, parameters, invocation);
	} else if (strcmp (method_name, "Delete") == 0) {
		_dbus_dvb_id_bus_recordings_store_Delete (object, parameters, invocation);
	} else if (strcmp (method_name, "GetChannelName") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetChannelName (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAllInformations") == 0) {
		_dbus_dvb_id_bus_recordings_store_GetAllInformations (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
dvb_id_bus_recordings_store_dbus_interface_get_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GError** error,
                                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
dvb_id_bus_recordings_store_dbus_interface_set_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GVariant* value,
                                                         GError** error,
                                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_dvb_id_bus_recordings_store_changed (GObject* _sender,
                                           guint32 rec_id,
                                           guint type,
                                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (rec_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.RecordingsStore", "Changed", _arguments, NULL);
}

guint
dvb_id_bus_recordings_store_register_object (gpointer object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dvb_id_bus_recordings_store_dbus_interface_info), &_dvb_id_bus_recordings_store_dbus_interface_vtable, data, _dvb_id_bus_recordings_store_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_dvb_id_bus_recordings_store_changed, data);
	return result;
}

static void
_dvb_id_bus_recordings_store_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_recordings_store_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

