/* IDBusScanner.c generated by valac 0.56.18, the Vala compiler
 * generated from IDBusScanner.vala, do not modify */

/*
 * Copyright (C) 2008-2011 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_ID_BUS_SCANNER (dvb_id_bus_scanner_get_type ())
#define DVB_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScanner))
#define DVB_IS_ID_BUS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_SCANNER))
#define DVB_ID_BUS_SCANNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_SCANNER, DVBIDBusScannerIface))

typedef struct _DVBIDBusScanner DVBIDBusScanner;
typedef struct _DVBIDBusScannerIface DVBIDBusScannerIface;

#define DVB_TYPE_ID_BUS_SCANNER_PROXY (dvb_id_bus_scanner_proxy_get_type ())
enum  {
	DVB_ID_BUS_SCANNER_FREQUENCY_SCANNED_SIGNAL,
	DVB_ID_BUS_SCANNER_FINISHED_SIGNAL,
	DVB_ID_BUS_SCANNER_CHANNEL_ADDED_SIGNAL,
	DVB_ID_BUS_SCANNER_FRONTEND_STATS_SIGNAL,
	DVB_ID_BUS_SCANNER_NUM_SIGNALS
};
static guint dvb_id_bus_scanner_signals[DVB_ID_BUS_SCANNER_NUM_SIGNALS] = {0};
typedef GDBusProxy DVBIDBusScannerProxy;
typedef GDBusProxyClass DVBIDBusScannerProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _DVBIDBusScannerIface {
	GTypeInterface parent_iface;
	void (*Run) (DVBIDBusScanner* self, GError** error);
	void (*Destroy) (DVBIDBusScanner* self, GError** error);
	gboolean (*WriteAllChannelsToFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
	gboolean (*WriteChannelsToFile) (DVBIDBusScanner* self, guint* channel_sids, gint channel_sids_length1, const gchar* path, GError** error);
	gboolean (*AddScanningData) (DVBIDBusScanner* self, GHashTable* data, GError** error);
	gboolean (*AddScanningDataFromFile) (DVBIDBusScanner* self, const gchar* path, GError** error);
};

VALA_EXTERN GType dvb_id_bus_scanner_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_scanner_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType dvb_id_bus_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusScanner, g_object_unref)
VALA_EXTERN void dvb_id_bus_scanner_Run (DVBIDBusScanner* self,
                             GError** error);
VALA_EXTERN void dvb_id_bus_scanner_Destroy (DVBIDBusScanner* self,
                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                    const gchar* path,
                                                    GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_WriteChannelsToFile (DVBIDBusScanner* self,
                                                 guint* channel_sids,
                                                 gint channel_sids_length1,
                                                 const gchar* path,
                                                 GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_AddScanningData (DVBIDBusScanner* self,
                                             GHashTable* data,
                                             GError** error);
VALA_EXTERN gboolean dvb_id_bus_scanner_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                     const gchar* path,
                                                     GError** error);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN (GClosure * closure,
                                                                           GValue * return_value,
                                                                           guint n_param_values,
                                                                           const GValue * param_values,
                                                                           gpointer invocation_hint,
                                                                           gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType dvb_id_bus_scanner_get_type_once (void);
static void dvb_id_bus_scanner_proxy_g_signal (GDBusProxy* proxy,
                                        const gchar* sender_name,
                                        const gchar* signal_name,
                                        GVariant* parameters);
static void _dbus_handle_dvb_id_bus_scanner_frequency_scanned (DVBIDBusScanner* self,
                                                        GVariant* parameters);
static void _dbus_handle_dvb_id_bus_scanner_finished (DVBIDBusScanner* self,
                                               GVariant* parameters);
static void _dbus_handle_dvb_id_bus_scanner_channel_added (DVBIDBusScanner* self,
                                                    GVariant* parameters);
static void _dbus_handle_dvb_id_bus_scanner_frontend_stats (DVBIDBusScanner* self,
                                                     GVariant* parameters);
static void dvb_id_bus_scanner_proxy_Run (DVBIDBusScanner* self,
                                   GError** error);
static void dvb_id_bus_scanner_proxy_Destroy (DVBIDBusScanner* self,
                                       GError** error);
static gboolean dvb_id_bus_scanner_proxy_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                          const gchar* path,
                                                          GError** error);
static gboolean dvb_id_bus_scanner_proxy_WriteChannelsToFile (DVBIDBusScanner* self,
                                                       guint* channel_sids,
                                                       gint channel_sids_length1,
                                                       const gchar* path,
                                                       GError** error);
static gboolean dvb_id_bus_scanner_proxy_AddScanningData (DVBIDBusScanner* self,
                                                   GHashTable* data,
                                                   GError** error);
static gboolean dvb_id_bus_scanner_proxy_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                           const gchar* path,
                                                           GError** error);
static void dvb_id_bus_scanner_proxy_dvb_id_bus_scanner_interface_init (DVBIDBusScannerIface* iface);
static void _dbus_dvb_id_bus_scanner_Run (DVBIDBusScanner* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_scanner_Destroy (DVBIDBusScanner* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_scanner_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_scanner_WriteChannelsToFile (DVBIDBusScanner* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_scanner_AddScanningData (DVBIDBusScanner* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation);
static void _dbus_dvb_id_bus_scanner_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void dvb_id_bus_scanner_dbus_interface_method_call (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* method_name,
                                                    GVariant* parameters,
                                                    GDBusMethodInvocation* invocation,
                                                    gpointer user_data);
static GVariant* dvb_id_bus_scanner_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data);
static gboolean dvb_id_bus_scanner_dbus_interface_set_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GVariant* value,
                                                         GError** error,
                                                         gpointer user_data);
static void _dbus_dvb_id_bus_scanner_frequency_scanned (GObject* _sender,
                                                 guint frequency,
                                                 guint freq_left,
                                                 gpointer* _data);
static void _dbus_dvb_id_bus_scanner_finished (GObject* _sender,
                                        gpointer* _data);
static void _dbus_dvb_id_bus_scanner_channel_added (GObject* _sender,
                                             guint frequency,
                                             guint sid,
                                             const gchar* name,
                                             const gchar* network,
                                             const gchar* type,
                                             gboolean scrambled,
                                             gpointer* _data);
static void _dbus_dvb_id_bus_scanner_frontend_stats (GObject* _sender,
                                              gdouble signal_strength,
                                              gdouble signal_noise_ratio,
                                              gpointer* _data);
static void _dvb_id_bus_scanner_unregister_object (gpointer user_data);

static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_Run_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_Run_out[] = {NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_Run = {-1, "Run", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_Run_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_Run_out), NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_Destroy_in[] = {NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_Destroy_out[] = {NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_Destroy = {-1, "Destroy", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_Destroy_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_Destroy_out), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_path = {-1, "path", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_in[] = {&_dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_path, NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_out[] = {&_dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_WriteAllChannelsToFile = {-1, "WriteAllChannelsToFile", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_WriteAllChannelsToFile_out), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_channel_sids = {-1, "channel_sids", "au", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_path = {-1, "path", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_in[] = {&_dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_channel_sids, &_dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_path, NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_out[] = {&_dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_WriteChannelsToFile = {-1, "WriteChannelsToFile", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_WriteChannelsToFile_out), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_AddScanningData_data = {-1, "data", "a{sv}", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_AddScanningData_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_AddScanningData_in[] = {&_dvb_id_bus_scanner_dbus_arg_info_AddScanningData_data, NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_AddScanningData_out[] = {&_dvb_id_bus_scanner_dbus_arg_info_AddScanningData_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_AddScanningData = {-1, "AddScanningData", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_AddScanningData_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_AddScanningData_out), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_path = {-1, "path", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_in[] = {&_dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_path, NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_out[] = {&_dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_result, NULL};
static const GDBusMethodInfo _dvb_id_bus_scanner_dbus_method_info_AddScanningDataFromFile = {-1, "AddScanningDataFromFile", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_in), (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_AddScanningDataFromFile_out), NULL};
static const GDBusMethodInfo * const _dvb_id_bus_scanner_dbus_method_info[] = {&_dvb_id_bus_scanner_dbus_method_info_Run, &_dvb_id_bus_scanner_dbus_method_info_Destroy, &_dvb_id_bus_scanner_dbus_method_info_WriteAllChannelsToFile, &_dvb_id_bus_scanner_dbus_method_info_WriteChannelsToFile, &_dvb_id_bus_scanner_dbus_method_info_AddScanningData, &_dvb_id_bus_scanner_dbus_method_info_AddScanningDataFromFile, NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_frequency_scanned_frequency = {-1, "frequency", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_frequency_scanned_freq_left = {-1, "freq_left", "u", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_frequency_scanned[] = {&_dvb_id_bus_scanner_dbus_arg_info_frequency_scanned_frequency, &_dvb_id_bus_scanner_dbus_arg_info_frequency_scanned_freq_left, NULL};
static const GDBusSignalInfo _dvb_id_bus_scanner_dbus_signal_info_frequency_scanned = {-1, "FrequencyScanned", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_frequency_scanned), NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_finished[] = {NULL};
static const GDBusSignalInfo _dvb_id_bus_scanner_dbus_signal_info_finished = {-1, "Finished", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_finished), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_frequency = {-1, "frequency", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_sid = {-1, "sid", "u", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_network = {-1, "network", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_type = {-1, "type", "s", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_channel_added_scrambled = {-1, "scrambled", "b", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_channel_added[] = {&_dvb_id_bus_scanner_dbus_arg_info_channel_added_frequency, &_dvb_id_bus_scanner_dbus_arg_info_channel_added_sid, &_dvb_id_bus_scanner_dbus_arg_info_channel_added_name, &_dvb_id_bus_scanner_dbus_arg_info_channel_added_network, &_dvb_id_bus_scanner_dbus_arg_info_channel_added_type, &_dvb_id_bus_scanner_dbus_arg_info_channel_added_scrambled, NULL};
static const GDBusSignalInfo _dvb_id_bus_scanner_dbus_signal_info_channel_added = {-1, "ChannelAdded", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_channel_added), NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_frontend_stats_signal_strength = {-1, "signal_strength", "d", NULL};
static const GDBusArgInfo _dvb_id_bus_scanner_dbus_arg_info_frontend_stats_signal_noise_ratio = {-1, "signal_noise_ratio", "d", NULL};
static const GDBusArgInfo * const _dvb_id_bus_scanner_dbus_arg_info_frontend_stats[] = {&_dvb_id_bus_scanner_dbus_arg_info_frontend_stats_signal_strength, &_dvb_id_bus_scanner_dbus_arg_info_frontend_stats_signal_noise_ratio, NULL};
static const GDBusSignalInfo _dvb_id_bus_scanner_dbus_signal_info_frontend_stats = {-1, "FrontendStats", (GDBusArgInfo **) (&_dvb_id_bus_scanner_dbus_arg_info_frontend_stats), NULL};
static const GDBusSignalInfo * const _dvb_id_bus_scanner_dbus_signal_info[] = {&_dvb_id_bus_scanner_dbus_signal_info_frequency_scanned, &_dvb_id_bus_scanner_dbus_signal_info_finished, &_dvb_id_bus_scanner_dbus_signal_info_channel_added, &_dvb_id_bus_scanner_dbus_signal_info_frontend_stats, NULL};
static const GDBusPropertyInfo * const _dvb_id_bus_scanner_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dvb_id_bus_scanner_dbus_interface_info = {-1, "org.gnome.DVB.Scanner", (GDBusMethodInfo **) (&_dvb_id_bus_scanner_dbus_method_info), (GDBusSignalInfo **) (&_dvb_id_bus_scanner_dbus_signal_info), (GDBusPropertyInfo **) (&_dvb_id_bus_scanner_dbus_property_info), NULL};
static const GDBusInterfaceVTable _dvb_id_bus_scanner_dbus_interface_vtable = {dvb_id_bus_scanner_dbus_interface_method_call, dvb_id_bus_scanner_dbus_interface_get_property, dvb_id_bus_scanner_dbus_interface_set_property};

void
dvb_id_bus_scanner_Run (DVBIDBusScanner* self,
                        GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->Run) {
		_iface_->Run (self, error);
	}
}

void
dvb_id_bus_scanner_Destroy (DVBIDBusScanner* self,
                            GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->Destroy) {
		_iface_->Destroy (self, error);
	}
}

gboolean
dvb_id_bus_scanner_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                           const gchar* path,
                                           GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->WriteAllChannelsToFile) {
		return _iface_->WriteAllChannelsToFile (self, path, error);
	}
	return FALSE;
}

gboolean
dvb_id_bus_scanner_WriteChannelsToFile (DVBIDBusScanner* self,
                                        guint* channel_sids,
                                        gint channel_sids_length1,
                                        const gchar* path,
                                        GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->WriteChannelsToFile) {
		return _iface_->WriteChannelsToFile (self, channel_sids, channel_sids_length1, path, error);
	}
	return FALSE;
}

gboolean
dvb_id_bus_scanner_AddScanningData (DVBIDBusScanner* self,
                                    GHashTable* data,
                                    GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->AddScanningData) {
		return _iface_->AddScanningData (self, data, error);
	}
	return FALSE;
}

/**
         * @path: Path to file containing scanning data
         * @returns: TRUE when the file has been parsed successfully
         *
         * Parses initial tuning data from a file as provided by dvb-apps
         */
gboolean
dvb_id_bus_scanner_AddScanningDataFromFile (DVBIDBusScanner* self,
                                            const gchar* path,
                                            GError** error)
{
	DVBIDBusScannerIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_ID_BUS_SCANNER_GET_INTERFACE (self);
	if (_iface_->AddScanningDataFromFile) {
		return _iface_->AddScanningDataFromFile (self, path, error);
	}
	return FALSE;
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN (GClosure * closure,
                                                                      GValue * return_value,
                                                                      guint n_param_values,
                                                                      const GValue * param_values,
                                                                      gpointer invocation_hint,
                                                                      gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN) (gpointer data1, guint arg_1, guint arg_2, const char* arg_3, const char* arg_4, const char* arg_5, gboolean arg_6, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 7);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), g_value_get_string (param_values + 5), g_value_get_boolean (param_values + 6), data2);
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
}

static void
dvb_id_bus_scanner_default_init (DVBIDBusScannerIface * iface,
                                 gpointer iface_data)
{
	dvb_id_bus_scanner_signals[DVB_ID_BUS_SCANNER_FREQUENCY_SCANNED_SIGNAL] = g_signal_new ("frequency-scanned", DVB_TYPE_ID_BUS_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
	dvb_id_bus_scanner_signals[DVB_ID_BUS_SCANNER_FINISHED_SIGNAL] = g_signal_new ("finished", DVB_TYPE_ID_BUS_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	dvb_id_bus_scanner_signals[DVB_ID_BUS_SCANNER_CHANNEL_ADDED_SIGNAL] = g_signal_new ("channel-added", DVB_TYPE_ID_BUS_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT_STRING_STRING_STRING_BOOLEAN, G_TYPE_NONE, 6, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN);
	dvb_id_bus_scanner_signals[DVB_ID_BUS_SCANNER_FRONTEND_STATS_SIGNAL] = g_signal_new ("frontend-stats", DVB_TYPE_ID_BUS_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
}

static GType
dvb_id_bus_scanner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBIDBusScannerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_id_bus_scanner_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_id_bus_scanner_type_id;
	dvb_id_bus_scanner_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBIDBusScanner", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_id_bus_scanner_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (dvb_id_bus_scanner_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dvb_id_bus_scanner_proxy_get_type);
	g_type_set_qdata (dvb_id_bus_scanner_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.DVB.Scanner");
	g_type_set_qdata (dvb_id_bus_scanner_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_dvb_id_bus_scanner_dbus_interface_info));
	g_type_set_qdata (dvb_id_bus_scanner_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dvb_id_bus_scanner_register_object);
	return dvb_id_bus_scanner_type_id;
}

GType
dvb_id_bus_scanner_get_type (void)
{
	static volatile gsize dvb_id_bus_scanner_type_id__once = 0;
	if (g_once_init_enter (&dvb_id_bus_scanner_type_id__once)) {
		GType dvb_id_bus_scanner_type_id;
		dvb_id_bus_scanner_type_id = dvb_id_bus_scanner_get_type_once ();
		g_once_init_leave (&dvb_id_bus_scanner_type_id__once, dvb_id_bus_scanner_type_id);
	}
	return dvb_id_bus_scanner_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DVBIDBusScannerProxy, dvb_id_bus_scanner_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DVB_TYPE_ID_BUS_SCANNER, dvb_id_bus_scanner_proxy_dvb_id_bus_scanner_interface_init) )
static void
dvb_id_bus_scanner_proxy_class_init (DVBIDBusScannerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = dvb_id_bus_scanner_proxy_g_signal;
}

static void
_dbus_handle_dvb_id_bus_scanner_frequency_scanned (DVBIDBusScanner* self,
                                                   GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint frequency = 0U;
	GVariant* _tmp404_;
	guint freq_left = 0U;
	GVariant* _tmp405_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp404_ = g_variant_iter_next_value (&_arguments_iter);
	frequency = g_variant_get_uint32 (_tmp404_);
	g_variant_unref (_tmp404_);
	_tmp405_ = g_variant_iter_next_value (&_arguments_iter);
	freq_left = g_variant_get_uint32 (_tmp405_);
	g_variant_unref (_tmp405_);
	g_signal_emit_by_name (self, "frequency-scanned", frequency, freq_left);
}

static void
_dbus_handle_dvb_id_bus_scanner_finished (DVBIDBusScanner* self,
                                          GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "finished");
}

static void
_dbus_handle_dvb_id_bus_scanner_channel_added (DVBIDBusScanner* self,
                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint frequency = 0U;
	GVariant* _tmp406_;
	guint sid = 0U;
	GVariant* _tmp407_;
	gchar* name = NULL;
	GVariant* _tmp408_;
	gchar* network = NULL;
	GVariant* _tmp409_;
	gchar* type = NULL;
	GVariant* _tmp410_;
	gboolean scrambled = FALSE;
	GVariant* _tmp411_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp406_ = g_variant_iter_next_value (&_arguments_iter);
	frequency = g_variant_get_uint32 (_tmp406_);
	g_variant_unref (_tmp406_);
	_tmp407_ = g_variant_iter_next_value (&_arguments_iter);
	sid = g_variant_get_uint32 (_tmp407_);
	g_variant_unref (_tmp407_);
	_tmp408_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp408_, NULL);
	g_variant_unref (_tmp408_);
	_tmp409_ = g_variant_iter_next_value (&_arguments_iter);
	network = g_variant_dup_string (_tmp409_, NULL);
	g_variant_unref (_tmp409_);
	_tmp410_ = g_variant_iter_next_value (&_arguments_iter);
	type = g_variant_dup_string (_tmp410_, NULL);
	g_variant_unref (_tmp410_);
	_tmp411_ = g_variant_iter_next_value (&_arguments_iter);
	scrambled = g_variant_get_boolean (_tmp411_);
	g_variant_unref (_tmp411_);
	g_signal_emit_by_name (self, "channel-added", frequency, sid, name, network, type, scrambled);
	_g_free0 (name);
	_g_free0 (network);
	_g_free0 (type);
}

static void
_dbus_handle_dvb_id_bus_scanner_frontend_stats (DVBIDBusScanner* self,
                                                GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gdouble signal_strength = 0.0;
	GVariant* _tmp412_;
	gdouble signal_noise_ratio = 0.0;
	GVariant* _tmp413_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp412_ = g_variant_iter_next_value (&_arguments_iter);
	signal_strength = g_variant_get_double (_tmp412_);
	g_variant_unref (_tmp412_);
	_tmp413_ = g_variant_iter_next_value (&_arguments_iter);
	signal_noise_ratio = g_variant_get_double (_tmp413_);
	g_variant_unref (_tmp413_);
	g_signal_emit_by_name (self, "frontend-stats", signal_strength, signal_noise_ratio);
}

static void
dvb_id_bus_scanner_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters)
{
	if (strcmp (signal_name, "FrequencyScanned") == 0) {
		_dbus_handle_dvb_id_bus_scanner_frequency_scanned ((DVBIDBusScanner*) proxy, parameters);
	} else if (strcmp (signal_name, "Finished") == 0) {
		_dbus_handle_dvb_id_bus_scanner_finished ((DVBIDBusScanner*) proxy, parameters);
	} else if (strcmp (signal_name, "ChannelAdded") == 0) {
		_dbus_handle_dvb_id_bus_scanner_channel_added ((DVBIDBusScanner*) proxy, parameters);
	} else if (strcmp (signal_name, "FrontendStats") == 0) {
		_dbus_handle_dvb_id_bus_scanner_frontend_stats ((DVBIDBusScanner*) proxy, parameters);
	}
}

static void
dvb_id_bus_scanner_proxy_init (DVBIDBusScannerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_dvb_id_bus_scanner_dbus_interface_info));
}

static void
dvb_id_bus_scanner_proxy_Run (DVBIDBusScanner* self,
                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "Run");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
dvb_id_bus_scanner_proxy_Destroy (DVBIDBusScanner* self,
                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "Destroy");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gboolean
dvb_id_bus_scanner_proxy_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                 const gchar* path,
                                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp416_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "WriteAllChannelsToFile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (path));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp414_ = FALSE;
		return _tmp414_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp415_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp415_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp416_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp416_);
	g_variant_unref (_tmp416_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_scanner_proxy_WriteChannelsToFile (DVBIDBusScanner* self,
                                              guint* channel_sids,
                                              gint channel_sids_length1,
                                              const gchar* path,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	guint* _tmp417_;
	GVariantBuilder _tmp418_;
	gint _tmp419_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp422_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "WriteChannelsToFile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp417_ = channel_sids;
	g_variant_builder_init (&_tmp418_, G_VARIANT_TYPE ("au"));
	for (_tmp419_ = 0; _tmp419_ < channel_sids_length1; _tmp419_++) {
		g_variant_builder_add_value (&_tmp418_, g_variant_new_uint32 (*_tmp417_));
		_tmp417_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp418_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (path));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp420_ = FALSE;
		return _tmp420_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp421_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp421_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp422_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp422_);
	g_variant_unref (_tmp422_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_scanner_proxy_AddScanningData (DVBIDBusScanner* self,
                                          GHashTable* data,
                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp423_;
	GHashTableIter _tmp424_;
	gpointer _tmp425_;
	gpointer _tmp426_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp429_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "AddScanningData");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp424_, data);
	g_variant_builder_init (&_tmp423_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp424_, &_tmp425_, &_tmp426_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp425_;
		_value = (GVariant*) _tmp426_;
		g_variant_builder_add (&_tmp423_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp423_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp427_ = FALSE;
		return _tmp427_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp428_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp428_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp429_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp429_);
	g_variant_unref (_tmp429_);
	g_object_unref (_reply_message);
	return _result;
}

static gboolean
dvb_id_bus_scanner_proxy_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                  const gchar* path,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp432_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.DVB.Scanner", "AddScanningDataFromFile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (path));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp430_ = FALSE;
		return _tmp430_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp431_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp431_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp432_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp432_);
	g_variant_unref (_tmp432_);
	g_object_unref (_reply_message);
	return _result;
}

static void
dvb_id_bus_scanner_proxy_dvb_id_bus_scanner_interface_init (DVBIDBusScannerIface* iface)
{
	iface->Run = dvb_id_bus_scanner_proxy_Run;
	iface->Destroy = dvb_id_bus_scanner_proxy_Destroy;
	iface->WriteAllChannelsToFile = dvb_id_bus_scanner_proxy_WriteAllChannelsToFile;
	iface->WriteChannelsToFile = dvb_id_bus_scanner_proxy_WriteChannelsToFile;
	iface->AddScanningData = dvb_id_bus_scanner_proxy_AddScanningData;
	iface->AddScanningDataFromFile = dvb_id_bus_scanner_proxy_AddScanningDataFromFile;
}

static void
_dbus_dvb_id_bus_scanner_Run (DVBIDBusScanner* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	dvb_id_bus_scanner_Run (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_scanner_Destroy (DVBIDBusScanner* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	dvb_id_bus_scanner_Destroy (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_dvb_id_bus_scanner_WriteAllChannelsToFile (DVBIDBusScanner* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* path = NULL;
	GVariant* _tmp433_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp433_ = g_variant_iter_next_value (&_arguments_iter);
	path = g_variant_dup_string (_tmp433_, NULL);
	g_variant_unref (_tmp433_);
	result = dvb_id_bus_scanner_WriteAllChannelsToFile (self, path, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (path);
	;
}

static void
_dbus_dvb_id_bus_scanner_WriteChannelsToFile (DVBIDBusScanner* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint* channel_sids = NULL;
	gint channel_sids_length1 = 0;
	GVariant* _tmp434_;
	guint* _tmp435_;
	gint _tmp435__length;
	gint _tmp435__size;
	gint _tmp435__length1;
	GVariantIter _tmp436_;
	GVariant* _tmp437_;
	gchar* path = NULL;
	GVariant* _tmp438_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp434_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp435_ = g_new (guint, 5);
	_tmp435__length = 0;
	_tmp435__size = 4;
	_tmp435__length1 = 0;
	g_variant_iter_init (&_tmp436_, _tmp434_);
	for (; (_tmp437_ = g_variant_iter_next_value (&_tmp436_)) != NULL; _tmp435__length1++) {
		if (_tmp435__size == _tmp435__length) {
			_tmp435__size = 2 * _tmp435__size;
			_tmp435_ = g_renew (guint, _tmp435_, _tmp435__size + 1);
		}
		_tmp435_[_tmp435__length++] = g_variant_get_uint32 (_tmp437_);
		g_variant_unref (_tmp437_);
	}
	channel_sids_length1 = _tmp435__length1;
	channel_sids = _tmp435_;
	g_variant_unref (_tmp434_);
	_tmp438_ = g_variant_iter_next_value (&_arguments_iter);
	path = g_variant_dup_string (_tmp438_, NULL);
	g_variant_unref (_tmp438_);
	result = dvb_id_bus_scanner_WriteChannelsToFile (self, channel_sids, channel_sids_length1, path, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	channel_sids = (g_free (channel_sids), NULL);
	_g_free0 (path);
	;
}

static void
_dbus_dvb_id_bus_scanner_AddScanningData (DVBIDBusScanner* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* data = NULL;
	GVariant* _tmp439_;
	GHashTable* _tmp440_;
	GVariantIter _tmp441_;
	GVariant* _tmp442_;
	GVariant* _tmp443_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp439_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp440_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp441_, _tmp439_);
	while (g_variant_iter_loop (&_tmp441_, "{?*}", &_tmp442_, &_tmp443_)) {
		g_hash_table_insert (_tmp440_, g_variant_dup_string (_tmp442_, NULL), g_variant_get_variant (_tmp443_));
	}
	data = _tmp440_;
	g_variant_unref (_tmp439_);
	result = dvb_id_bus_scanner_AddScanningData (self, data, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_hash_table_unref0 (data);
	;
}

static void
_dbus_dvb_id_bus_scanner_AddScanningDataFromFile (DVBIDBusScanner* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* path = NULL;
	GVariant* _tmp444_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp444_ = g_variant_iter_next_value (&_arguments_iter);
	path = g_variant_dup_string (_tmp444_, NULL);
	g_variant_unref (_tmp444_);
	result = dvb_id_bus_scanner_AddScanningDataFromFile (self, path, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (path);
	;
}

static void
dvb_id_bus_scanner_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Run") == 0) {
		_dbus_dvb_id_bus_scanner_Run (object, parameters, invocation);
	} else if (strcmp (method_name, "Destroy") == 0) {
		_dbus_dvb_id_bus_scanner_Destroy (object, parameters, invocation);
	} else if (strcmp (method_name, "WriteAllChannelsToFile") == 0) {
		_dbus_dvb_id_bus_scanner_WriteAllChannelsToFile (object, parameters, invocation);
	} else if (strcmp (method_name, "WriteChannelsToFile") == 0) {
		_dbus_dvb_id_bus_scanner_WriteChannelsToFile (object, parameters, invocation);
	} else if (strcmp (method_name, "AddScanningData") == 0) {
		_dbus_dvb_id_bus_scanner_AddScanningData (object, parameters, invocation);
	} else if (strcmp (method_name, "AddScanningDataFromFile") == 0) {
		_dbus_dvb_id_bus_scanner_AddScanningDataFromFile (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
dvb_id_bus_scanner_dbus_interface_get_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
dvb_id_bus_scanner_dbus_interface_set_property (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* property_name,
                                                GVariant* value,
                                                GError** error,
                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_dvb_id_bus_scanner_frequency_scanned (GObject* _sender,
                                            guint frequency,
                                            guint freq_left,
                                            gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frequency));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (freq_left));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Scanner", "FrequencyScanned", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_scanner_finished (GObject* _sender,
                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Scanner", "Finished", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_scanner_channel_added (GObject* _sender,
                                        guint frequency,
                                        guint sid,
                                        const gchar* name,
                                        const gchar* network,
                                        const gchar* type,
                                        gboolean scrambled,
                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (frequency));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (sid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (network));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (type));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (scrambled));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Scanner", "ChannelAdded", _arguments, NULL);
}

static void
_dbus_dvb_id_bus_scanner_frontend_stats (GObject* _sender,
                                         gdouble signal_strength,
                                         gdouble signal_noise_ratio,
                                         gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (signal_strength));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (signal_noise_ratio));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.DVB.Scanner", "FrontendStats", _arguments, NULL);
}

guint
dvb_id_bus_scanner_register_object (gpointer object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dvb_id_bus_scanner_dbus_interface_info), &_dvb_id_bus_scanner_dbus_interface_vtable, data, _dvb_id_bus_scanner_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "frequency-scanned", (GCallback) _dbus_dvb_id_bus_scanner_frequency_scanned, data);
	g_signal_connect (object, "finished", (GCallback) _dbus_dvb_id_bus_scanner_finished, data);
	g_signal_connect (object, "channel-added", (GCallback) _dbus_dvb_id_bus_scanner_channel_added, data);
	g_signal_connect (object, "frontend-stats", (GCallback) _dbus_dvb_id_bus_scanner_frontend_stats, data);
	return result;
}

static void
_dvb_id_bus_scanner_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_scanner_frequency_scanned, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_scanner_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_scanner_channel_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_dvb_id_bus_scanner_frontend_stats, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

